/* add-edit-page.c generated by valac 0.30.2, the Vala compiler
 * generated from add-edit-page.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* Page for adding or editing an account.*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "webkit/webkit.h"
#include <stdlib.h>
#include <string.h>
#include "geary-static.h"
#include <glib/gi18n-lib.h>
#include <gee.h>


#define TYPE_ADD_EDIT_PAGE (add_edit_page_get_type ())
#define ADD_EDIT_PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADD_EDIT_PAGE, AddEditPage))
#define ADD_EDIT_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ADD_EDIT_PAGE, AddEditPageClass))
#define IS_ADD_EDIT_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADD_EDIT_PAGE))
#define IS_ADD_EDIT_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ADD_EDIT_PAGE))
#define ADD_EDIT_PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ADD_EDIT_PAGE, AddEditPageClass))

typedef struct _AddEditPage AddEditPage;
typedef struct _AddEditPageClass AddEditPageClass;
typedef struct _AddEditPagePrivate AddEditPagePrivate;

#define ADD_EDIT_PAGE_TYPE_PAGE_MODE (add_edit_page_page_mode_get_type ())

#define TYPE_STYLISH_WEB_VIEW (stylish_web_view_get_type ())
#define STYLISH_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STYLISH_WEB_VIEW, StylishWebView))
#define STYLISH_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STYLISH_WEB_VIEW, StylishWebViewClass))
#define IS_STYLISH_WEB_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STYLISH_WEB_VIEW))
#define IS_STYLISH_WEB_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STYLISH_WEB_VIEW))
#define STYLISH_WEB_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STYLISH_WEB_VIEW, StylishWebViewClass))

typedef struct _StylishWebView StylishWebView;
typedef struct _StylishWebViewClass StylishWebViewClass;

#define ADD_EDIT_PAGE_TYPE_ENCRYPTION (add_edit_page_encryption_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_GEARY_APPLICATION (geary_application_get_type ())
#define GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GEARY_APPLICATION, GearyApplication))
#define GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GEARY_APPLICATION, GearyApplicationClass))
#define IS_GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GEARY_APPLICATION))
#define IS_GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GEARY_APPLICATION))
#define GEARY_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GEARY_APPLICATION, GearyApplicationClass))

typedef struct _GearyApplication GearyApplication;
typedef struct _GearyApplicationClass GearyApplicationClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _AddEditPage {
	GtkBox parent_instance;
	AddEditPagePrivate * priv;
};

struct _AddEditPageClass {
	GtkBoxClass parent_class;
};

typedef enum  {
	ADD_EDIT_PAGE_PAGE_MODE_WELCOME,
	ADD_EDIT_PAGE_PAGE_MODE_ADD,
	ADD_EDIT_PAGE_PAGE_MODE_EDIT
} AddEditPagePageMode;

struct _AddEditPagePrivate {
	AddEditPagePageMode mode;
	GtkWidget* container_widget;
	GtkBox* welcome_box;
	GtkLabel* label_error;
	GtkEntry* entry_email;
	GtkLabel* label_password;
	GtkEntry* entry_password;
	GtkEntry* entry_real_name;
	GtkLabel* label_nickname;
	GtkEntry* entry_nickname;
	GtkComboBoxText* combo_service;
	GtkCheckButton* check_remember_password;
	GtkCheckButton* check_save_sent_mail;
	GtkButton* alternate_email_button;
	GtkBox* composer_container;
	GtkCheckButton* check_use_email_signature;
	GtkStack* signature_stack;
	GtkTextView* textview_email_signature;
	StylishWebView* preview_webview;
	GtkAlignment* other_info;
	GtkEntry* entry_imap_host;
	GtkEntry* entry_imap_port;
	GtkEntry* entry_imap_username;
	GtkEntry* entry_imap_password;
	GtkComboBox* combo_imap_encryption;
	GtkEntry* entry_smtp_host;
	GtkEntry* entry_smtp_port;
	GtkEntry* entry_smtp_username;
	GtkEntry* entry_smtp_password;
	GtkComboBox* combo_smtp_encryption;
	GtkCheckButton* check_smtp_use_imap_credentials;
	GtkCheckButton* check_smtp_noauth;
	GtkCheckButton* check_save_drafts;
	gchar* smtp_username_store;
	gchar* smtp_password_store;
	GtkBox* storage_container;
	GtkComboBoxText* combo_storage_length;
	gboolean edited_imap_port;
	gboolean edited_smtp_port;
	GearyEngineValidationResult last_validation_result;
	gboolean first_ui_update;
};

typedef enum  {
	ADD_EDIT_PAGE_ENCRYPTION_NONE = 0,
	ADD_EDIT_PAGE_ENCRYPTION_SSL = 1,
	ADD_EDIT_PAGE_ENCRYPTION_STARTTLS = 2
} AddEditPageEncryption;


static gpointer add_edit_page_parent_class = NULL;

GType add_edit_page_get_type (void) G_GNUC_CONST;
GType add_edit_page_page_mode_get_type (void) G_GNUC_CONST;
GType stylish_web_view_get_type (void) G_GNUC_CONST;
#define ADD_EDIT_PAGE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ADD_EDIT_PAGE, AddEditPagePrivate))
enum  {
	ADD_EDIT_PAGE_DUMMY_PROPERTY,
	ADD_EDIT_PAGE_REAL_NAME,
	ADD_EDIT_PAGE_NICKNAME,
	ADD_EDIT_PAGE_EMAIL_ADDRESS,
	ADD_EDIT_PAGE_PASSWORD,
	ADD_EDIT_PAGE_IMAP_USERNAME,
	ADD_EDIT_PAGE_IMAP_PASSWORD,
	ADD_EDIT_PAGE_REMEMBER_PASSWORD,
	ADD_EDIT_PAGE_USE_EMAIL_SIGNATURE,
	ADD_EDIT_PAGE_EMAIL_SIGNATURE,
	ADD_EDIT_PAGE_SAVE_SENT_MAIL,
	ADD_EDIT_PAGE_SMTP_USERNAME,
	ADD_EDIT_PAGE_SMTP_PASSWORD,
	ADD_EDIT_PAGE_IMAP_HOST,
	ADD_EDIT_PAGE_IMAP_SSL,
	ADD_EDIT_PAGE_IMAP_STARTTLS,
	ADD_EDIT_PAGE_SMTP_HOST,
	ADD_EDIT_PAGE_SMTP_SSL,
	ADD_EDIT_PAGE_SMTP_STARTTLS,
	ADD_EDIT_PAGE_SMTP_USE_IMAP_CREDENTIALS,
	ADD_EDIT_PAGE_SMTP_NOAUTH,
	ADD_EDIT_PAGE_SAVE_DRAFTS
};
static GType add_edit_page_encryption_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define ADD_EDIT_PAGE_REAL_NAME_PLACEHOLDER _ ("First Last")
AddEditPage* add_edit_page_new (void);
AddEditPage* add_edit_page_construct (GType object_type);
GType geary_application_get_type (void) G_GNUC_CONST;
GearyApplication* geary_application_get_instance (void);
GtkBuilder* geary_application_create_builder (GearyApplication* self, const gchar* name);
static gboolean add_edit_page_combo_storage_separator_delegate (AddEditPage* self, GtkTreeModel* model, GtkTreeIter* iter);
static gboolean _add_edit_page_combo_storage_separator_delegate_gtk_tree_view_row_separator_func (GtkTreeModel* model, GtkTreeIter* iter, gpointer self);
StylishWebView* stylish_web_view_new (void);
StylishWebView* stylish_web_view_construct (GType object_type);
void add_edit_page_reset_all (AddEditPage* self);
void add_edit_page_update_ui (AddEditPage* self);
static void _add_edit_page_update_ui_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self);
static void add_edit_page_on_changed (AddEditPage* self);
static void _add_edit_page_on_changed_gtk_editable_changed (GtkEditable* _sender, gpointer self);
static void _add_edit_page_on_changed_gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void _add_edit_page_on_changed_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self);
static void add_edit_page_on_alternate_email_button_clicked (AddEditPage* self);
static void _add_edit_page_on_alternate_email_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void add_edit_page_on_email_changed (AddEditPage* self);
static void _add_edit_page_on_email_changed_gtk_editable_changed (GtkEditable* _sender, gpointer self);
static void add_edit_page_on_password_changed (AddEditPage* self);
static void _add_edit_page_on_password_changed_gtk_editable_changed (GtkEditable* _sender, gpointer self);
static void add_edit_page_on_imap_encryption_changed (AddEditPage* self);
static void _add_edit_page_on_imap_encryption_changed_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self);
static void add_edit_page_on_smtp_encryption_changed (AddEditPage* self);
static void _add_edit_page_on_smtp_encryption_changed_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self);
static void __lambda57_ (AddEditPage* self);
static void add_edit_page_on_smtp_auth_changed (AddEditPage* self, gboolean use_imap_credentials_toggled);
static void ___lambda57__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void __lambda58_ (AddEditPage* self);
static void ___lambda58__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
static void add_edit_page_on_port_insert_text (AddEditPage* self, GtkEditable* e, const gchar* text, gint length, gint* position);
static void _add_edit_page_on_port_insert_text_gtk_editable_insert_text (GtkEditable* _sender, const gchar* new_text, gint new_text_length, gint* position, gpointer self);
static void add_edit_page_on_nickname_insert_text (AddEditPage* self, GtkEditable* e, const gchar* text, gint length, gint* position);
static void _add_edit_page_on_nickname_insert_text_gtk_editable_insert_text (GtkEditable* _sender, const gchar* new_text, gint new_text_length, gint* position, gpointer self);
static void add_edit_page_on_signature_stack_changed (AddEditPage* self);
static void _add_edit_page_on_signature_stack_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void __lambda59_ (AddEditPage* self);
static void ___lambda59__gtk_widget_map (GtkWidget* _sender, gpointer self);
void add_edit_page_set_account_information (AddEditPage* self, GearyAccountInformation* info, GearyEngineValidationResult _result_);
void add_edit_page_set_all_info (AddEditPage* self, const gchar* initial_real_name, const gchar* initial_nickname, const gchar* initial_email, const gchar* initial_imap_username, const gchar* initial_imap_password, gboolean initial_remember_password, const gchar* initial_smtp_username, const gchar* initial_smtp_password, gint initial_service_provider, gboolean initial_save_sent_mail, gboolean allow_save_sent_mail, const gchar* initial_default_imap_host, guint16 initial_default_imap_port, gboolean initial_default_imap_ssl, gboolean initial_default_imap_starttls, const gchar* initial_default_smtp_host, guint16 initial_default_smtp_port, gboolean initial_default_smtp_ssl, gboolean initial_default_smtp_starttls, gboolean initial_default_smtp_use_imap_credentials, gboolean initial_default_smtp_noauth, gint prefetch_period_days, gboolean initial_save_drafts, gboolean initial_use_email_signature, const gchar* initial_email_signature, GearyEngineValidationResult _result_);
void add_edit_page_set_real_name (AddEditPage* self, const gchar* value);
void add_edit_page_set_nickname (AddEditPage* self, const gchar* value);
void add_edit_page_set_email_address (AddEditPage* self, const gchar* value);
void add_edit_page_set_password (AddEditPage* self, const gchar* value);
void add_edit_page_set_remember_password (AddEditPage* self, gboolean value);
void add_edit_page_set_save_sent_mail (AddEditPage* self, gboolean value);
void add_edit_page_set_service_provider (AddEditPage* self, GearyServiceProvider provider);
void add_edit_page_set_use_email_signature (AddEditPage* self, gboolean value);
void add_edit_page_set_email_signature (AddEditPage* self, const gchar* value);
void add_edit_page_set_imap_host (AddEditPage* self, const gchar* value);
void add_edit_page_set_imap_port (AddEditPage* self, guint16 value);
void add_edit_page_set_imap_username (AddEditPage* self, const gchar* value);
void add_edit_page_set_imap_password (AddEditPage* self, const gchar* value);
void add_edit_page_set_imap_ssl (AddEditPage* self, gboolean value);
void add_edit_page_set_imap_starttls (AddEditPage* self, gboolean value);
void add_edit_page_set_smtp_host (AddEditPage* self, const gchar* value);
void add_edit_page_set_smtp_port (AddEditPage* self, guint16 value);
void add_edit_page_set_smtp_username (AddEditPage* self, const gchar* value);
void add_edit_page_set_smtp_password (AddEditPage* self, const gchar* value);
void add_edit_page_set_smtp_ssl (AddEditPage* self, gboolean value);
void add_edit_page_set_smtp_starttls (AddEditPage* self, gboolean value);
void add_edit_page_set_smtp_use_imap_credentials (AddEditPage* self, gboolean value);
void add_edit_page_set_smtp_noauth (AddEditPage* self, gboolean value);
void add_edit_page_set_save_drafts (AddEditPage* self, gboolean value);
void add_edit_page_set_validation_result (AddEditPage* self, GearyEngineValidationResult _result_);
static void add_edit_page_set_storage_length (AddEditPage* self, gint days);
static gchar* add_edit_page_get_default_real_name (AddEditPage* self);
void add_edit_page_set_mode (AddEditPage* self, AddEditPagePageMode m);
AddEditPagePageMode add_edit_page_get_mode (AddEditPage* self);
static guint16 add_edit_page_get_default_imap_port (AddEditPage* self);
static guint16 add_edit_page_get_default_smtp_port (AddEditPage* self);
gchar* smart_escape (const gchar* text, gboolean preserve_whitespace_in_html);
gchar* add_edit_page_get_email_signature (AddEditPage* self);
gboolean add_edit_page_is_complete (AddEditPage* self);
GearyServiceProvider add_edit_page_get_service_provider (AddEditPage* self);
const gchar* add_edit_page_get_nickname (AddEditPage* self);
const gchar* add_edit_page_get_email_address (AddEditPage* self);
const gchar* add_edit_page_get_imap_host (AddEditPage* self);
guint16 add_edit_page_get_imap_port (AddEditPage* self);
const gchar* add_edit_page_get_imap_username (AddEditPage* self);
const gchar* add_edit_page_get_imap_password (AddEditPage* self);
const gchar* add_edit_page_get_smtp_host (AddEditPage* self);
guint16 add_edit_page_get_smtp_port (AddEditPage* self);
const gchar* add_edit_page_get_smtp_username (AddEditPage* self);
const gchar* add_edit_page_get_smtp_password (AddEditPage* self);
const gchar* add_edit_page_get_password (AddEditPage* self);
GearyAccountInformation* add_edit_page_get_account_information (AddEditPage* self);
static void add_edit_page_fix_credentials_for_supported_provider (AddEditPage* self);
gboolean add_edit_page_get_smtp_use_imap_credentials (AddEditPage* self);
const gchar* add_edit_page_get_real_name (AddEditPage* self);
gboolean add_edit_page_get_remember_password (AddEditPage* self);
gboolean add_edit_page_get_save_sent_mail (AddEditPage* self);
gboolean add_edit_page_get_imap_ssl (AddEditPage* self);
gboolean add_edit_page_get_imap_starttls (AddEditPage* self);
gboolean add_edit_page_get_smtp_ssl (AddEditPage* self);
gboolean add_edit_page_get_smtp_starttls (AddEditPage* self);
gboolean add_edit_page_get_smtp_noauth (AddEditPage* self);
static gint add_edit_page_get_storage_length (AddEditPage* self);
gboolean add_edit_page_get_save_drafts (AddEditPage* self);
gboolean add_edit_page_get_use_email_signature (AddEditPage* self);
void add_edit_page_set_other_info_sensitive (AddEditPage* self, gboolean sensitive);
static void add_edit_page_real_show_all (GtkWidget* base);
static void add_edit_page_finalize (GObject* obj);
static void _vala_add_edit_page_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_add_edit_page_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType add_edit_page_page_mode_get_type (void) {
	static volatile gsize add_edit_page_page_mode_type_id__volatile = 0;
	if (g_once_init_enter (&add_edit_page_page_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{ADD_EDIT_PAGE_PAGE_MODE_WELCOME, "ADD_EDIT_PAGE_PAGE_MODE_WELCOME", "welcome"}, {ADD_EDIT_PAGE_PAGE_MODE_ADD, "ADD_EDIT_PAGE_PAGE_MODE_ADD", "add"}, {ADD_EDIT_PAGE_PAGE_MODE_EDIT, "ADD_EDIT_PAGE_PAGE_MODE_EDIT", "edit"}, {0, NULL, NULL}};
		GType add_edit_page_page_mode_type_id;
		add_edit_page_page_mode_type_id = g_enum_register_static ("AddEditPagePageMode", values);
		g_once_init_leave (&add_edit_page_page_mode_type_id__volatile, add_edit_page_page_mode_type_id);
	}
	return add_edit_page_page_mode_type_id__volatile;
}


static GType add_edit_page_encryption_get_type (void) {
	static volatile gsize add_edit_page_encryption_type_id__volatile = 0;
	if (g_once_init_enter (&add_edit_page_encryption_type_id__volatile)) {
		static const GEnumValue values[] = {{ADD_EDIT_PAGE_ENCRYPTION_NONE, "ADD_EDIT_PAGE_ENCRYPTION_NONE", "none"}, {ADD_EDIT_PAGE_ENCRYPTION_SSL, "ADD_EDIT_PAGE_ENCRYPTION_SSL", "ssl"}, {ADD_EDIT_PAGE_ENCRYPTION_STARTTLS, "ADD_EDIT_PAGE_ENCRYPTION_STARTTLS", "starttls"}, {0, NULL, NULL}};
		GType add_edit_page_encryption_type_id;
		add_edit_page_encryption_type_id = g_enum_register_static ("AddEditPageEncryption", values);
		g_once_init_leave (&add_edit_page_encryption_type_id__volatile, add_edit_page_encryption_type_id);
	}
	return add_edit_page_encryption_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
#line 227 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return self ? g_object_ref (self) : NULL;
#line 294 "add-edit-page.c"
}


static gboolean _add_edit_page_combo_storage_separator_delegate_gtk_tree_view_row_separator_func (GtkTreeModel* model, GtkTreeIter* iter, gpointer self) {
	gboolean result;
	result = add_edit_page_combo_storage_separator_delegate ((AddEditPage*) self, model, iter);
#line 252 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 303 "add-edit-page.c"
}


static void _add_edit_page_update_ui_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self) {
#line 316 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_update_ui ((AddEditPage*) self);
#line 310 "add-edit-page.c"
}


static void _add_edit_page_on_changed_gtk_editable_changed (GtkEditable* _sender, gpointer self) {
#line 317 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_on_changed ((AddEditPage*) self);
#line 317 "add-edit-page.c"
}


static void _add_edit_page_on_changed_gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
#line 321 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_on_changed ((AddEditPage*) self);
#line 324 "add-edit-page.c"
}


static void _add_edit_page_on_changed_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self) {
#line 323 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_on_changed ((AddEditPage*) self);
#line 331 "add-edit-page.c"
}


static void _add_edit_page_on_alternate_email_button_clicked_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 335 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_on_alternate_email_button_clicked ((AddEditPage*) self);
#line 338 "add-edit-page.c"
}


static void _add_edit_page_on_email_changed_gtk_editable_changed (GtkEditable* _sender, gpointer self) {
#line 337 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_on_email_changed ((AddEditPage*) self);
#line 345 "add-edit-page.c"
}


static void _add_edit_page_on_password_changed_gtk_editable_changed (GtkEditable* _sender, gpointer self) {
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_on_password_changed ((AddEditPage*) self);
#line 352 "add-edit-page.c"
}


static void _add_edit_page_on_imap_encryption_changed_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self) {
#line 340 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_on_imap_encryption_changed ((AddEditPage*) self);
#line 359 "add-edit-page.c"
}


static void _add_edit_page_on_smtp_encryption_changed_gtk_combo_box_changed (GtkComboBox* _sender, gpointer self) {
#line 341 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_on_smtp_encryption_changed ((AddEditPage*) self);
#line 366 "add-edit-page.c"
}


static void __lambda57_ (AddEditPage* self) {
#line 343 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_on_smtp_auth_changed (self, TRUE);
#line 373 "add-edit-page.c"
}


static void ___lambda57__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
#line 343 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	__lambda57_ ((AddEditPage*) self);
#line 380 "add-edit-page.c"
}


static void __lambda58_ (AddEditPage* self) {
#line 344 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_on_smtp_auth_changed (self, FALSE);
#line 387 "add-edit-page.c"
}


static void ___lambda58__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
#line 344 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	__lambda58_ ((AddEditPage*) self);
#line 394 "add-edit-page.c"
}


static void _add_edit_page_on_port_insert_text_gtk_editable_insert_text (GtkEditable* _sender, const gchar* new_text, gint new_text_length, gint* position, gpointer self) {
#line 346 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_on_port_insert_text ((AddEditPage*) self, _sender, new_text, new_text_length, position);
#line 401 "add-edit-page.c"
}


static void _add_edit_page_on_nickname_insert_text_gtk_editable_insert_text (GtkEditable* _sender, const gchar* new_text, gint new_text_length, gint* position, gpointer self) {
#line 349 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_on_nickname_insert_text ((AddEditPage*) self, _sender, new_text, new_text_length, position);
#line 408 "add-edit-page.c"
}


static void _add_edit_page_on_signature_stack_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 352 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_on_signature_stack_changed ((AddEditPage*) self);
#line 415 "add-edit-page.c"
}


static void __lambda59_ (AddEditPage* self) {
#line 355 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->first_ui_update = TRUE;
#line 422 "add-edit-page.c"
}


static void ___lambda59__gtk_widget_map (GtkWidget* _sender, gpointer self) {
#line 355 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	__lambda59_ ((AddEditPage*) self);
#line 429 "add-edit-page.c"
}


AddEditPage* add_edit_page_construct (GType object_type) {
	AddEditPage * self = NULL;
	GtkBuilder* builder = NULL;
	GearyApplication* _tmp0_ = NULL;
	GearyApplication* _tmp1_ = NULL;
	GtkBuilder* _tmp2_ = NULL;
	GtkBuilder* _tmp3_ = NULL;
	GObject* _tmp4_ = NULL;
	GtkWidget* _tmp5_ = NULL;
	GtkWidget* _tmp6_ = NULL;
	GtkBuilder* _tmp7_ = NULL;
	GObject* _tmp8_ = NULL;
	GtkBox* _tmp9_ = NULL;
	GtkLabel* label_welcome = NULL;
	GtkBuilder* _tmp10_ = NULL;
	GObject* _tmp11_ = NULL;
	GtkLabel* _tmp12_ = NULL;
	GtkLabel* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	const gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	GtkBuilder* _tmp18_ = NULL;
	GObject* _tmp19_ = NULL;
	GtkEntry* _tmp20_ = NULL;
	GtkEntry* _tmp21_ = NULL;
	GtkBuilder* _tmp22_ = NULL;
	GObject* _tmp23_ = NULL;
	GtkLabel* _tmp24_ = NULL;
	GtkBuilder* _tmp25_ = NULL;
	GObject* _tmp26_ = NULL;
	GtkEntry* _tmp27_ = NULL;
	GtkBuilder* _tmp28_ = NULL;
	GObject* _tmp29_ = NULL;
	GtkComboBoxText* _tmp30_ = NULL;
	GtkBuilder* _tmp31_ = NULL;
	GObject* _tmp32_ = NULL;
	GtkEntry* _tmp33_ = NULL;
	GtkBuilder* _tmp34_ = NULL;
	GObject* _tmp35_ = NULL;
	GtkLabel* _tmp36_ = NULL;
	GtkBuilder* _tmp37_ = NULL;
	GObject* _tmp38_ = NULL;
	GtkEntry* _tmp39_ = NULL;
	GtkBuilder* _tmp40_ = NULL;
	GObject* _tmp41_ = NULL;
	GtkCheckButton* _tmp42_ = NULL;
	GtkBuilder* _tmp43_ = NULL;
	GObject* _tmp44_ = NULL;
	GtkCheckButton* _tmp45_ = NULL;
	GtkBuilder* _tmp46_ = NULL;
	GObject* _tmp47_ = NULL;
	GtkButton* _tmp48_ = NULL;
	GtkBuilder* _tmp49_ = NULL;
	GObject* _tmp50_ = NULL;
	GtkLabel* _tmp51_ = NULL;
	GtkBuilder* _tmp52_ = NULL;
	GObject* _tmp53_ = NULL;
	GtkAlignment* _tmp54_ = NULL;
	GtkBuilder* _tmp55_ = NULL;
	GObject* _tmp56_ = NULL;
	GtkBox* _tmp57_ = NULL;
	GtkBuilder* _tmp58_ = NULL;
	GObject* _tmp59_ = NULL;
	GtkComboBoxText* _tmp60_ = NULL;
	GtkComboBoxText* _tmp61_ = NULL;
	GtkComboBoxText* _tmp62_ = NULL;
	const gchar* _tmp63_ = NULL;
	GtkComboBoxText* _tmp64_ = NULL;
	const gchar* _tmp65_ = NULL;
	GtkComboBoxText* _tmp66_ = NULL;
	const gchar* _tmp67_ = NULL;
	GtkComboBoxText* _tmp68_ = NULL;
	const gchar* _tmp69_ = NULL;
	GtkComboBoxText* _tmp70_ = NULL;
	const gchar* _tmp71_ = NULL;
	GtkComboBoxText* _tmp72_ = NULL;
	const gchar* _tmp73_ = NULL;
	GtkComboBoxText* _tmp74_ = NULL;
	const gchar* _tmp75_ = NULL;
	GtkComboBoxText* _tmp76_ = NULL;
	GtkComboBoxText* _tmp77_ = NULL;
	const gchar* _tmp78_ = NULL;
	GtkBuilder* _tmp79_ = NULL;
	GObject* _tmp80_ = NULL;
	GtkBox* _tmp81_ = NULL;
	GtkBuilder* _tmp82_ = NULL;
	GObject* _tmp83_ = NULL;
	GtkCheckButton* _tmp84_ = NULL;
	GtkScrolledWindow* edit_window = NULL;
	GtkScrolledWindow* _tmp85_ = NULL;
	GtkScrolledWindow* _tmp86_ = NULL;
	GtkScrolledWindow* _tmp87_ = NULL;
	GtkTextView* _tmp88_ = NULL;
	GtkScrolledWindow* _tmp89_ = NULL;
	GtkTextView* _tmp90_ = NULL;
	GtkScrolledWindow* preview_window = NULL;
	GtkScrolledWindow* _tmp91_ = NULL;
	GtkScrolledWindow* _tmp92_ = NULL;
	GtkScrolledWindow* _tmp93_ = NULL;
	StylishWebView* _tmp94_ = NULL;
	GtkScrolledWindow* _tmp95_ = NULL;
	StylishWebView* _tmp96_ = NULL;
	GtkStack* _tmp97_ = NULL;
	GtkStack* _tmp98_ = NULL;
	GtkScrolledWindow* _tmp99_ = NULL;
	const gchar* _tmp100_ = NULL;
	GtkStack* _tmp101_ = NULL;
	GtkScrolledWindow* _tmp102_ = NULL;
	GValue _tmp103_ = {0};
	GtkStack* _tmp104_ = NULL;
	GtkScrolledWindow* _tmp105_ = NULL;
	const gchar* _tmp106_ = NULL;
	GtkStack* _tmp107_ = NULL;
	GtkScrolledWindow* _tmp108_ = NULL;
	GValue _tmp109_ = {0};
	GtkStackSwitcher* switcher = NULL;
	GtkStackSwitcher* _tmp110_ = NULL;
	GtkStackSwitcher* _tmp111_ = NULL;
	GtkStack* _tmp112_ = NULL;
	GtkBox* signature_box = NULL;
	GtkBuilder* _tmp113_ = NULL;
	GObject* _tmp114_ = NULL;
	GtkBox* _tmp115_ = NULL;
	GtkBox* _tmp116_ = NULL;
	GtkBox* _tmp117_ = NULL;
	GtkStack* _tmp118_ = NULL;
	GtkStackSwitcher* _tmp119_ = NULL;
	GtkBox* _tmp120_ = NULL;
	GtkStackSwitcher* _tmp121_ = NULL;
	GtkBuilder* _tmp122_ = NULL;
	GObject* _tmp123_ = NULL;
	GtkEntry* _tmp124_ = NULL;
	GtkBuilder* _tmp125_ = NULL;
	GObject* _tmp126_ = NULL;
	GtkEntry* _tmp127_ = NULL;
	GtkBuilder* _tmp128_ = NULL;
	GObject* _tmp129_ = NULL;
	GtkEntry* _tmp130_ = NULL;
	GtkBuilder* _tmp131_ = NULL;
	GObject* _tmp132_ = NULL;
	GtkEntry* _tmp133_ = NULL;
	GtkBuilder* _tmp134_ = NULL;
	GObject* _tmp135_ = NULL;
	GtkComboBox* _tmp136_ = NULL;
	GtkBuilder* _tmp137_ = NULL;
	GObject* _tmp138_ = NULL;
	GtkEntry* _tmp139_ = NULL;
	GtkBuilder* _tmp140_ = NULL;
	GObject* _tmp141_ = NULL;
	GtkEntry* _tmp142_ = NULL;
	GtkBuilder* _tmp143_ = NULL;
	GObject* _tmp144_ = NULL;
	GtkEntry* _tmp145_ = NULL;
	GtkBuilder* _tmp146_ = NULL;
	GObject* _tmp147_ = NULL;
	GtkEntry* _tmp148_ = NULL;
	GtkBuilder* _tmp149_ = NULL;
	GObject* _tmp150_ = NULL;
	GtkComboBox* _tmp151_ = NULL;
	GtkBuilder* _tmp152_ = NULL;
	GObject* _tmp153_ = NULL;
	GtkCheckButton* _tmp154_ = NULL;
	GtkBuilder* _tmp155_ = NULL;
	GObject* _tmp156_ = NULL;
	GtkCheckButton* _tmp157_ = NULL;
	GtkBuilder* _tmp158_ = NULL;
	GObject* _tmp159_ = NULL;
	GtkCheckButton* _tmp160_ = NULL;
	gint _tmp161_ = 0;
	GearyServiceProvider* _tmp162_ = NULL;
	GtkComboBoxText* _tmp167_ = NULL;
	GtkEntry* _tmp168_ = NULL;
	GtkEntry* _tmp169_ = NULL;
	GtkEntry* _tmp170_ = NULL;
	GtkEntry* _tmp171_ = NULL;
	GtkCheckButton* _tmp172_ = NULL;
	GtkCheckButton* _tmp173_ = NULL;
	GtkComboBoxText* _tmp174_ = NULL;
	GtkEntry* _tmp175_ = NULL;
	GtkEntry* _tmp176_ = NULL;
	GtkEntry* _tmp177_ = NULL;
	GtkEntry* _tmp178_ = NULL;
	GtkEntry* _tmp179_ = NULL;
	GtkEntry* _tmp180_ = NULL;
	GtkEntry* _tmp181_ = NULL;
	GtkEntry* _tmp182_ = NULL;
	GtkCheckButton* _tmp183_ = NULL;
	GtkCheckButton* _tmp184_ = NULL;
	GtkCheckButton* _tmp185_ = NULL;
	GtkButton* _tmp186_ = NULL;
	GtkEntry* _tmp187_ = NULL;
	GtkEntry* _tmp188_ = NULL;
	GtkComboBox* _tmp189_ = NULL;
	GtkComboBox* _tmp190_ = NULL;
	GtkCheckButton* _tmp191_ = NULL;
	GtkCheckButton* _tmp192_ = NULL;
	GtkEntry* _tmp193_ = NULL;
	GtkEntry* _tmp194_ = NULL;
	GtkEntry* _tmp195_ = NULL;
	GtkCheckButton* _tmp196_ = NULL;
	GtkBox* _tmp197_ = NULL;
	GtkStack* _tmp198_ = NULL;
#line 222 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self = (AddEditPage*) g_object_new (object_type, "orientation", GTK_ORIENTATION_VERTICAL, "spacing", 4, NULL);
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = geary_application_get_instance ();
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = _tmp0_;
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = geary_application_create_builder (_tmp1_, "login.glade");
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	builder = _tmp2_;
#line 227 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp3_ = builder;
#line 227 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp4_ = gtk_builder_get_object (_tmp3_, "container");
#line 227 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget));
#line 227 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->container_widget);
#line 227 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->container_widget = _tmp5_;
#line 228 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp6_ = self->priv->container_widget;
#line 228 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_box_pack_start (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_box_get_type (), GtkBox), _tmp6_, TRUE, TRUE, (guint) 0);
#line 230 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp7_ = builder;
#line 230 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp8_ = gtk_builder_get_object (_tmp7_, "welcome_box");
#line 230 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_box_get_type (), GtkBox));
#line 230 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->welcome_box);
#line 230 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->welcome_box = _tmp9_;
#line 231 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp10_ = builder;
#line 231 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp11_ = gtk_builder_get_object (_tmp10_, "label-welcome");
#line 231 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_label_get_type (), GtkLabel));
#line 231 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	label_welcome = _tmp12_;
#line 232 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp13_ = label_welcome;
#line 232 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp14_ = _ ("Welcome to Geary.");
#line 232 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp15_ = _ ("Enter your account information to get started.");
#line 232 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp16_ = g_strdup_printf ("<span size=\"large\"><b>%s</b></span>\n%s", _tmp14_, _tmp15_);
#line 232 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp17_ = _tmp16_;
#line 232 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_label_set_markup (_tmp13_, _tmp17_);
#line 232 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_free0 (_tmp17_);
#line 235 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp18_ = builder;
#line 235 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp19_ = gtk_builder_get_object (_tmp18_, "entry: real_name");
#line 235 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp20_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_entry_get_type (), GtkEntry));
#line 235 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_real_name);
#line 235 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->entry_real_name = _tmp20_;
#line 236 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp21_ = self->priv->entry_real_name;
#line 236 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_entry_set_placeholder_text (_tmp21_, ADD_EDIT_PAGE_REAL_NAME_PLACEHOLDER);
#line 237 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp22_ = builder;
#line 237 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp23_ = gtk_builder_get_object (_tmp22_, "label: nickname");
#line 237 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp24_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, gtk_label_get_type (), GtkLabel));
#line 237 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->label_nickname);
#line 237 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->label_nickname = _tmp24_;
#line 238 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp25_ = builder;
#line 238 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp26_ = gtk_builder_get_object (_tmp25_, "entry: nickname");
#line 238 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp27_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, gtk_entry_get_type (), GtkEntry));
#line 238 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_nickname);
#line 238 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->entry_nickname = _tmp27_;
#line 239 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp28_ = builder;
#line 239 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp29_ = gtk_builder_get_object (_tmp28_, "combo: service");
#line 239 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp30_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, gtk_combo_box_text_get_type (), GtkComboBoxText));
#line 239 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->combo_service);
#line 239 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->combo_service = _tmp30_;
#line 240 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp31_ = builder;
#line 240 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp32_ = gtk_builder_get_object (_tmp31_, "entry: email");
#line 240 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp33_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, gtk_entry_get_type (), GtkEntry));
#line 240 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_email);
#line 240 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->entry_email = _tmp33_;
#line 241 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp34_ = builder;
#line 241 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp35_ = gtk_builder_get_object (_tmp34_, "label: password");
#line 241 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp36_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, gtk_label_get_type (), GtkLabel));
#line 241 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->label_password);
#line 241 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->label_password = _tmp36_;
#line 242 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp37_ = builder;
#line 242 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp38_ = gtk_builder_get_object (_tmp37_, "entry: password");
#line 242 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp39_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, gtk_entry_get_type (), GtkEntry));
#line 242 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_password);
#line 242 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->entry_password = _tmp39_;
#line 243 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp40_ = builder;
#line 243 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp41_ = gtk_builder_get_object (_tmp40_, "check: remember_password");
#line 243 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp42_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, gtk_check_button_get_type (), GtkCheckButton));
#line 243 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->check_remember_password);
#line 243 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->check_remember_password = _tmp42_;
#line 244 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp43_ = builder;
#line 244 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp44_ = gtk_builder_get_object (_tmp43_, "check: save_sent_mail");
#line 244 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp45_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, gtk_check_button_get_type (), GtkCheckButton));
#line 244 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->check_save_sent_mail);
#line 244 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->check_save_sent_mail = _tmp45_;
#line 245 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp46_ = builder;
#line 245 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp47_ = gtk_builder_get_object (_tmp46_, "button: edit_alternate_email");
#line 245 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp48_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, gtk_button_get_type (), GtkButton));
#line 245 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->alternate_email_button);
#line 245 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->alternate_email_button = _tmp48_;
#line 246 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp49_ = builder;
#line 246 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp50_ = gtk_builder_get_object (_tmp49_, "label: error");
#line 246 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp51_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, gtk_label_get_type (), GtkLabel));
#line 246 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->label_error);
#line 246 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->label_error = _tmp51_;
#line 247 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp52_ = builder;
#line 247 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp53_ = gtk_builder_get_object (_tmp52_, "container: other_info");
#line 247 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp54_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, gtk_alignment_get_type (), GtkAlignment));
#line 247 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->other_info);
#line 247 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->other_info = _tmp54_;
#line 250 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp55_ = builder;
#line 250 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp56_ = gtk_builder_get_object (_tmp55_, "storage container");
#line 250 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp57_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, gtk_box_get_type (), GtkBox));
#line 250 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->storage_container);
#line 250 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->storage_container = _tmp57_;
#line 251 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp58_ = builder;
#line 251 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp59_ = gtk_builder_get_object (_tmp58_, "combo: storage");
#line 251 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp60_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, gtk_combo_box_text_get_type (), GtkComboBoxText));
#line 251 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->combo_storage_length);
#line 251 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->combo_storage_length = _tmp60_;
#line 252 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp61_ = self->priv->combo_storage_length;
#line 252 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_combo_box_set_row_separator_func (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, gtk_combo_box_get_type (), GtkComboBox), _add_edit_page_combo_storage_separator_delegate_gtk_tree_view_row_separator_func, g_object_ref (self), g_object_unref);
#line 253 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp62_ = self->priv->combo_storage_length;
#line 253 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp63_ = _ ("2 weeks back");
#line 253 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_combo_box_text_append (_tmp62_, "14", _tmp63_);
#line 254 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp64_ = self->priv->combo_storage_length;
#line 254 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp65_ = _ ("1 month back");
#line 254 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_combo_box_text_append (_tmp64_, "30", _tmp65_);
#line 255 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp66_ = self->priv->combo_storage_length;
#line 255 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp67_ = _ ("3 months back");
#line 255 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_combo_box_text_append (_tmp66_, "90", _tmp67_);
#line 256 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp68_ = self->priv->combo_storage_length;
#line 256 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp69_ = _ ("6 months back");
#line 256 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_combo_box_text_append (_tmp68_, "180", _tmp69_);
#line 257 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp70_ = self->priv->combo_storage_length;
#line 257 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp71_ = _ ("1 year back");
#line 257 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_combo_box_text_append (_tmp70_, "365", _tmp71_);
#line 258 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp72_ = self->priv->combo_storage_length;
#line 258 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp73_ = _ ("2 years back");
#line 258 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_combo_box_text_append (_tmp72_, "730", _tmp73_);
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp74_ = self->priv->combo_storage_length;
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp75_ = _ ("4 years back");
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_combo_box_text_append (_tmp74_, "1461", _tmp75_);
#line 260 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp76_ = self->priv->combo_storage_length;
#line 260 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_combo_box_text_append (_tmp76_, ".", ".");
#line 261 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp77_ = self->priv->combo_storage_length;
#line 261 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp78_ = _ ("Everything");
#line 261 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_combo_box_text_append (_tmp77_, "-1", _tmp78_);
#line 264 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp79_ = builder;
#line 264 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp80_ = gtk_builder_get_object (_tmp79_, "composer container");
#line 264 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp81_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp80_, gtk_box_get_type (), GtkBox));
#line 264 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->composer_container);
#line 264 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->composer_container = _tmp81_;
#line 265 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp82_ = builder;
#line 265 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp83_ = gtk_builder_get_object (_tmp82_, "check: use_email_signature");
#line 265 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp84_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp83_, gtk_check_button_get_type (), GtkCheckButton));
#line 265 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->check_use_email_signature);
#line 265 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->check_use_email_signature = _tmp84_;
#line 267 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp85_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 267 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_ref_sink (_tmp85_);
#line 267 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	edit_window = _tmp85_;
#line 268 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp86_ = edit_window;
#line 268 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_scrolled_window_set_policy (_tmp86_, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 269 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp87_ = edit_window;
#line 269 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_scrolled_window_set_shadow_type (_tmp87_, GTK_SHADOW_IN);
#line 270 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp88_ = (GtkTextView*) gtk_text_view_new ();
#line 270 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_ref_sink (_tmp88_);
#line 270 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->textview_email_signature);
#line 270 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->textview_email_signature = _tmp88_;
#line 271 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp89_ = edit_window;
#line 271 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp90_ = self->priv->textview_email_signature;
#line 271 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp89_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp90_, gtk_widget_get_type (), GtkWidget));
#line 273 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp91_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 273 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_ref_sink (_tmp91_);
#line 273 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	preview_window = _tmp91_;
#line 274 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp92_ = preview_window;
#line 274 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_scrolled_window_set_policy (_tmp92_, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 275 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp93_ = preview_window;
#line 275 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_scrolled_window_set_shadow_type (_tmp93_, GTK_SHADOW_IN);
#line 276 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp94_ = stylish_web_view_new ();
#line 276 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_ref_sink (_tmp94_);
#line 276 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->preview_webview);
#line 276 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->preview_webview = _tmp94_;
#line 277 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp95_ = preview_window;
#line 277 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp96_ = self->priv->preview_webview;
#line 277 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp95_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp96_, gtk_widget_get_type (), GtkWidget));
#line 279 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp97_ = (GtkStack*) gtk_stack_new ();
#line 279 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_ref_sink (_tmp97_);
#line 279 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->signature_stack);
#line 279 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->signature_stack = _tmp97_;
#line 280 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp98_ = self->priv->signature_stack;
#line 280 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp99_ = edit_window;
#line 280 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp100_ = _ ("Edit");
#line 280 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_stack_add_titled (_tmp98_, G_TYPE_CHECK_INSTANCE_CAST (_tmp99_, gtk_widget_get_type (), GtkWidget), "edit_window", _tmp100_);
#line 281 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp101_ = self->priv->signature_stack;
#line 281 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp102_ = edit_window;
#line 281 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_value_init (&_tmp103_, G_TYPE_STRING);
#line 281 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_value_set_string (&_tmp103_, "text-editor-symbolic");
#line 281 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_container_child_set_property (G_TYPE_CHECK_INSTANCE_CAST (_tmp101_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp102_, gtk_widget_get_type (), GtkWidget), "icon-name", &_tmp103_);
#line 281 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	G_IS_VALUE (&_tmp103_) ? (g_value_unset (&_tmp103_), NULL) : NULL;
#line 282 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp104_ = self->priv->signature_stack;
#line 282 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp105_ = preview_window;
#line 282 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp106_ = _ ("Preview");
#line 282 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_stack_add_titled (_tmp104_, G_TYPE_CHECK_INSTANCE_CAST (_tmp105_, gtk_widget_get_type (), GtkWidget), "preview_window", _tmp106_);
#line 283 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp107_ = self->priv->signature_stack;
#line 283 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp108_ = preview_window;
#line 283 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_value_init (&_tmp109_, G_TYPE_STRING);
#line 283 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_value_set_string (&_tmp109_, "text-x-generic-symbolic");
#line 283 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_container_child_set_property (G_TYPE_CHECK_INSTANCE_CAST (_tmp107_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp108_, gtk_widget_get_type (), GtkWidget), "icon-name", &_tmp109_);
#line 283 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	G_IS_VALUE (&_tmp109_) ? (g_value_unset (&_tmp109_), NULL) : NULL;
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp110_ = (GtkStackSwitcher*) gtk_stack_switcher_new ();
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_ref_sink (_tmp110_);
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	switcher = _tmp110_;
#line 285 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp111_ = switcher;
#line 285 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp112_ = self->priv->signature_stack;
#line 285 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_stack_switcher_set_stack (_tmp111_, _tmp112_);
#line 287 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp113_ = builder;
#line 287 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp114_ = gtk_builder_get_object (_tmp113_, "signature box");
#line 287 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp115_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp114_, gtk_box_get_type (), GtkBox));
#line 287 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	signature_box = _tmp115_;
#line 288 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp116_ = signature_box;
#line 288 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_box_set_spacing (_tmp116_, 4);
#line 289 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp117_ = signature_box;
#line 289 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp118_ = self->priv->signature_stack;
#line 289 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_box_pack_start (_tmp117_, G_TYPE_CHECK_INSTANCE_CAST (_tmp118_, gtk_widget_get_type (), GtkWidget), TRUE, TRUE, (guint) 0);
#line 290 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp119_ = switcher;
#line 290 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_valign (G_TYPE_CHECK_INSTANCE_CAST (_tmp119_, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_START);
#line 291 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp120_ = signature_box;
#line 291 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp121_ = switcher;
#line 291 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_box_pack_start (_tmp120_, G_TYPE_CHECK_INSTANCE_CAST (_tmp121_, gtk_widget_get_type (), GtkWidget), FALSE, FALSE, (guint) 0);
#line 294 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp122_ = builder;
#line 294 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp123_ = gtk_builder_get_object (_tmp122_, "entry: imap host");
#line 294 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp124_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp123_, gtk_entry_get_type (), GtkEntry));
#line 294 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_imap_host);
#line 294 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->entry_imap_host = _tmp124_;
#line 295 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp125_ = builder;
#line 295 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp126_ = gtk_builder_get_object (_tmp125_, "entry: imap port");
#line 295 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp127_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp126_, gtk_entry_get_type (), GtkEntry));
#line 295 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_imap_port);
#line 295 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->entry_imap_port = _tmp127_;
#line 296 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp128_ = builder;
#line 296 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp129_ = gtk_builder_get_object (_tmp128_, "entry: imap username");
#line 296 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp130_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp129_, gtk_entry_get_type (), GtkEntry));
#line 296 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_imap_username);
#line 296 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->entry_imap_username = _tmp130_;
#line 297 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp131_ = builder;
#line 297 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp132_ = gtk_builder_get_object (_tmp131_, "entry: imap password");
#line 297 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp133_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp132_, gtk_entry_get_type (), GtkEntry));
#line 297 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_imap_password);
#line 297 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->entry_imap_password = _tmp133_;
#line 298 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp134_ = builder;
#line 298 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp135_ = gtk_builder_get_object (_tmp134_, "combo: imap encryption");
#line 298 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp136_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp135_, gtk_combo_box_get_type (), GtkComboBox));
#line 298 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->combo_imap_encryption);
#line 298 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->combo_imap_encryption = _tmp136_;
#line 301 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp137_ = builder;
#line 301 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp138_ = gtk_builder_get_object (_tmp137_, "entry: smtp host");
#line 301 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp139_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp138_, gtk_entry_get_type (), GtkEntry));
#line 301 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_smtp_host);
#line 301 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->entry_smtp_host = _tmp139_;
#line 302 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp140_ = builder;
#line 302 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp141_ = gtk_builder_get_object (_tmp140_, "entry: smtp port");
#line 302 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp142_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp141_, gtk_entry_get_type (), GtkEntry));
#line 302 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_smtp_port);
#line 302 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->entry_smtp_port = _tmp142_;
#line 303 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp143_ = builder;
#line 303 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp144_ = gtk_builder_get_object (_tmp143_, "entry: smtp username");
#line 303 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp145_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp144_, gtk_entry_get_type (), GtkEntry));
#line 303 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_smtp_username);
#line 303 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->entry_smtp_username = _tmp145_;
#line 304 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp146_ = builder;
#line 304 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp147_ = gtk_builder_get_object (_tmp146_, "entry: smtp password");
#line 304 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp148_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp147_, gtk_entry_get_type (), GtkEntry));
#line 304 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_smtp_password);
#line 304 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->entry_smtp_password = _tmp148_;
#line 305 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp149_ = builder;
#line 305 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp150_ = gtk_builder_get_object (_tmp149_, "combo: smtp encryption");
#line 305 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp151_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp150_, gtk_combo_box_get_type (), GtkComboBox));
#line 305 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->combo_smtp_encryption);
#line 305 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->combo_smtp_encryption = _tmp151_;
#line 306 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp152_ = builder;
#line 306 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp153_ = gtk_builder_get_object (_tmp152_, "check: use imap credentials");
#line 306 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp154_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp153_, gtk_check_button_get_type (), GtkCheckButton));
#line 306 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->check_smtp_use_imap_credentials);
#line 306 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->check_smtp_use_imap_credentials = _tmp154_;
#line 307 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp155_ = builder;
#line 307 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp156_ = gtk_builder_get_object (_tmp155_, "check: smtp no authentication");
#line 307 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp157_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp156_, gtk_check_button_get_type (), GtkCheckButton));
#line 307 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->check_smtp_noauth);
#line 307 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->check_smtp_noauth = _tmp157_;
#line 308 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp158_ = builder;
#line 308 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp159_ = gtk_builder_get_object (_tmp158_, "check: save_drafts");
#line 308 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp160_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp159_, gtk_check_button_get_type (), GtkCheckButton));
#line 308 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->check_save_drafts);
#line 308 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->check_save_drafts = _tmp160_;
#line 311 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp162_ = geary_service_provider_get_providers (&_tmp161_);
#line 1188 "add-edit-page.c"
	{
		GearyServiceProvider* p_collection = NULL;
		gint p_collection_length1 = 0;
		gint _p_collection_size_ = 0;
		gint p_it = 0;
#line 311 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		p_collection = _tmp162_;
#line 311 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		p_collection_length1 = _tmp161_;
#line 311 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		for (p_it = 0; p_it < _tmp161_; p_it = p_it + 1) {
#line 1200 "add-edit-page.c"
			GearyServiceProvider p = 0;
#line 311 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			p = p_collection[p_it];
#line 1204 "add-edit-page.c"
			{
				GtkComboBoxText* _tmp163_ = NULL;
				GearyServiceProvider _tmp164_ = 0;
				gchar* _tmp165_ = NULL;
				gchar* _tmp166_ = NULL;
#line 312 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp163_ = self->priv->combo_service;
#line 312 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp164_ = p;
#line 312 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp165_ = geary_service_provider_display_name (_tmp164_);
#line 312 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp166_ = _tmp165_;
#line 312 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				gtk_combo_box_text_append_text (_tmp163_, _tmp166_);
#line 312 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_g_free0 (_tmp166_);
#line 1222 "add-edit-page.c"
			}
		}
#line 311 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		p_collection = (g_free (p_collection), NULL);
#line 1227 "add-edit-page.c"
	}
#line 314 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_reset_all (self);
#line 316 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp167_ = self->priv->combo_service;
#line 316 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp167_, gtk_combo_box_get_type (), GtkComboBox), "changed", (GCallback) _add_edit_page_update_ui_gtk_combo_box_changed, self, 0);
#line 317 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp168_ = self->priv->entry_email;
#line 317 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp168_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _add_edit_page_on_changed_gtk_editable_changed, self, 0);
#line 318 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp169_ = self->priv->entry_password;
#line 318 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp169_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _add_edit_page_on_changed_gtk_editable_changed, self, 0);
#line 319 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp170_ = self->priv->entry_real_name;
#line 319 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp170_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _add_edit_page_on_changed_gtk_editable_changed, self, 0);
#line 320 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp171_ = self->priv->entry_nickname;
#line 320 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp171_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _add_edit_page_on_changed_gtk_editable_changed, self, 0);
#line 321 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp172_ = self->priv->check_remember_password;
#line 321 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp172_, gtk_toggle_button_get_type (), GtkToggleButton), "toggled", (GCallback) _add_edit_page_on_changed_gtk_toggle_button_toggled, self, 0);
#line 322 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp173_ = self->priv->check_save_sent_mail;
#line 322 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp173_, gtk_toggle_button_get_type (), GtkToggleButton), "toggled", (GCallback) _add_edit_page_on_changed_gtk_toggle_button_toggled, self, 0);
#line 323 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp174_ = self->priv->combo_service;
#line 323 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp174_, gtk_combo_box_get_type (), GtkComboBox), "changed", (GCallback) _add_edit_page_on_changed_gtk_combo_box_changed, self, 0);
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp175_ = self->priv->entry_imap_host;
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp175_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _add_edit_page_on_changed_gtk_editable_changed, self, 0);
#line 325 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp176_ = self->priv->entry_imap_port;
#line 325 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp176_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _add_edit_page_on_changed_gtk_editable_changed, self, 0);
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp177_ = self->priv->entry_imap_username;
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp177_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _add_edit_page_on_changed_gtk_editable_changed, self, 0);
#line 327 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp178_ = self->priv->entry_imap_password;
#line 327 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp178_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _add_edit_page_on_changed_gtk_editable_changed, self, 0);
#line 328 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp179_ = self->priv->entry_smtp_host;
#line 328 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp179_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _add_edit_page_on_changed_gtk_editable_changed, self, 0);
#line 329 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp180_ = self->priv->entry_smtp_port;
#line 329 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp180_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _add_edit_page_on_changed_gtk_editable_changed, self, 0);
#line 330 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp181_ = self->priv->entry_smtp_username;
#line 330 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp181_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _add_edit_page_on_changed_gtk_editable_changed, self, 0);
#line 331 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp182_ = self->priv->entry_smtp_password;
#line 331 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp182_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _add_edit_page_on_changed_gtk_editable_changed, self, 0);
#line 332 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp183_ = self->priv->check_smtp_use_imap_credentials;
#line 332 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp183_, gtk_toggle_button_get_type (), GtkToggleButton), "toggled", (GCallback) _add_edit_page_on_changed_gtk_toggle_button_toggled, self, 0);
#line 333 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp184_ = self->priv->check_smtp_noauth;
#line 333 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp184_, gtk_toggle_button_get_type (), GtkToggleButton), "toggled", (GCallback) _add_edit_page_on_changed_gtk_toggle_button_toggled, self, 0);
#line 334 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp185_ = self->priv->check_save_drafts;
#line 334 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp185_, gtk_toggle_button_get_type (), GtkToggleButton), "toggled", (GCallback) _add_edit_page_on_changed_gtk_toggle_button_toggled, self, 0);
#line 335 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp186_ = self->priv->alternate_email_button;
#line 335 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (_tmp186_, "clicked", (GCallback) _add_edit_page_on_alternate_email_button_clicked_gtk_button_clicked, self, 0);
#line 337 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp187_ = self->priv->entry_email;
#line 337 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp187_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _add_edit_page_on_email_changed_gtk_editable_changed, self, 0);
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp188_ = self->priv->entry_password;
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp188_, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _add_edit_page_on_password_changed_gtk_editable_changed, self, 0);
#line 340 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp189_ = self->priv->combo_imap_encryption;
#line 340 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (_tmp189_, "changed", (GCallback) _add_edit_page_on_imap_encryption_changed_gtk_combo_box_changed, self, 0);
#line 341 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp190_ = self->priv->combo_smtp_encryption;
#line 341 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (_tmp190_, "changed", (GCallback) _add_edit_page_on_smtp_encryption_changed_gtk_combo_box_changed, self, 0);
#line 343 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp191_ = self->priv->check_smtp_use_imap_credentials;
#line 343 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp191_, gtk_toggle_button_get_type (), GtkToggleButton), "toggled", (GCallback) ___lambda57__gtk_toggle_button_toggled, self, 0);
#line 344 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp192_ = self->priv->check_smtp_noauth;
#line 344 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp192_, gtk_toggle_button_get_type (), GtkToggleButton), "toggled", (GCallback) ___lambda58__gtk_toggle_button_toggled, self, 0);
#line 346 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp193_ = self->priv->entry_imap_port;
#line 346 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp193_, GTK_TYPE_EDITABLE, GtkEditable), "insert-text", (GCallback) _add_edit_page_on_port_insert_text_gtk_editable_insert_text, self, 0);
#line 347 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp194_ = self->priv->entry_smtp_port;
#line 347 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp194_, GTK_TYPE_EDITABLE, GtkEditable), "insert-text", (GCallback) _add_edit_page_on_port_insert_text_gtk_editable_insert_text, self, 0);
#line 349 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp195_ = self->priv->entry_nickname;
#line 349 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp195_, GTK_TYPE_EDITABLE, GtkEditable), "insert-text", (GCallback) _add_edit_page_on_nickname_insert_text_gtk_editable_insert_text, self, 0);
#line 351 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp196_ = self->priv->check_use_email_signature;
#line 351 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp197_ = signature_box;
#line 351 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_bind_property_with_closures (G_TYPE_CHECK_INSTANCE_CAST (_tmp196_, G_TYPE_OBJECT, GObject), "active", G_TYPE_CHECK_INSTANCE_CAST (_tmp197_, G_TYPE_OBJECT, GObject), "sensitive", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, NULL)));
#line 352 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp198_ = self->priv->signature_stack;
#line 352 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp198_, G_TYPE_OBJECT, GObject), "notify::visible-child-name", (GCallback) _add_edit_page_on_signature_stack_changed_g_object_notify, self, 0);
#line 355 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "map", (GCallback) ___lambda59__gtk_widget_map, self, 0);
#line 221 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (signature_box);
#line 221 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (switcher);
#line 221 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (preview_window);
#line 221 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (edit_window);
#line 221 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (label_welcome);
#line 221 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (builder);
#line 221 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return self;
#line 1373 "add-edit-page.c"
}


AddEditPage* add_edit_page_new (void) {
#line 221 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return add_edit_page_construct (TYPE_ADD_EDIT_PAGE);
#line 1380 "add-edit-page.c"
}


void add_edit_page_set_account_information (AddEditPage* self, GearyAccountInformation* info, GearyEngineValidationResult _result_) {
	gboolean _tmp0_ = FALSE;
	GearyAccountInformation* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp7_ = NULL;
	GearyAccountInformation* _tmp8_ = NULL;
	GearyCredentials* _tmp9_ = NULL;
	GearyCredentials* _tmp10_ = NULL;
	const gchar* _tmp16_ = NULL;
	GearyAccountInformation* _tmp17_ = NULL;
	GearyCredentials* _tmp18_ = NULL;
	GearyCredentials* _tmp19_ = NULL;
	GearyAccountInformation* _tmp25_ = NULL;
	const gchar* _tmp26_ = NULL;
	const gchar* _tmp27_ = NULL;
	GearyAccountInformation* _tmp28_ = NULL;
	const gchar* _tmp29_ = NULL;
	const gchar* _tmp30_ = NULL;
	GearyAccountInformation* _tmp31_ = NULL;
	const gchar* _tmp32_ = NULL;
	const gchar* _tmp33_ = NULL;
	GearyAccountInformation* _tmp34_ = NULL;
	GearyCredentials* _tmp35_ = NULL;
	GearyCredentials* _tmp36_ = NULL;
	const gchar* _tmp37_ = NULL;
	const gchar* _tmp38_ = NULL;
	GearyAccountInformation* _tmp39_ = NULL;
	GearyCredentials* _tmp40_ = NULL;
	GearyCredentials* _tmp41_ = NULL;
	const gchar* _tmp42_ = NULL;
	const gchar* _tmp43_ = NULL;
	GearyAccountInformation* _tmp44_ = NULL;
	GearyServiceProvider _tmp45_ = 0;
	GearyServiceProvider _tmp46_ = 0;
	GearyAccountInformation* _tmp47_ = NULL;
	gboolean _tmp48_ = FALSE;
	gboolean _tmp49_ = FALSE;
	GearyAccountInformation* _tmp50_ = NULL;
	gboolean _tmp51_ = FALSE;
	GearyAccountInformation* _tmp52_ = NULL;
	const gchar* _tmp53_ = NULL;
	const gchar* _tmp54_ = NULL;
	GearyAccountInformation* _tmp55_ = NULL;
	guint16 _tmp56_ = 0U;
	guint16 _tmp57_ = 0U;
	GearyAccountInformation* _tmp58_ = NULL;
	gboolean _tmp59_ = FALSE;
	gboolean _tmp60_ = FALSE;
	GearyAccountInformation* _tmp61_ = NULL;
	gboolean _tmp62_ = FALSE;
	gboolean _tmp63_ = FALSE;
	GearyAccountInformation* _tmp64_ = NULL;
	const gchar* _tmp65_ = NULL;
	const gchar* _tmp66_ = NULL;
	GearyAccountInformation* _tmp67_ = NULL;
	guint16 _tmp68_ = 0U;
	guint16 _tmp69_ = 0U;
	GearyAccountInformation* _tmp70_ = NULL;
	gboolean _tmp71_ = FALSE;
	gboolean _tmp72_ = FALSE;
	GearyAccountInformation* _tmp73_ = NULL;
	gboolean _tmp74_ = FALSE;
	gboolean _tmp75_ = FALSE;
	GearyAccountInformation* _tmp76_ = NULL;
	gboolean _tmp77_ = FALSE;
	gboolean _tmp78_ = FALSE;
	GearyAccountInformation* _tmp79_ = NULL;
	gboolean _tmp80_ = FALSE;
	gboolean _tmp81_ = FALSE;
	GearyAccountInformation* _tmp82_ = NULL;
	gint _tmp83_ = 0;
	gint _tmp84_ = 0;
	GearyAccountInformation* _tmp85_ = NULL;
	gboolean _tmp86_ = FALSE;
	gboolean _tmp87_ = FALSE;
	GearyAccountInformation* _tmp88_ = NULL;
	gboolean _tmp89_ = FALSE;
	gboolean _tmp90_ = FALSE;
	GearyAccountInformation* _tmp91_ = NULL;
	const gchar* _tmp92_ = NULL;
	const gchar* _tmp93_ = NULL;
	GearyEngineValidationResult _tmp94_ = 0;
#line 359 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 359 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (info));
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = info;
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = geary_account_information_get_imap_remember_password (_tmp1_);
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp3_ = _tmp2_;
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp3_) {
#line 1479 "add-edit-page.c"
		GearyAccountInformation* _tmp4_ = NULL;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp4_ = info;
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp5_ = geary_account_information_get_smtp_remember_password (_tmp4_);
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp6_ = _tmp5_;
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp0_ = _tmp6_;
#line 1491 "add-edit-page.c"
	} else {
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp0_ = FALSE;
#line 1495 "add-edit-page.c"
	}
#line 366 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp8_ = info;
#line 366 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp9_ = geary_account_information_get_smtp_credentials (_tmp8_);
#line 366 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp10_ = _tmp9_;
#line 366 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp10_ != NULL) {
#line 1505 "add-edit-page.c"
		GearyAccountInformation* _tmp11_ = NULL;
		GearyCredentials* _tmp12_ = NULL;
		GearyCredentials* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
#line 366 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp11_ = info;
#line 366 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp12_ = geary_account_information_get_smtp_credentials (_tmp11_);
#line 366 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp13_ = _tmp12_;
#line 366 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp14_ = geary_credentials_get_user (_tmp13_);
#line 366 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp15_ = _tmp14_;
#line 366 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp7_ = _tmp15_;
#line 1523 "add-edit-page.c"
	} else {
#line 366 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp7_ = NULL;
#line 1527 "add-edit-page.c"
	}
#line 367 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp17_ = info;
#line 367 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp18_ = geary_account_information_get_smtp_credentials (_tmp17_);
#line 367 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp19_ = _tmp18_;
#line 367 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp19_ != NULL) {
#line 1537 "add-edit-page.c"
		GearyAccountInformation* _tmp20_ = NULL;
		GearyCredentials* _tmp21_ = NULL;
		GearyCredentials* _tmp22_ = NULL;
		const gchar* _tmp23_ = NULL;
		const gchar* _tmp24_ = NULL;
#line 367 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp20_ = info;
#line 367 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp21_ = geary_account_information_get_smtp_credentials (_tmp20_);
#line 367 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp22_ = _tmp21_;
#line 367 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp23_ = geary_credentials_get_pass (_tmp22_);
#line 367 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp24_ = _tmp23_;
#line 367 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp16_ = _tmp24_;
#line 1555 "add-edit-page.c"
	} else {
#line 367 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp16_ = NULL;
#line 1559 "add-edit-page.c"
	}
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp25_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp26_ = geary_account_information_get_real_name (_tmp25_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp27_ = _tmp26_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp28_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp29_ = geary_account_information_get_nickname (_tmp28_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp30_ = _tmp29_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp31_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp32_ = geary_account_information_get_email (_tmp31_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp33_ = _tmp32_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp34_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp35_ = geary_account_information_get_imap_credentials (_tmp34_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp36_ = _tmp35_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp37_ = geary_credentials_get_user (_tmp36_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp38_ = _tmp37_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp39_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp40_ = geary_account_information_get_imap_credentials (_tmp39_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp41_ = _tmp40_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp42_ = geary_credentials_get_pass (_tmp41_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp43_ = _tmp42_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp44_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp45_ = geary_account_information_get_service_provider (_tmp44_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp46_ = _tmp45_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp47_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp48_ = geary_account_information_get_save_sent_mail (_tmp47_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp49_ = _tmp48_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp50_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp51_ = geary_account_information_allow_save_sent_mail (_tmp50_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp52_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp53_ = geary_account_information_get_default_imap_server_host (_tmp52_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp54_ = _tmp53_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp55_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp56_ = geary_account_information_get_default_imap_server_port (_tmp55_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp57_ = _tmp56_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp58_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp59_ = geary_account_information_get_default_imap_server_ssl (_tmp58_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp60_ = _tmp59_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp61_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp62_ = geary_account_information_get_default_imap_server_starttls (_tmp61_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp63_ = _tmp62_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp64_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp65_ = geary_account_information_get_default_smtp_server_host (_tmp64_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp66_ = _tmp65_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp67_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp68_ = geary_account_information_get_default_smtp_server_port (_tmp67_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp69_ = _tmp68_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp70_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp71_ = geary_account_information_get_default_smtp_server_ssl (_tmp70_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp72_ = _tmp71_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp73_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp74_ = geary_account_information_get_default_smtp_server_starttls (_tmp73_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp75_ = _tmp74_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp76_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp77_ = geary_account_information_get_default_smtp_use_imap_credentials (_tmp76_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp78_ = _tmp77_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp79_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp80_ = geary_account_information_get_default_smtp_server_noauth (_tmp79_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp81_ = _tmp80_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp82_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp83_ = geary_account_information_get_prefetch_period_days (_tmp82_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp84_ = _tmp83_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp85_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp86_ = geary_account_information_get_save_drafts (_tmp85_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp87_ = _tmp86_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp88_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp89_ = geary_account_information_get_use_email_signature (_tmp88_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp90_ = _tmp89_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp91_ = info;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp92_ = geary_account_information_get_email_signature (_tmp91_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp93_ = _tmp92_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp94_ = _result_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_all_info (self, _tmp27_, _tmp30_, _tmp33_, _tmp38_, _tmp43_, _tmp0_, _tmp7_, _tmp16_, (gint) _tmp46_, _tmp49_, _tmp51_, _tmp54_, _tmp57_, _tmp60_, _tmp63_, _tmp66_, _tmp69_, _tmp72_, _tmp75_, _tmp78_, _tmp81_, _tmp84_, _tmp87_, _tmp90_, _tmp93_, _tmp94_);
#line 1703 "add-edit-page.c"
}


void add_edit_page_set_all_info (AddEditPage* self, const gchar* initial_real_name, const gchar* initial_nickname, const gchar* initial_email, const gchar* initial_imap_username, const gchar* initial_imap_password, gboolean initial_remember_password, const gchar* initial_smtp_username, const gchar* initial_smtp_password, gint initial_service_provider, gboolean initial_save_sent_mail, gboolean allow_save_sent_mail, const gchar* initial_default_imap_host, guint16 initial_default_imap_port, gboolean initial_default_imap_ssl, gboolean initial_default_imap_starttls, const gchar* initial_default_smtp_host, guint16 initial_default_smtp_port, gboolean initial_default_smtp_ssl, gboolean initial_default_smtp_starttls, gboolean initial_default_smtp_use_imap_credentials, gboolean initial_default_smtp_noauth, gint prefetch_period_days, gboolean initial_save_drafts, gboolean initial_use_email_signature, const gchar* initial_email_signature, GearyEngineValidationResult _result_) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	GtkCheckButton* _tmp11_ = NULL;
	gboolean _tmp12_ = FALSE;
	gint _tmp13_ = 0;
	GtkComboBox* _tmp14_ = NULL;
	GtkComboBox* _tmp15_ = NULL;
	gboolean _tmp16_ = FALSE;
	const gchar* _tmp17_ = NULL;
	GtkStack* _tmp18_ = NULL;
	const gchar* _tmp19_ = NULL;
	const gchar* _tmp20_ = NULL;
	guint16 _tmp21_ = 0U;
	const gchar* _tmp22_ = NULL;
	const gchar* _tmp23_ = NULL;
	const gchar* _tmp24_ = NULL;
	const gchar* _tmp25_ = NULL;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	const gchar* _tmp28_ = NULL;
	const gchar* _tmp29_ = NULL;
	guint16 _tmp30_ = 0U;
	const gchar* _tmp31_ = NULL;
	const gchar* _tmp32_ = NULL;
	const gchar* _tmp33_ = NULL;
	const gchar* _tmp34_ = NULL;
	gboolean _tmp35_ = FALSE;
	gboolean _tmp36_ = FALSE;
	gboolean _tmp37_ = FALSE;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp39_ = FALSE;
	GearyEngineValidationResult _tmp40_ = 0;
	gint _tmp41_ = 0;
#line 389 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 418 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = initial_real_name;
#line 418 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = _tmp1_;
#line 418 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp0_ == NULL) {
#line 418 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp0_ = "";
#line 1759 "add-edit-page.c"
	}
#line 418 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_real_name (self, _tmp0_);
#line 419 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp3_ = initial_nickname;
#line 419 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp3_;
#line 419 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp2_ == NULL) {
#line 419 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp2_ = "";
#line 1771 "add-edit-page.c"
	}
#line 419 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_nickname (self, _tmp2_);
#line 420 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp5_ = initial_email;
#line 420 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp4_ = _tmp5_;
#line 420 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp4_ == NULL) {
#line 420 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp4_ = "";
#line 1783 "add-edit-page.c"
	}
#line 420 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_email_address (self, _tmp4_);
#line 421 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp7_ = initial_imap_password;
#line 421 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp7_ != NULL) {
#line 1791 "add-edit-page.c"
		const gchar* _tmp8_ = NULL;
#line 421 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp8_ = initial_imap_password;
#line 421 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp6_ = _tmp8_;
#line 1797 "add-edit-page.c"
	} else {
#line 421 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp6_ = "";
#line 1801 "add-edit-page.c"
	}
#line 421 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_password (self, _tmp6_);
#line 422 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp9_ = initial_remember_password;
#line 422 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_remember_password (self, _tmp9_);
#line 423 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp10_ = initial_save_sent_mail;
#line 423 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_save_sent_mail (self, _tmp10_);
#line 424 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp11_ = self->priv->check_save_sent_mail;
#line 424 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp12_ = allow_save_sent_mail;
#line 424 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_widget_get_type (), GtkWidget), _tmp12_);
#line 425 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp13_ = initial_service_provider;
#line 425 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_service_provider (self, (GearyServiceProvider) _tmp13_);
#line 426 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp14_ = self->priv->combo_imap_encryption;
#line 426 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_combo_box_set_active (_tmp14_, (gint) ADD_EDIT_PAGE_ENCRYPTION_NONE);
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp15_ = self->priv->combo_smtp_encryption;
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_combo_box_set_active (_tmp15_, (gint) ADD_EDIT_PAGE_ENCRYPTION_NONE);
#line 428 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp16_ = initial_use_email_signature;
#line 428 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_use_email_signature (self, _tmp16_);
#line 429 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp17_ = initial_email_signature;
#line 429 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_email_signature (self, _tmp17_);
#line 430 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp18_ = self->priv->signature_stack;
#line 430 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_stack_set_visible_child_name (_tmp18_, "edit_window");
#line 433 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp20_ = initial_default_imap_host;
#line 433 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp19_ = _tmp20_;
#line 433 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp19_ == NULL) {
#line 433 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp19_ = "";
#line 1851 "add-edit-page.c"
	}
#line 433 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_imap_host (self, _tmp19_);
#line 434 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp21_ = initial_default_imap_port;
#line 434 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_imap_port (self, _tmp21_);
#line 435 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp23_ = initial_imap_username;
#line 435 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp22_ = _tmp23_;
#line 435 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp22_ == NULL) {
#line 435 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp22_ = "";
#line 1867 "add-edit-page.c"
	}
#line 435 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_imap_username (self, _tmp22_);
#line 436 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp25_ = initial_imap_password;
#line 436 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp24_ = _tmp25_;
#line 436 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp24_ == NULL) {
#line 436 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp24_ = "";
#line 1879 "add-edit-page.c"
	}
#line 436 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_imap_password (self, _tmp24_);
#line 437 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp26_ = initial_default_imap_ssl;
#line 437 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_imap_ssl (self, _tmp26_);
#line 438 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp27_ = initial_default_imap_starttls;
#line 438 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_imap_starttls (self, _tmp27_);
#line 441 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp29_ = initial_default_smtp_host;
#line 441 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp28_ = _tmp29_;
#line 441 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp28_ == NULL) {
#line 441 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp28_ = "";
#line 1899 "add-edit-page.c"
	}
#line 441 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_smtp_host (self, _tmp28_);
#line 442 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp30_ = initial_default_smtp_port;
#line 442 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_smtp_port (self, _tmp30_);
#line 443 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp32_ = initial_smtp_username;
#line 443 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp31_ = _tmp32_;
#line 443 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp31_ == NULL) {
#line 443 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp31_ = "";
#line 1915 "add-edit-page.c"
	}
#line 443 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_smtp_username (self, _tmp31_);
#line 444 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp34_ = initial_smtp_password;
#line 444 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp33_ = _tmp34_;
#line 444 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp33_ == NULL) {
#line 444 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp33_ = "";
#line 1927 "add-edit-page.c"
	}
#line 444 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_smtp_password (self, _tmp33_);
#line 445 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp35_ = initial_default_smtp_ssl;
#line 445 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_smtp_ssl (self, _tmp35_);
#line 446 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp36_ = initial_default_smtp_starttls;
#line 446 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_smtp_starttls (self, _tmp36_);
#line 447 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp37_ = initial_default_smtp_use_imap_credentials;
#line 447 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_smtp_use_imap_credentials (self, _tmp37_);
#line 448 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp38_ = initial_default_smtp_noauth;
#line 448 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_smtp_noauth (self, _tmp38_);
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp39_ = initial_save_drafts;
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_save_drafts (self, _tmp39_);
#line 452 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp40_ = _result_;
#line 452 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_validation_result (self, _tmp40_);
#line 454 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp41_ = prefetch_period_days;
#line 454 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_storage_length (self, _tmp41_);
#line 1959 "add-edit-page.c"
}


void add_edit_page_set_validation_result (AddEditPage* self, GearyEngineValidationResult _result_) {
	GearyEngineValidationResult _tmp0_ = 0;
#line 457 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 458 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = _result_;
#line 458 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->last_validation_result = _tmp0_;
#line 1971 "add-edit-page.c"
}


void add_edit_page_reset_all (AddEditPage* self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 462 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 464 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = add_edit_page_get_default_real_name (self);
#line 464 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = _tmp0_;
#line 464 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_all_info (self, _tmp1_, NULL, NULL, NULL, NULL, TRUE, NULL, NULL, (gint) GEARY_SERVICE_PROVIDER_GMAIL, TRUE, TRUE, NULL, GEARY_IMAP_CLIENT_CONNECTION_DEFAULT_PORT_SSL, TRUE, FALSE, NULL, GEARY_SMTP_CLIENT_CONNECTION_DEFAULT_PORT_STARTTLS, FALSE, TRUE, FALSE, FALSE, GEARY_ACCOUNT_INFORMATION_DEFAULT_PREFETCH_PERIOD_DAYS, TRUE, FALSE, NULL, GEARY_ENGINE_VALIDATION_RESULT_OK);
#line 464 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_free0 (_tmp1_);
#line 466 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->edited_imap_port = FALSE;
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->edited_smtp_port = FALSE;
#line 1992 "add-edit-page.c"
}


/** Puts this page into one of three different modes:
     *  WELCOME: The first screen when Geary is started.
     *      ADD: Add account screen is like the Welcome screen, but without the welcome message.
     *     EDIT: This screen has only a few options that can be modified after creating an account.
     */
void add_edit_page_set_mode (AddEditPage* self, AddEditPagePageMode m) {
	AddEditPagePageMode _tmp0_ = 0;
#line 475 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 476 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = m;
#line 476 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->mode = _tmp0_;
#line 477 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_update_ui (self);
#line 2011 "add-edit-page.c"
}


AddEditPagePageMode add_edit_page_get_mode (AddEditPage* self) {
	AddEditPagePageMode result = 0;
	AddEditPagePageMode _tmp0_ = 0;
#line 480 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), 0);
#line 481 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->mode;
#line 481 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp0_;
#line 481 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 2026 "add-edit-page.c"
}


static void add_edit_page_on_email_changed (AddEditPage* self) {
	GtkEntry* _tmp0_ = NULL;
	GtkEntry* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GtkEntry* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
#line 485 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_imap_username;
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = self->priv->entry_email;
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp3_ = _tmp2_;
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_entry_set_text (_tmp0_, _tmp3_);
#line 488 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp4_ = self->priv->entry_smtp_username;
#line 488 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp5_ = gtk_widget_get_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget));
#line 488 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp6_ = _tmp5_;
#line 488 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp6_) {
#line 2058 "add-edit-page.c"
		GtkEntry* _tmp7_ = NULL;
		GtkEntry* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
#line 489 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp7_ = self->priv->entry_smtp_username;
#line 489 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp8_ = self->priv->entry_email;
#line 489 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp9_ = gtk_entry_get_text (_tmp8_);
#line 489 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp10_ = _tmp9_;
#line 489 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_entry_set_text (_tmp7_, _tmp10_);
#line 2073 "add-edit-page.c"
	}
}


static void add_edit_page_on_password_changed (AddEditPage* self) {
	GtkEntry* _tmp0_ = NULL;
	GtkEntry* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GtkEntry* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 494 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_imap_password;
#line 494 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = self->priv->entry_password;
#line 494 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 494 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp3_ = _tmp2_;
#line 494 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_entry_set_text (_tmp0_, _tmp3_);
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp4_ = self->priv->entry_password;
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp5_ = gtk_widget_get_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget));
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp6_ = _tmp5_;
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp6_) {
#line 2106 "add-edit-page.c"
		GtkEntry* _tmp7_ = NULL;
		GtkEntry* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
#line 497 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp7_ = self->priv->entry_smtp_password;
#line 497 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp8_ = self->priv->entry_password;
#line 497 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp9_ = gtk_entry_get_text (_tmp8_);
#line 497 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp10_ = _tmp9_;
#line 497 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_entry_set_text (_tmp7_, _tmp10_);
#line 2121 "add-edit-page.c"
	}
}


static void add_edit_page_on_changed (AddEditPage* self) {
#line 500 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 501 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_emit_by_name (self, "info-changed");
#line 2131 "add-edit-page.c"
}


static void add_edit_page_on_alternate_email_button_clicked (AddEditPage* self) {
#line 504 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 505 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_emit_by_name (self, "edit-alternate-emails");
#line 2140 "add-edit-page.c"
}


static gboolean string_get_next_char (const gchar* self, gint* index, gunichar* c) {
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gint _tmp0_ = 0;
	gunichar _tmp1_ = 0U;
	gunichar _tmp2_ = 0U;
#line 1015 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1016 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp0_ = *index;
#line 1016 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp1_ = g_utf8_get_char (((gchar*) self) + _tmp0_);
#line 1016 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_vala_c = _tmp1_;
#line 1017 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp2_ = _vala_c;
#line 1017 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	if (_tmp2_ != ((gunichar) 0)) {
#line 2162 "add-edit-page.c"
		gint _tmp3_ = 0;
		gchar* _tmp4_ = NULL;
#line 1018 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp3_ = *index;
#line 1018 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		_tmp4_ = g_utf8_next_char (((gchar*) self) + _tmp3_);
#line 1018 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		*index = (gint) (_tmp4_ - ((gchar*) self));
#line 1019 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		result = TRUE;
#line 1019 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		if (c) {
#line 1019 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 2177 "add-edit-page.c"
		}
#line 1019 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		return result;
#line 2181 "add-edit-page.c"
	} else {
#line 1021 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		result = FALSE;
#line 1021 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		if (c) {
#line 1021 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
			*c = _vala_c;
#line 2189 "add-edit-page.c"
		}
#line 1021 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		return result;
#line 2193 "add-edit-page.c"
	}
#line 1015 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	if (c) {
#line 1015 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		*c = _vala_c;
#line 2199 "add-edit-page.c"
	}
}


static void add_edit_page_on_nickname_insert_text (AddEditPage* self, GtkEditable* e, const gchar* text, gint length, gint* position) {
	gunichar c = 0U;
	gint index = 0;
#line 509 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 509 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (GTK_IS_EDITABLE (e));
#line 509 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (text != NULL);
#line 511 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	index = 0;
#line 512 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	while (TRUE) {
#line 2217 "add-edit-page.c"
		const gchar* _tmp0_ = NULL;
		gunichar _tmp1_ = 0U;
		gboolean _tmp2_ = FALSE;
		gunichar _tmp3_ = 0U;
		gboolean _tmp4_ = FALSE;
#line 512 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp0_ = text;
#line 512 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp2_ = string_get_next_char (_tmp0_, &index, &_tmp1_);
#line 512 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		c = _tmp1_;
#line 512 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		if (!_tmp2_) {
#line 512 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			break;
#line 2233 "add-edit-page.c"
		}
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp3_ = c;
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp4_ = g_unichar_isprint (_tmp3_);
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		if (!_tmp4_) {
#line 2241 "add-edit-page.c"
			GtkEditable* _tmp5_ = NULL;
#line 514 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp5_ = e;
#line 514 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			g_signal_stop_emission_by_name (_tmp5_, "insert-text");
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			return;
#line 2249 "add-edit-page.c"
		}
	}
}


static gboolean uint64_try_parse (const gchar* str, guint64* _result_) {
	guint64 _vala_result = 0ULL;
	gboolean result = FALSE;
	gchar* endptr = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	guint64 _tmp2_ = 0ULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
#line 660 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 662 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 662 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp2_ = g_ascii_strtoull (_tmp0_, &_tmp1_, (guint) 0);
#line 662 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	endptr = _tmp1_;
#line 662 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_vala_result = _tmp2_;
#line 663 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp3_ = endptr;
#line 663 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp4_ = str;
#line 663 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp5_ = str;
#line 663 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp6_ = strlen (_tmp5_);
#line 663 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp7_ = _tmp6_;
#line 663 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	if (_tmp3_ == (((gchar*) _tmp4_) + _tmp7_)) {
#line 664 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		result = TRUE;
#line 664 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		if (_result_) {
#line 664 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
			*_result_ = _vala_result;
#line 2295 "add-edit-page.c"
		}
#line 664 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		return result;
#line 2299 "add-edit-page.c"
	} else {
#line 666 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		result = FALSE;
#line 666 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		if (_result_) {
#line 666 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
			*_result_ = _vala_result;
#line 2307 "add-edit-page.c"
		}
#line 666 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		return result;
#line 2311 "add-edit-page.c"
	}
#line 660 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	if (_result_) {
#line 660 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
		*_result_ = _vala_result;
#line 2317 "add-edit-page.c"
	}
}


static guint64 uint64_parse (const gchar* str) {
	guint64 result = 0ULL;
	const gchar* _tmp0_ = NULL;
	guint64 _tmp1_ = 0ULL;
#line 657 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 658 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 658 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoull (_tmp0_, NULL, (guint) 0);
#line 658 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 658 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	return result;
#line 2336 "add-edit-page.c"
}


static void add_edit_page_on_port_insert_text (AddEditPage* self, GtkEditable* e, const gchar* text, gint length, gint* position) {
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
#line 521 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 521 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (GTK_IS_EDITABLE (e));
#line 521 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (text != NULL);
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = text;
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = uint64_try_parse (_tmp1_, NULL);
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (!_tmp2_) {
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp0_ = TRUE;
#line 2358 "add-edit-page.c"
	} else {
		GtkEditable* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		guint64 _tmp6_ = 0ULL;
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp3_ = e;
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp4_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_entry_get_type (), GtkEntry));
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp5_ = _tmp4_;
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp6_ = uint64_parse (_tmp5_);
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp0_ = _tmp6_ > ((guint64) G_MAXUINT16);
#line 2374 "add-edit-page.c"
	}
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp0_) {
#line 2378 "add-edit-page.c"
		GtkEditable* _tmp7_ = NULL;
#line 524 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp7_ = e;
#line 524 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_signal_stop_emission_by_name (_tmp7_, "insert-text");
#line 2384 "add-edit-page.c"
	} else {
		GtkEditable* _tmp8_ = NULL;
		GtkEntry* _tmp9_ = NULL;
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp8_ = e;
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp9_ = self->priv->entry_imap_port;
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		if (_tmp8_ == _tmp9_) {
#line 527 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			self->priv->edited_imap_port = TRUE;
#line 2396 "add-edit-page.c"
		} else {
			GtkEditable* _tmp10_ = NULL;
			GtkEntry* _tmp11_ = NULL;
#line 528 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp10_ = e;
#line 528 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp11_ = self->priv->entry_smtp_port;
#line 528 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp10_ == _tmp11_) {
#line 529 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				self->priv->edited_smtp_port = TRUE;
#line 2408 "add-edit-page.c"
			}
		}
	}
}


static void add_edit_page_on_imap_encryption_changed (AddEditPage* self) {
	gboolean _tmp0_ = FALSE;
	guint16 _tmp1_ = 0U;
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 534 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->edited_imap_port;
#line 534 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp0_) {
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		return;
#line 2426 "add-edit-page.c"
	}
#line 537 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = add_edit_page_get_default_imap_port (self);
#line 537 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_imap_port (self, _tmp1_);
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->edited_imap_port = FALSE;
#line 2434 "add-edit-page.c"
}


static guint16 add_edit_page_get_default_imap_port (AddEditPage* self) {
	guint16 result = 0U;
	GtkComboBox* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 541 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), 0U);
#line 542 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->combo_imap_encryption;
#line 542 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_combo_box_get_active (_tmp0_);
#line 542 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 542 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	switch (_tmp2_) {
#line 542 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_ENCRYPTION_SSL:
#line 2455 "add-edit-page.c"
		{
#line 544 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			result = GEARY_IMAP_CLIENT_CONNECTION_DEFAULT_PORT_SSL;
#line 544 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			return result;
#line 2461 "add-edit-page.c"
		}
		default:
#line 542 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_ENCRYPTION_NONE:
#line 542 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_ENCRYPTION_STARTTLS:
#line 2468 "add-edit-page.c"
		{
#line 549 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			result = GEARY_IMAP_CLIENT_CONNECTION_DEFAULT_PORT;
#line 549 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			return result;
#line 2474 "add-edit-page.c"
		}
	}
}


static void add_edit_page_on_smtp_encryption_changed (AddEditPage* self) {
	gboolean _tmp0_ = FALSE;
	guint16 _tmp1_ = 0U;
#line 553 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 554 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->edited_smtp_port;
#line 554 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp0_) {
#line 555 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		return;
#line 2491 "add-edit-page.c"
	}
#line 557 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = add_edit_page_get_default_smtp_port (self);
#line 557 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_set_smtp_port (self, _tmp1_);
#line 558 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->edited_smtp_port = FALSE;
#line 2499 "add-edit-page.c"
}


static void add_edit_page_on_smtp_auth_changed (AddEditPage* self, gboolean use_imap_credentials_toggled) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp12_ = FALSE;
	GtkCheckButton* _tmp13_ = NULL;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
#line 561 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 562 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = use_imap_credentials_toggled;
#line 562 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp1_) {
#line 2516 "add-edit-page.c"
		GtkCheckButton* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
#line 562 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp2_ = self->priv->check_smtp_use_imap_credentials;
#line 562 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp3_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 562 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp4_ = _tmp3_;
#line 562 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp0_ = _tmp4_;
#line 2528 "add-edit-page.c"
	} else {
#line 562 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp0_ = FALSE;
#line 2532 "add-edit-page.c"
	}
#line 562 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp0_) {
#line 2536 "add-edit-page.c"
		GtkCheckButton* _tmp5_ = NULL;
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp5_ = self->priv->check_smtp_noauth;
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_toggle_button_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_toggle_button_get_type (), GtkToggleButton), FALSE);
#line 2542 "add-edit-page.c"
	} else {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
#line 564 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp7_ = use_imap_credentials_toggled;
#line 564 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		if (!_tmp7_) {
#line 2550 "add-edit-page.c"
			GtkCheckButton* _tmp8_ = NULL;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_ = FALSE;
#line 564 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp8_ = self->priv->check_smtp_noauth;
#line 564 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp9_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 564 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp10_ = _tmp9_;
#line 564 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp6_ = _tmp10_;
#line 2562 "add-edit-page.c"
		} else {
#line 564 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp6_ = FALSE;
#line 2566 "add-edit-page.c"
		}
#line 564 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		if (_tmp6_) {
#line 2570 "add-edit-page.c"
			GtkCheckButton* _tmp11_ = NULL;
#line 565 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp11_ = self->priv->check_smtp_use_imap_credentials;
#line 565 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			gtk_toggle_button_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_toggle_button_get_type (), GtkToggleButton), FALSE);
#line 2576 "add-edit-page.c"
		}
	}
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp13_ = self->priv->check_smtp_use_imap_credentials;
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp14_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp15_ = _tmp14_;
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp15_) {
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp12_ = TRUE;
#line 2589 "add-edit-page.c"
	} else {
		GtkCheckButton* _tmp16_ = NULL;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_ = FALSE;
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp16_ = self->priv->check_smtp_noauth;
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp17_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp18_ = _tmp17_;
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp12_ = _tmp18_;
#line 2602 "add-edit-page.c"
	}
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp12_) {
#line 2606 "add-edit-page.c"
		GtkEntry* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
		const gchar* _tmp21_ = NULL;
		gboolean _tmp22_ = FALSE;
		GtkEntry* _tmp27_ = NULL;
		const gchar* _tmp28_ = NULL;
		const gchar* _tmp29_ = NULL;
		gboolean _tmp30_ = FALSE;
		GtkEntry* _tmp35_ = NULL;
		GtkEntry* _tmp36_ = NULL;
		GtkEntry* _tmp37_ = NULL;
		GtkEntry* _tmp38_ = NULL;
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp19_ = self->priv->entry_smtp_username;
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp20_ = gtk_entry_get_text (_tmp19_);
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp21_ = _tmp20_;
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp22_ = geary_string_is_empty_or_whitespace (_tmp21_);
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		if (!_tmp22_) {
#line 2629 "add-edit-page.c"
			GtkEntry* _tmp23_ = NULL;
			const gchar* _tmp24_ = NULL;
			const gchar* _tmp25_ = NULL;
			gchar* _tmp26_ = NULL;
#line 569 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp23_ = self->priv->entry_smtp_username;
#line 569 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp24_ = gtk_entry_get_text (_tmp23_);
#line 569 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp25_ = _tmp24_;
#line 569 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp26_ = g_strdup (_tmp25_);
#line 569 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_g_free0 (self->priv->smtp_username_store);
#line 569 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			self->priv->smtp_username_store = _tmp26_;
#line 2646 "add-edit-page.c"
		}
#line 570 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp27_ = self->priv->entry_smtp_password;
#line 570 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp28_ = gtk_entry_get_text (_tmp27_);
#line 570 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp29_ = _tmp28_;
#line 570 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp30_ = geary_string_is_empty_or_whitespace (_tmp29_);
#line 570 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		if (!_tmp30_) {
#line 2658 "add-edit-page.c"
			GtkEntry* _tmp31_ = NULL;
			const gchar* _tmp32_ = NULL;
			const gchar* _tmp33_ = NULL;
			gchar* _tmp34_ = NULL;
#line 571 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp31_ = self->priv->entry_smtp_password;
#line 571 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp32_ = gtk_entry_get_text (_tmp31_);
#line 571 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp33_ = _tmp32_;
#line 571 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp34_ = g_strdup (_tmp33_);
#line 571 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_g_free0 (self->priv->smtp_password_store);
#line 571 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			self->priv->smtp_password_store = _tmp34_;
#line 2675 "add-edit-page.c"
		}
#line 573 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp35_ = self->priv->entry_smtp_username;
#line 573 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_entry_set_text (_tmp35_, "");
#line 574 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp36_ = self->priv->entry_smtp_password;
#line 574 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_entry_set_text (_tmp36_, "");
#line 576 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp37_ = self->priv->entry_smtp_username;
#line 576 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 577 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp38_ = self->priv->entry_smtp_password;
#line 577 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 2693 "add-edit-page.c"
	} else {
		const gchar* _tmp39_ = NULL;
		gboolean _tmp40_ = FALSE;
		gchar* _tmp43_ = NULL;
		const gchar* _tmp44_ = NULL;
		gboolean _tmp45_ = FALSE;
		gchar* _tmp48_ = NULL;
		GtkEntry* _tmp49_ = NULL;
		GtkEntry* _tmp50_ = NULL;
#line 579 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp39_ = self->priv->smtp_username_store;
#line 579 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp40_ = geary_string_is_empty_or_whitespace (_tmp39_);
#line 579 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		if (!_tmp40_) {
#line 2709 "add-edit-page.c"
			GtkEntry* _tmp41_ = NULL;
			const gchar* _tmp42_ = NULL;
#line 580 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp41_ = self->priv->entry_smtp_username;
#line 580 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp42_ = self->priv->smtp_username_store;
#line 580 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			gtk_entry_set_text (_tmp41_, _tmp42_);
#line 2718 "add-edit-page.c"
		}
#line 581 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp43_ = g_strdup ("");
#line 581 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_free0 (self->priv->smtp_username_store);
#line 581 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		self->priv->smtp_username_store = _tmp43_;
#line 582 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp44_ = self->priv->smtp_password_store;
#line 582 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp45_ = geary_string_is_empty_or_whitespace (_tmp44_);
#line 582 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		if (!_tmp45_) {
#line 2732 "add-edit-page.c"
			GtkEntry* _tmp46_ = NULL;
			const gchar* _tmp47_ = NULL;
#line 583 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp46_ = self->priv->entry_smtp_password;
#line 583 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp47_ = self->priv->smtp_password_store;
#line 583 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			gtk_entry_set_text (_tmp46_, _tmp47_);
#line 2741 "add-edit-page.c"
		}
#line 584 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp48_ = g_strdup ("");
#line 584 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_free0 (self->priv->smtp_password_store);
#line 584 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		self->priv->smtp_password_store = _tmp48_;
#line 586 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp49_ = self->priv->entry_smtp_username;
#line 586 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, gtk_widget_get_type (), GtkWidget), TRUE);
#line 587 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp50_ = self->priv->entry_smtp_password;
#line 587 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, gtk_widget_get_type (), GtkWidget), TRUE);
#line 2757 "add-edit-page.c"
	}
}


static void add_edit_page_on_signature_stack_changed (AddEditPage* self) {
	GtkStack* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
#line 591 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 592 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->signature_stack;
#line 592 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_stack_get_visible_child_name (_tmp0_);
#line 592 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 592 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (g_strcmp0 (_tmp2_, "preview_window") == 0) {
#line 2776 "add-edit-page.c"
		StylishWebView* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
#line 593 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp3_ = self->priv->preview_webview;
#line 593 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp4_ = add_edit_page_get_email_signature (self);
#line 593 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp5_ = _tmp4_;
#line 593 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp6_ = _tmp5_;
#line 593 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp7_ = smart_escape (_tmp6_, TRUE);
#line 593 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp8_ = _tmp7_;
#line 593 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		webkit_web_view_load_html_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, webkit_web_view_get_type (), WebKitWebView), _tmp8_, "");
#line 593 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_free0 (_tmp8_);
#line 593 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_free0 (_tmp6_);
#line 2801 "add-edit-page.c"
	}
}


static guint16 add_edit_page_get_default_smtp_port (AddEditPage* self) {
	guint16 result = 0U;
	GtkComboBox* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 596 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), 0U);
#line 597 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->combo_smtp_encryption;
#line 597 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_combo_box_get_active (_tmp0_);
#line 597 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 597 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	switch (_tmp2_) {
#line 597 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_ENCRYPTION_SSL:
#line 2823 "add-edit-page.c"
		{
#line 599 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			result = GEARY_SMTP_CLIENT_CONNECTION_DEFAULT_PORT_SSL;
#line 599 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			return result;
#line 2829 "add-edit-page.c"
		}
#line 597 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_ENCRYPTION_STARTTLS:
#line 2833 "add-edit-page.c"
		{
#line 602 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			result = GEARY_SMTP_CLIENT_CONNECTION_DEFAULT_PORT_STARTTLS;
#line 602 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			return result;
#line 2839 "add-edit-page.c"
		}
		default:
#line 597 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_ENCRYPTION_NONE:
#line 2844 "add-edit-page.c"
		{
#line 606 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			result = GEARY_SMTP_CLIENT_CONNECTION_DEFAULT_PORT;
#line 606 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			return result;
#line 2850 "add-edit-page.c"
		}
	}
}


gboolean add_edit_page_is_complete (AddEditPage* self) {
	gboolean result = FALSE;
	GearyServiceProvider _tmp0_ = 0;
#line 610 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), FALSE);
#line 611 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = add_edit_page_get_service_provider (self);
#line 611 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	switch (_tmp0_) {
#line 611 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case GEARY_SERVICE_PROVIDER_OTHER:
#line 2867 "add-edit-page.c"
		{
			gboolean _tmp1_ = FALSE;
			gboolean _tmp2_ = FALSE;
			gboolean _tmp3_ = FALSE;
			gboolean _tmp4_ = FALSE;
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_ = FALSE;
			const gchar* _tmp8_ = NULL;
			const gchar* _tmp9_ = NULL;
			gboolean _tmp10_ = FALSE;
			gboolean _tmp36_ = FALSE;
			gboolean _tmp37_ = FALSE;
			const gchar* _tmp38_ = NULL;
			const gchar* _tmp39_ = NULL;
			gboolean _tmp40_ = FALSE;
#line 613 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp8_ = add_edit_page_get_nickname (self);
#line 613 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp9_ = _tmp8_;
#line 613 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp10_ = geary_string_is_empty_or_whitespace (_tmp9_);
#line 613 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp10_) {
#line 613 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp7_ = TRUE;
#line 2894 "add-edit-page.c"
			} else {
				const gchar* _tmp11_ = NULL;
				const gchar* _tmp12_ = NULL;
				gboolean _tmp13_ = FALSE;
#line 614 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp11_ = add_edit_page_get_email_address (self);
#line 614 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp12_ = _tmp11_;
#line 614 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp13_ = geary_string_is_empty_or_whitespace (_tmp12_);
#line 614 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp7_ = _tmp13_;
#line 2907 "add-edit-page.c"
			}
#line 613 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp7_) {
#line 613 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp6_ = TRUE;
#line 2913 "add-edit-page.c"
			} else {
				const gchar* _tmp14_ = NULL;
				const gchar* _tmp15_ = NULL;
				gboolean _tmp16_ = FALSE;
#line 615 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp14_ = add_edit_page_get_imap_host (self);
#line 615 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp15_ = _tmp14_;
#line 615 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp16_ = geary_string_is_empty_or_whitespace (_tmp15_);
#line 615 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp6_ = _tmp16_;
#line 2926 "add-edit-page.c"
			}
#line 613 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp6_) {
#line 613 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp5_ = TRUE;
#line 2932 "add-edit-page.c"
			} else {
				guint16 _tmp17_ = 0U;
				guint16 _tmp18_ = 0U;
				gchar* _tmp19_ = NULL;
				gchar* _tmp20_ = NULL;
				gboolean _tmp21_ = FALSE;
#line 616 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp17_ = add_edit_page_get_imap_port (self);
#line 616 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp18_ = _tmp17_;
#line 616 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp19_ = g_strdup_printf ("%hu", _tmp18_);
#line 616 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp20_ = _tmp19_;
#line 616 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp21_ = geary_string_is_empty_or_whitespace (_tmp20_);
#line 616 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp5_ = _tmp21_;
#line 616 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_g_free0 (_tmp20_);
#line 2953 "add-edit-page.c"
			}
#line 613 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp5_) {
#line 613 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp4_ = TRUE;
#line 2959 "add-edit-page.c"
			} else {
				const gchar* _tmp22_ = NULL;
				const gchar* _tmp23_ = NULL;
				gboolean _tmp24_ = FALSE;
#line 617 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp22_ = add_edit_page_get_imap_username (self);
#line 617 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp23_ = _tmp22_;
#line 617 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp24_ = geary_string_is_empty_or_whitespace (_tmp23_);
#line 617 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp4_ = _tmp24_;
#line 2972 "add-edit-page.c"
			}
#line 613 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp4_) {
#line 613 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp3_ = TRUE;
#line 2978 "add-edit-page.c"
			} else {
				const gchar* _tmp25_ = NULL;
				const gchar* _tmp26_ = NULL;
				gboolean _tmp27_ = FALSE;
#line 618 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp25_ = add_edit_page_get_imap_password (self);
#line 618 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp26_ = _tmp25_;
#line 618 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp27_ = geary_string_is_empty_or_whitespace (_tmp26_);
#line 618 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp3_ = _tmp27_;
#line 2991 "add-edit-page.c"
			}
#line 613 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp3_) {
#line 613 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp2_ = TRUE;
#line 2997 "add-edit-page.c"
			} else {
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_ = NULL;
				gboolean _tmp30_ = FALSE;
#line 619 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp28_ = add_edit_page_get_smtp_host (self);
#line 619 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp29_ = _tmp28_;
#line 619 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp30_ = geary_string_is_empty_or_whitespace (_tmp29_);
#line 619 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp2_ = _tmp30_;
#line 3010 "add-edit-page.c"
			}
#line 613 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp2_) {
#line 613 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp1_ = TRUE;
#line 3016 "add-edit-page.c"
			} else {
				guint16 _tmp31_ = 0U;
				guint16 _tmp32_ = 0U;
				gchar* _tmp33_ = NULL;
				gchar* _tmp34_ = NULL;
				gboolean _tmp35_ = FALSE;
#line 620 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp31_ = add_edit_page_get_smtp_port (self);
#line 620 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp32_ = _tmp31_;
#line 620 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp33_ = g_strdup_printf ("%hu", _tmp32_);
#line 620 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp34_ = _tmp33_;
#line 620 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp35_ = geary_string_is_empty_or_whitespace (_tmp34_);
#line 620 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp1_ = _tmp35_;
#line 620 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_g_free0 (_tmp34_);
#line 3037 "add-edit-page.c"
			}
#line 613 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp1_) {
#line 621 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				result = FALSE;
#line 621 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				return result;
#line 3045 "add-edit-page.c"
			}
#line 622 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp38_ = add_edit_page_get_smtp_username (self);
#line 622 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp39_ = _tmp38_;
#line 622 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp40_ = geary_string_is_empty_or_whitespace (_tmp39_);
#line 622 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp40_) {
#line 622 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp37_ = TRUE;
#line 3057 "add-edit-page.c"
			} else {
				const gchar* _tmp41_ = NULL;
				const gchar* _tmp42_ = NULL;
				gboolean _tmp43_ = FALSE;
#line 623 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp41_ = add_edit_page_get_smtp_password (self);
#line 623 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp42_ = _tmp41_;
#line 623 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp43_ = geary_string_is_empty_or_whitespace (_tmp42_);
#line 623 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp37_ = _tmp43_;
#line 3070 "add-edit-page.c"
			}
#line 622 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp37_) {
#line 3074 "add-edit-page.c"
				gboolean _tmp44_ = FALSE;
				GtkCheckButton* _tmp45_ = NULL;
				gboolean _tmp46_ = FALSE;
				gboolean _tmp47_ = FALSE;
#line 624 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp45_ = self->priv->check_smtp_noauth;
#line 624 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp46_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 624 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp47_ = _tmp46_;
#line 624 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				if (_tmp47_) {
#line 624 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
					_tmp44_ = TRUE;
#line 3089 "add-edit-page.c"
				} else {
					GtkCheckButton* _tmp48_ = NULL;
					gboolean _tmp49_ = FALSE;
					gboolean _tmp50_ = FALSE;
#line 624 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
					_tmp48_ = self->priv->check_smtp_use_imap_credentials;
#line 624 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
					_tmp49_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 624 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
					_tmp50_ = _tmp49_;
#line 624 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
					_tmp44_ = _tmp50_;
#line 3102 "add-edit-page.c"
				}
#line 624 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp36_ = !_tmp44_;
#line 3106 "add-edit-page.c"
			} else {
#line 622 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp36_ = FALSE;
#line 3110 "add-edit-page.c"
			}
#line 622 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp36_) {
#line 625 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				result = FALSE;
#line 625 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				return result;
#line 3118 "add-edit-page.c"
			}
#line 626 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			break;
#line 3122 "add-edit-page.c"
		}
		default:
		{
			gboolean _tmp51_ = FALSE;
			gboolean _tmp52_ = FALSE;
			const gchar* _tmp53_ = NULL;
			const gchar* _tmp54_ = NULL;
			gboolean _tmp55_ = FALSE;
#line 630 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp53_ = add_edit_page_get_nickname (self);
#line 630 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp54_ = _tmp53_;
#line 630 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp55_ = geary_string_is_empty_or_whitespace (_tmp54_);
#line 630 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp55_) {
#line 630 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp52_ = TRUE;
#line 3141 "add-edit-page.c"
			} else {
				const gchar* _tmp56_ = NULL;
				const gchar* _tmp57_ = NULL;
				gboolean _tmp58_ = FALSE;
#line 631 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp56_ = add_edit_page_get_email_address (self);
#line 631 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp57_ = _tmp56_;
#line 631 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp58_ = geary_string_is_empty_or_whitespace (_tmp57_);
#line 631 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp52_ = _tmp58_;
#line 3154 "add-edit-page.c"
			}
#line 630 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp52_) {
#line 630 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp51_ = TRUE;
#line 3160 "add-edit-page.c"
			} else {
				const gchar* _tmp59_ = NULL;
				const gchar* _tmp60_ = NULL;
				gboolean _tmp61_ = FALSE;
#line 632 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp59_ = add_edit_page_get_password (self);
#line 632 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp60_ = _tmp59_;
#line 632 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp61_ = geary_string_is_empty_or_whitespace (_tmp60_);
#line 632 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp51_ = _tmp61_;
#line 3173 "add-edit-page.c"
			}
#line 630 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp51_) {
#line 633 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				result = FALSE;
#line 633 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				return result;
#line 3181 "add-edit-page.c"
			}
#line 634 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			break;
#line 3185 "add-edit-page.c"
		}
	}
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = TRUE;
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 3192 "add-edit-page.c"
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 1115 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1116 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1116 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1117 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1117 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1118 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	result = _result_;
#line 1118 "/usr/share/vala-0.30/vapi/glib-2.0.vapi"
	return result;
#line 3215 "add-edit-page.c"
}


GearyAccountInformation* add_edit_page_get_account_information (AddEditPage* self) {
	GearyAccountInformation* result = NULL;
	GearyAccountInformation* account_information = NULL;
	GearyCredentials* imap_credentials = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	GearyCredentials* _tmp8_ = NULL;
	GearyCredentials* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gchar* _tmp19_ = NULL;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	GearyCredentials* smtp_credentials = NULL;
	GearyCredentials* _tmp28_ = NULL;
	GearyAccountInformation* _tmp53_ = NULL;
	const gchar* _tmp54_ = NULL;
	const gchar* _tmp55_ = NULL;
	gchar* _tmp56_ = NULL;
	gchar* _tmp57_ = NULL;
	GearyAccountInformation* _tmp58_ = NULL;
	const gchar* _tmp59_ = NULL;
	const gchar* _tmp60_ = NULL;
	gchar* _tmp61_ = NULL;
	gchar* _tmp62_ = NULL;
	GearyAccountInformation* _tmp63_ = NULL;
	GearyCredentials* _tmp64_ = NULL;
	GearyAccountInformation* _tmp65_ = NULL;
	GearyCredentials* _tmp66_ = NULL;
	GearyAccountInformation* _tmp67_ = NULL;
	gboolean _tmp68_ = FALSE;
	gboolean _tmp69_ = FALSE;
	GearyAccountInformation* _tmp70_ = NULL;
	gboolean _tmp71_ = FALSE;
	gboolean _tmp72_ = FALSE;
	GearyAccountInformation* _tmp73_ = NULL;
	GearyServiceProvider _tmp74_ = 0;
	GearyAccountInformation* _tmp75_ = NULL;
	gboolean _tmp76_ = FALSE;
	gboolean _tmp77_ = FALSE;
	GearyAccountInformation* _tmp78_ = NULL;
	const gchar* _tmp79_ = NULL;
	const gchar* _tmp80_ = NULL;
	GearyAccountInformation* _tmp81_ = NULL;
	guint16 _tmp82_ = 0U;
	guint16 _tmp83_ = 0U;
	GearyAccountInformation* _tmp84_ = NULL;
	gboolean _tmp85_ = FALSE;
	gboolean _tmp86_ = FALSE;
	GearyAccountInformation* _tmp87_ = NULL;
	gboolean _tmp88_ = FALSE;
	gboolean _tmp89_ = FALSE;
	GearyAccountInformation* _tmp90_ = NULL;
	const gchar* _tmp91_ = NULL;
	const gchar* _tmp92_ = NULL;
	gchar* _tmp93_ = NULL;
	gchar* _tmp94_ = NULL;
	GearyAccountInformation* _tmp95_ = NULL;
	guint16 _tmp96_ = 0U;
	guint16 _tmp97_ = 0U;
	GearyAccountInformation* _tmp98_ = NULL;
	gboolean _tmp99_ = FALSE;
	gboolean _tmp100_ = FALSE;
	GearyAccountInformation* _tmp101_ = NULL;
	gboolean _tmp102_ = FALSE;
	gboolean _tmp103_ = FALSE;
	GearyAccountInformation* _tmp104_ = NULL;
	gboolean _tmp105_ = FALSE;
	gboolean _tmp106_ = FALSE;
	GearyAccountInformation* _tmp107_ = NULL;
	gboolean _tmp108_ = FALSE;
	gboolean _tmp109_ = FALSE;
	GearyAccountInformation* _tmp110_ = NULL;
	gint _tmp111_ = 0;
	GearyAccountInformation* _tmp112_ = NULL;
	gboolean _tmp113_ = FALSE;
	gboolean _tmp114_ = FALSE;
	GearyAccountInformation* _tmp115_ = NULL;
	gboolean _tmp116_ = FALSE;
	gboolean _tmp117_ = FALSE;
	GearyAccountInformation* _tmp118_ = NULL;
	gchar* _tmp119_ = NULL;
	gchar* _tmp120_ = NULL;
	gchar* _tmp121_ = NULL;
	gboolean _tmp122_ = FALSE;
	gboolean _tmp123_ = FALSE;
	GError * _inner_error_ = NULL;
#line 640 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), NULL);
#line 642 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_fix_credentials_for_supported_provider (self);
#line 644 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = add_edit_page_get_imap_username (self);
#line 644 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = _tmp0_;
#line 644 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = string_strip (_tmp1_);
#line 644 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp3_ = _tmp2_;
#line 644 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp4_ = add_edit_page_get_imap_password (self);
#line 644 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp5_ = _tmp4_;
#line 644 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp6_ = string_strip (_tmp5_);
#line 644 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp7_ = _tmp6_;
#line 644 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp8_ = geary_credentials_new (_tmp3_, _tmp7_);
#line 644 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp9_ = _tmp8_;
#line 644 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_free0 (_tmp7_);
#line 644 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_free0 (_tmp3_);
#line 644 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	imap_credentials = _tmp9_;
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp11_ = add_edit_page_get_smtp_use_imap_credentials (self);
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp12_ = _tmp11_;
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp12_) {
#line 3349 "add-edit-page.c"
		const gchar* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp13_ = add_edit_page_get_imap_username (self);
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp14_ = _tmp13_;
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp15_ = string_strip (_tmp14_);
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_free0 (_tmp10_);
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp10_ = _tmp15_;
#line 3363 "add-edit-page.c"
	} else {
		const gchar* _tmp16_ = NULL;
		const gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp16_ = add_edit_page_get_smtp_username (self);
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp17_ = _tmp16_;
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp18_ = string_strip (_tmp17_);
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_free0 (_tmp10_);
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp10_ = _tmp18_;
#line 3378 "add-edit-page.c"
	}
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp20_ = add_edit_page_get_smtp_use_imap_credentials (self);
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp21_ = _tmp20_;
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp21_) {
#line 3386 "add-edit-page.c"
		const gchar* _tmp22_ = NULL;
		const gchar* _tmp23_ = NULL;
		gchar* _tmp24_ = NULL;
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp22_ = add_edit_page_get_imap_password (self);
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp23_ = _tmp22_;
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp24_ = string_strip (_tmp23_);
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_free0 (_tmp19_);
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp19_ = _tmp24_;
#line 3400 "add-edit-page.c"
	} else {
		const gchar* _tmp25_ = NULL;
		const gchar* _tmp26_ = NULL;
		gchar* _tmp27_ = NULL;
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp25_ = add_edit_page_get_smtp_password (self);
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp26_ = _tmp25_;
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp27_ = string_strip (_tmp26_);
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_free0 (_tmp19_);
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp19_ = _tmp27_;
#line 3415 "add-edit-page.c"
	}
#line 645 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp28_ = geary_credentials_new (_tmp10_, _tmp19_);
#line 645 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	smtp_credentials = _tmp28_;
#line 3421 "add-edit-page.c"
	{
		GeeMap* _tmp29_ = NULL;
		GearyEngine* _tmp30_ = NULL;
		GearyEngine* _tmp31_ = NULL;
		GeeMap* _tmp32_ = NULL;
		GearyAccountInformation* original_account = NULL;
		GeeMap* _tmp33_ = NULL;
		GeeMap* _tmp34_ = NULL;
		const gchar* _tmp35_ = NULL;
		const gchar* _tmp36_ = NULL;
		gpointer _tmp37_ = NULL;
		GearyAccountInformation* _tmp38_ = NULL;
		GearyAccountInformation* _tmp39_ = NULL;
#line 650 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp30_ = geary_engine_get_instance ();
#line 650 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp31_ = _tmp30_;
#line 650 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp32_ = geary_engine_get_accounts (_tmp31_, &_inner_error_);
#line 650 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp29_ = _tmp32_;
#line 650 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3445 "add-edit-page.c"
			goto __catch55_g_error;
		}
#line 650 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp33_ = _tmp29_;
#line 650 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp29_ = NULL;
#line 650 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp34_ = _tmp33_;
#line 650 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp35_ = add_edit_page_get_email_address (self);
#line 650 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp36_ = _tmp35_;
#line 650 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp37_ = gee_map_get (_tmp34_, _tmp36_);
#line 650 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp38_ = (GearyAccountInformation*) _tmp37_;
#line 650 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_object_unref0 (_tmp34_);
#line 650 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		original_account = _tmp38_;
#line 651 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp39_ = original_account;
#line 651 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		if (_tmp39_ == NULL) {
#line 3470 "add-edit-page.c"
			GearyAccountInformation* _tmp40_ = NULL;
			GearyEngine* _tmp41_ = NULL;
			GearyEngine* _tmp42_ = NULL;
			const gchar* _tmp43_ = NULL;
			const gchar* _tmp44_ = NULL;
			GearyAccountInformation* _tmp45_ = NULL;
			GearyAccountInformation* _tmp46_ = NULL;
#line 653 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp41_ = geary_engine_get_instance ();
#line 653 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp42_ = _tmp41_;
#line 653 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp43_ = add_edit_page_get_email_address (self);
#line 653 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp44_ = _tmp43_;
#line 653 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp45_ = geary_engine_create_orphan_account (_tmp42_, _tmp44_, &_inner_error_);
#line 653 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp40_ = _tmp45_;
#line 653 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 653 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_g_object_unref0 (original_account);
#line 653 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_g_object_unref0 (_tmp29_);
#line 3496 "add-edit-page.c"
				goto __catch55_g_error;
			}
#line 653 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp46_ = _tmp40_;
#line 653 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp40_ = NULL;
#line 653 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_g_object_unref0 (account_information);
#line 653 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			account_information = _tmp46_;
#line 651 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_g_object_unref0 (_tmp40_);
#line 3509 "add-edit-page.c"
		} else {
			GearyAccountInformation* _tmp47_ = NULL;
			GearyAccountInformation* _tmp48_ = NULL;
#line 656 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp47_ = original_account;
#line 656 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp48_ = geary_account_information_new_temp_copy (_tmp47_);
#line 656 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_g_object_unref0 (account_information);
#line 656 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			account_information = _tmp48_;
#line 3521 "add-edit-page.c"
		}
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_object_unref0 (original_account);
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_object_unref0 (_tmp29_);
#line 3527 "add-edit-page.c"
	}
	goto __finally55;
	__catch55_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp49_ = NULL;
		const gchar* _tmp50_ = NULL;
		GError* _tmp51_ = NULL;
		const gchar* _tmp52_ = NULL;
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		err = _inner_error_;
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_inner_error_ = NULL;
#line 659 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp49_ = add_edit_page_get_email_address (self);
#line 659 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp50_ = _tmp49_;
#line 659 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp51_ = err;
#line 659 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp52_ = _tmp51_->message;
#line 659 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_debug ("add-edit-page.vala:659: Unable to open account information for %s: %s", _tmp50_, _tmp52_);
#line 661 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		result = NULL;
#line 661 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_error_free0 (err);
#line 661 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_object_unref0 (smtp_credentials);
#line 661 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_free0 (_tmp19_);
#line 661 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_free0 (_tmp10_);
#line 661 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_object_unref0 (imap_credentials);
#line 661 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_object_unref0 (account_information);
#line 661 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		return result;
#line 3567 "add-edit-page.c"
	}
	__finally55:
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_object_unref0 (smtp_credentials);
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_free0 (_tmp19_);
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_free0 (_tmp10_);
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_object_unref0 (imap_credentials);
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_object_unref0 (account_information);
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_clear_error (&_inner_error_);
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		return NULL;
#line 3588 "add-edit-page.c"
	}
#line 664 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp53_ = account_information;
#line 664 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp54_ = add_edit_page_get_real_name (self);
#line 664 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp55_ = _tmp54_;
#line 664 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp56_ = string_strip (_tmp55_);
#line 664 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp57_ = _tmp56_;
#line 664 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_real_name (_tmp53_, _tmp57_);
#line 664 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_free0 (_tmp57_);
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp58_ = account_information;
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp59_ = add_edit_page_get_nickname (self);
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp60_ = _tmp59_;
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp61_ = string_strip (_tmp60_);
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp62_ = _tmp61_;
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_nickname (_tmp58_, _tmp62_);
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_free0 (_tmp62_);
#line 666 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp63_ = account_information;
#line 666 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp64_ = imap_credentials;
#line 666 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_imap_credentials (_tmp63_, _tmp64_);
#line 667 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp65_ = account_information;
#line 667 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp66_ = smtp_credentials;
#line 667 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_smtp_credentials (_tmp65_, _tmp66_);
#line 668 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp67_ = account_information;
#line 668 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp68_ = add_edit_page_get_remember_password (self);
#line 668 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp69_ = _tmp68_;
#line 668 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_imap_remember_password (_tmp67_, _tmp69_);
#line 669 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp70_ = account_information;
#line 669 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp71_ = add_edit_page_get_remember_password (self);
#line 669 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp72_ = _tmp71_;
#line 669 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_smtp_remember_password (_tmp70_, _tmp72_);
#line 670 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp73_ = account_information;
#line 670 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp74_ = add_edit_page_get_service_provider (self);
#line 670 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_service_provider (_tmp73_, _tmp74_);
#line 671 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp75_ = account_information;
#line 671 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp76_ = add_edit_page_get_save_sent_mail (self);
#line 671 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp77_ = _tmp76_;
#line 671 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_save_sent_mail (_tmp75_, _tmp77_);
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp78_ = account_information;
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp79_ = add_edit_page_get_imap_host (self);
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp80_ = _tmp79_;
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_default_imap_server_host (_tmp78_, _tmp80_);
#line 673 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp81_ = account_information;
#line 673 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp82_ = add_edit_page_get_imap_port (self);
#line 673 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp83_ = _tmp82_;
#line 673 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_default_imap_server_port (_tmp81_, _tmp83_);
#line 674 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp84_ = account_information;
#line 674 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp85_ = add_edit_page_get_imap_ssl (self);
#line 674 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp86_ = _tmp85_;
#line 674 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_default_imap_server_ssl (_tmp84_, _tmp86_);
#line 675 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp87_ = account_information;
#line 675 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp88_ = add_edit_page_get_imap_starttls (self);
#line 675 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp89_ = _tmp88_;
#line 675 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_default_imap_server_starttls (_tmp87_, _tmp89_);
#line 676 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp90_ = account_information;
#line 676 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp91_ = add_edit_page_get_smtp_host (self);
#line 676 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp92_ = _tmp91_;
#line 676 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp93_ = string_strip (_tmp92_);
#line 676 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp94_ = _tmp93_;
#line 676 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_default_smtp_server_host (_tmp90_, _tmp94_);
#line 676 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_free0 (_tmp94_);
#line 677 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp95_ = account_information;
#line 677 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp96_ = add_edit_page_get_smtp_port (self);
#line 677 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp97_ = _tmp96_;
#line 677 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_default_smtp_server_port (_tmp95_, _tmp97_);
#line 678 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp98_ = account_information;
#line 678 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp99_ = add_edit_page_get_smtp_ssl (self);
#line 678 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp100_ = _tmp99_;
#line 678 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_default_smtp_server_ssl (_tmp98_, _tmp100_);
#line 679 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp101_ = account_information;
#line 679 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp102_ = add_edit_page_get_smtp_starttls (self);
#line 679 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp103_ = _tmp102_;
#line 679 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_default_smtp_server_starttls (_tmp101_, _tmp103_);
#line 680 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp104_ = account_information;
#line 680 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp105_ = add_edit_page_get_smtp_use_imap_credentials (self);
#line 680 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp106_ = _tmp105_;
#line 680 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_default_smtp_use_imap_credentials (_tmp104_, _tmp106_);
#line 681 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp107_ = account_information;
#line 681 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp108_ = add_edit_page_get_smtp_noauth (self);
#line 681 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp109_ = _tmp108_;
#line 681 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_default_smtp_server_noauth (_tmp107_, _tmp109_);
#line 682 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp110_ = account_information;
#line 682 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp111_ = add_edit_page_get_storage_length (self);
#line 682 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_prefetch_period_days (_tmp110_, _tmp111_);
#line 683 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp112_ = account_information;
#line 683 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp113_ = add_edit_page_get_save_drafts (self);
#line 683 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp114_ = _tmp113_;
#line 683 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_save_drafts (_tmp112_, _tmp114_);
#line 684 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp115_ = account_information;
#line 684 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp116_ = add_edit_page_get_use_email_signature (self);
#line 684 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp117_ = _tmp116_;
#line 684 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_use_email_signature (_tmp115_, _tmp117_);
#line 685 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp118_ = account_information;
#line 685 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp119_ = add_edit_page_get_email_signature (self);
#line 685 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp120_ = _tmp119_;
#line 685 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp121_ = _tmp120_;
#line 685 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	geary_account_information_set_email_signature (_tmp118_, _tmp121_);
#line 685 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_free0 (_tmp121_);
#line 687 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp122_ = add_edit_page_get_smtp_noauth (self);
#line 687 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp123_ = _tmp122_;
#line 687 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp123_) {
#line 3786 "add-edit-page.c"
		GearyAccountInformation* _tmp124_ = NULL;
#line 688 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp124_ = account_information;
#line 688 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		geary_account_information_set_smtp_credentials (_tmp124_, NULL);
#line 3792 "add-edit-page.c"
	}
#line 690 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_on_changed (self);
#line 692 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = account_information;
#line 692 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (smtp_credentials);
#line 692 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_free0 (_tmp19_);
#line 692 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_free0 (_tmp10_);
#line 692 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (imap_credentials);
#line 692 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 3808 "add-edit-page.c"
}


static void add_edit_page_fix_credentials_for_supported_provider (AddEditPage* self) {
	GearyServiceProvider _tmp0_ = 0;
#line 696 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 697 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = add_edit_page_get_service_provider (self);
#line 697 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp0_ != GEARY_SERVICE_PROVIDER_OTHER) {
#line 3820 "add-edit-page.c"
		const gchar* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
#line 698 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp1_ = add_edit_page_get_email_address (self);
#line 698 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp2_ = _tmp1_;
#line 698 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_imap_username (self, _tmp2_);
#line 699 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp3_ = add_edit_page_get_email_address (self);
#line 699 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp4_ = _tmp3_;
#line 699 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_smtp_username (self, _tmp4_);
#line 700 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp5_ = add_edit_page_get_password (self);
#line 700 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp6_ = _tmp5_;
#line 700 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_imap_password (self, _tmp6_);
#line 701 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp7_ = add_edit_page_get_password (self);
#line 701 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp8_ = _tmp7_;
#line 701 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_smtp_password (self, _tmp8_);
#line 3853 "add-edit-page.c"
	}
}


void add_edit_page_update_ui (AddEditPage* self) {
	GtkBox* _tmp0_ = NULL;
	AddEditPagePageMode _tmp1_ = 0;
	GtkEntry* _tmp2_ = NULL;
	GtkLabel* _tmp3_ = NULL;
	AddEditPagePageMode _tmp4_ = 0;
	GtkBox* _tmp5_ = NULL;
	AddEditPagePageMode _tmp6_ = 0;
	GtkCheckButton* _tmp7_ = NULL;
	AddEditPagePageMode _tmp8_ = 0;
	GtkCheckButton* _tmp9_ = NULL;
	AddEditPagePageMode _tmp10_ = 0;
	GtkBox* _tmp11_ = NULL;
	AddEditPagePageMode _tmp12_ = 0;
	GtkButton* _tmp13_ = NULL;
	AddEditPagePageMode _tmp14_ = 0;
	GearyServiceProvider _tmp15_ = 0;
	GtkComboBoxText* _tmp27_ = NULL;
	GtkEntry* _tmp28_ = NULL;
	GtkEntry* _tmp29_ = NULL;
	GtkEntry* _tmp30_ = NULL;
	GtkEntry* _tmp31_ = NULL;
	GtkComboBox* _tmp32_ = NULL;
	GtkEntry* _tmp33_ = NULL;
	GtkEntry* _tmp34_ = NULL;
	GtkEntry* _tmp35_ = NULL;
	GtkComboBox* _tmp36_ = NULL;
	GtkCheckButton* _tmp37_ = NULL;
	GtkCheckButton* _tmp38_ = NULL;
	AddEditPagePageMode _tmp39_ = 0;
	gboolean _tmp40_ = FALSE;
	gboolean _tmp41_ = FALSE;
	GtkLabel* _tmp49_ = NULL;
	GearyEngineValidationResult _tmp50_ = 0;
	gboolean _tmp108_ = FALSE;
	gboolean _tmp109_ = FALSE;
#line 706 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 707 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	GTK_WIDGET_CLASS (add_edit_page_parent_class)->show_all (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_box_get_type (), GtkBox), gtk_widget_get_type (), GtkWidget));
#line 709 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->welcome_box;
#line 709 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = self->priv->mode;
#line 709 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), _tmp1_ == ADD_EDIT_PAGE_PAGE_MODE_WELCOME);
#line 710 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = self->priv->entry_nickname;
#line 710 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp3_ = self->priv->label_nickname;
#line 710 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp4_ = self->priv->mode;
#line 710 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget), _tmp4_ != ADD_EDIT_PAGE_PAGE_MODE_WELCOME);
#line 710 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget), _tmp4_ != ADD_EDIT_PAGE_PAGE_MODE_WELCOME);
#line 711 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp5_ = self->priv->storage_container;
#line 711 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp6_ = self->priv->mode;
#line 711 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget), _tmp6_ == ADD_EDIT_PAGE_PAGE_MODE_EDIT);
#line 712 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp7_ = self->priv->check_save_sent_mail;
#line 712 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp8_ = self->priv->mode;
#line 712 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget), _tmp8_ == ADD_EDIT_PAGE_PAGE_MODE_EDIT);
#line 713 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp9_ = self->priv->check_save_drafts;
#line 713 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp10_ = self->priv->mode;
#line 713 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget), _tmp10_ == ADD_EDIT_PAGE_PAGE_MODE_EDIT);
#line 714 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp11_ = self->priv->composer_container;
#line 714 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp12_ = self->priv->mode;
#line 714 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_widget_get_type (), GtkWidget), _tmp12_ == ADD_EDIT_PAGE_PAGE_MODE_EDIT);
#line 715 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp13_ = self->priv->alternate_email_button;
#line 715 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp14_ = self->priv->mode;
#line 715 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_widget_get_type (), GtkWidget), _tmp14_ == ADD_EDIT_PAGE_PAGE_MODE_EDIT);
#line 717 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp15_ = add_edit_page_get_service_provider (self);
#line 717 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp15_ == GEARY_SERVICE_PROVIDER_OTHER) {
#line 3948 "add-edit-page.c"
		GtkLabel* _tmp16_ = NULL;
		GtkEntry* _tmp17_ = NULL;
		GtkAlignment* _tmp18_ = NULL;
		GtkCheckButton* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
#line 719 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp16_ = self->priv->label_password;
#line 719 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_widget_get_type (), GtkWidget));
#line 720 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp17_ = self->priv->entry_password;
#line 720 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_widget_get_type (), GtkWidget));
#line 721 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp18_ = self->priv->other_info;
#line 721 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gtk_widget_get_type (), GtkWidget));
#line 722 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_other_info_sensitive (self, TRUE);
#line 723 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp19_ = self->priv->check_remember_password;
#line 723 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp20_ = _ ("Remem_ber passwords");
#line 723 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_button_get_type (), GtkButton), _tmp20_);
#line 3974 "add-edit-page.c"
	} else {
		GtkLabel* _tmp21_ = NULL;
		GtkEntry* _tmp22_ = NULL;
		GtkAlignment* _tmp23_ = NULL;
		AddEditPagePageMode _tmp24_ = 0;
		GtkCheckButton* _tmp25_ = NULL;
		const gchar* _tmp26_ = NULL;
#line 726 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp21_ = self->priv->label_password;
#line 726 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_widget_get_type (), GtkWidget));
#line 727 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp22_ = self->priv->entry_password;
#line 727 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, gtk_widget_get_type (), GtkWidget));
#line 728 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp23_ = self->priv->other_info;
#line 728 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, gtk_widget_get_type (), GtkWidget));
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp24_ = self->priv->mode;
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_other_info_sensitive (self, _tmp24_ == ADD_EDIT_PAGE_PAGE_MODE_WELCOME);
#line 730 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp25_ = self->priv->check_remember_password;
#line 730 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp26_ = _ ("Remem_ber password");
#line 730 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_button_set_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, gtk_button_get_type (), GtkButton), _tmp26_);
#line 4004 "add-edit-page.c"
	}
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp27_ = self->priv->combo_service;
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp28_ = self->priv->entry_email;
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp29_ = self->priv->entry_imap_host;
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp30_ = self->priv->entry_imap_port;
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp31_ = self->priv->entry_imap_username;
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp32_ = self->priv->combo_imap_encryption;
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp33_ = self->priv->entry_smtp_host;
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp34_ = self->priv->entry_smtp_port;
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp35_ = self->priv->entry_smtp_username;
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp36_ = self->priv->combo_smtp_encryption;
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp37_ = self->priv->check_smtp_use_imap_credentials;
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp38_ = self->priv->check_smtp_noauth;
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp39_ = self->priv->mode;
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, gtk_widget_get_type (), GtkWidget), _tmp39_ != ADD_EDIT_PAGE_PAGE_MODE_EDIT);
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, gtk_widget_get_type (), GtkWidget), _tmp39_ != ADD_EDIT_PAGE_PAGE_MODE_EDIT);
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, gtk_widget_get_type (), GtkWidget), _tmp39_ != ADD_EDIT_PAGE_PAGE_MODE_EDIT);
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, gtk_widget_get_type (), GtkWidget), _tmp39_ != ADD_EDIT_PAGE_PAGE_MODE_EDIT);
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, gtk_widget_get_type (), GtkWidget), _tmp39_ != ADD_EDIT_PAGE_PAGE_MODE_EDIT);
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, gtk_widget_get_type (), GtkWidget), _tmp39_ != ADD_EDIT_PAGE_PAGE_MODE_EDIT);
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, gtk_widget_get_type (), GtkWidget), _tmp39_ != ADD_EDIT_PAGE_PAGE_MODE_EDIT);
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, gtk_widget_get_type (), GtkWidget), _tmp39_ != ADD_EDIT_PAGE_PAGE_MODE_EDIT);
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, gtk_widget_get_type (), GtkWidget), _tmp39_ != ADD_EDIT_PAGE_PAGE_MODE_EDIT);
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, gtk_widget_get_type (), GtkWidget), _tmp39_ != ADD_EDIT_PAGE_PAGE_MODE_EDIT);
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, gtk_widget_get_type (), GtkWidget), _tmp39_ != ADD_EDIT_PAGE_PAGE_MODE_EDIT);
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, gtk_widget_get_type (), GtkWidget), _tmp39_ != ADD_EDIT_PAGE_PAGE_MODE_EDIT);
#line 748 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp40_ = add_edit_page_get_smtp_noauth (self);
#line 748 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp41_ = _tmp40_;
#line 748 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp41_) {
#line 4062 "add-edit-page.c"
		GtkCheckButton* _tmp42_ = NULL;
		GtkEntry* _tmp43_ = NULL;
		GtkEntry* _tmp44_ = NULL;
#line 749 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp42_ = self->priv->check_smtp_use_imap_credentials;
#line 749 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 750 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp43_ = self->priv->entry_smtp_username;
#line 750 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 751 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp44_ = self->priv->entry_smtp_password;
#line 751 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 4078 "add-edit-page.c"
	} else {
		gboolean _tmp45_ = FALSE;
		gboolean _tmp46_ = FALSE;
#line 752 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp45_ = add_edit_page_get_smtp_use_imap_credentials (self);
#line 752 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp46_ = _tmp45_;
#line 752 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		if (_tmp46_) {
#line 4088 "add-edit-page.c"
			GtkEntry* _tmp47_ = NULL;
			GtkEntry* _tmp48_ = NULL;
#line 753 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp47_ = self->priv->entry_smtp_username;
#line 753 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 754 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp48_ = self->priv->entry_smtp_password;
#line 754 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 4099 "add-edit-page.c"
		}
	}
#line 758 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp49_ = self->priv->label_error;
#line 758 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 759 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp50_ = self->priv->last_validation_result;
#line 759 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp50_ == GEARY_ENGINE_VALIDATION_RESULT_OK) {
#line 4110 "add-edit-page.c"
		GtkLabel* _tmp51_ = NULL;
#line 760 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp51_ = self->priv->label_error;
#line 760 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 4116 "add-edit-page.c"
	} else {
		GtkLabel* _tmp52_ = NULL;
		gchar* error_string = NULL;
		const gchar* _tmp53_ = NULL;
		gchar* _tmp54_ = NULL;
		GearyEngineValidationResult _tmp55_ = 0;
		gboolean _tmp56_ = FALSE;
		GearyEngineValidationResult _tmp60_ = 0;
		gboolean _tmp61_ = FALSE;
		GearyServiceProvider _tmp65_ = 0;
		GtkLabel* _tmp102_ = NULL;
		const gchar* _tmp103_ = NULL;
		gchar* _tmp104_ = NULL;
		gchar* _tmp105_ = NULL;
		gchar* _tmp106_ = NULL;
		gchar* _tmp107_ = NULL;
#line 762 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp52_ = self->priv->label_error;
#line 762 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_widget_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, gtk_widget_get_type (), GtkWidget), TRUE);
#line 764 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp53_ = _ ("Unable to validate:\n");
#line 764 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp54_ = g_strdup (_tmp53_);
#line 764 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		error_string = _tmp54_;
#line 765 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp55_ = self->priv->last_validation_result;
#line 765 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp56_ = geary_engine_validation_result_is_all_set (_tmp55_, GEARY_ENGINE_VALIDATION_RESULT_INVALID_NICKNAME);
#line 765 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		if (_tmp56_) {
#line 4149 "add-edit-page.c"
			const gchar* _tmp57_ = NULL;
			const gchar* _tmp58_ = NULL;
			gchar* _tmp59_ = NULL;
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp57_ = error_string;
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp58_ = _ ("        &#8226; Invalid account nickname.\n");
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp59_ = g_strconcat (_tmp57_, _tmp58_, NULL);
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_g_free0 (error_string);
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			error_string = _tmp59_;
#line 4163 "add-edit-page.c"
		}
#line 768 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp60_ = self->priv->last_validation_result;
#line 768 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp61_ = geary_engine_validation_result_is_all_set (_tmp60_, GEARY_ENGINE_VALIDATION_RESULT_EMAIL_EXISTS);
#line 768 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		if (_tmp61_) {
#line 4171 "add-edit-page.c"
			const gchar* _tmp62_ = NULL;
			const gchar* _tmp63_ = NULL;
			gchar* _tmp64_ = NULL;
#line 769 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp62_ = error_string;
#line 769 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp63_ = _ ("        &#8226; Email address already added to Geary.\n");
#line 769 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp64_ = g_strconcat (_tmp62_, _tmp63_, NULL);
#line 769 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_g_free0 (error_string);
#line 769 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			error_string = _tmp64_;
#line 4185 "add-edit-page.c"
		}
#line 771 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp65_ = add_edit_page_get_service_provider (self);
#line 771 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		if (_tmp65_ == GEARY_SERVICE_PROVIDER_OTHER) {
#line 4191 "add-edit-page.c"
			GearyEngineValidationResult _tmp66_ = 0;
			gboolean _tmp67_ = FALSE;
			GearyEngineValidationResult _tmp71_ = 0;
			gboolean _tmp72_ = FALSE;
			GearyEngineValidationResult _tmp76_ = 0;
			gboolean _tmp77_ = FALSE;
			GearyEngineValidationResult _tmp81_ = 0;
			gboolean _tmp82_ = FALSE;
#line 772 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp66_ = self->priv->last_validation_result;
#line 772 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp67_ = geary_engine_validation_result_is_all_set (_tmp66_, GEARY_ENGINE_VALIDATION_RESULT_IMAP_CONNECTION_FAILED);
#line 772 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp67_) {
#line 4206 "add-edit-page.c"
				const gchar* _tmp68_ = NULL;
				const gchar* _tmp69_ = NULL;
				gchar* _tmp70_ = NULL;
#line 773 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp68_ = error_string;
#line 773 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp69_ = _ ("        &#8226; IMAP connection error.\n");
#line 773 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp70_ = g_strconcat (_tmp68_, _tmp69_, NULL);
#line 773 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_g_free0 (error_string);
#line 773 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				error_string = _tmp70_;
#line 4220 "add-edit-page.c"
			}
#line 775 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp71_ = self->priv->last_validation_result;
#line 775 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp72_ = geary_engine_validation_result_is_all_set (_tmp71_, GEARY_ENGINE_VALIDATION_RESULT_IMAP_CREDENTIALS_INVALID);
#line 775 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp72_) {
#line 4228 "add-edit-page.c"
				const gchar* _tmp73_ = NULL;
				const gchar* _tmp74_ = NULL;
				gchar* _tmp75_ = NULL;
#line 776 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp73_ = error_string;
#line 776 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp74_ = _ ("        &#8226; IMAP username or password incorrect.\n");
#line 776 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp75_ = g_strconcat (_tmp73_, _tmp74_, NULL);
#line 776 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_g_free0 (error_string);
#line 776 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				error_string = _tmp75_;
#line 4242 "add-edit-page.c"
			}
#line 778 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp76_ = self->priv->last_validation_result;
#line 778 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp77_ = geary_engine_validation_result_is_all_set (_tmp76_, GEARY_ENGINE_VALIDATION_RESULT_SMTP_CONNECTION_FAILED);
#line 778 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp77_) {
#line 4250 "add-edit-page.c"
				const gchar* _tmp78_ = NULL;
				const gchar* _tmp79_ = NULL;
				gchar* _tmp80_ = NULL;
#line 779 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp78_ = error_string;
#line 779 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp79_ = _ ("        &#8226; SMTP connection error.\n");
#line 779 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp80_ = g_strconcat (_tmp78_, _tmp79_, NULL);
#line 779 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_g_free0 (error_string);
#line 779 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				error_string = _tmp80_;
#line 4264 "add-edit-page.c"
			}
#line 781 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp81_ = self->priv->last_validation_result;
#line 781 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp82_ = geary_engine_validation_result_is_all_set (_tmp81_, GEARY_ENGINE_VALIDATION_RESULT_SMTP_CREDENTIALS_INVALID);
#line 781 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp82_) {
#line 4272 "add-edit-page.c"
				const gchar* _tmp83_ = NULL;
				const gchar* _tmp84_ = NULL;
				gchar* _tmp85_ = NULL;
#line 782 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp83_ = error_string;
#line 782 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp84_ = _ ("        &#8226; SMTP username or password incorrect.\n");
#line 782 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp85_ = g_strconcat (_tmp83_, _tmp84_, NULL);
#line 782 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_g_free0 (error_string);
#line 782 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				error_string = _tmp85_;
#line 4286 "add-edit-page.c"
			}
		} else {
			gboolean _tmp86_ = FALSE;
			GearyEngineValidationResult _tmp87_ = 0;
			gboolean _tmp88_ = FALSE;
			gboolean _tmp94_ = FALSE;
			GearyEngineValidationResult _tmp95_ = 0;
			gboolean _tmp96_ = FALSE;
#line 784 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp87_ = self->priv->last_validation_result;
#line 784 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp88_ = geary_engine_validation_result_is_all_set (_tmp87_, GEARY_ENGINE_VALIDATION_RESULT_IMAP_CONNECTION_FAILED);
#line 784 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp88_) {
#line 784 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp86_ = TRUE;
#line 4303 "add-edit-page.c"
			} else {
				GearyEngineValidationResult _tmp89_ = 0;
				gboolean _tmp90_ = FALSE;
#line 785 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp89_ = self->priv->last_validation_result;
#line 785 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp90_ = geary_engine_validation_result_is_all_set (_tmp89_, GEARY_ENGINE_VALIDATION_RESULT_SMTP_CONNECTION_FAILED);
#line 785 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp86_ = _tmp90_;
#line 4313 "add-edit-page.c"
			}
#line 784 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp86_) {
#line 4317 "add-edit-page.c"
				const gchar* _tmp91_ = NULL;
				const gchar* _tmp92_ = NULL;
				gchar* _tmp93_ = NULL;
#line 786 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp91_ = error_string;
#line 786 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp92_ = _ ("        &#8226; Connection error.\n");
#line 786 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp93_ = g_strconcat (_tmp91_, _tmp92_, NULL);
#line 786 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_g_free0 (error_string);
#line 786 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				error_string = _tmp93_;
#line 4331 "add-edit-page.c"
			}
#line 788 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp95_ = self->priv->last_validation_result;
#line 788 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp96_ = geary_engine_validation_result_is_all_set (_tmp95_, GEARY_ENGINE_VALIDATION_RESULT_IMAP_CREDENTIALS_INVALID);
#line 788 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp96_) {
#line 788 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp94_ = TRUE;
#line 4341 "add-edit-page.c"
			} else {
				GearyEngineValidationResult _tmp97_ = 0;
				gboolean _tmp98_ = FALSE;
#line 789 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp97_ = self->priv->last_validation_result;
#line 789 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp98_ = geary_engine_validation_result_is_all_set (_tmp97_, GEARY_ENGINE_VALIDATION_RESULT_SMTP_CREDENTIALS_INVALID);
#line 789 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp94_ = _tmp98_;
#line 4351 "add-edit-page.c"
			}
#line 788 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp94_) {
#line 4355 "add-edit-page.c"
				const gchar* _tmp99_ = NULL;
				const gchar* _tmp100_ = NULL;
				gchar* _tmp101_ = NULL;
#line 790 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp99_ = error_string;
#line 790 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp100_ = _ ("        &#8226; Username or password incorrect.\n");
#line 790 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp101_ = g_strconcat (_tmp99_, _tmp100_, NULL);
#line 790 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_g_free0 (error_string);
#line 790 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				error_string = _tmp101_;
#line 4369 "add-edit-page.c"
			}
		}
#line 793 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp102_ = self->priv->label_error;
#line 793 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp103_ = error_string;
#line 793 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp104_ = g_strconcat ("<span color=\"red\">", _tmp103_, NULL);
#line 793 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp105_ = _tmp104_;
#line 793 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp106_ = g_strconcat (_tmp105_, "</span>", NULL);
#line 793 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp107_ = _tmp106_;
#line 793 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_label_set_label (_tmp102_, _tmp107_);
#line 793 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_free0 (_tmp107_);
#line 793 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_free0 (_tmp105_);
#line 759 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_g_free0 (error_string);
#line 4392 "add-edit-page.c"
	}
#line 796 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_emit_by_name (self, "size-changed");
#line 801 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp109_ = self->priv->first_ui_update;
#line 801 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp109_) {
#line 4400 "add-edit-page.c"
		GtkContainer* _tmp110_ = NULL;
		GtkContainer* _tmp111_ = NULL;
		gboolean _tmp112_ = FALSE;
#line 801 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp110_ = gtk_widget_get_parent (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 801 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp111_ = _tmp110_;
#line 801 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp112_ = gtk_widget_get_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp111_, gtk_widget_get_type (), GtkWidget));
#line 801 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp108_ = _tmp112_;
#line 4412 "add-edit-page.c"
	} else {
#line 801 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp108_ = FALSE;
#line 4416 "add-edit-page.c"
	}
#line 801 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp108_) {
#line 4420 "add-edit-page.c"
		AddEditPagePageMode _tmp113_ = 0;
#line 802 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp113_ = self->priv->mode;
#line 802 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		if (_tmp113_ == ADD_EDIT_PAGE_PAGE_MODE_EDIT) {
#line 4426 "add-edit-page.c"
			GearyServiceProvider _tmp114_ = 0;
#line 803 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp114_ = add_edit_page_get_service_provider (self);
#line 803 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp114_ != GEARY_SERVICE_PROVIDER_OTHER) {
#line 4432 "add-edit-page.c"
				GtkEntry* _tmp115_ = NULL;
#line 804 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp115_ = self->priv->entry_password;
#line 804 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp115_, gtk_widget_get_type (), GtkWidget));
#line 4438 "add-edit-page.c"
			} else {
				GtkEntry* _tmp116_ = NULL;
#line 806 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp116_ = self->priv->entry_imap_password;
#line 806 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp116_, gtk_widget_get_type (), GtkWidget));
#line 4445 "add-edit-page.c"
			}
		} else {
			const gchar* _tmp117_ = NULL;
			const gchar* _tmp118_ = NULL;
			gboolean _tmp119_ = FALSE;
#line 808 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp117_ = add_edit_page_get_real_name (self);
#line 808 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp118_ = _tmp117_;
#line 808 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			_tmp119_ = geary_string_is_empty (_tmp118_);
#line 808 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			if (_tmp119_) {
#line 4459 "add-edit-page.c"
				GtkEntry* _tmp120_ = NULL;
#line 809 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp120_ = self->priv->entry_real_name;
#line 809 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp120_, gtk_widget_get_type (), GtkWidget));
#line 4465 "add-edit-page.c"
			} else {
				AddEditPagePageMode _tmp121_ = 0;
#line 810 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp121_ = self->priv->mode;
#line 810 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				if (_tmp121_ == ADD_EDIT_PAGE_PAGE_MODE_ADD) {
#line 4472 "add-edit-page.c"
					GtkEntry* _tmp122_ = NULL;
#line 811 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
					_tmp122_ = self->priv->entry_nickname;
#line 811 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
					gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp122_, gtk_widget_get_type (), GtkWidget));
#line 4478 "add-edit-page.c"
				} else {
					GtkEntry* _tmp123_ = NULL;
#line 813 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
					_tmp123_ = self->priv->entry_email;
#line 813 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
					gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp123_, gtk_widget_get_type (), GtkWidget));
#line 4485 "add-edit-page.c"
				}
			}
		}
#line 816 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		self->priv->first_ui_update = FALSE;
#line 4491 "add-edit-page.c"
	}
}


GearyServiceProvider add_edit_page_get_service_provider (AddEditPage* self) {
	GearyServiceProvider result = 0;
	GtkComboBoxText* _tmp0_ = NULL;
	gint _tmp1_ = 0;
#line 820 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), 0);
#line 821 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->combo_service;
#line 821 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_combo_box_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_combo_box_get_type (), GtkComboBox));
#line 821 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = (GearyServiceProvider) _tmp1_;
#line 821 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 4510 "add-edit-page.c"
}


void add_edit_page_set_service_provider (AddEditPage* self, GearyServiceProvider provider) {
	gint _tmp0_ = 0;
	GearyServiceProvider* _tmp1_ = NULL;
	GtkComboBoxText* _tmp6_ = NULL;
	gint _tmp7_ = 0;
#line 824 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 825 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = geary_service_provider_get_providers (&_tmp0_);
#line 4523 "add-edit-page.c"
	{
		GearyServiceProvider* p_collection = NULL;
		gint p_collection_length1 = 0;
		gint _p_collection_size_ = 0;
		gint p_it = 0;
#line 825 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		p_collection = _tmp1_;
#line 825 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		p_collection_length1 = _tmp0_;
#line 825 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		for (p_it = 0; p_it < _tmp0_; p_it = p_it + 1) {
#line 4535 "add-edit-page.c"
			GearyServiceProvider p = 0;
#line 825 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
			p = p_collection[p_it];
#line 4539 "add-edit-page.c"
			{
				GearyServiceProvider _tmp2_ = 0;
				GearyServiceProvider _tmp3_ = 0;
#line 826 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp2_ = p;
#line 826 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				_tmp3_ = provider;
#line 826 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
				if (_tmp2_ == _tmp3_) {
#line 4549 "add-edit-page.c"
					GtkComboBoxText* _tmp4_ = NULL;
					GearyServiceProvider _tmp5_ = 0;
#line 827 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
					_tmp4_ = self->priv->combo_service;
#line 827 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
					_tmp5_ = p;
#line 827 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
					gtk_combo_box_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_combo_box_get_type (), GtkComboBox), (gint) _tmp5_);
#line 4558 "add-edit-page.c"
				}
			}
		}
#line 825 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		p_collection = (g_free (p_collection), NULL);
#line 4564 "add-edit-page.c"
	}
#line 830 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp6_ = self->priv->combo_service;
#line 830 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp7_ = gtk_combo_box_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_combo_box_get_type (), GtkComboBox));
#line 830 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp7_ == -1) {
#line 4572 "add-edit-page.c"
		GtkComboBoxText* _tmp8_ = NULL;
#line 831 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp8_ = self->priv->combo_service;
#line 831 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_combo_box_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_combo_box_get_type (), GtkComboBox), 0);
#line 4578 "add-edit-page.c"
	}
}


void add_edit_page_set_other_info_sensitive (AddEditPage* self, gboolean sensitive) {
	GtkEntry* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GtkEntry* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	GtkEntry* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	GtkEntry* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	GtkComboBox* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	GtkEntry* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	GtkEntry* _tmp12_ = NULL;
	gboolean _tmp13_ = FALSE;
	GtkCheckButton* _tmp14_ = NULL;
	gboolean _tmp15_ = FALSE;
	GtkEntry* _tmp16_ = NULL;
	gboolean _tmp17_ = FALSE;
	GtkEntry* _tmp18_ = NULL;
	gboolean _tmp19_ = FALSE;
	GtkComboBox* _tmp20_ = NULL;
	gboolean _tmp21_ = FALSE;
#line 835 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 836 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_imap_host;
#line 836 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = sensitive;
#line 836 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), _tmp1_);
#line 837 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = self->priv->entry_imap_port;
#line 837 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp3_ = sensitive;
#line 837 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget), _tmp3_);
#line 838 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp4_ = self->priv->entry_imap_username;
#line 838 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp5_ = sensitive;
#line 838 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget), _tmp5_);
#line 839 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp6_ = self->priv->entry_imap_password;
#line 839 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp7_ = sensitive;
#line 839 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget), _tmp7_);
#line 840 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp8_ = self->priv->combo_imap_encryption;
#line 840 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp9_ = sensitive;
#line 840 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget), _tmp9_);
#line 842 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp10_ = self->priv->entry_smtp_host;
#line 842 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp11_ = sensitive;
#line 842 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_widget_get_type (), GtkWidget), _tmp11_);
#line 843 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp12_ = self->priv->entry_smtp_port;
#line 843 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp13_ = sensitive;
#line 843 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget), _tmp13_);
#line 844 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp14_ = self->priv->check_smtp_use_imap_credentials;
#line 844 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp15_ = sensitive;
#line 844 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_widget_get_type (), GtkWidget), _tmp15_);
#line 845 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp16_ = self->priv->entry_smtp_username;
#line 845 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp17_ = sensitive;
#line 845 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_widget_get_type (), GtkWidget), _tmp17_);
#line 846 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp18_ = self->priv->entry_smtp_password;
#line 846 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp19_ = sensitive;
#line 846 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gtk_widget_get_type (), GtkWidget), _tmp19_);
#line 847 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp20_ = self->priv->combo_smtp_encryption;
#line 847 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp21_ = sensitive;
#line 847 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, gtk_widget_get_type (), GtkWidget), _tmp21_);
#line 4674 "add-edit-page.c"
}


static void add_edit_page_real_show_all (GtkWidget* base) {
	AddEditPage * self;
#line 852 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_ADD_EDIT_PAGE, AddEditPage);
#line 854 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_update_ui (self);
#line 4684 "add-edit-page.c"
}


static gchar* add_edit_page_get_default_real_name (AddEditPage* self) {
	gchar* result = NULL;
	gchar* real_name = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp5_ = NULL;
#line 857 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), NULL);
#line 858 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = g_get_real_name ();
#line 858 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 858 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	real_name = _tmp1_;
#line 859 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp3_ = real_name;
#line 859 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (g_strcmp0 (_tmp3_, "Unknown") == 0) {
#line 859 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp2_ = "";
#line 4710 "add-edit-page.c"
	} else {
		const gchar* _tmp4_ = NULL;
#line 859 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp4_ = real_name;
#line 859 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp2_ = _tmp4_;
#line 4717 "add-edit-page.c"
	}
#line 859 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp5_ = g_strdup (_tmp2_);
#line 859 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp5_;
#line 859 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_free0 (real_name);
#line 859 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 4727 "add-edit-page.c"
}


static void add_edit_page_set_storage_length (AddEditPage* self, gint days) {
	GtkComboBoxText* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 864 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 865 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->combo_storage_length;
#line 865 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = days;
#line 865 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = g_strdup_printf ("%i", _tmp1_);
#line 865 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp3_ = _tmp2_;
#line 865 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_combo_box_set_active_id (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_combo_box_get_type (), GtkComboBox), _tmp3_);
#line 865 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_free0 (_tmp3_);
#line 4750 "add-edit-page.c"
}


static gint add_edit_page_get_storage_length (AddEditPage* self) {
	gint result = 0;
	GtkComboBoxText* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
#line 869 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), 0);
#line 870 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->combo_storage_length;
#line 870 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_combo_box_get_active_id (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_combo_box_get_type (), GtkComboBox));
#line 870 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = atoi (_tmp1_);
#line 870 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_;
#line 870 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 4771 "add-edit-page.c"
}


static gboolean add_edit_page_combo_storage_separator_delegate (AddEditPage* self, GtkTreeModel* model, GtkTreeIter* iter) {
	gboolean result = FALSE;
	GValue v = {0};
	GtkTreeModel* _tmp0_ = NULL;
	GtkTreeIter _tmp1_ = {0};
	GValue _tmp2_ = {0};
	const gchar* _tmp3_ = NULL;
#line 873 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), FALSE);
#line 873 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (GTK_IS_TREE_MODEL (model), FALSE);
#line 873 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 875 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = model;
#line 875 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = *iter;
#line 875 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_tree_model_get_value (_tmp0_, &_tmp1_, 0, &_tmp2_);
#line 875 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 875 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	v = _tmp2_;
#line 877 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp3_ = g_value_get_string (&v);
#line 877 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = g_strcmp0 (_tmp3_, ".") == 0;
#line 877 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
#line 877 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 4806 "add-edit-page.c"
}


const gchar* add_edit_page_get_real_name (AddEditPage* self) {
	const gchar* result;
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
#line 19 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), NULL);
#line 19 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_real_name;
#line 19 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 19 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 19 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_;
#line 19 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 4827 "add-edit-page.c"
}


void add_edit_page_set_real_name (AddEditPage* self, const gchar* value) {
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 20 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 20 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_real_name;
#line 20 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 20 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_entry_set_text (_tmp0_, _tmp1_);
#line 20 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "real-name");
#line 4844 "add-edit-page.c"
}


const gchar* add_edit_page_get_nickname (AddEditPage* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	AddEditPagePageMode _tmp1_ = 0;
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), NULL);
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = self->priv->mode;
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp1_ == ADD_EDIT_PAGE_PAGE_MODE_WELCOME) {
#line 4858 "add-edit-page.c"
		const gchar* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp2_ = add_edit_page_get_email_address (self);
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp3_ = _tmp2_;
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp0_ = _tmp3_;
#line 4867 "add-edit-page.c"
	} else {
		GtkEntry* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp4_ = self->priv->entry_nickname;
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp5_ = gtk_entry_get_text (_tmp4_);
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp6_ = _tmp5_;
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp0_ = _tmp6_;
#line 4880 "add-edit-page.c"
	}
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp0_;
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 4886 "add-edit-page.c"
}


void add_edit_page_set_nickname (AddEditPage* self, const gchar* value) {
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 25 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 25 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_nickname;
#line 25 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 25 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_entry_set_text (_tmp0_, _tmp1_);
#line 25 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "nickname");
#line 4903 "add-edit-page.c"
}


const gchar* add_edit_page_get_email_address (AddEditPage* self) {
	const gchar* result;
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
#line 29 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), NULL);
#line 29 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_email;
#line 29 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 29 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 29 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_;
#line 29 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 4924 "add-edit-page.c"
}


void add_edit_page_set_email_address (AddEditPage* self, const gchar* value) {
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 30 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 30 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_email;
#line 30 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 30 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_entry_set_text (_tmp0_, _tmp1_);
#line 30 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "email-address");
#line 4941 "add-edit-page.c"
}


const gchar* add_edit_page_get_password (AddEditPage* self) {
	const gchar* result;
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
#line 34 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), NULL);
#line 34 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_password;
#line 34 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 34 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 34 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_;
#line 34 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 4962 "add-edit-page.c"
}


void add_edit_page_set_password (AddEditPage* self, const gchar* value) {
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 35 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 35 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_password;
#line 35 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 35 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_entry_set_text (_tmp0_, _tmp1_);
#line 35 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "password");
#line 4979 "add-edit-page.c"
}


const gchar* add_edit_page_get_imap_username (AddEditPage* self) {
	const gchar* result;
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
#line 39 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), NULL);
#line 39 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_imap_username;
#line 39 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 39 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 39 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_;
#line 39 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5000 "add-edit-page.c"
}


void add_edit_page_set_imap_username (AddEditPage* self, const gchar* value) {
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 40 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 40 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_imap_username;
#line 40 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 40 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_entry_set_text (_tmp0_, _tmp1_);
#line 40 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "imap-username");
#line 5017 "add-edit-page.c"
}


const gchar* add_edit_page_get_imap_password (AddEditPage* self) {
	const gchar* result;
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
#line 44 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), NULL);
#line 44 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_imap_password;
#line 44 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 44 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 44 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_;
#line 44 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5038 "add-edit-page.c"
}


void add_edit_page_set_imap_password (AddEditPage* self, const gchar* value) {
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 45 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 45 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_imap_password;
#line 45 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 45 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_entry_set_text (_tmp0_, _tmp1_);
#line 45 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "imap-password");
#line 5055 "add-edit-page.c"
}


gboolean add_edit_page_get_remember_password (AddEditPage* self) {
	gboolean result;
	GtkCheckButton* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 49 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), FALSE);
#line 49 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->check_remember_password;
#line 49 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 49 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 49 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_;
#line 49 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5076 "add-edit-page.c"
}


void add_edit_page_set_remember_password (AddEditPage* self, gboolean value) {
	GtkCheckButton* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 50 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 50 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->check_remember_password;
#line 50 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 50 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_toggle_button_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_toggle_button_get_type (), GtkToggleButton), _tmp1_);
#line 50 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "remember-password");
#line 5093 "add-edit-page.c"
}


gboolean add_edit_page_get_use_email_signature (AddEditPage* self) {
	gboolean result;
	GtkCheckButton* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 54 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), FALSE);
#line 54 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->check_use_email_signature;
#line 54 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 54 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 54 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_;
#line 54 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5114 "add-edit-page.c"
}


void add_edit_page_set_use_email_signature (AddEditPage* self, gboolean value) {
	GtkCheckButton* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 55 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 55 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->check_use_email_signature;
#line 55 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 55 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_toggle_button_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_toggle_button_get_type (), GtkToggleButton), _tmp1_);
#line 55 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "use-email-signature");
#line 5131 "add-edit-page.c"
}


gchar* add_edit_page_get_email_signature (AddEditPage* self) {
	gchar* result;
	GtkTextView* _tmp0_ = NULL;
	GtkTextBuffer* _tmp1_ = NULL;
	GtkTextBuffer* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
#line 59 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), NULL);
#line 60 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->textview_email_signature;
#line 60 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_text_view_get_buffer (_tmp0_);
#line 60 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 60 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_get (_tmp2_, "text", &_tmp3_, NULL);
#line 60 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp4_ = _tmp3_;
#line 60 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp4_;
#line 60 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5158 "add-edit-page.c"
}


void add_edit_page_set_email_signature (AddEditPage* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GtkTextView* _tmp2_ = NULL;
	GtkTextBuffer* _tmp3_ = NULL;
	GtkTextBuffer* _tmp4_ = NULL;
#line 62 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 63 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 63 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = _tmp1_;
#line 63 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp0_ == NULL) {
#line 63 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp0_ = "";
#line 5178 "add-edit-page.c"
	}
#line 63 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = self->priv->textview_email_signature;
#line 63 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp3_ = gtk_text_view_get_buffer (_tmp2_);
#line 63 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp4_ = _tmp3_;
#line 63 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_set (_tmp4_, "text", _tmp0_, NULL);
#line 62 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "email-signature");
#line 5190 "add-edit-page.c"
}


gboolean add_edit_page_get_save_sent_mail (AddEditPage* self) {
	gboolean result;
	GtkCheckButton* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 68 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), FALSE);
#line 68 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->check_save_sent_mail;
#line 68 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 68 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 68 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_;
#line 68 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5211 "add-edit-page.c"
}


void add_edit_page_set_save_sent_mail (AddEditPage* self, gboolean value) {
	GtkCheckButton* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 69 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 69 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->check_save_sent_mail;
#line 69 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 69 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_toggle_button_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_toggle_button_get_type (), GtkToggleButton), _tmp1_);
#line 69 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "save-sent-mail");
#line 5228 "add-edit-page.c"
}


const gchar* add_edit_page_get_smtp_username (AddEditPage* self) {
	const gchar* result;
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
#line 73 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), NULL);
#line 73 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_smtp_username;
#line 73 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 73 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 73 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_;
#line 73 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5249 "add-edit-page.c"
}


void add_edit_page_set_smtp_username (AddEditPage* self, const gchar* value) {
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 74 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 74 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_smtp_username;
#line 74 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 74 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_entry_set_text (_tmp0_, _tmp1_);
#line 74 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "smtp-username");
#line 5266 "add-edit-page.c"
}


const gchar* add_edit_page_get_smtp_password (AddEditPage* self) {
	const gchar* result;
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
#line 78 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), NULL);
#line 78 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_smtp_password;
#line 78 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 78 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 78 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_;
#line 78 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5287 "add-edit-page.c"
}


void add_edit_page_set_smtp_password (AddEditPage* self, const gchar* value) {
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 79 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 79 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_smtp_password;
#line 79 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 79 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_entry_set_text (_tmp0_, _tmp1_);
#line 79 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "smtp-password");
#line 5304 "add-edit-page.c"
}


const gchar* add_edit_page_get_imap_host (AddEditPage* self) {
	const gchar* result;
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), NULL);
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_imap_host;
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_;
#line 83 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5325 "add-edit-page.c"
}


void add_edit_page_set_imap_host (AddEditPage* self, const gchar* value) {
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_imap_host;
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_entry_set_text (_tmp0_, _tmp1_);
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "imap-host");
#line 5342 "add-edit-page.c"
}


guint16 add_edit_page_get_imap_port (AddEditPage* self) {
	guint16 result;
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	guint16 _tmp6_ = 0U;
#line 88 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), 0U);
#line 88 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_imap_port;
#line 88 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 88 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 88 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp3_ = string_strip (_tmp2_);
#line 88 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp4_ = _tmp3_;
#line 88 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp5_ = atoi (_tmp4_);
#line 88 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp6_ = (guint16) _tmp5_;
#line 88 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_free0 (_tmp4_);
#line 88 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp6_;
#line 88 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5377 "add-edit-page.c"
}


void add_edit_page_set_imap_port (AddEditPage* self, guint16 value) {
	GtkEntry* _tmp0_ = NULL;
	guint16 _tmp1_ = 0U;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_imap_port;
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = g_strdup_printf ("%hu", _tmp1_);
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp3_ = _tmp2_;
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_entry_set_text (_tmp0_, _tmp3_);
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_free0 (_tmp3_);
#line 5400 "add-edit-page.c"
}


gboolean add_edit_page_get_imap_ssl (AddEditPage* self) {
	gboolean result;
	GtkComboBox* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 93 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), FALSE);
#line 93 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->combo_imap_encryption;
#line 93 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_combo_box_get_active (_tmp0_);
#line 93 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 93 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_ == ((gint) ADD_EDIT_PAGE_ENCRYPTION_SSL);
#line 93 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5421 "add-edit-page.c"
}


void add_edit_page_set_imap_ssl (AddEditPage* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 94 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 95 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = value;
#line 95 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp0_) {
#line 5433 "add-edit-page.c"
		GtkComboBox* _tmp1_ = NULL;
#line 96 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp1_ = self->priv->combo_imap_encryption;
#line 96 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_combo_box_set_active (_tmp1_, (gint) ADD_EDIT_PAGE_ENCRYPTION_SSL);
#line 5439 "add-edit-page.c"
	}
#line 94 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "imap-ssl");
#line 5443 "add-edit-page.c"
}


gboolean add_edit_page_get_imap_starttls (AddEditPage* self) {
	gboolean result;
	GtkComboBox* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 101 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), FALSE);
#line 101 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->combo_imap_encryption;
#line 101 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_combo_box_get_active (_tmp0_);
#line 101 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 101 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_ == ((gint) ADD_EDIT_PAGE_ENCRYPTION_STARTTLS);
#line 101 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5464 "add-edit-page.c"
}


void add_edit_page_set_imap_starttls (AddEditPage* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 102 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 103 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = value;
#line 103 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp0_) {
#line 5476 "add-edit-page.c"
		GtkComboBox* _tmp1_ = NULL;
#line 104 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp1_ = self->priv->combo_imap_encryption;
#line 104 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_combo_box_set_active (_tmp1_, (gint) ADD_EDIT_PAGE_ENCRYPTION_STARTTLS);
#line 5482 "add-edit-page.c"
	}
#line 102 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "imap-starttls");
#line 5486 "add-edit-page.c"
}


const gchar* add_edit_page_get_smtp_host (AddEditPage* self) {
	const gchar* result;
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
#line 109 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), NULL);
#line 109 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_smtp_host;
#line 109 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 109 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 109 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_;
#line 109 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5507 "add-edit-page.c"
}


void add_edit_page_set_smtp_host (AddEditPage* self, const gchar* value) {
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 110 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 110 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_smtp_host;
#line 110 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 110 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_entry_set_text (_tmp0_, _tmp1_);
#line 110 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "smtp-host");
#line 5524 "add-edit-page.c"
}


guint16 add_edit_page_get_smtp_port (AddEditPage* self) {
	guint16 result;
	GtkEntry* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	guint16 _tmp6_ = 0U;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), 0U);
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_smtp_port;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp3_ = string_strip (_tmp2_);
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp4_ = _tmp3_;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp5_ = atoi (_tmp4_);
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp6_ = (guint16) _tmp5_;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_free0 (_tmp4_);
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp6_;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5559 "add-edit-page.c"
}


void add_edit_page_set_smtp_port (AddEditPage* self, guint16 value) {
	GtkEntry* _tmp0_ = NULL;
	guint16 _tmp1_ = 0U;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->entry_smtp_port;
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = g_strdup_printf ("%hu", _tmp1_);
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp3_ = _tmp2_;
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_entry_set_text (_tmp0_, _tmp3_);
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_free0 (_tmp3_);
#line 5582 "add-edit-page.c"
}


gboolean add_edit_page_get_smtp_ssl (AddEditPage* self) {
	gboolean result;
	GtkComboBox* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 119 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), FALSE);
#line 119 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->combo_smtp_encryption;
#line 119 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_combo_box_get_active (_tmp0_);
#line 119 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 119 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_ == ((gint) ADD_EDIT_PAGE_ENCRYPTION_SSL);
#line 119 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5603 "add-edit-page.c"
}


void add_edit_page_set_smtp_ssl (AddEditPage* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 120 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 121 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = value;
#line 121 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp0_) {
#line 5615 "add-edit-page.c"
		GtkComboBox* _tmp1_ = NULL;
#line 122 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp1_ = self->priv->combo_smtp_encryption;
#line 122 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_combo_box_set_active (_tmp1_, (gint) ADD_EDIT_PAGE_ENCRYPTION_SSL);
#line 5621 "add-edit-page.c"
	}
#line 120 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "smtp-ssl");
#line 5625 "add-edit-page.c"
}


gboolean add_edit_page_get_smtp_starttls (AddEditPage* self) {
	gboolean result;
	GtkComboBox* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 127 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), FALSE);
#line 127 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->combo_smtp_encryption;
#line 127 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_combo_box_get_active (_tmp0_);
#line 127 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 127 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_ == ((gint) ADD_EDIT_PAGE_ENCRYPTION_STARTTLS);
#line 127 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5646 "add-edit-page.c"
}


void add_edit_page_set_smtp_starttls (AddEditPage* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 128 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 129 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = value;
#line 129 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	if (_tmp0_) {
#line 5658 "add-edit-page.c"
		GtkComboBox* _tmp1_ = NULL;
#line 130 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		_tmp1_ = self->priv->combo_smtp_encryption;
#line 130 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		gtk_combo_box_set_active (_tmp1_, (gint) ADD_EDIT_PAGE_ENCRYPTION_STARTTLS);
#line 5664 "add-edit-page.c"
	}
#line 128 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "smtp-starttls");
#line 5668 "add-edit-page.c"
}


gboolean add_edit_page_get_smtp_use_imap_credentials (AddEditPage* self) {
	gboolean result;
	GtkCheckButton* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 135 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), FALSE);
#line 135 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->check_smtp_use_imap_credentials;
#line 135 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 135 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 135 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_;
#line 135 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5689 "add-edit-page.c"
}


void add_edit_page_set_smtp_use_imap_credentials (AddEditPage* self, gboolean value) {
	GtkCheckButton* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 136 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 136 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->check_smtp_use_imap_credentials;
#line 136 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 136 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_toggle_button_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_toggle_button_get_type (), GtkToggleButton), _tmp1_);
#line 136 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "smtp-use-imap-credentials");
#line 5706 "add-edit-page.c"
}


gboolean add_edit_page_get_smtp_noauth (AddEditPage* self) {
	gboolean result;
	GtkCheckButton* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 140 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), FALSE);
#line 140 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->check_smtp_noauth;
#line 140 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 140 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 140 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_;
#line 140 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5727 "add-edit-page.c"
}


void add_edit_page_set_smtp_noauth (AddEditPage* self, gboolean value) {
	GtkCheckButton* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 141 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 141 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->check_smtp_noauth;
#line 141 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 141 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_toggle_button_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_toggle_button_get_type (), GtkToggleButton), _tmp1_);
#line 141 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "smtp-noauth");
#line 5744 "add-edit-page.c"
}


gboolean add_edit_page_get_save_drafts (AddEditPage* self) {
	gboolean result;
	GtkCheckButton* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_val_if_fail (IS_ADD_EDIT_PAGE (self), FALSE);
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->check_save_drafts;
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp2_ = _tmp1_;
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	result = _tmp2_;
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	return result;
#line 5765 "add-edit-page.c"
}


void add_edit_page_set_save_drafts (AddEditPage* self, gboolean value) {
	GtkCheckButton* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 146 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_return_if_fail (IS_ADD_EDIT_PAGE (self));
#line 146 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp0_ = self->priv->check_save_drafts;
#line 146 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_tmp1_ = value;
#line 146 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	gtk_toggle_button_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_toggle_button_get_type (), GtkToggleButton), _tmp1_);
#line 146 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_notify ((GObject *) self, "save-drafts");
#line 5782 "add-edit-page.c"
}


static void add_edit_page_class_init (AddEditPageClass * klass) {
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	add_edit_page_parent_class = g_type_class_peek_parent (klass);
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_type_class_add_private (klass, sizeof (AddEditPagePrivate));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	((GtkWidgetClass *) klass)->show_all = add_edit_page_real_show_all;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_add_edit_page_get_property;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_add_edit_page_set_property;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	G_OBJECT_CLASS (klass)->finalize = add_edit_page_finalize;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_REAL_NAME, g_param_spec_string ("real-name", "real-name", "real-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_NICKNAME, g_param_spec_string ("nickname", "nickname", "nickname", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_EMAIL_ADDRESS, g_param_spec_string ("email-address", "email-address", "email-address", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_PASSWORD, g_param_spec_string ("password", "password", "password", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_IMAP_USERNAME, g_param_spec_string ("imap-username", "imap-username", "imap-username", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_IMAP_PASSWORD, g_param_spec_string ("imap-password", "imap-password", "imap-password", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_REMEMBER_PASSWORD, g_param_spec_boolean ("remember-password", "remember-password", "remember-password", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_USE_EMAIL_SIGNATURE, g_param_spec_boolean ("use-email-signature", "use-email-signature", "use-email-signature", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_EMAIL_SIGNATURE, g_param_spec_string ("email-signature", "email-signature", "email-signature", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_SAVE_SENT_MAIL, g_param_spec_boolean ("save-sent-mail", "save-sent-mail", "save-sent-mail", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_SMTP_USERNAME, g_param_spec_string ("smtp-username", "smtp-username", "smtp-username", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_SMTP_PASSWORD, g_param_spec_string ("smtp-password", "smtp-password", "smtp-password", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_IMAP_HOST, g_param_spec_string ("imap-host", "imap-host", "imap-host", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_IMAP_SSL, g_param_spec_boolean ("imap-ssl", "imap-ssl", "imap-ssl", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_IMAP_STARTTLS, g_param_spec_boolean ("imap-starttls", "imap-starttls", "imap-starttls", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_SMTP_HOST, g_param_spec_string ("smtp-host", "smtp-host", "smtp-host", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_SMTP_SSL, g_param_spec_boolean ("smtp-ssl", "smtp-ssl", "smtp-ssl", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_SMTP_STARTTLS, g_param_spec_boolean ("smtp-starttls", "smtp-starttls", "smtp-starttls", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_SMTP_USE_IMAP_CREDENTIALS, g_param_spec_boolean ("smtp-use-imap-credentials", "smtp-use-imap-credentials", "smtp-use-imap-credentials", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_SMTP_NOAUTH, g_param_spec_boolean ("smtp-noauth", "smtp-noauth", "smtp-noauth", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ADD_EDIT_PAGE_SAVE_DRAFTS, g_param_spec_boolean ("save-drafts", "save-drafts", "save-drafts", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_new ("info_changed", TYPE_ADD_EDIT_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_new ("size_changed", TYPE_ADD_EDIT_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	g_signal_new ("edit_alternate_emails", TYPE_ADD_EDIT_PAGE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 5847 "add-edit-page.c"
}


static void add_edit_page_instance_init (AddEditPage * self) {
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv = ADD_EDIT_PAGE_GET_PRIVATE (self);
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->mode = ADD_EDIT_PAGE_PAGE_MODE_WELCOME;
#line 208 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->edited_imap_port = FALSE;
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->edited_smtp_port = FALSE;
#line 211 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->last_validation_result = GEARY_ENGINE_VALIDATION_RESULT_OK;
#line 213 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self->priv->first_ui_update = TRUE;
#line 5864 "add-edit-page.c"
}


static void add_edit_page_finalize (GObject* obj) {
	AddEditPage * self;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ADD_EDIT_PAGE, AddEditPage);
#line 158 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->container_widget);
#line 159 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->welcome_box);
#line 161 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->label_error);
#line 163 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_email);
#line 164 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->label_password);
#line 165 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_password);
#line 166 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_real_name);
#line 167 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->label_nickname);
#line 168 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_nickname);
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->combo_service);
#line 170 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->check_remember_password);
#line 171 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->check_save_sent_mail);
#line 172 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->alternate_email_button);
#line 175 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->composer_container);
#line 176 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->check_use_email_signature);
#line 177 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->signature_stack);
#line 178 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->textview_email_signature);
#line 179 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->preview_webview);
#line 181 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->other_info);
#line 184 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_imap_host);
#line 185 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_imap_port);
#line 186 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_imap_username);
#line 187 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_imap_password);
#line 188 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->combo_imap_encryption);
#line 191 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_smtp_host);
#line 192 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_smtp_port);
#line 193 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_smtp_username);
#line 194 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->entry_smtp_password);
#line 195 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->combo_smtp_encryption);
#line 196 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->check_smtp_use_imap_credentials);
#line 197 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->check_smtp_noauth);
#line 199 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->check_save_drafts);
#line 201 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_free0 (self->priv->smtp_username_store);
#line 202 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_free0 (self->priv->smtp_password_store);
#line 205 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->storage_container);
#line 206 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	_g_object_unref0 (self->priv->combo_storage_length);
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	G_OBJECT_CLASS (add_edit_page_parent_class)->finalize (obj);
#line 5946 "add-edit-page.c"
}


GType add_edit_page_get_type (void) {
	static volatile gsize add_edit_page_type_id__volatile = 0;
	if (g_once_init_enter (&add_edit_page_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AddEditPageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) add_edit_page_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AddEditPage), 0, (GInstanceInitFunc) add_edit_page_instance_init, NULL };
		GType add_edit_page_type_id;
		add_edit_page_type_id = g_type_register_static (gtk_box_get_type (), "AddEditPage", &g_define_type_info, 0);
		g_once_init_leave (&add_edit_page_type_id__volatile, add_edit_page_type_id);
	}
	return add_edit_page_type_id__volatile;
}


static void _vala_add_edit_page_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	AddEditPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ADD_EDIT_PAGE, AddEditPage);
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	switch (property_id) {
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_REAL_NAME:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_string (value, add_edit_page_get_real_name (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_NICKNAME:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_string (value, add_edit_page_get_nickname (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_EMAIL_ADDRESS:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_string (value, add_edit_page_get_email_address (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_PASSWORD:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_string (value, add_edit_page_get_password (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_IMAP_USERNAME:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_string (value, add_edit_page_get_imap_username (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_IMAP_PASSWORD:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_string (value, add_edit_page_get_imap_password (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_REMEMBER_PASSWORD:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_boolean (value, add_edit_page_get_remember_password (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_USE_EMAIL_SIGNATURE:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_boolean (value, add_edit_page_get_use_email_signature (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_EMAIL_SIGNATURE:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_take_string (value, add_edit_page_get_email_signature (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_SAVE_SENT_MAIL:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_boolean (value, add_edit_page_get_save_sent_mail (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_SMTP_USERNAME:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_string (value, add_edit_page_get_smtp_username (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_SMTP_PASSWORD:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_string (value, add_edit_page_get_smtp_password (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_IMAP_HOST:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_string (value, add_edit_page_get_imap_host (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_IMAP_SSL:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_boolean (value, add_edit_page_get_imap_ssl (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_IMAP_STARTTLS:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_boolean (value, add_edit_page_get_imap_starttls (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_SMTP_HOST:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_string (value, add_edit_page_get_smtp_host (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_SMTP_SSL:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_boolean (value, add_edit_page_get_smtp_ssl (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_SMTP_STARTTLS:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_boolean (value, add_edit_page_get_smtp_starttls (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_SMTP_USE_IMAP_CREDENTIALS:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_boolean (value, add_edit_page_get_smtp_use_imap_credentials (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_SMTP_NOAUTH:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_boolean (value, add_edit_page_get_smtp_noauth (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_SAVE_DRAFTS:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		g_value_set_boolean (value, add_edit_page_get_save_drafts (self));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 6093 "add-edit-page.c"
		default:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 6099 "add-edit-page.c"
	}
}


static void _vala_add_edit_page_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	AddEditPage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ADD_EDIT_PAGE, AddEditPage);
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
	switch (property_id) {
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_REAL_NAME:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_real_name (self, g_value_get_string (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_NICKNAME:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_nickname (self, g_value_get_string (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_EMAIL_ADDRESS:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_email_address (self, g_value_get_string (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_PASSWORD:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_password (self, g_value_get_string (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_IMAP_USERNAME:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_imap_username (self, g_value_get_string (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_IMAP_PASSWORD:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_imap_password (self, g_value_get_string (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_REMEMBER_PASSWORD:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_remember_password (self, g_value_get_boolean (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_USE_EMAIL_SIGNATURE:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_use_email_signature (self, g_value_get_boolean (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_EMAIL_SIGNATURE:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_email_signature (self, g_value_get_string (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_SAVE_SENT_MAIL:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_save_sent_mail (self, g_value_get_boolean (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_SMTP_USERNAME:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_smtp_username (self, g_value_get_string (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_SMTP_PASSWORD:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_smtp_password (self, g_value_get_string (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_IMAP_HOST:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_imap_host (self, g_value_get_string (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_IMAP_SSL:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_imap_ssl (self, g_value_get_boolean (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_IMAP_STARTTLS:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_imap_starttls (self, g_value_get_boolean (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_SMTP_HOST:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_smtp_host (self, g_value_get_string (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_SMTP_SSL:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_smtp_ssl (self, g_value_get_boolean (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_SMTP_STARTTLS:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_smtp_starttls (self, g_value_get_boolean (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_SMTP_USE_IMAP_CREDENTIALS:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_smtp_use_imap_credentials (self, g_value_get_boolean (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_SMTP_NOAUTH:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_smtp_noauth (self, g_value_get_boolean (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		case ADD_EDIT_PAGE_SAVE_DRAFTS:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		add_edit_page_set_save_drafts (self, g_value_get_boolean (value));
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 6235 "add-edit-page.c"
		default:
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "/builddir/build/BUILD/geary-0.11.2/src/client/accounts/add-edit-page.vala"
		break;
#line 6241 "add-edit-page.c"
	}
}



