/* smtp-outbox-folder.c generated by valac 0.30.2, the Vala compiler
 * generated from smtp-outbox-folder.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* Special type of folder that runs an asynchronous send queue.  Messages are*/
/* saved to the database, then queued up for sending.*/
/**/
/* The Outbox table is not currently maintained in its own database, so it must piggy-back*/
/* on the ImapDB.Database.  SmtpOutboxFolder assumes the database is opened before it's passed in*/
/* to the constructor -- it does not open or close the database itself and will start using it*/
/* immediately.*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define GEARY_TYPE_BASE_OBJECT (geary_base_object_get_type ())
#define GEARY_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObject))
#define GEARY_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))
#define GEARY_IS_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_BASE_OBJECT))
#define GEARY_IS_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_BASE_OBJECT))
#define GEARY_BASE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))

typedef struct _GearyBaseObject GearyBaseObject;
typedef struct _GearyBaseObjectClass GearyBaseObjectClass;
typedef struct _GearyBaseObjectPrivate GearyBaseObjectPrivate;

#define GEARY_TYPE_FOLDER (geary_folder_get_type ())
#define GEARY_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_FOLDER, GearyFolder))
#define GEARY_FOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_FOLDER, GearyFolderClass))
#define GEARY_IS_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_FOLDER))
#define GEARY_IS_FOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_FOLDER))
#define GEARY_FOLDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_FOLDER, GearyFolderClass))

typedef struct _GearyFolder GearyFolder;
typedef struct _GearyFolderClass GearyFolderClass;
typedef struct _GearyFolderPrivate GearyFolderPrivate;

#define GEARY_FOLDER_TYPE_OPEN_STATE (geary_folder_open_state_get_type ())

#define GEARY_FOLDER_TYPE_OPEN_FAILED (geary_folder_open_failed_get_type ())

#define GEARY_FOLDER_TYPE_CLOSE_REASON (geary_folder_close_reason_get_type ())

#define GEARY_TYPE_EMAIL_IDENTIFIER (geary_email_identifier_get_type ())
#define GEARY_EMAIL_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier))
#define GEARY_EMAIL_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifierClass))
#define GEARY_IS_EMAIL_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_EMAIL_IDENTIFIER))
#define GEARY_IS_EMAIL_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_EMAIL_IDENTIFIER))
#define GEARY_EMAIL_IDENTIFIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifierClass))

typedef struct _GearyEmailIdentifier GearyEmailIdentifier;
typedef struct _GearyEmailIdentifierClass GearyEmailIdentifierClass;

#define GEARY_FOLDER_TYPE_COUNT_CHANGE_REASON (geary_folder_count_change_reason_get_type ())

#define GEARY_TYPE_NAMED_FLAGS (geary_named_flags_get_type ())
#define GEARY_NAMED_FLAGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_NAMED_FLAGS, GearyNamedFlags))
#define GEARY_NAMED_FLAGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_NAMED_FLAGS, GearyNamedFlagsClass))
#define GEARY_IS_NAMED_FLAGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_NAMED_FLAGS))
#define GEARY_IS_NAMED_FLAGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_NAMED_FLAGS))
#define GEARY_NAMED_FLAGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_NAMED_FLAGS, GearyNamedFlagsClass))

typedef struct _GearyNamedFlags GearyNamedFlags;
typedef struct _GearyNamedFlagsClass GearyNamedFlagsClass;

#define GEARY_TYPE_EMAIL_FLAGS (geary_email_flags_get_type ())
#define GEARY_EMAIL_FLAGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_EMAIL_FLAGS, GearyEmailFlags))
#define GEARY_EMAIL_FLAGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_EMAIL_FLAGS, GearyEmailFlagsClass))
#define GEARY_IS_EMAIL_FLAGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_EMAIL_FLAGS))
#define GEARY_IS_EMAIL_FLAGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_EMAIL_FLAGS))
#define GEARY_EMAIL_FLAGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_EMAIL_FLAGS, GearyEmailFlagsClass))

typedef struct _GearyEmailFlags GearyEmailFlags;
typedef struct _GearyEmailFlagsClass GearyEmailFlagsClass;

#define GEARY_TYPE_SPECIAL_FOLDER_TYPE (geary_special_folder_type_get_type ())

#define GEARY_FOLDER_TYPE_OPEN_FLAGS (geary_folder_open_flags_get_type ())

#define GEARY_EMAIL_TYPE_FIELD (geary_email_field_get_type ())

#define GEARY_FOLDER_TYPE_LIST_FLAGS (geary_folder_list_flags_get_type ())

#define GEARY_TYPE_EMAIL (geary_email_get_type ())
#define GEARY_EMAIL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_EMAIL, GearyEmail))
#define GEARY_EMAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_EMAIL, GearyEmailClass))
#define GEARY_IS_EMAIL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_EMAIL))
#define GEARY_IS_EMAIL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_EMAIL))
#define GEARY_EMAIL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_EMAIL, GearyEmailClass))

typedef struct _GearyEmail GearyEmail;
typedef struct _GearyEmailClass GearyEmailClass;

#define GEARY_TYPE_ACCOUNT (geary_account_get_type ())
#define GEARY_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_ACCOUNT, GearyAccount))
#define GEARY_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_ACCOUNT, GearyAccountClass))
#define GEARY_IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_ACCOUNT))
#define GEARY_IS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_ACCOUNT))
#define GEARY_ACCOUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_ACCOUNT, GearyAccountClass))

typedef struct _GearyAccount GearyAccount;
typedef struct _GearyAccountClass GearyAccountClass;

#define GEARY_TYPE_FOLDER_PROPERTIES (geary_folder_properties_get_type ())
#define GEARY_FOLDER_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_FOLDER_PROPERTIES, GearyFolderProperties))
#define GEARY_FOLDER_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_FOLDER_PROPERTIES, GearyFolderPropertiesClass))
#define GEARY_IS_FOLDER_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_FOLDER_PROPERTIES))
#define GEARY_IS_FOLDER_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_FOLDER_PROPERTIES))
#define GEARY_FOLDER_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_FOLDER_PROPERTIES, GearyFolderPropertiesClass))

typedef struct _GearyFolderProperties GearyFolderProperties;
typedef struct _GearyFolderPropertiesClass GearyFolderPropertiesClass;

#define GEARY_TYPE_FOLDER_PATH (geary_folder_path_get_type ())
#define GEARY_FOLDER_PATH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_FOLDER_PATH, GearyFolderPath))
#define GEARY_FOLDER_PATH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_FOLDER_PATH, GearyFolderPathClass))
#define GEARY_IS_FOLDER_PATH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_FOLDER_PATH))
#define GEARY_IS_FOLDER_PATH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_FOLDER_PATH))
#define GEARY_FOLDER_PATH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_FOLDER_PATH, GearyFolderPathClass))

typedef struct _GearyFolderPath GearyFolderPath;
typedef struct _GearyFolderPathClass GearyFolderPathClass;

#define GEARY_TYPE_PROGRESS_MONITOR (geary_progress_monitor_get_type ())
#define GEARY_PROGRESS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_PROGRESS_MONITOR, GearyProgressMonitor))
#define GEARY_PROGRESS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_PROGRESS_MONITOR, GearyProgressMonitorClass))
#define GEARY_IS_PROGRESS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_PROGRESS_MONITOR))
#define GEARY_IS_PROGRESS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_PROGRESS_MONITOR))
#define GEARY_PROGRESS_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_PROGRESS_MONITOR, GearyProgressMonitorClass))

typedef struct _GearyProgressMonitor GearyProgressMonitor;
typedef struct _GearyProgressMonitorClass GearyProgressMonitorClass;

#define GEARY_TYPE_ABSTRACT_LOCAL_FOLDER (geary_abstract_local_folder_get_type ())
#define GEARY_ABSTRACT_LOCAL_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolder))
#define GEARY_ABSTRACT_LOCAL_FOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolderClass))
#define GEARY_IS_ABSTRACT_LOCAL_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_ABSTRACT_LOCAL_FOLDER))
#define GEARY_IS_ABSTRACT_LOCAL_FOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_ABSTRACT_LOCAL_FOLDER))
#define GEARY_ABSTRACT_LOCAL_FOLDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolderClass))

typedef struct _GearyAbstractLocalFolder GearyAbstractLocalFolder;
typedef struct _GearyAbstractLocalFolderClass GearyAbstractLocalFolderClass;
typedef struct _GearyAbstractLocalFolderPrivate GearyAbstractLocalFolderPrivate;

#define GEARY_FOLDER_SUPPORT_TYPE_REMOVE (geary_folder_support_remove_get_type ())
#define GEARY_FOLDER_SUPPORT_REMOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_FOLDER_SUPPORT_TYPE_REMOVE, GearyFolderSupportRemove))
#define GEARY_FOLDER_SUPPORT_IS_REMOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_FOLDER_SUPPORT_TYPE_REMOVE))
#define GEARY_FOLDER_SUPPORT_REMOVE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEARY_FOLDER_SUPPORT_TYPE_REMOVE, GearyFolderSupportRemoveIface))

typedef struct _GearyFolderSupportRemove GearyFolderSupportRemove;
typedef struct _GearyFolderSupportRemoveIface GearyFolderSupportRemoveIface;

#define GEARY_FOLDER_SUPPORT_TYPE_CREATE (geary_folder_support_create_get_type ())
#define GEARY_FOLDER_SUPPORT_CREATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_FOLDER_SUPPORT_TYPE_CREATE, GearyFolderSupportCreate))
#define GEARY_FOLDER_SUPPORT_IS_CREATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_FOLDER_SUPPORT_TYPE_CREATE))
#define GEARY_FOLDER_SUPPORT_CREATE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEARY_FOLDER_SUPPORT_TYPE_CREATE, GearyFolderSupportCreateIface))

typedef struct _GearyFolderSupportCreate GearyFolderSupportCreate;
typedef struct _GearyFolderSupportCreateIface GearyFolderSupportCreateIface;

#define GEARY_RF_C822_TYPE_MESSAGE (geary_rf_c822_message_get_type ())
#define GEARY_RF_C822_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822Message))
#define GEARY_RF_C822_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822MessageClass))
#define GEARY_RF_C822_IS_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_RF_C822_TYPE_MESSAGE))
#define GEARY_RF_C822_IS_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_RF_C822_TYPE_MESSAGE))
#define GEARY_RF_C822_MESSAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_RF_C822_TYPE_MESSAGE, GearyRFC822MessageClass))

typedef struct _GearyRFC822Message GearyRFC822Message;
typedef struct _GearyRFC822MessageClass GearyRFC822MessageClass;

#define GEARY_TYPE_SMTP_OUTBOX_FOLDER (geary_smtp_outbox_folder_get_type ())
#define GEARY_SMTP_OUTBOX_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder))
#define GEARY_SMTP_OUTBOX_FOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolderClass))
#define GEARY_IS_SMTP_OUTBOX_FOLDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_SMTP_OUTBOX_FOLDER))
#define GEARY_IS_SMTP_OUTBOX_FOLDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_SMTP_OUTBOX_FOLDER))
#define GEARY_SMTP_OUTBOX_FOLDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolderClass))

typedef struct _GearySmtpOutboxFolder GearySmtpOutboxFolder;
typedef struct _GearySmtpOutboxFolderClass GearySmtpOutboxFolderClass;
typedef struct _GearySmtpOutboxFolderPrivate GearySmtpOutboxFolderPrivate;

#define GEARY_TYPE_FOLDER_ROOT (geary_folder_root_get_type ())
#define GEARY_FOLDER_ROOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_FOLDER_ROOT, GearyFolderRoot))
#define GEARY_FOLDER_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_FOLDER_ROOT, GearyFolderRootClass))
#define GEARY_IS_FOLDER_ROOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_FOLDER_ROOT))
#define GEARY_IS_FOLDER_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_FOLDER_ROOT))
#define GEARY_FOLDER_ROOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_FOLDER_ROOT, GearyFolderRootClass))

typedef struct _GearyFolderRoot GearyFolderRoot;
typedef struct _GearyFolderRootClass GearyFolderRootClass;

#define GEARY_TYPE_SMTP_OUTBOX_FOLDER_ROOT (geary_smtp_outbox_folder_root_get_type ())
#define GEARY_SMTP_OUTBOX_FOLDER_ROOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_SMTP_OUTBOX_FOLDER_ROOT, GearySmtpOutboxFolderRoot))
#define GEARY_SMTP_OUTBOX_FOLDER_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_SMTP_OUTBOX_FOLDER_ROOT, GearySmtpOutboxFolderRootClass))
#define GEARY_IS_SMTP_OUTBOX_FOLDER_ROOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_SMTP_OUTBOX_FOLDER_ROOT))
#define GEARY_IS_SMTP_OUTBOX_FOLDER_ROOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_SMTP_OUTBOX_FOLDER_ROOT))
#define GEARY_SMTP_OUTBOX_FOLDER_ROOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_SMTP_OUTBOX_FOLDER_ROOT, GearySmtpOutboxFolderRootClass))

typedef struct _GearySmtpOutboxFolderRoot GearySmtpOutboxFolderRoot;
typedef struct _GearySmtpOutboxFolderRootClass GearySmtpOutboxFolderRootClass;

#define GEARY_DB_TYPE_CONTEXT (geary_db_context_get_type ())
#define GEARY_DB_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_DB_TYPE_CONTEXT, GearyDbContext))
#define GEARY_DB_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_DB_TYPE_CONTEXT, GearyDbContextClass))
#define GEARY_DB_IS_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_DB_TYPE_CONTEXT))
#define GEARY_DB_IS_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_DB_TYPE_CONTEXT))
#define GEARY_DB_CONTEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_DB_TYPE_CONTEXT, GearyDbContextClass))

typedef struct _GearyDbContext GearyDbContext;
typedef struct _GearyDbContextClass GearyDbContextClass;

#define GEARY_DB_TYPE_DATABASE (geary_db_database_get_type ())
#define GEARY_DB_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_DB_TYPE_DATABASE, GearyDbDatabase))
#define GEARY_DB_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_DB_TYPE_DATABASE, GearyDbDatabaseClass))
#define GEARY_DB_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_DB_TYPE_DATABASE))
#define GEARY_DB_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_DB_TYPE_DATABASE))
#define GEARY_DB_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_DB_TYPE_DATABASE, GearyDbDatabaseClass))

typedef struct _GearyDbDatabase GearyDbDatabase;
typedef struct _GearyDbDatabaseClass GearyDbDatabaseClass;

#define GEARY_DB_TYPE_VERSIONED_DATABASE (geary_db_versioned_database_get_type ())
#define GEARY_DB_VERSIONED_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_DB_TYPE_VERSIONED_DATABASE, GearyDbVersionedDatabase))
#define GEARY_DB_VERSIONED_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_DB_TYPE_VERSIONED_DATABASE, GearyDbVersionedDatabaseClass))
#define GEARY_DB_IS_VERSIONED_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_DB_TYPE_VERSIONED_DATABASE))
#define GEARY_DB_IS_VERSIONED_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_DB_TYPE_VERSIONED_DATABASE))
#define GEARY_DB_VERSIONED_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_DB_TYPE_VERSIONED_DATABASE, GearyDbVersionedDatabaseClass))

typedef struct _GearyDbVersionedDatabase GearyDbVersionedDatabase;
typedef struct _GearyDbVersionedDatabaseClass GearyDbVersionedDatabaseClass;

#define GEARY_IMAP_DB_TYPE_DATABASE (geary_imap_db_database_get_type ())
#define GEARY_IMAP_DB_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_IMAP_DB_TYPE_DATABASE, GearyImapDBDatabase))
#define GEARY_IMAP_DB_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_IMAP_DB_TYPE_DATABASE, GearyImapDBDatabaseClass))
#define GEARY_IMAP_DB_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_IMAP_DB_TYPE_DATABASE))
#define GEARY_IMAP_DB_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_IMAP_DB_TYPE_DATABASE))
#define GEARY_IMAP_DB_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_IMAP_DB_TYPE_DATABASE, GearyImapDBDatabaseClass))

typedef struct _GearyImapDBDatabase GearyImapDBDatabase;
typedef struct _GearyImapDBDatabaseClass GearyImapDBDatabaseClass;

#define GEARY_SMTP_TYPE_CLIENT_SESSION (geary_smtp_client_session_get_type ())
#define GEARY_SMTP_CLIENT_SESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_SMTP_TYPE_CLIENT_SESSION, GearySmtpClientSession))
#define GEARY_SMTP_CLIENT_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_SMTP_TYPE_CLIENT_SESSION, GearySmtpClientSessionClass))
#define GEARY_SMTP_IS_CLIENT_SESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_SMTP_TYPE_CLIENT_SESSION))
#define GEARY_SMTP_IS_CLIENT_SESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_SMTP_TYPE_CLIENT_SESSION))
#define GEARY_SMTP_CLIENT_SESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_SMTP_TYPE_CLIENT_SESSION, GearySmtpClientSessionClass))

typedef struct _GearySmtpClientSession GearySmtpClientSession;
typedef struct _GearySmtpClientSessionClass GearySmtpClientSessionClass;

#define GEARY_NONBLOCKING_TYPE_MAILBOX (geary_nonblocking_mailbox_get_type ())
#define GEARY_NONBLOCKING_MAILBOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_NONBLOCKING_TYPE_MAILBOX, GearyNonblockingMailbox))
#define GEARY_NONBLOCKING_MAILBOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_NONBLOCKING_TYPE_MAILBOX, GearyNonblockingMailboxClass))
#define GEARY_NONBLOCKING_IS_MAILBOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_NONBLOCKING_TYPE_MAILBOX))
#define GEARY_NONBLOCKING_IS_MAILBOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_NONBLOCKING_TYPE_MAILBOX))
#define GEARY_NONBLOCKING_MAILBOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_NONBLOCKING_TYPE_MAILBOX, GearyNonblockingMailboxClass))

typedef struct _GearyNonblockingMailbox GearyNonblockingMailbox;
typedef struct _GearyNonblockingMailboxClass GearyNonblockingMailboxClass;

#define GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW (geary_smtp_outbox_folder_outbox_row_get_type ())
#define GEARY_SMTP_OUTBOX_FOLDER_OUTBOX_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW, GearySmtpOutboxFolderOutboxRow))
#define GEARY_SMTP_OUTBOX_FOLDER_OUTBOX_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW, GearySmtpOutboxFolderOutboxRowClass))
#define GEARY_SMTP_OUTBOX_FOLDER_IS_OUTBOX_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW))
#define GEARY_SMTP_OUTBOX_FOLDER_IS_OUTBOX_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW))
#define GEARY_SMTP_OUTBOX_FOLDER_OUTBOX_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW, GearySmtpOutboxFolderOutboxRowClass))

typedef struct _GearySmtpOutboxFolderOutboxRow GearySmtpOutboxFolderOutboxRow;
typedef struct _GearySmtpOutboxFolderOutboxRowClass GearySmtpOutboxFolderOutboxRowClass;

#define GEARY_TYPE_SMTP_OUTBOX_FOLDER_PROPERTIES (geary_smtp_outbox_folder_properties_get_type ())
#define GEARY_SMTP_OUTBOX_FOLDER_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_SMTP_OUTBOX_FOLDER_PROPERTIES, GearySmtpOutboxFolderProperties))
#define GEARY_SMTP_OUTBOX_FOLDER_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_SMTP_OUTBOX_FOLDER_PROPERTIES, GearySmtpOutboxFolderPropertiesClass))
#define GEARY_IS_SMTP_OUTBOX_FOLDER_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_SMTP_OUTBOX_FOLDER_PROPERTIES))
#define GEARY_IS_SMTP_OUTBOX_FOLDER_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_SMTP_OUTBOX_FOLDER_PROPERTIES))
#define GEARY_SMTP_OUTBOX_FOLDER_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_SMTP_OUTBOX_FOLDER_PROPERTIES, GearySmtpOutboxFolderPropertiesClass))

typedef struct _GearySmtpOutboxFolderProperties GearySmtpOutboxFolderProperties;
typedef struct _GearySmtpOutboxFolderPropertiesClass GearySmtpOutboxFolderPropertiesClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _geary_smtp_client_session_unref0(var) ((var == NULL) ? NULL : (var = (geary_smtp_client_session_unref (var), NULL)))

#define GEARY_TYPE_ACCOUNT_INFORMATION (geary_account_information_get_type ())
#define GEARY_ACCOUNT_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_ACCOUNT_INFORMATION, GearyAccountInformation))
#define GEARY_ACCOUNT_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_ACCOUNT_INFORMATION, GearyAccountInformationClass))
#define GEARY_IS_ACCOUNT_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_ACCOUNT_INFORMATION))
#define GEARY_IS_ACCOUNT_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_ACCOUNT_INFORMATION))
#define GEARY_ACCOUNT_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_ACCOUNT_INFORMATION, GearyAccountInformationClass))

typedef struct _GearyAccountInformation GearyAccountInformation;
typedef struct _GearyAccountInformationClass GearyAccountInformationClass;

#define GEARY_TYPE_ENDPOINT (geary_endpoint_get_type ())
#define GEARY_ENDPOINT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_ENDPOINT, GearyEndpoint))
#define GEARY_ENDPOINT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_ENDPOINT, GearyEndpointClass))
#define GEARY_IS_ENDPOINT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_ENDPOINT))
#define GEARY_IS_ENDPOINT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_ENDPOINT))
#define GEARY_ENDPOINT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_ENDPOINT, GearyEndpointClass))

typedef struct _GearyEndpoint GearyEndpoint;
typedef struct _GearyEndpointClass GearyEndpointClass;

#define GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER (geary_smtp_outbox_email_identifier_get_type ())
#define GEARY_SMTP_OUTBOX_EMAIL_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER, GearySmtpOutboxEmailIdentifier))
#define GEARY_SMTP_OUTBOX_EMAIL_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER, GearySmtpOutboxEmailIdentifierClass))
#define GEARY_IS_SMTP_OUTBOX_EMAIL_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER))
#define GEARY_IS_SMTP_OUTBOX_EMAIL_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER))
#define GEARY_SMTP_OUTBOX_EMAIL_IDENTIFIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER, GearySmtpOutboxEmailIdentifierClass))

typedef struct _GearySmtpOutboxEmailIdentifier GearySmtpOutboxEmailIdentifier;
typedef struct _GearySmtpOutboxEmailIdentifierClass GearySmtpOutboxEmailIdentifierClass;
typedef struct _Block72Data Block72Data;

#define GEARY_DB_TYPE_TRANSACTION_TYPE (geary_db_transaction_type_get_type ())

#define GEARY_DB_TYPE_TRANSACTION_OUTCOME (geary_db_transaction_outcome_get_type ())

#define GEARY_DB_TYPE_CONNECTION (geary_db_connection_get_type ())
#define GEARY_DB_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_DB_TYPE_CONNECTION, GearyDbConnection))
#define GEARY_DB_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_DB_TYPE_CONNECTION, GearyDbConnectionClass))
#define GEARY_DB_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_DB_TYPE_CONNECTION))
#define GEARY_DB_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_DB_TYPE_CONNECTION))
#define GEARY_DB_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_DB_TYPE_CONNECTION, GearyDbConnectionClass))

typedef struct _GearyDbConnection GearyDbConnection;
typedef struct _GearyDbConnectionClass GearyDbConnectionClass;
#define _geary_smtp_outbox_folder_outbox_row_unref0(var) ((var == NULL) ? NULL : (var = (geary_smtp_outbox_folder_outbox_row_unref (var), NULL)))
typedef struct _GearySmtpOutboxFolderFindBoundariesAsyncData GearySmtpOutboxFolderFindBoundariesAsyncData;
typedef struct _Block73Data Block73Data;
typedef struct _GearySmtpOutboxFolderAddToContainingFoldersAsyncData GearySmtpOutboxFolderAddToContainingFoldersAsyncData;

#define GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA (geary_message_data_abstract_message_data_get_type ())
#define GEARY_MESSAGE_DATA_ABSTRACT_MESSAGE_DATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData))
#define GEARY_MESSAGE_DATA_ABSTRACT_MESSAGE_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageDataClass))
#define GEARY_MESSAGE_DATA_IS_ABSTRACT_MESSAGE_DATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA))
#define GEARY_MESSAGE_DATA_IS_ABSTRACT_MESSAGE_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA))
#define GEARY_MESSAGE_DATA_ABSTRACT_MESSAGE_DATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageDataClass))

typedef struct _GearyMessageDataAbstractMessageData GearyMessageDataAbstractMessageData;
typedef struct _GearyMessageDataAbstractMessageDataClass GearyMessageDataAbstractMessageDataClass;

#define GEARY_MESSAGE_DATA_TYPE_STRING_MESSAGE_DATA (geary_message_data_string_message_data_get_type ())
#define GEARY_MESSAGE_DATA_STRING_MESSAGE_DATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_MESSAGE_DATA_TYPE_STRING_MESSAGE_DATA, GearyMessageDataStringMessageData))
#define GEARY_MESSAGE_DATA_STRING_MESSAGE_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_MESSAGE_DATA_TYPE_STRING_MESSAGE_DATA, GearyMessageDataStringMessageDataClass))
#define GEARY_MESSAGE_DATA_IS_STRING_MESSAGE_DATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_MESSAGE_DATA_TYPE_STRING_MESSAGE_DATA))
#define GEARY_MESSAGE_DATA_IS_STRING_MESSAGE_DATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_MESSAGE_DATA_TYPE_STRING_MESSAGE_DATA))
#define GEARY_MESSAGE_DATA_STRING_MESSAGE_DATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_MESSAGE_DATA_TYPE_STRING_MESSAGE_DATA, GearyMessageDataStringMessageDataClass))

typedef struct _GearyMessageDataStringMessageData GearyMessageDataStringMessageData;
typedef struct _GearyMessageDataStringMessageDataClass GearyMessageDataStringMessageDataClass;

#define GEARY_RF_C822_TYPE_SUBJECT (geary_rf_c822_subject_get_type ())
#define GEARY_RF_C822_SUBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_RF_C822_TYPE_SUBJECT, GearyRFC822Subject))
#define GEARY_RF_C822_SUBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_RF_C822_TYPE_SUBJECT, GearyRFC822SubjectClass))
#define GEARY_RF_C822_IS_SUBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_RF_C822_TYPE_SUBJECT))
#define GEARY_RF_C822_IS_SUBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_RF_C822_TYPE_SUBJECT))
#define GEARY_RF_C822_SUBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_RF_C822_TYPE_SUBJECT, GearyRFC822SubjectClass))

typedef struct _GearyRFC822Subject GearyRFC822Subject;
typedef struct _GearyRFC822SubjectClass GearyRFC822SubjectClass;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block74Data Block74Data;

#define GEARY_DB_TYPE_STATEMENT (geary_db_statement_get_type ())
#define GEARY_DB_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_DB_TYPE_STATEMENT, GearyDbStatement))
#define GEARY_DB_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_DB_TYPE_STATEMENT, GearyDbStatementClass))
#define GEARY_DB_IS_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_DB_TYPE_STATEMENT))
#define GEARY_DB_IS_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_DB_TYPE_STATEMENT))
#define GEARY_DB_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_DB_TYPE_STATEMENT, GearyDbStatementClass))

typedef struct _GearyDbStatement GearyDbStatement;
typedef struct _GearyDbStatementClass GearyDbStatementClass;

#define GEARY_DB_TYPE_RESULT (geary_db_result_get_type ())
#define GEARY_DB_RESULT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_DB_TYPE_RESULT, GearyDbResult))
#define GEARY_DB_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_DB_TYPE_RESULT, GearyDbResultClass))
#define GEARY_DB_IS_RESULT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_DB_TYPE_RESULT))
#define GEARY_DB_IS_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_DB_TYPE_RESULT))
#define GEARY_DB_RESULT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_DB_TYPE_RESULT, GearyDbResultClass))

typedef struct _GearyDbResult GearyDbResult;
typedef struct _GearyDbResultClass GearyDbResultClass;

#define GEARY_MEMORY_TYPE_BUFFER (geary_memory_buffer_get_type ())
#define GEARY_MEMORY_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer))
#define GEARY_MEMORY_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBufferClass))
#define GEARY_MEMORY_IS_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_MEMORY_TYPE_BUFFER))
#define GEARY_MEMORY_IS_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_MEMORY_TYPE_BUFFER))
#define GEARY_MEMORY_BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBufferClass))

typedef struct _GearyMemoryBuffer GearyMemoryBuffer;
typedef struct _GearyMemoryBufferClass GearyMemoryBufferClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _GearySmtpOutboxFolderOutboxRowPrivate GearySmtpOutboxFolderOutboxRowPrivate;

#define GEARY_TYPE_CREDENTIALS (geary_credentials_get_type ())
#define GEARY_CREDENTIALS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_CREDENTIALS, GearyCredentials))
#define GEARY_CREDENTIALS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_CREDENTIALS, GearyCredentialsClass))
#define GEARY_IS_CREDENTIALS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_CREDENTIALS))
#define GEARY_IS_CREDENTIALS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_CREDENTIALS))
#define GEARY_CREDENTIALS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_CREDENTIALS, GearyCredentialsClass))

typedef struct _GearyCredentials GearyCredentials;
typedef struct _GearyCredentialsClass GearyCredentialsClass;

#define GEARY_TYPE_SERVICE_FLAG (geary_service_flag_get_type ())

#define GEARY_ACCOUNT_TYPE_PROBLEM (geary_account_problem_get_type ())
typedef struct _GearySmtpOutboxFolderDoPostmanAsyncData GearySmtpOutboxFolderDoPostmanAsyncData;
typedef struct _Block75Data Block75Data;
typedef struct _GearySmtpOutboxFolderGetEmailCountAsyncData GearySmtpOutboxFolderGetEmailCountAsyncData;
typedef struct _Block76Data Block76Data;
typedef struct _GearySmtpOutboxFolderEnqueueEmailAsyncData GearySmtpOutboxFolderEnqueueEmailAsyncData;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _GearySmtpOutboxFolderCreateEmailAsyncData GearySmtpOutboxFolderCreateEmailAsyncData;
typedef struct _Block77Data Block77Data;
typedef struct _GearySmtpOutboxFolderListEmailByIdAsyncData GearySmtpOutboxFolderListEmailByIdAsyncData;
typedef struct _Block78Data Block78Data;
typedef struct _GearySmtpOutboxFolderListEmailBySparseIdAsyncData GearySmtpOutboxFolderListEmailBySparseIdAsyncData;
typedef struct _Block79Data Block79Data;

#define GEARY_DB_TYPE_RESET_SCOPE (geary_db_reset_scope_get_type ())
typedef struct _GearySmtpOutboxFolderListLocalEmailFieldsAsyncData GearySmtpOutboxFolderListLocalEmailFieldsAsyncData;
typedef struct _Block80Data Block80Data;
typedef struct _GearySmtpOutboxFolderFetchEmailAsyncData GearySmtpOutboxFolderFetchEmailAsyncData;
typedef struct _Block81Data Block81Data;

#define GEARY_TYPE_NAMED_FLAG (geary_named_flag_get_type ())
#define GEARY_NAMED_FLAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_NAMED_FLAG, GearyNamedFlag))
#define GEARY_NAMED_FLAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_NAMED_FLAG, GearyNamedFlagClass))
#define GEARY_IS_NAMED_FLAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_NAMED_FLAG))
#define GEARY_IS_NAMED_FLAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_NAMED_FLAG))
#define GEARY_NAMED_FLAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_NAMED_FLAG, GearyNamedFlagClass))

typedef struct _GearyNamedFlag GearyNamedFlag;
typedef struct _GearyNamedFlagClass GearyNamedFlagClass;
typedef struct _GearySmtpOutboxFolderMarkEmailAsSentAsyncData GearySmtpOutboxFolderMarkEmailAsSentAsyncData;
typedef struct _GearySmtpOutboxFolderRemoveEmailAsyncData GearySmtpOutboxFolderRemoveEmailAsyncData;
typedef struct _Block82Data Block82Data;
typedef struct _GearySmtpOutboxFolderInternalRemoveEmailAsyncData GearySmtpOutboxFolderInternalRemoveEmailAsyncData;
typedef struct _GearySmtpOutboxFolderRemoveSingleEmailAsyncData GearySmtpOutboxFolderRemoveSingleEmailAsyncData;

#define GEARY_TYPE_EMAIL_PROPERTIES (geary_email_properties_get_type ())
#define GEARY_EMAIL_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_EMAIL_PROPERTIES, GearyEmailProperties))
#define GEARY_EMAIL_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_EMAIL_PROPERTIES, GearyEmailPropertiesClass))
#define GEARY_IS_EMAIL_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_EMAIL_PROPERTIES))
#define GEARY_IS_EMAIL_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_EMAIL_PROPERTIES))
#define GEARY_EMAIL_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_EMAIL_PROPERTIES, GearyEmailPropertiesClass))

typedef struct _GearyEmailProperties GearyEmailProperties;
typedef struct _GearyEmailPropertiesClass GearyEmailPropertiesClass;

#define GEARY_TYPE_SMTP_OUTBOX_EMAIL_PROPERTIES (geary_smtp_outbox_email_properties_get_type ())
#define GEARY_SMTP_OUTBOX_EMAIL_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_SMTP_OUTBOX_EMAIL_PROPERTIES, GearySmtpOutboxEmailProperties))
#define GEARY_SMTP_OUTBOX_EMAIL_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_SMTP_OUTBOX_EMAIL_PROPERTIES, GearySmtpOutboxEmailPropertiesClass))
#define GEARY_IS_SMTP_OUTBOX_EMAIL_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_SMTP_OUTBOX_EMAIL_PROPERTIES))
#define GEARY_IS_SMTP_OUTBOX_EMAIL_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_SMTP_OUTBOX_EMAIL_PROPERTIES))
#define GEARY_SMTP_OUTBOX_EMAIL_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_SMTP_OUTBOX_EMAIL_PROPERTIES, GearySmtpOutboxEmailPropertiesClass))

typedef struct _GearySmtpOutboxEmailProperties GearySmtpOutboxEmailProperties;
typedef struct _GearySmtpOutboxEmailPropertiesClass GearySmtpOutboxEmailPropertiesClass;

#define GEARY_SMTP_TYPE_RESPONSE (geary_smtp_response_get_type ())
#define GEARY_SMTP_RESPONSE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_SMTP_TYPE_RESPONSE, GearySmtpResponse))
#define GEARY_SMTP_RESPONSE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_SMTP_TYPE_RESPONSE, GearySmtpResponseClass))
#define GEARY_SMTP_IS_RESPONSE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_SMTP_TYPE_RESPONSE))
#define GEARY_SMTP_IS_RESPONSE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_SMTP_TYPE_RESPONSE))
#define GEARY_SMTP_RESPONSE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_SMTP_TYPE_RESPONSE, GearySmtpResponseClass))

typedef struct _GearySmtpResponse GearySmtpResponse;
typedef struct _GearySmtpResponseClass GearySmtpResponseClass;

#define GEARY_SMTP_TYPE_GREETING (geary_smtp_greeting_get_type ())
#define GEARY_SMTP_GREETING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_SMTP_TYPE_GREETING, GearySmtpGreeting))
#define GEARY_SMTP_GREETING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_SMTP_TYPE_GREETING, GearySmtpGreetingClass))
#define GEARY_SMTP_IS_GREETING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_SMTP_TYPE_GREETING))
#define GEARY_SMTP_IS_GREETING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_SMTP_TYPE_GREETING))
#define GEARY_SMTP_GREETING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_SMTP_TYPE_GREETING, GearySmtpGreetingClass))

typedef struct _GearySmtpGreeting GearySmtpGreeting;
typedef struct _GearySmtpGreetingClass GearySmtpGreetingClass;
#define _geary_smtp_response_unref0(var) ((var == NULL) ? NULL : (var = (geary_smtp_response_unref (var), NULL)))

#define GEARY_RF_C822_TYPE_MAILBOX_ADDRESS (geary_rf_c822_mailbox_address_get_type ())
#define GEARY_RF_C822_MAILBOX_ADDRESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, GearyRFC822MailboxAddress))
#define GEARY_RF_C822_MAILBOX_ADDRESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, GearyRFC822MailboxAddressClass))
#define GEARY_RF_C822_IS_MAILBOX_ADDRESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_RF_C822_TYPE_MAILBOX_ADDRESS))
#define GEARY_RF_C822_IS_MAILBOX_ADDRESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_RF_C822_TYPE_MAILBOX_ADDRESS))
#define GEARY_RF_C822_MAILBOX_ADDRESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, GearyRFC822MailboxAddressClass))

typedef struct _GearyRFC822MailboxAddress GearyRFC822MailboxAddress;
typedef struct _GearyRFC822MailboxAddressClass GearyRFC822MailboxAddressClass;
typedef struct _GearySmtpOutboxFolderSendEmailAsyncData GearySmtpOutboxFolderSendEmailAsyncData;
typedef struct _GearySmtpOutboxFolderSaveSentMailAsyncData GearySmtpOutboxFolderSaveSentMailAsyncData;
typedef struct _Block83Data Block83Data;
typedef struct _GearySmtpOutboxFolderIsUnsentAsyncData GearySmtpOutboxFolderIsUnsentAsyncData;
typedef struct _GearySmtpOutboxFolderParamSpecOutboxRow GearySmtpOutboxFolderParamSpecOutboxRow;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GearyBaseObject {
	GObject parent_instance;
	GearyBaseObjectPrivate * priv;
};

struct _GearyBaseObjectClass {
	GObjectClass parent_class;
};

typedef enum  {
	GEARY_FOLDER_OPEN_STATE_CLOSED,
	GEARY_FOLDER_OPEN_STATE_OPENING,
	GEARY_FOLDER_OPEN_STATE_REMOTE,
	GEARY_FOLDER_OPEN_STATE_LOCAL,
	GEARY_FOLDER_OPEN_STATE_BOTH
} GearyFolderOpenState;

typedef enum  {
	GEARY_FOLDER_OPEN_FAILED_LOCAL_FAILED,
	GEARY_FOLDER_OPEN_FAILED_REMOTE_FAILED,
	GEARY_FOLDER_OPEN_FAILED_CANCELLED
} GearyFolderOpenFailed;

typedef enum  {
	GEARY_FOLDER_CLOSE_REASON_LOCAL_CLOSE,
	GEARY_FOLDER_CLOSE_REASON_LOCAL_ERROR,
	GEARY_FOLDER_CLOSE_REASON_REMOTE_CLOSE,
	GEARY_FOLDER_CLOSE_REASON_REMOTE_ERROR,
	GEARY_FOLDER_CLOSE_REASON_FOLDER_CLOSED
} GearyFolderCloseReason;

typedef enum  {
	GEARY_FOLDER_COUNT_CHANGE_REASON_NONE = 0,
	GEARY_FOLDER_COUNT_CHANGE_REASON_APPENDED = 1 << 0,
	GEARY_FOLDER_COUNT_CHANGE_REASON_INSERTED = 1 << 1,
	GEARY_FOLDER_COUNT_CHANGE_REASON_REMOVED = 1 << 2
} GearyFolderCountChangeReason;

typedef enum  {
	GEARY_SPECIAL_FOLDER_TYPE_NONE,
	GEARY_SPECIAL_FOLDER_TYPE_INBOX,
	GEARY_SPECIAL_FOLDER_TYPE_SEARCH,
	GEARY_SPECIAL_FOLDER_TYPE_DRAFTS,
	GEARY_SPECIAL_FOLDER_TYPE_SENT,
	GEARY_SPECIAL_FOLDER_TYPE_FLAGGED,
	GEARY_SPECIAL_FOLDER_TYPE_IMPORTANT,
	GEARY_SPECIAL_FOLDER_TYPE_ALL_MAIL,
	GEARY_SPECIAL_FOLDER_TYPE_SPAM,
	GEARY_SPECIAL_FOLDER_TYPE_TRASH,
	GEARY_SPECIAL_FOLDER_TYPE_OUTBOX,
	GEARY_SPECIAL_FOLDER_TYPE_ARCHIVE
} GearySpecialFolderType;

typedef enum  {
	GEARY_FOLDER_OPEN_FLAGS_NONE = 0,
	GEARY_FOLDER_OPEN_FLAGS_FAST_OPEN = 1 << 0,
	GEARY_FOLDER_OPEN_FLAGS_NO_DELAY = 1 << 1
} GearyFolderOpenFlags;

typedef enum  {
	GEARY_EMAIL_FIELD_NONE = 0,
	GEARY_EMAIL_FIELD_DATE = 1 << 0,
	GEARY_EMAIL_FIELD_ORIGINATORS = 1 << 1,
	GEARY_EMAIL_FIELD_RECEIVERS = 1 << 2,
	GEARY_EMAIL_FIELD_REFERENCES = 1 << 3,
	GEARY_EMAIL_FIELD_SUBJECT = 1 << 4,
	GEARY_EMAIL_FIELD_HEADER = 1 << 5,
	GEARY_EMAIL_FIELD_BODY = 1 << 6,
	GEARY_EMAIL_FIELD_PROPERTIES = 1 << 7,
	GEARY_EMAIL_FIELD_PREVIEW = 1 << 8,
	GEARY_EMAIL_FIELD_FLAGS = 1 << 9,
	GEARY_EMAIL_FIELD_ENVELOPE = (((GEARY_EMAIL_FIELD_DATE | GEARY_EMAIL_FIELD_ORIGINATORS) | GEARY_EMAIL_FIELD_RECEIVERS) | GEARY_EMAIL_FIELD_REFERENCES) | GEARY_EMAIL_FIELD_SUBJECT,
	GEARY_EMAIL_FIELD_ALL = ((((((((GEARY_EMAIL_FIELD_DATE | GEARY_EMAIL_FIELD_ORIGINATORS) | GEARY_EMAIL_FIELD_RECEIVERS) | GEARY_EMAIL_FIELD_REFERENCES) | GEARY_EMAIL_FIELD_SUBJECT) | GEARY_EMAIL_FIELD_HEADER) | GEARY_EMAIL_FIELD_BODY) | GEARY_EMAIL_FIELD_PROPERTIES) | GEARY_EMAIL_FIELD_PREVIEW) | GEARY_EMAIL_FIELD_FLAGS
} GearyEmailField;

typedef enum  {
	GEARY_FOLDER_LIST_FLAGS_NONE = 0,
	GEARY_FOLDER_LIST_FLAGS_LOCAL_ONLY = 1 << 0,
	GEARY_FOLDER_LIST_FLAGS_FORCE_UPDATE = 1 << 1,
	GEARY_FOLDER_LIST_FLAGS_INCLUDING_ID = 1 << 2,
	GEARY_FOLDER_LIST_FLAGS_OLDEST_TO_NEWEST = 1 << 3
} GearyFolderListFlags;

struct _GearyFolder {
	GearyBaseObject parent_instance;
	GearyFolderPrivate * priv;
};

struct _GearyFolderClass {
	GearyBaseObjectClass parent_class;
	void (*notify_opened) (GearyFolder* self, GearyFolderOpenState state, gint count);
	void (*notify_open_failed) (GearyFolder* self, GearyFolderOpenFailed failure, GError* err);
	void (*notify_closed) (GearyFolder* self, GearyFolderCloseReason reason);
	void (*notify_email_appended) (GearyFolder* self, GeeCollection* ids);
	void (*notify_email_locally_appended) (GearyFolder* self, GeeCollection* ids);
	void (*notify_email_inserted) (GearyFolder* self, GeeCollection* ids);
	void (*notify_email_locally_inserted) (GearyFolder* self, GeeCollection* ids);
	void (*notify_email_removed) (GearyFolder* self, GeeCollection* ids);
	void (*notify_email_count_changed) (GearyFolder* self, gint new_count, GearyFolderCountChangeReason reason);
	void (*notify_email_flags_changed) (GearyFolder* self, GeeMap* flag_map);
	void (*notify_email_locally_complete) (GearyFolder* self, GeeCollection* ids);
	void (*notify_special_folder_type_changed) (GearyFolder* self, GearySpecialFolderType old_type, GearySpecialFolderType new_type);
	void (*notify_display_name_changed) (GearyFolder* self);
	gchar* (*get_display_name) (GearyFolder* self);
	GearyFolderOpenState (*get_open_state) (GearyFolder* self);
	void (*open_async) (GearyFolder* self, GearyFolderOpenFlags open_flags, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*open_finish) (GearyFolder* self, GAsyncResult* _res_, GError** error);
	void (*wait_for_open_async) (GearyFolder* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*wait_for_open_finish) (GearyFolder* self, GAsyncResult* _res_, GError** error);
	void (*close_async) (GearyFolder* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gboolean (*close_finish) (GearyFolder* self, GAsyncResult* _res_, GError** error);
	void (*wait_for_close_async) (GearyFolder* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*wait_for_close_finish) (GearyFolder* self, GAsyncResult* _res_, GError** error);
	void (*find_boundaries_async) (GearyFolder* self, GeeCollection* ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*find_boundaries_finish) (GearyFolder* self, GAsyncResult* _res_, GearyEmailIdentifier** low, GearyEmailIdentifier** high, GError** error);
	void (*list_email_by_id_async) (GearyFolder* self, GearyEmailIdentifier* initial_id, gint count, GearyEmailField required_fields, GearyFolderListFlags flags, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeList* (*list_email_by_id_finish) (GearyFolder* self, GAsyncResult* _res_, GError** error);
	void (*list_email_by_sparse_id_async) (GearyFolder* self, GeeCollection* ids, GearyEmailField required_fields, GearyFolderListFlags flags, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeList* (*list_email_by_sparse_id_finish) (GearyFolder* self, GAsyncResult* _res_, GError** error);
	void (*list_local_email_fields_async) (GearyFolder* self, GeeCollection* ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GeeMap* (*list_local_email_fields_finish) (GearyFolder* self, GAsyncResult* _res_, GError** error);
	void (*fetch_email_async) (GearyFolder* self, GearyEmailIdentifier* email_id, GearyEmailField required_fields, GearyFolderListFlags flags, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GearyEmail* (*fetch_email_finish) (GearyFolder* self, GAsyncResult* _res_, GError** error);
	gchar* (*to_string) (GearyFolder* self);
	GearyAccount* (*get_account) (GearyFolder* self);
	GearyFolderProperties* (*get_properties) (GearyFolder* self);
	GearyFolderPath* (*get_path) (GearyFolder* self);
	GearySpecialFolderType (*get_special_folder_type) (GearyFolder* self);
	GearyProgressMonitor* (*get_opening_monitor) (GearyFolder* self);
};

struct _GearyAbstractLocalFolder {
	GearyFolder parent_instance;
	GearyAbstractLocalFolderPrivate * priv;
};

struct _GearyAbstractLocalFolderClass {
	GearyFolderClass parent_class;
};

struct _GearyFolderSupportRemoveIface {
	GTypeInterface parent_iface;
	void (*remove_email_async) (GearyFolderSupportRemove* self, GeeList* email_ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*remove_email_finish) (GearyFolderSupportRemove* self, GAsyncResult* _res_, GError** error);
};

struct _GearyFolderSupportCreateIface {
	GTypeInterface parent_iface;
	void (*create_email_async) (GearyFolderSupportCreate* self, GearyRFC822Message* rfc822, GearyEmailFlags* flags, GDateTime* date_received, GearyEmailIdentifier* id, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GearyEmailIdentifier* (*create_email_finish) (GearyFolderSupportCreate* self, GAsyncResult* _res_, GError** error);
};

struct _GearySmtpOutboxFolder {
	GearyAbstractLocalFolder parent_instance;
	GearySmtpOutboxFolderPrivate * priv;
};

struct _GearySmtpOutboxFolderClass {
	GearyAbstractLocalFolderClass parent_class;
	void (*create_email_async) (GearySmtpOutboxFolder* self, GearyRFC822Message* rfc822, GearyEmailFlags* flags, GDateTime* date_received, GearyEmailIdentifier* id, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GearyEmailIdentifier* (*create_email_finish) (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error);
	void (*remove_email_async) (GearySmtpOutboxFolder* self, GeeList* email_ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*remove_email_finish) (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error);
	void (*remove_single_email_async) (GearySmtpOutboxFolder* self, GearyEmailIdentifier* id, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*remove_single_email_finish) (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error);
};

struct _GearySmtpOutboxFolderPrivate {
	GearySmtpOutboxFolderRoot* _path;
	GearyImapDBDatabase* db;
	GearyAccount* _account;
	GearyProgressMonitor* sending_monitor;
	GearySmtpClientSession* smtp;
	GearyNonblockingMailbox* outbox_queue;
	GearySmtpOutboxFolderProperties* _properties;
	gint64 next_ordering;
	GRecMutex __lock_next_ordering;
};

struct _Block72Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	GearySmtpOutboxEmailIdentifier* outbox_low;
	GearySmtpOutboxEmailIdentifier* outbox_high;
	GeeCollection* ids;
	GCancellable* cancellable;
	gpointer _async_data_;
};

typedef enum  {
	GEARY_DB_TRANSACTION_TYPE_DEFERRED,
	GEARY_DB_TRANSACTION_TYPE_IMMEDIATE,
	GEARY_DB_TRANSACTION_TYPE_EXCLUSIVE,
	GEARY_DB_TRANSACTION_TYPE_RO = GEARY_DB_TRANSACTION_TYPE_DEFERRED,
	GEARY_DB_TRANSACTION_TYPE_RW = GEARY_DB_TRANSACTION_TYPE_IMMEDIATE,
	GEARY_DB_TRANSACTION_TYPE_WR = GEARY_DB_TRANSACTION_TYPE_EXCLUSIVE,
	GEARY_DB_TRANSACTION_TYPE_WO = GEARY_DB_TRANSACTION_TYPE_EXCLUSIVE
} GearyDbTransactionType;

typedef enum  {
	GEARY_DB_TRANSACTION_OUTCOME_ROLLBACK = 0,
	GEARY_DB_TRANSACTION_OUTCOME_COMMIT = 1,
	GEARY_DB_TRANSACTION_OUTCOME_SUCCESS = GEARY_DB_TRANSACTION_OUTCOME_COMMIT,
	GEARY_DB_TRANSACTION_OUTCOME_FAILURE = GEARY_DB_TRANSACTION_OUTCOME_ROLLBACK,
	GEARY_DB_TRANSACTION_OUTCOME_DONE = GEARY_DB_TRANSACTION_OUTCOME_COMMIT
} GearyDbTransactionOutcome;

typedef GearyDbTransactionOutcome (*GearyDbTransactionMethod) (GearyDbConnection* cx, GCancellable* cancellable, void* user_data, GError** error);
struct _GearySmtpOutboxFolderFindBoundariesAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GearySmtpOutboxFolder* self;
	GeeCollection* ids;
	GearyEmailIdentifier* low;
	GearyEmailIdentifier* high;
	GCancellable* cancellable;
	Block72Data* _data72_;
	GeeCollection* _tmp0_;
	GCancellable* _tmp1_;
	GearyImapDBDatabase* _tmp2_;
	GCancellable* _tmp3_;
	GearyEmailIdentifier* _tmp4_;
	GearyEmailIdentifier* _tmp5_;
	GError * _inner_error_;
};

struct _Block73Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	GeeCollection* ids;
	GeeHashMultiMap* map;
	gpointer _async_data_;
};

struct _GearySmtpOutboxFolderAddToContainingFoldersAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GearySmtpOutboxFolder* self;
	GeeCollection* ids;
	GeeHashMultiMap* map;
	GCancellable* cancellable;
	Block73Data* _data73_;
	GeeCollection* _tmp0_;
	GeeHashMultiMap* _tmp1_;
	GearyImapDBDatabase* _tmp2_;
	GCancellable* _tmp3_;
	GError * _inner_error_;
};

struct _Block74Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	GeeArrayList* list;
};

typedef enum  {
	GEARY_DATABASE_ERROR_GENERAL,
	GEARY_DATABASE_ERROR_OPEN_REQUIRED,
	GEARY_DATABASE_ERROR_BUSY,
	GEARY_DATABASE_ERROR_CORRUPT,
	GEARY_DATABASE_ERROR_ACCESS,
	GEARY_DATABASE_ERROR_MEMORY,
	GEARY_DATABASE_ERROR_ABORT,
	GEARY_DATABASE_ERROR_INTERRUPT,
	GEARY_DATABASE_ERROR_LIMITS,
	GEARY_DATABASE_ERROR_TYPESPEC,
	GEARY_DATABASE_ERROR_FINISHED,
	GEARY_DATABASE_ERROR_SCHEMA_VERSION
} GearyDatabaseError;
#define GEARY_DATABASE_ERROR geary_database_error_quark ()
struct _GearySmtpOutboxFolderOutboxRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GearySmtpOutboxFolderOutboxRowPrivate * priv;
	gint64 id;
	gint position;
	gint64 ordering;
	gboolean sent;
	GearyMemoryBuffer* message;
	GearySmtpOutboxEmailIdentifier* outbox_id;
};

struct _GearySmtpOutboxFolderOutboxRowClass {
	GTypeClass parent_class;
	void (*finalize) (GearySmtpOutboxFolderOutboxRow *self);
};

typedef enum  {
	GEARY_SERVICE_FLAG_IMAP = 1 << 0,
	GEARY_SERVICE_FLAG_SMTP = 1 << 1
} GearyServiceFlag;

typedef enum  {
	GEARY_RF_C822_ERROR_INVALID,
	GEARY_RF_C822_ERROR_NOT_FOUND,
	GEARY_RF_C822_ERROR_FAILED
} GearyRFC822Error;
#define GEARY_RF_C822_ERROR geary_rf_c822_error_quark ()
typedef enum  {
	GEARY_SMTP_ERROR_PARSE_ERROR,
	GEARY_SMTP_ERROR_STARTTLS_FAILED,
	GEARY_SMTP_ERROR_AUTHENTICATION_FAILED,
	GEARY_SMTP_ERROR_SERVER_ERROR,
	GEARY_SMTP_ERROR_ALREADY_CONNECTED,
	GEARY_SMTP_ERROR_NOT_CONNECTED,
	GEARY_SMTP_ERROR_REQUIRED_FIELD,
	GEARY_SMTP_ERROR_NOT_SUPPORTED
} GearySmtpError;
#define GEARY_SMTP_ERROR geary_smtp_error_quark ()
typedef enum  {
	GEARY_ACCOUNT_PROBLEM_RECV_EMAIL_LOGIN_FAILED,
	GEARY_ACCOUNT_PROBLEM_SEND_EMAIL_LOGIN_FAILED,
	GEARY_ACCOUNT_PROBLEM_HOST_UNREACHABLE,
	GEARY_ACCOUNT_PROBLEM_NETWORK_UNAVAILABLE,
	GEARY_ACCOUNT_PROBLEM_DATABASE_FAILURE,
	GEARY_ACCOUNT_PROBLEM_EMAIL_DELIVERY_FAILURE,
	GEARY_ACCOUNT_PROBLEM_SAVE_SENT_MAIL_FAILED
} GearyAccountProblem;

struct _GearySmtpOutboxFolderDoPostmanAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GearySmtpOutboxFolder* self;
	guint send_retry_seconds;
	Block74Data* _data74_;
	GeeArrayList* _tmp0_;
	GearyImapDBDatabase* _tmp1_;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GearySmtpOutboxFolderProperties* _tmp5_;
	GeeArrayList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GeeArrayList* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	GeeArrayList* _row_list;
	GeeArrayList* _tmp12_;
	GeeArrayList* _tmp13_;
	gint _row_size;
	GeeArrayList* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _row_index;
	gint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	GearySmtpOutboxFolderOutboxRow* row;
	GeeArrayList* _tmp20_;
	gint _tmp21_;
	gpointer _tmp22_;
	GearyNonblockingMailbox* _tmp23_;
	GearySmtpOutboxFolderOutboxRow* _tmp24_;
	GError* prime_err;
	GError* _tmp25_;
	const gchar* _tmp26_;
	gboolean _tmp27_;
	GearySmtpOutboxFolderOutboxRow* _vala1_row;
	GearySmtpOutboxFolderOutboxRow* _tmp28_;
	GearyNonblockingMailbox* _tmp29_;
	gpointer _tmp30_;
	GearySmtpOutboxFolderOutboxRow* _tmp31_;
	gboolean _tmp32_;
	GearySmtpOutboxFolderOutboxRow* _tmp33_;
	gint64 _tmp34_;
	gboolean _tmp35_;
	GearySmtpOutboxFolderOutboxRow* _tmp36_;
	GearySmtpOutboxEmailIdentifier* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	GError* wait_err;
	const gchar* _tmp40_;
	gboolean _tmp41_;
	GearyAccount* _tmp42_;
	GearyAccountInformation* _tmp43_;
	GearyAccountInformation* _tmp44_;
	GearyCredentials* _tmp45_;
	GearyCredentials* _tmp46_;
	GearyAccount* _tmp47_;
	GearyAccountInformation* _tmp48_;
	GearyAccountInformation* _tmp49_;
	GearyCredentials* _tmp50_;
	GearyCredentials* _tmp51_;
	gboolean _tmp52_;
	GearyAccount* _tmp53_;
	GearyAccountInformation* _tmp54_;
	GearyAccountInformation* _tmp55_;
	GError* e;
	GError* _tmp56_;
	const gchar* _tmp57_;
	GearyRFC822Message* message;
	GearyRFC822Message* _tmp58_;
	GearySmtpOutboxFolderOutboxRow* _tmp59_;
	GearyMemoryBuffer* _tmp60_;
	GearyRFC822Message* _tmp61_;
	GearyRFC822Message* _tmp62_;
	GError* msg_err;
	GError* _tmp63_;
	const gchar* _tmp64_;
	gboolean should_nap;
	gboolean mail_sent;
	GearyAccount* _tmp65_;
	GearyAccountInformation* _tmp66_;
	GearyAccountInformation* _tmp67_;
	GearyEndpoint* _tmp68_;
	GearyEndpoint* _tmp69_;
	gboolean _tmp70_;
	gboolean _tmp71_;
	gboolean _tmp72_;
	GearyRFC822Message* _tmp73_;
	gchar* _tmp74_;
	gchar* _tmp75_;
	GearySmtpOutboxFolderOutboxRow* _tmp76_;
	GearySmtpOutboxEmailIdentifier* _tmp77_;
	gchar* _tmp78_;
	gchar* _tmp79_;
	GearyRFC822Message* _tmp80_;
	GearyNonblockingMailbox* _tmp81_;
	GearySmtpOutboxFolderOutboxRow* _tmp82_;
	GError* send_err;
	GError* _tmp83_;
	const gchar* _tmp84_;
	GError* _tmp85_;
	gboolean report;
	gboolean _tmp86_;
	GearyAccount* _tmp87_;
	GearyAccountInformation* _tmp88_;
	GearyAccountInformation* _tmp89_;
	gboolean _tmp90_;
	GError* _vala1_e;
	GError* _tmp91_;
	const gchar* _tmp92_;
	gboolean _tmp93_;
	GError* _tmp94_;
	GError* _tmp95_;
	GearyAccount* _tmp96_;
	GearyAccountInformation* _tmp97_;
	GearyAccountInformation* _tmp98_;
	GearyEndpoint* _tmp99_;
	GearyEndpoint* _tmp100_;
	gchar* _tmp101_;
	gchar* _tmp102_;
	GError* _tmp103_;
	gboolean _tmp104_;
	guint _tmp105_;
	guint _tmp106_;
	guint _tmp107_;
	guint _tmp108_;
	gboolean _tmp109_;
	GearyNonblockingMailbox* _tmp110_;
	GearySmtpOutboxFolderOutboxRow* _tmp111_;
	gboolean _tmp112_;
	GearyAccount* _tmp113_;
	GearyAccountInformation* _tmp114_;
	GearyAccountInformation* _tmp115_;
	gboolean _tmp116_;
	GearyAccount* _tmp117_;
	GearyAccountInformation* _tmp118_;
	GearyAccountInformation* _tmp119_;
	gboolean _tmp120_;
	gboolean _tmp121_;
	GearySmtpOutboxFolderOutboxRow* _tmp122_;
	GearySmtpOutboxEmailIdentifier* _tmp123_;
	gchar* _tmp124_;
	gchar* _tmp125_;
	GearySmtpOutboxFolderOutboxRow* _tmp126_;
	GearySmtpOutboxEmailIdentifier* _tmp127_;
	GError* _vala2_e;
	GError* _tmp128_;
	const gchar* _tmp129_;
	GearySmtpOutboxFolderOutboxRow* _tmp130_;
	GearySmtpOutboxEmailIdentifier* _tmp131_;
	gchar* _tmp132_;
	gchar* _tmp133_;
	GearyRFC822Message* _tmp134_;
	GError* _vala3_e;
	GError* _tmp135_;
	const gchar* _tmp136_;
	GError* _tmp137_;
	GearySmtpOutboxFolderOutboxRow* _tmp138_;
	GearySmtpOutboxEmailIdentifier* _tmp139_;
	gchar* _tmp140_;
	gchar* _tmp141_;
	GeeArrayList* list;
	GeeArrayList* _tmp142_;
	GeeArrayList* _tmp143_;
	GearySmtpOutboxFolderOutboxRow* _tmp144_;
	GearySmtpOutboxEmailIdentifier* _tmp145_;
	GeeArrayList* _tmp146_;
	GError* _vala4_e;
	GError* _tmp147_;
	const gchar* _tmp148_;
	GError * _inner_error_;
};

struct _Block75Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	gint count;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _GearySmtpOutboxFolderGetEmailCountAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GearySmtpOutboxFolder* self;
	GCancellable* cancellable;
	gint result;
	Block75Data* _data75_;
	GCancellable* _tmp0_;
	GearyImapDBDatabase* _tmp1_;
	GCancellable* _tmp2_;
	GError * _inner_error_;
};

struct _Block76Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	gint email_count;
	GearySmtpOutboxFolderOutboxRow* row;
	GearyRFC822Message* rfc822;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _GearySmtpOutboxFolderEnqueueEmailAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GearySmtpOutboxFolder* self;
	GearyRFC822Message* rfc822;
	GCancellable* cancellable;
	GearySmtpOutboxEmailIdentifier* result;
	Block76Data* _data76_;
	GearyRFC822Message* _tmp0_;
	GCancellable* _tmp1_;
	GearyImapDBDatabase* _tmp2_;
	GCancellable* _tmp3_;
	GearySmtpOutboxFolderOutboxRow* _tmp4_;
	gint _tmp5_;
	GCancellable* _tmp6_;
	gint _tmp7_;
	GearySmtpOutboxFolderProperties* _tmp8_;
	GearyNonblockingMailbox* _tmp9_;
	GearySmtpOutboxFolderOutboxRow* _tmp10_;
	GeeList* list;
	GeeArrayList* _tmp11_;
	GeeList* _tmp12_;
	GearySmtpOutboxFolderOutboxRow* _tmp13_;
	GearySmtpOutboxEmailIdentifier* _tmp14_;
	GeeList* _tmp15_;
	GeeList* _tmp16_;
	gint _tmp17_;
	GearySmtpOutboxFolderOutboxRow* _tmp18_;
	GearySmtpOutboxEmailIdentifier* _tmp19_;
	GearySmtpOutboxEmailIdentifier* _tmp20_;
	GError * _inner_error_;
};

typedef enum  {
	GEARY_ENGINE_ERROR_OPEN_REQUIRED,
	GEARY_ENGINE_ERROR_ALREADY_OPEN,
	GEARY_ENGINE_ERROR_ALREADY_EXISTS,
	GEARY_ENGINE_ERROR_NOT_FOUND,
	GEARY_ENGINE_ERROR_BAD_PARAMETERS,
	GEARY_ENGINE_ERROR_BAD_RESPONSE,
	GEARY_ENGINE_ERROR_INCOMPLETE_MESSAGE,
	GEARY_ENGINE_ERROR_SERVER_UNAVAILABLE,
	GEARY_ENGINE_ERROR_ALREADY_CLOSED,
	GEARY_ENGINE_ERROR_CLOSE_REQUIRED,
	GEARY_ENGINE_ERROR_CORRUPT,
	GEARY_ENGINE_ERROR_PERMISSIONS,
	GEARY_ENGINE_ERROR_VERSION,
	GEARY_ENGINE_ERROR_UNSUPPORTED
} GearyEngineError;
#define GEARY_ENGINE_ERROR geary_engine_error_quark ()
struct _GearySmtpOutboxFolderCreateEmailAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GearySmtpOutboxFolder* self;
	GearyRFC822Message* rfc822;
	GearyEmailFlags* flags;
	GDateTime* date_received;
	GearyEmailIdentifier* id;
	GCancellable* cancellable;
	GearyEmailIdentifier* result;
	GearySmtpOutboxEmailIdentifier* _tmp0_;
	GearyRFC822Message* _tmp1_;
	GCancellable* _tmp2_;
	GearySmtpOutboxEmailIdentifier* _tmp3_;
	GearySmtpOutboxEmailIdentifier* _tmp4_;
	GError * _inner_error_;
};

struct _Block77Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	GearySmtpOutboxEmailIdentifier* initial_id;
	GeeList* list;
	gint count;
	GearyFolderListFlags flags;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _GearySmtpOutboxFolderListEmailByIdAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GearySmtpOutboxFolder* self;
	GearyEmailIdentifier* _initial_id;
	gint count;
	GearyEmailField required_fields;
	GearyFolderListFlags flags;
	GCancellable* cancellable;
	GeeList* result;
	Block77Data* _data77_;
	gint _tmp0_;
	GearyFolderListFlags _tmp1_;
	GCancellable* _tmp2_;
	GearyEmailIdentifier* _tmp3_;
	GearySmtpOutboxEmailIdentifier* _tmp4_;
	gboolean _tmp5_;
	GearyEmailIdentifier* _tmp6_;
	GearySmtpOutboxEmailIdentifier* _tmp7_;
	GearySmtpOutboxEmailIdentifier* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GError* _tmp11_;
	GError* _tmp12_;
	gint _tmp13_;
	GearyImapDBDatabase* _tmp14_;
	GCancellable* _tmp15_;
	GeeList* _tmp16_;
	GeeList* _tmp17_;
	GError * _inner_error_;
};

struct _Block78Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	GeeList* list;
	GeeCollection* ids;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _GearySmtpOutboxFolderListEmailBySparseIdAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GearySmtpOutboxFolder* self;
	GeeCollection* ids;
	GearyEmailField required_fields;
	GearyFolderListFlags flags;
	GCancellable* cancellable;
	GeeList* result;
	Block78Data* _data78_;
	GeeCollection* _tmp0_;
	GCancellable* _tmp1_;
	GeeArrayList* _tmp2_;
	GearyImapDBDatabase* _tmp3_;
	GCancellable* _tmp4_;
	GeeList* _tmp5_;
	GeeList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GeeList* _tmp9_;
	GeeList* _tmp10_;
	GError * _inner_error_;
};

struct _Block79Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	GeeMap* map;
	GeeCollection* ids;
	GCancellable* cancellable;
	gpointer _async_data_;
};

typedef enum  {
	GEARY_DB_RESET_SCOPE_SAVE_BINDINGS,
	GEARY_DB_RESET_SCOPE_CLEAR_BINDINGS
} GearyDbResetScope;

struct _GearySmtpOutboxFolderListLocalEmailFieldsAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GearySmtpOutboxFolder* self;
	GeeCollection* ids;
	GCancellable* cancellable;
	GeeMap* result;
	Block79Data* _data79_;
	GeeCollection* _tmp0_;
	GCancellable* _tmp1_;
	GeeHashMap* _tmp2_;
	GearyImapDBDatabase* _tmp3_;
	GCancellable* _tmp4_;
	GeeMap* _tmp5_;
	GeeMap* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GeeMap* _tmp9_;
	GeeMap* _tmp10_;
	GError * _inner_error_;
};

struct _Block80Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	GearySmtpOutboxEmailIdentifier* outbox_id;
	GearySmtpOutboxFolderOutboxRow* row;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _GearySmtpOutboxFolderFetchEmailAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GearySmtpOutboxFolder* self;
	GearyEmailIdentifier* id;
	GearyEmailField required_fields;
	GearyFolderListFlags flags;
	GCancellable* cancellable;
	GearyEmail* result;
	Block80Data* _data80_;
	GCancellable* _tmp0_;
	GearyEmailIdentifier* _tmp1_;
	GearySmtpOutboxEmailIdentifier* _tmp2_;
	GearySmtpOutboxEmailIdentifier* _tmp3_;
	GearyEmailIdentifier* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GError* _tmp7_;
	GError* _tmp8_;
	GearyImapDBDatabase* _tmp9_;
	GCancellable* _tmp10_;
	GearySmtpOutboxFolderOutboxRow* _tmp11_;
	GearyEmailIdentifier* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GError* _tmp15_;
	GError* _tmp16_;
	GearyEmail* _tmp17_;
	GearySmtpOutboxFolderOutboxRow* _tmp18_;
	GearyEmail* _tmp19_;
	GearyEmail* _tmp20_;
	GError * _inner_error_;
};

struct _Block81Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	GearySmtpOutboxEmailIdentifier* outbox_id;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _GearySmtpOutboxFolderMarkEmailAsSentAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GearySmtpOutboxFolder* self;
	GearySmtpOutboxEmailIdentifier* outbox_id;
	GCancellable* cancellable;
	Block81Data* _data81_;
	GearySmtpOutboxEmailIdentifier* _tmp0_;
	GCancellable* _tmp1_;
	GearyImapDBDatabase* _tmp2_;
	GCancellable* _tmp3_;
	GearyEmailFlags* flags;
	GearyEmailFlags* _tmp4_;
	GearyEmailFlags* _tmp5_;
	GearyNamedFlag* _tmp6_;
	GearyNamedFlag* _tmp7_;
	GearyNamedFlag* _tmp8_;
	GeeHashMap* changed_map;
	GeeHashMap* _tmp9_;
	GeeHashMap* _tmp10_;
	GearySmtpOutboxEmailIdentifier* _tmp11_;
	GearyEmailFlags* _tmp12_;
	GeeHashMap* _tmp13_;
	GError * _inner_error_;
};

struct _GearySmtpOutboxFolderRemoveEmailAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GearySmtpOutboxFolder* self;
	GeeList* email_ids;
	GCancellable* cancellable;
	GeeList* _tmp0_;
	GCancellable* _tmp1_;
	GError * _inner_error_;
};

struct _Block82Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	GeeList* removed;
	gint final_count;
	GeeList* email_ids;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _GearySmtpOutboxFolderInternalRemoveEmailAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GearySmtpOutboxFolder* self;
	GeeList* email_ids;
	GCancellable* cancellable;
	gboolean result;
	Block82Data* _data82_;
	GeeList* _tmp0_;
	GCancellable* _tmp1_;
	GeeArrayList* _tmp2_;
	GearyImapDBDatabase* _tmp3_;
	GCancellable* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GearySmtpOutboxFolderProperties* _tmp7_;
	GError * _inner_error_;
};

struct _GearySmtpOutboxFolderRemoveSingleEmailAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GearySmtpOutboxFolder* self;
	GearyEmailIdentifier* id;
	GCancellable* cancellable;
	GeeList* list;
	GeeArrayList* _tmp0_;
	GearyEmailIdentifier* _tmp1_;
	GCancellable* _tmp2_;
	GError * _inner_error_;
};

struct _GearySmtpOutboxFolderSendEmailAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GearySmtpOutboxFolder* self;
	GearyRFC822Message* rfc822;
	GCancellable* cancellable;
	GearyProgressMonitor* _tmp0_;
	GError* smtp_err;
	GearySmtpClientSession* _tmp1_;
	GearyAccount* _tmp2_;
	GearyAccountInformation* _tmp3_;
	GearyAccountInformation* _tmp4_;
	GearyCredentials* _tmp5_;
	GearyCredentials* _tmp6_;
	GCancellable* _tmp7_;
	GearySmtpGreeting* _tmp8_;
	GearySmtpGreeting* _tmp9_;
	GError* login_err;
	GError* _tmp10_;
	const gchar* _tmp11_;
	GError* _tmp12_;
	GError* _tmp13_;
	GError* _tmp14_;
	GearySmtpClientSession* _tmp15_;
	GearyAccount* _tmp16_;
	GearyAccountInformation* _tmp17_;
	GearyAccountInformation* _tmp18_;
	GearyRFC822MailboxAddress* _tmp19_;
	GearyRFC822MailboxAddress* _tmp20_;
	GearyRFC822Message* _tmp21_;
	GCancellable* _tmp22_;
	GError* send_err;
	GError* _tmp23_;
	const gchar* _tmp24_;
	GError* _tmp25_;
	GError* _tmp26_;
	GearySmtpClientSession* _tmp27_;
	GCancellable* _tmp28_;
	GearySmtpResponse* _tmp29_;
	GearySmtpResponse* _tmp30_;
	GError* err;
	GearySmtpClientSession* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	GError* _tmp34_;
	const gchar* _tmp35_;
	GearyProgressMonitor* _tmp36_;
	GError* _tmp37_;
	GError* _tmp38_;
	GError* _tmp39_;
	GearyRFC822Message* _tmp40_;
	GError * _inner_error_;
};

struct _GearySmtpOutboxFolderSaveSentMailAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GearySmtpOutboxFolder* self;
	GearyRFC822Message* rfc822;
	GCancellable* cancellable;
	GearyFolder* _tmp0_;
	GearyAccount* _tmp1_;
	GCancellable* _tmp2_;
	GearyFolder* _tmp3_;
	GearyFolderSupportCreate* create;
	GearyFolder* _tmp4_;
	GearyFolderSupportCreate* _tmp5_;
	GearyFolderSupportCreate* _tmp6_;
	GError* _tmp7_;
	gboolean open;
	GearyFolderSupportCreate* _tmp8_;
	GCancellable* _tmp9_;
	GearyFolderSupportCreate* _tmp10_;
	GearyRFC822Message* _tmp11_;
	GCancellable* _tmp12_;
	GearyEmailIdentifier* _tmp13_;
	GearyEmailIdentifier* _tmp14_;
	GearyFolderSupportCreate* _tmp15_;
	GCancellable* _tmp16_;
	GError* e;
	gboolean _tmp17_;
	GearyFolderSupportCreate* _tmp18_;
	GCancellable* _tmp19_;
	GError* _vala1_e;
	GearyFolderSupportCreate* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GError* _tmp23_;
	const gchar* _tmp24_;
	GError* _tmp25_;
	GError* _tmp26_;
	GError * _inner_error_;
};

struct _Block83Data {
	int _ref_count_;
	GearySmtpOutboxFolder* self;
	gboolean exists;
	gint64 ordering;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _GearySmtpOutboxFolderIsUnsentAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	GearySmtpOutboxFolder* self;
	gint64 ordering;
	GCancellable* cancellable;
	gboolean result;
	Block83Data* _data83_;
	gint64 _tmp0_;
	GCancellable* _tmp1_;
	GearyImapDBDatabase* _tmp2_;
	GCancellable* _tmp3_;
	GError * _inner_error_;
};

struct _GearySmtpOutboxFolderParamSpecOutboxRow {
	GParamSpec parent_instance;
};


static gpointer geary_smtp_outbox_folder_parent_class = NULL;
static gpointer geary_smtp_outbox_folder_outbox_row_parent_class = NULL;
static GearyFolderSupportRemoveIface* geary_smtp_outbox_folder_geary_folder_support_remove_parent_iface = NULL;
static GearyFolderSupportCreateIface* geary_smtp_outbox_folder_geary_folder_support_create_parent_iface = NULL;

GType geary_base_object_get_type (void) G_GNUC_CONST;
GType geary_folder_get_type (void) G_GNUC_CONST;
GType geary_folder_open_state_get_type (void) G_GNUC_CONST;
GType geary_folder_open_failed_get_type (void) G_GNUC_CONST;
GType geary_folder_close_reason_get_type (void) G_GNUC_CONST;
GType geary_email_identifier_get_type (void) G_GNUC_CONST;
GType geary_folder_count_change_reason_get_type (void) G_GNUC_CONST;
GType geary_named_flags_get_type (void) G_GNUC_CONST;
GType geary_email_flags_get_type (void) G_GNUC_CONST;
GType geary_special_folder_type_get_type (void) G_GNUC_CONST;
GType geary_folder_open_flags_get_type (void) G_GNUC_CONST;
GType geary_email_field_get_type (void) G_GNUC_CONST;
GType geary_folder_list_flags_get_type (void) G_GNUC_CONST;
GType geary_email_get_type (void) G_GNUC_CONST;
GType geary_account_get_type (void) G_GNUC_CONST;
GType geary_folder_properties_get_type (void) G_GNUC_CONST;
GType geary_folder_path_get_type (void) G_GNUC_CONST;
GType geary_progress_monitor_get_type (void) G_GNUC_CONST;
GType geary_abstract_local_folder_get_type (void) G_GNUC_CONST;
GType geary_folder_support_remove_get_type (void) G_GNUC_CONST;
GType geary_rf_c822_message_get_type (void) G_GNUC_CONST;
GType geary_folder_support_create_get_type (void) G_GNUC_CONST;
GType geary_smtp_outbox_folder_get_type (void) G_GNUC_CONST;
GType geary_folder_root_get_type (void) G_GNUC_CONST;
GType geary_smtp_outbox_folder_root_get_type (void) G_GNUC_CONST;
GType geary_db_context_get_type (void) G_GNUC_CONST;
GType geary_db_database_get_type (void) G_GNUC_CONST;
GType geary_db_versioned_database_get_type (void) G_GNUC_CONST;
GType geary_imap_db_database_get_type (void) G_GNUC_CONST;
gpointer geary_smtp_client_session_ref (gpointer instance);
void geary_smtp_client_session_unref (gpointer instance);
GParamSpec* geary_smtp_param_spec_client_session (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void geary_smtp_value_set_client_session (GValue* value, gpointer v_object);
void geary_smtp_value_take_client_session (GValue* value, gpointer v_object);
gpointer geary_smtp_value_get_client_session (const GValue* value);
GType geary_smtp_client_session_get_type (void) G_GNUC_CONST;
GType geary_nonblocking_mailbox_get_type (void) G_GNUC_CONST;
static gpointer geary_smtp_outbox_folder_outbox_row_ref (gpointer instance);
static void geary_smtp_outbox_folder_outbox_row_unref (gpointer instance);
static GParamSpec* geary_smtp_outbox_folder_param_spec_outbox_row (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void geary_smtp_outbox_folder_value_set_outbox_row (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void geary_smtp_outbox_folder_value_take_outbox_row (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer geary_smtp_outbox_folder_value_get_outbox_row (const GValue* value) G_GNUC_UNUSED;
static GType geary_smtp_outbox_folder_outbox_row_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
GType geary_smtp_outbox_folder_properties_get_type (void) G_GNUC_CONST;
#define GEARY_SMTP_OUTBOX_FOLDER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolderPrivate))
enum  {
	GEARY_SMTP_OUTBOX_FOLDER_DUMMY_PROPERTY,
	GEARY_SMTP_OUTBOX_FOLDER_ACCOUNT,
	GEARY_SMTP_OUTBOX_FOLDER_PROPERTIES,
	GEARY_SMTP_OUTBOX_FOLDER_PATH,
	GEARY_SMTP_OUTBOX_FOLDER_SPECIAL_FOLDER_TYPE
};
GearySmtpOutboxFolderRoot* geary_smtp_outbox_folder_root_new (void);
GearySmtpOutboxFolderRoot* geary_smtp_outbox_folder_root_construct (GType object_type);
GearyNonblockingMailbox* geary_nonblocking_mailbox_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GCompareDataFunc comparator, void* comparator_target, GDestroyNotify comparator_target_destroy_notify);
GearyNonblockingMailbox* geary_nonblocking_mailbox_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, GCompareDataFunc comparator, void* comparator_target, GDestroyNotify comparator_target_destroy_notify);
GearySmtpOutboxFolderProperties* geary_smtp_outbox_folder_properties_new (gint total, gint unread);
GearySmtpOutboxFolderProperties* geary_smtp_outbox_folder_properties_construct (GType object_type, gint total, gint unread);
#define GEARY_SMTP_OUTBOX_FOLDER_MIN_SEND_RETRY_INTERVAL_SEC ((guint) 4)
#define GEARY_SMTP_OUTBOX_FOLDER_MAX_SEND_RETRY_INTERVAL_SEC ((guint) 64)
GearySmtpOutboxFolder* geary_smtp_outbox_folder_new (GearyImapDBDatabase* db, GearyAccount* account, GearyProgressMonitor* sending_monitor);
GearySmtpOutboxFolder* geary_smtp_outbox_folder_construct (GType object_type, GearyImapDBDatabase* db, GearyAccount* account, GearyProgressMonitor* sending_monitor);
GearyAbstractLocalFolder* geary_abstract_local_folder_construct (GType object_type);
GType geary_account_information_get_type (void) G_GNUC_CONST;
GearyAccountInformation* geary_account_get_information (GearyAccount* self);
GType geary_endpoint_get_type (void) G_GNUC_CONST;
GearyEndpoint* geary_account_information_get_smtp_endpoint (GearyAccountInformation* self);
GearySmtpClientSession* geary_smtp_client_session_new (GearyEndpoint* endpoint);
GearySmtpClientSession* geary_smtp_client_session_construct (GType object_type, GearyEndpoint* endpoint);
static void geary_smtp_outbox_folder_do_postman_async (GearySmtpOutboxFolder* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void geary_smtp_outbox_folder_do_postman_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_);
static void geary_smtp_outbox_folder_real_find_boundaries_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_real_find_boundaries_async (GearyFolder* base, GeeCollection* ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
static gboolean geary_smtp_outbox_folder_real_find_boundaries_async_co (GearySmtpOutboxFolderFindBoundariesAsyncData* _data_);
GType geary_smtp_outbox_email_identifier_get_type (void) G_GNUC_CONST;
static Block72Data* block72_data_ref (Block72Data* _data72_);
static void block72_data_unref (void * _userdata_);
GType geary_db_transaction_type_get_type (void) G_GNUC_CONST;
GType geary_db_transaction_outcome_get_type (void) G_GNUC_CONST;
GType geary_db_connection_get_type (void) G_GNUC_CONST;
void geary_db_database_exec_transaction_async (GearyDbDatabase* self, GearyDbTransactionType type, GearyDbTransactionMethod cb, void* cb_target, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
GearyDbTransactionOutcome geary_db_database_exec_transaction_finish (GearyDbDatabase* self, GAsyncResult* _res_, GError** error);
static GearyDbTransactionOutcome __lambda96_ (Block72Data* _data72_, GearyDbConnection* cx, GError** error);
static GearySmtpOutboxFolderOutboxRow* geary_smtp_outbox_folder_do_fetch_row_by_ordering (GearySmtpOutboxFolder* self, GearyDbConnection* cx, gint64 ordering, GCancellable* cancellable, GError** error);
gint64 geary_smtp_outbox_email_identifier_get_ordering (GearySmtpOutboxEmailIdentifier* self);
static GearyDbTransactionOutcome ___lambda96__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error);
static void geary_smtp_outbox_folder_find_boundaries_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void geary_smtp_outbox_folder_add_to_containing_folders_async_data_free (gpointer _data);
void geary_smtp_outbox_folder_add_to_containing_folders_async (GearySmtpOutboxFolder* self, GeeCollection* ids, GeeHashMultiMap* map, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
void geary_smtp_outbox_folder_add_to_containing_folders_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error);
static gboolean geary_smtp_outbox_folder_add_to_containing_folders_async_co (GearySmtpOutboxFolderAddToContainingFoldersAsyncData* _data_);
static Block73Data* block73_data_ref (Block73Data* _data73_);
static void block73_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda97_ (Block73Data* _data73_, GearyDbConnection* cx, GCancellable* cancellable, GError** error);
GearyFolderPath* geary_folder_get_path (GearyFolder* self);
static GearyDbTransactionOutcome ___lambda97__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error);
static void geary_smtp_outbox_folder_add_to_containing_folders_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gchar* geary_smtp_outbox_folder_message_subject (GearyRFC822Message* message);
GType geary_message_data_abstract_message_data_get_type (void) G_GNUC_CONST;
GType geary_message_data_string_message_data_get_type (void) G_GNUC_CONST;
GType geary_rf_c822_subject_get_type (void) G_GNUC_CONST;
GearyRFC822Subject* geary_rf_c822_message_get_subject (GearyRFC822Message* self);
gboolean geary_string_is_empty (const gchar* str);
gchar* geary_message_data_abstract_message_data_to_string (GearyMessageDataAbstractMessageData* self);
static void geary_smtp_outbox_folder_do_postman_async_data_free (gpointer _data);
static gboolean geary_smtp_outbox_folder_do_postman_async_co (GearySmtpOutboxFolderDoPostmanAsyncData* _data_);
static Block74Data* block74_data_ref (Block74Data* _data74_);
static void block74_data_unref (void * _userdata_);
static GearyDbTransactionOutcome ___lambda92_ (Block74Data* _data74_, GearyDbConnection* cx, GCancellable* cancellable, GError** error);
GType geary_db_statement_get_type (void) G_GNUC_CONST;
GQuark geary_database_error_quark (void);
GearyDbStatement* geary_db_connection_prepare (GearyDbConnection* self, const gchar* sql, GError** error);
GType geary_db_result_get_type (void) G_GNUC_CONST;
GearyDbResult* geary_db_statement_exec (GearyDbStatement* self, GCancellable* cancellable, GError** error);
gboolean geary_db_result_get_finished (GearyDbResult* self);
gint64 geary_db_result_rowid_at (GearyDbResult* self, gint column, GError** error);
gint64 geary_db_result_int64_at (GearyDbResult* self, gint column, GError** error);
GType geary_memory_buffer_get_type (void) G_GNUC_CONST;
GearyMemoryBuffer* geary_db_result_string_buffer_at (GearyDbResult* self, gint column, GError** error);
static GearySmtpOutboxFolderOutboxRow* geary_smtp_outbox_folder_outbox_row_new (gint64 id, gint position, gint64 ordering, gboolean sent, GearyMemoryBuffer* message, GearySmtpOutboxFolderRoot* root);
static GearySmtpOutboxFolderOutboxRow* geary_smtp_outbox_folder_outbox_row_construct (GType object_type, gint64 id, gint position, gint64 ordering, gboolean sent, GearyMemoryBuffer* message, GearySmtpOutboxFolderRoot* root);
gboolean geary_db_result_next (GearyDbResult* self, GCancellable* cancellable, GError** error);
static GearyDbTransactionOutcome ____lambda92__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error);
static void geary_smtp_outbox_folder_do_postman_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
void geary_smtp_outbox_folder_properties_set_total (GearySmtpOutboxFolderProperties* self, gint total);
gboolean geary_nonblocking_mailbox_send (GearyNonblockingMailbox* self, gconstpointer msg);
void geary_nonblocking_mailbox_recv_async (GearyNonblockingMailbox* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
gpointer geary_nonblocking_mailbox_recv_finish (GearyNonblockingMailbox* self, GAsyncResult* _res_, GError** error);
static void geary_smtp_outbox_folder_is_unsent_async (GearySmtpOutboxFolder* self, gint64 ordering, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
static gboolean geary_smtp_outbox_folder_is_unsent_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error);
gchar* geary_email_identifier_to_string (GearyEmailIdentifier* self);
GType geary_credentials_get_type (void) G_GNUC_CONST;
GearyCredentials* geary_account_information_get_smtp_credentials (GearyAccountInformation* self);
gboolean geary_credentials_is_complete (GearyCredentials* self);
GType geary_service_flag_get_type (void) G_GNUC_CONST;
void geary_account_information_get_passwords_async (GearyAccountInformation* self, GearyServiceFlag services, GAsyncReadyCallback _callback_, gpointer _user_data_);
GearyServiceFlag geary_account_information_get_passwords_finish (GearyAccountInformation* self, GAsyncResult* _res_, GError** error);
GQuark geary_rf_c822_error_quark (void);
GearyRFC822Message* geary_rf_c822_message_new_from_buffer (GearyMemoryBuffer* full_email, GError** error);
GearyRFC822Message* geary_rf_c822_message_construct_from_buffer (GType object_type, GearyMemoryBuffer* full_email, GError** error);
gboolean geary_endpoint_get_is_trusted_or_never_connected (GearyEndpoint* self);
static void geary_smtp_outbox_folder_send_email_async (GearySmtpOutboxFolder* self, GearyRFC822Message* rfc822, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void geary_smtp_outbox_folder_send_email_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error);
GQuark geary_smtp_error_quark (void);
void geary_account_information_fetch_passwords_async (GearyAccountInformation* self, GearyServiceFlag services, gboolean force_request, GAsyncReadyCallback _callback_, gpointer _user_data_);
gboolean geary_account_information_fetch_passwords_finish (GearyAccountInformation* self, GAsyncResult* _res_, GError** error);
GType geary_account_problem_get_type (void) G_GNUC_CONST;
gchar* geary_endpoint_to_string (GearyEndpoint* self);
void geary_scheduler_sleep_async (guint seconds, GAsyncReadyCallback _callback_, gpointer _user_data_);
void geary_scheduler_sleep_finish (GAsyncResult* _res_);
guint geary_numeric_uint_ceiling (guint value, guint ceiling);
gboolean geary_account_information_allow_save_sent_mail (GearyAccountInformation* self);
gboolean geary_account_information_get_save_sent_mail (GearyAccountInformation* self);
static void geary_smtp_outbox_folder_mark_email_as_sent_async (GearySmtpOutboxFolder* self, GearySmtpOutboxEmailIdentifier* outbox_id, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void geary_smtp_outbox_folder_mark_email_as_sent_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error);
static void geary_smtp_outbox_folder_save_sent_mail_async (GearySmtpOutboxFolder* self, GearyRFC822Message* rfc822, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void geary_smtp_outbox_folder_save_sent_mail_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error);
static void geary_smtp_outbox_folder_internal_remove_email_async (GearySmtpOutboxFolder* self, GeeList* email_ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
static gboolean geary_smtp_outbox_folder_internal_remove_email_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error);
static GearyFolderOpenState geary_smtp_outbox_folder_real_get_open_state (GearyFolder* base);
gboolean geary_abstract_local_folder_is_open (GearyAbstractLocalFolder* self);
static void geary_smtp_outbox_folder_get_email_count_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_get_email_count_async (GearySmtpOutboxFolder* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
static gint geary_smtp_outbox_folder_get_email_count_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error);
static gboolean geary_smtp_outbox_folder_get_email_count_async_co (GearySmtpOutboxFolderGetEmailCountAsyncData* _data_);
static Block75Data* block75_data_ref (Block75Data* _data75_);
static void block75_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda98_ (Block75Data* _data75_, GearyDbConnection* cx, GError** error);
static gint geary_smtp_outbox_folder_do_get_email_count (GearySmtpOutboxFolder* self, GearyDbConnection* cx, GCancellable* cancellable, GError** error);
static GearyDbTransactionOutcome ___lambda98__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error);
static void geary_smtp_outbox_folder_get_email_count_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void geary_smtp_outbox_folder_enqueue_email_async_data_free (gpointer _data);
void geary_smtp_outbox_folder_enqueue_email_async (GearySmtpOutboxFolder* self, GearyRFC822Message* rfc822, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
GearySmtpOutboxEmailIdentifier* geary_smtp_outbox_folder_enqueue_email_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error);
static gboolean geary_smtp_outbox_folder_enqueue_email_async_co (GearySmtpOutboxFolderEnqueueEmailAsyncData* _data_);
static Block76Data* block76_data_ref (Block76Data* _data76_);
static void block76_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda99_ (Block76Data* _data76_, GearyDbConnection* cx, GError** error);
static gint64 geary_smtp_outbox_folder_do_get_next_ordering (GearySmtpOutboxFolder* self, GearyDbConnection* cx, GCancellable* cancellable, GError** error);
GearyMemoryBuffer* geary_rf_c822_message_get_network_buffer (GearyRFC822Message* self, gboolean dotstuffed, GError** error);
GearyDbStatement* geary_db_statement_bind_string_buffer (GearyDbStatement* self, gint index, GearyMemoryBuffer* buffer, GError** error);
GearyDbStatement* geary_db_statement_bind_int64 (GearyDbStatement* self, gint index, gint64 i64, GError** error);
gint64 geary_db_statement_exec_insert (GearyDbStatement* self, GCancellable* cancellable, GError** error);
GearyDbStatement* geary_db_statement_bind_rowid (GearyDbStatement* self, gint index, gint64 rowid, GError** error);
static gint geary_smtp_outbox_folder_do_get_position_by_ordering (GearySmtpOutboxFolder* self, GearyDbConnection* cx, gint64 ordering, GCancellable* cancellable, GError** error);
static GearyDbTransactionOutcome ___lambda99__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error);
static void geary_smtp_outbox_folder_enqueue_email_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
void geary_folder_notify_email_appended (GearyFolder* self, GeeCollection* ids);
void geary_folder_notify_email_locally_appended (GearyFolder* self, GeeCollection* ids);
void geary_folder_notify_email_count_changed (GearyFolder* self, gint new_count, GearyFolderCountChangeReason reason);
static void geary_smtp_outbox_folder_real_create_email_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_real_create_email_async (GearySmtpOutboxFolder* self, GearyRFC822Message* rfc822, GearyEmailFlags* flags, GDateTime* date_received, GearyEmailIdentifier* id, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
void geary_smtp_outbox_folder_create_email_async (GearySmtpOutboxFolder* self, GearyRFC822Message* rfc822, GearyEmailFlags* flags, GDateTime* date_received, GearyEmailIdentifier* id, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
GearyEmailIdentifier* geary_smtp_outbox_folder_create_email_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error);
static gboolean geary_smtp_outbox_folder_real_create_email_async_co (GearySmtpOutboxFolderCreateEmailAsyncData* _data_);
GQuark geary_engine_error_quark (void);
void geary_abstract_local_folder_check_open (GearyAbstractLocalFolder* self, GError** error);
static void geary_smtp_outbox_folder_create_email_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void geary_smtp_outbox_folder_real_list_email_by_id_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_real_list_email_by_id_async (GearyFolder* base, GearyEmailIdentifier* _initial_id, gint count, GearyEmailField required_fields, GearyFolderListFlags flags, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
static gboolean geary_smtp_outbox_folder_real_list_email_by_id_async_co (GearySmtpOutboxFolderListEmailByIdAsyncData* _data_);
static Block77Data* block77_data_ref (Block77Data* _data77_);
static void block77_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda100_ (Block77Data* _data77_, GearyDbConnection* cx, GError** error);
gboolean geary_folder_list_flags_is_newest_to_oldest (GearyFolderListFlags self);
gboolean geary_folder_list_flags_is_including_id (GearyFolderListFlags self);
GearyDbStatement* geary_db_statement_bind_int (GearyDbStatement* self, gint index, gint i, GError** error);
gboolean geary_db_result_bool_at (GearyDbResult* self, gint column, GError** error);
static GearyEmail* geary_smtp_outbox_folder_row_to_email (GearySmtpOutboxFolder* self, GearySmtpOutboxFolderOutboxRow* row, GError** error);
static GearyDbTransactionOutcome ___lambda100__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error);
static void geary_smtp_outbox_folder_list_email_by_id_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void geary_smtp_outbox_folder_real_list_email_by_sparse_id_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_real_list_email_by_sparse_id_async (GearyFolder* base, GeeCollection* ids, GearyEmailField required_fields, GearyFolderListFlags flags, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
static gboolean geary_smtp_outbox_folder_real_list_email_by_sparse_id_async_co (GearySmtpOutboxFolderListEmailBySparseIdAsyncData* _data_);
static Block78Data* block78_data_ref (Block78Data* _data78_);
static void block78_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda101_ (Block78Data* _data78_, GearyDbConnection* cx, GError** error);
static GearyDbTransactionOutcome ___lambda101__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error);
static void geary_smtp_outbox_folder_list_email_by_sparse_id_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void geary_smtp_outbox_folder_real_list_local_email_fields_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_real_list_local_email_fields_async (GearyFolder* base, GeeCollection* ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
static gboolean geary_smtp_outbox_folder_real_list_local_email_fields_async_co (GearySmtpOutboxFolderListLocalEmailFieldsAsyncData* _data_);
static Block79Data* block79_data_ref (Block79Data* _data79_);
static void block79_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda102_ (Block79Data* _data79_, GearyDbConnection* cx, GError** error);
GType geary_db_reset_scope_get_type (void) G_GNUC_CONST;
GearyDbStatement* geary_db_statement_reset (GearyDbStatement* self, GearyDbResetScope reset_scope, GError** error);
static GearyDbTransactionOutcome ___lambda102__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error);
static void geary_smtp_outbox_folder_list_local_email_fields_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void geary_smtp_outbox_folder_real_fetch_email_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_real_fetch_email_async (GearyFolder* base, GearyEmailIdentifier* id, GearyEmailField required_fields, GearyFolderListFlags flags, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
static gboolean geary_smtp_outbox_folder_real_fetch_email_async_co (GearySmtpOutboxFolderFetchEmailAsyncData* _data_);
static Block80Data* block80_data_ref (Block80Data* _data80_);
static void block80_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda103_ (Block80Data* _data80_, GearyDbConnection* cx, GError** error);
static GearyDbTransactionOutcome ___lambda103__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error);
static void geary_smtp_outbox_folder_fetch_email_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void geary_smtp_outbox_folder_mark_email_as_sent_async_data_free (gpointer _data);
static gboolean geary_smtp_outbox_folder_mark_email_as_sent_async_co (GearySmtpOutboxFolderMarkEmailAsSentAsyncData* _data_);
static Block81Data* block81_data_ref (Block81Data* _data81_);
static void block81_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda94_ (Block81Data* _data81_, GearyDbConnection* cx, GError** error);
static void geary_smtp_outbox_folder_do_mark_email_as_sent (GearySmtpOutboxFolder* self, GearyDbConnection* cx, GearySmtpOutboxEmailIdentifier* id, GCancellable* cancellable, GError** error);
static GearyDbTransactionOutcome ___lambda94__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error);
static void geary_smtp_outbox_folder_mark_email_as_sent_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
GearyEmailFlags* geary_email_flags_new (void);
GearyEmailFlags* geary_email_flags_construct (GType object_type);
GType geary_named_flag_get_type (void) G_GNUC_CONST;
void geary_named_flags_add (GearyNamedFlags* self, GearyNamedFlag* flag);
GearyNamedFlag* geary_email_flags_get_OUTBOX_SENT (void);
void geary_folder_notify_email_flags_changed (GearyFolder* self, GeeMap* flag_map);
static void geary_smtp_outbox_folder_real_remove_email_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_real_remove_email_async (GearySmtpOutboxFolder* self, GeeList* email_ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
void geary_smtp_outbox_folder_remove_email_async (GearySmtpOutboxFolder* self, GeeList* email_ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
void geary_smtp_outbox_folder_remove_email_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error);
static gboolean geary_smtp_outbox_folder_real_remove_email_async_co (GearySmtpOutboxFolderRemoveEmailAsyncData* _data_);
static void geary_smtp_outbox_folder_remove_email_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void geary_smtp_outbox_folder_internal_remove_email_async_data_free (gpointer _data);
static gboolean geary_smtp_outbox_folder_internal_remove_email_async_co (GearySmtpOutboxFolderInternalRemoveEmailAsyncData* _data_);
static Block82Data* block82_data_ref (Block82Data* _data82_);
static void block82_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda95_ (Block82Data* _data82_, GearyDbConnection* cx, GError** error);
static gboolean geary_smtp_outbox_folder_do_remove_email (GearySmtpOutboxFolder* self, GearyDbConnection* cx, GearySmtpOutboxEmailIdentifier* id, GCancellable* cancellable, GError** error);
static GearyDbTransactionOutcome ___lambda95__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error);
static void geary_smtp_outbox_folder_internal_remove_email_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
void geary_folder_notify_email_removed (GearyFolder* self, GeeCollection* ids);
static void geary_smtp_outbox_folder_real_remove_single_email_async_data_free (gpointer _data);
static void geary_smtp_outbox_folder_real_remove_single_email_async (GearySmtpOutboxFolder* self, GearyEmailIdentifier* id, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
void geary_smtp_outbox_folder_remove_single_email_async (GearySmtpOutboxFolder* self, GearyEmailIdentifier* id, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
void geary_smtp_outbox_folder_remove_single_email_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error);
static gboolean geary_smtp_outbox_folder_real_remove_single_email_async_co (GearySmtpOutboxFolderRemoveSingleEmailAsyncData* _data_);
static void geary_smtp_outbox_folder_remove_single_email_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
GearyEmail* geary_rf_c822_message_get_email (GearyRFC822Message* self, GearyEmailIdentifier* id, GError** error);
GType geary_email_properties_get_type (void) G_GNUC_CONST;
void geary_email_set_email_properties (GearyEmail* self, GearyEmailProperties* properties);
GearySmtpOutboxEmailProperties* geary_smtp_outbox_email_properties_new (GDateTime* date_received, glong total_bytes);
GearySmtpOutboxEmailProperties* geary_smtp_outbox_email_properties_construct (GType object_type, GDateTime* date_received, glong total_bytes);
GType geary_smtp_outbox_email_properties_get_type (void) G_GNUC_CONST;
void geary_email_set_flags (GearyEmail* self, GearyEmailFlags* email_flags);
static void geary_smtp_outbox_folder_send_email_async_data_free (gpointer _data);
static gboolean geary_smtp_outbox_folder_send_email_async_co (GearySmtpOutboxFolderSendEmailAsyncData* _data_);
void geary_progress_monitor_notify_start (GearyProgressMonitor* self);
void geary_smtp_client_session_login_async (GearySmtpClientSession* self, GearyCredentials* creds, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
gpointer geary_smtp_response_ref (gpointer instance);
void geary_smtp_response_unref (gpointer instance);
GParamSpec* geary_smtp_param_spec_response (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void geary_smtp_value_set_response (GValue* value, gpointer v_object);
void geary_smtp_value_take_response (GValue* value, gpointer v_object);
gpointer geary_smtp_value_get_response (const GValue* value);
GType geary_smtp_response_get_type (void) G_GNUC_CONST;
GType geary_smtp_greeting_get_type (void) G_GNUC_CONST;
GearySmtpGreeting* geary_smtp_client_session_login_finish (GearySmtpClientSession* self, GAsyncResult* _res_, GError** error);
static void geary_smtp_outbox_folder_send_email_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
GType geary_rf_c822_mailbox_address_get_type (void) G_GNUC_CONST;
void geary_smtp_client_session_send_email_async (GearySmtpClientSession* self, GearyRFC822MailboxAddress* from, GearyRFC822Message* email, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
void geary_smtp_client_session_send_email_finish (GearySmtpClientSession* self, GAsyncResult* _res_, GError** error);
GearyRFC822MailboxAddress* geary_account_information_get_primary_mailbox_address (GearyAccountInformation* self);
void geary_smtp_client_session_logout_async (GearySmtpClientSession* self, gboolean force, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
GearySmtpResponse* geary_smtp_client_session_logout_finish (GearySmtpClientSession* self, GAsyncResult* _res_, GError** error);
gchar* geary_smtp_client_session_to_string (GearySmtpClientSession* self);
void geary_progress_monitor_notify_finish (GearyProgressMonitor* self);
static void geary_smtp_outbox_folder_save_sent_mail_async_data_free (gpointer _data);
static gboolean geary_smtp_outbox_folder_save_sent_mail_async_co (GearySmtpOutboxFolderSaveSentMailAsyncData* _data_);
void geary_account_get_required_special_folder_async (GearyAccount* self, GearySpecialFolderType special, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
GearyFolder* geary_account_get_required_special_folder_finish (GearyAccount* self, GAsyncResult* _res_, GError** error);
static void geary_smtp_outbox_folder_save_sent_mail_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
void geary_folder_open_async (GearyFolder* self, GearyFolderOpenFlags open_flags, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
gboolean geary_folder_open_finish (GearyFolder* self, GAsyncResult* _res_, GError** error);
void geary_folder_support_create_create_email_async (GearyFolderSupportCreate* self, GearyRFC822Message* rfc822, GearyEmailFlags* flags, GDateTime* date_received, GearyEmailIdentifier* id, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
GearyEmailIdentifier* geary_folder_support_create_create_email_finish (GearyFolderSupportCreate* self, GAsyncResult* _res_, GError** error);
void geary_folder_close_async (GearyFolder* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
gboolean geary_folder_close_finish (GearyFolder* self, GAsyncResult* _res_, GError** error);
gchar* geary_folder_to_string (GearyFolder* self);
static void geary_smtp_outbox_folder_is_unsent_async_data_free (gpointer _data);
static gboolean geary_smtp_outbox_folder_is_unsent_async_co (GearySmtpOutboxFolderIsUnsentAsyncData* _data_);
static Block83Data* block83_data_ref (Block83Data* _data83_);
static void block83_data_unref (void * _userdata_);
static GearyDbTransactionOutcome __lambda93_ (Block83Data* _data83_, GearyDbConnection* cx, GError** error);
static GearyDbTransactionOutcome ___lambda93__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error);
static void geary_smtp_outbox_folder_is_unsent_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
gint geary_db_result_int_at (GearyDbResult* self, gint column, GError** error);
gint geary_db_statement_exec_get_modified (GearyDbStatement* self, GCancellable* cancellable, GError** error);
static void g_cclosure_user_marshal_VOID__ENUM_POINTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
enum  {
	GEARY_SMTP_OUTBOX_FOLDER_OUTBOX_ROW_DUMMY_PROPERTY
};
GearySmtpOutboxEmailIdentifier* geary_smtp_outbox_email_identifier_new (gint64 message_id, gint64 ordering);
GearySmtpOutboxEmailIdentifier* geary_smtp_outbox_email_identifier_construct (GType object_type, gint64 message_id, gint64 ordering);
static void geary_smtp_outbox_folder_outbox_row_finalize (GearySmtpOutboxFolderOutboxRow* obj);
static void geary_smtp_outbox_folder_finalize (GObject* obj);
GearyAccount* geary_folder_get_account (GearyFolder* self);
GearyFolderProperties* geary_folder_get_properties (GearyFolder* self);
GearySpecialFolderType geary_folder_get_special_folder_type (GearyFolder* self);
static void _vala_geary_smtp_outbox_folder_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);


static gpointer _g_object_ref0 (gpointer self) {
#line 75 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return self ? g_object_ref (self) : NULL;
#line 1854 "smtp-outbox-folder.c"
}


GearySmtpOutboxFolder* geary_smtp_outbox_folder_construct (GType object_type, GearyImapDBDatabase* db, GearyAccount* account, GearyProgressMonitor* sending_monitor) {
	GearySmtpOutboxFolder * self = NULL;
	GearyImapDBDatabase* _tmp0_ = NULL;
	GearyImapDBDatabase* _tmp1_ = NULL;
	GearyAccount* _tmp2_ = NULL;
	GearyProgressMonitor* _tmp3_ = NULL;
	GearyProgressMonitor* _tmp4_ = NULL;
	GearyAccount* _tmp5_ = NULL;
	GearyAccountInformation* _tmp6_ = NULL;
	GearyAccountInformation* _tmp7_ = NULL;
	GearyEndpoint* _tmp8_ = NULL;
	GearyEndpoint* _tmp9_ = NULL;
	GearySmtpClientSession* _tmp10_ = NULL;
#line 72 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IMAP_DB_IS_DATABASE (db), NULL);
#line 72 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT (account), NULL);
#line 72 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_PROGRESS_MONITOR (sending_monitor), NULL);
#line 73 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = (GearySmtpOutboxFolder*) geary_abstract_local_folder_construct (object_type);
#line 75 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = db;
#line 75 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 75 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->priv->db);
#line 75 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->priv->db = _tmp1_;
#line 76 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = account;
#line 76 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->priv->_account = _tmp2_;
#line 77 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = sending_monitor;
#line 77 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 77 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->priv->sending_monitor);
#line 77 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->priv->sending_monitor = _tmp4_;
#line 79 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = self->priv->_account;
#line 79 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = geary_account_get_information (_tmp5_);
#line 79 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = _tmp6_;
#line 79 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = geary_account_information_get_smtp_endpoint (_tmp7_);
#line 79 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp9_ = _tmp8_;
#line 79 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp10_ = geary_smtp_client_session_new (_tmp9_);
#line 79 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_geary_smtp_client_session_unref0 (self->priv->smtp);
#line 79 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->priv->smtp = _tmp10_;
#line 79 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp9_);
#line 81 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_do_postman_async (self, NULL, NULL);
#line 72 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return self;
#line 1921 "smtp-outbox-folder.c"
}


GearySmtpOutboxFolder* geary_smtp_outbox_folder_new (GearyImapDBDatabase* db, GearyAccount* account, GearyProgressMonitor* sending_monitor) {
#line 72 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return geary_smtp_outbox_folder_construct (GEARY_TYPE_SMTP_OUTBOX_FOLDER, db, account, sending_monitor);
#line 1928 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_find_boundaries_async_data_free (gpointer _data) {
	GearySmtpOutboxFolderFindBoundariesAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderFindBoundariesAsyncData, _data_);
#line 1939 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_find_boundaries_async (GearyFolder* base, GeeCollection* ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GearySmtpOutboxFolder * self;
	GearySmtpOutboxFolderFindBoundariesAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
	GeeCollection* _tmp2_ = NULL;
	GCancellable* _tmp3_ = NULL;
	GCancellable* _tmp4_ = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderFindBoundariesAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, geary_smtp_outbox_folder_real_find_boundaries_async);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, geary_smtp_outbox_folder_real_find_boundaries_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = ids;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->ids);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->ids = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = cancellable;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp4_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_find_boundaries_async_co (_data_);
#line 1981 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_find_boundaries_finish (GearyFolder* base, GAsyncResult* _res_, GearyEmailIdentifier** low, GearyEmailIdentifier** high, GError** error) {
	GearySmtpOutboxFolderFindBoundariesAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 1991 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (low) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		*low = _data_->low;
#line 1999 "smtp-outbox-folder.c"
	} else {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data_->low);
#line 2003 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->low = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (high) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		*high = _data_->high;
#line 2011 "smtp-outbox-folder.c"
	} else {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data_->high);
#line 2015 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->high = NULL;
#line 2019 "smtp-outbox-folder.c"
}


static Block72Data* block72_data_ref (Block72Data* _data72_) {
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data72_->_ref_count_);
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data72_;
#line 2028 "smtp-outbox-folder.c"
}


static void block72_data_unref (void * _userdata_) {
	Block72Data* _data72_;
	_data72_ = (Block72Data*) _userdata_;
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data72_->_ref_count_)) {
#line 2037 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data72_->self;
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data72_->outbox_high);
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data72_->outbox_low);
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data72_->ids);
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data72_->cancellable);
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block72Data, _data72_);
#line 2053 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome __lambda96_ (Block72Data* _data72_, GearyDbConnection* cx, GError** error) {
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	GError * _inner_error_ = NULL;
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data72_->self;
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 2066 "smtp-outbox-folder.c"
	{
		GeeIterator* _id_it = NULL;
		GeeCollection* _tmp0_ = NULL;
		GeeIterator* _tmp1_ = NULL;
#line 90 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = _data72_->ids;
#line 90 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 90 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_id_it = _tmp1_;
#line 90 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (TRUE) {
#line 2079 "smtp-outbox-folder.c"
			GeeIterator* _tmp2_ = NULL;
			gboolean _tmp3_ = FALSE;
			GearyEmailIdentifier* id = NULL;
			GeeIterator* _tmp4_ = NULL;
			gpointer _tmp5_ = NULL;
			GearySmtpOutboxEmailIdentifier* outbox_id = NULL;
			GearyEmailIdentifier* _tmp6_ = NULL;
			GearySmtpOutboxEmailIdentifier* _tmp7_ = NULL;
			GearySmtpOutboxEmailIdentifier* _tmp8_ = NULL;
			GearySmtpOutboxFolderOutboxRow* row = NULL;
			GearyDbConnection* _tmp9_ = NULL;
			GearySmtpOutboxEmailIdentifier* _tmp10_ = NULL;
			gint64 _tmp11_ = 0LL;
			gint64 _tmp12_ = 0LL;
			GCancellable* _tmp13_ = NULL;
			GearySmtpOutboxFolderOutboxRow* _tmp14_ = NULL;
			GearySmtpOutboxFolderOutboxRow* _tmp15_ = NULL;
			gboolean _tmp16_ = FALSE;
			gboolean _tmp24_ = FALSE;
#line 90 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp2_ = _id_it;
#line 90 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 90 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!_tmp3_) {
#line 90 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				break;
#line 2107 "smtp-outbox-folder.c"
			}
#line 90 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp4_ = _id_it;
#line 90 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 90 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			id = (GearyEmailIdentifier*) _tmp5_;
#line 91 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp6_ = id;
#line 91 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER) ? ((GearySmtpOutboxEmailIdentifier*) _tmp6_) : NULL);
#line 91 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			outbox_id = _tmp7_;
#line 92 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp8_ = outbox_id;
#line 92 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp8_ == NULL) {
#line 93 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 93 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 93 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				continue;
#line 2131 "smtp-outbox-folder.c"
			}
#line 95 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp9_ = cx;
#line 95 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp10_ = outbox_id;
#line 95 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp11_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp10_);
#line 95 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp12_ = _tmp11_;
#line 95 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp13_ = _data72_->cancellable;
#line 95 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp14_ = geary_smtp_outbox_folder_do_fetch_row_by_ordering (self, _tmp9_, _tmp12_, _tmp13_, &_inner_error_);
#line 95 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			row = _tmp14_;
#line 95 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 95 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 95 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 95 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 95 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_it);
#line 95 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 2159 "smtp-outbox-folder.c"
			}
#line 96 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp15_ = row;
#line 96 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp15_ == NULL) {
#line 97 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (row);
#line 97 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 97 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 97 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				continue;
#line 2173 "smtp-outbox-folder.c"
			}
#line 99 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_data72_->outbox_low == NULL) {
#line 99 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp16_ = TRUE;
#line 2179 "smtp-outbox-folder.c"
			} else {
				GearySmtpOutboxEmailIdentifier* _tmp17_ = NULL;
				gint64 _tmp18_ = 0LL;
				gint64 _tmp19_ = 0LL;
				gint64 _tmp20_ = 0LL;
				gint64 _tmp21_ = 0LL;
#line 99 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp17_ = outbox_id;
#line 99 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp18_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp17_);
#line 99 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp19_ = _tmp18_;
#line 99 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp20_ = geary_smtp_outbox_email_identifier_get_ordering (_data72_->outbox_low);
#line 99 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp21_ = _tmp20_;
#line 99 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp16_ = _tmp19_ < _tmp21_;
#line 2198 "smtp-outbox-folder.c"
			}
#line 99 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp16_) {
#line 2202 "smtp-outbox-folder.c"
				GearySmtpOutboxEmailIdentifier* _tmp22_ = NULL;
				GearySmtpOutboxEmailIdentifier* _tmp23_ = NULL;
#line 100 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp22_ = outbox_id;
#line 100 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp23_ = _g_object_ref0 (_tmp22_);
#line 100 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data72_->outbox_low);
#line 100 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data72_->outbox_low = _tmp23_;
#line 2213 "smtp-outbox-folder.c"
			}
#line 101 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_data72_->outbox_high == NULL) {
#line 101 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp24_ = TRUE;
#line 2219 "smtp-outbox-folder.c"
			} else {
				GearySmtpOutboxEmailIdentifier* _tmp25_ = NULL;
				gint64 _tmp26_ = 0LL;
				gint64 _tmp27_ = 0LL;
				gint64 _tmp28_ = 0LL;
				gint64 _tmp29_ = 0LL;
#line 101 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp25_ = outbox_id;
#line 101 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp26_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp25_);
#line 101 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp27_ = _tmp26_;
#line 101 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp28_ = geary_smtp_outbox_email_identifier_get_ordering (_data72_->outbox_high);
#line 101 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp29_ = _tmp28_;
#line 101 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp24_ = _tmp27_ > _tmp29_;
#line 2238 "smtp-outbox-folder.c"
			}
#line 101 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp24_) {
#line 2242 "smtp-outbox-folder.c"
				GearySmtpOutboxEmailIdentifier* _tmp30_ = NULL;
				GearySmtpOutboxEmailIdentifier* _tmp31_ = NULL;
#line 102 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp30_ = outbox_id;
#line 102 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp31_ = _g_object_ref0 (_tmp30_);
#line 102 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data72_->outbox_high);
#line 102 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data72_->outbox_high = _tmp31_;
#line 2253 "smtp-outbox-folder.c"
			}
#line 90 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_geary_smtp_outbox_folder_outbox_row_unref0 (row);
#line 90 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (outbox_id);
#line 90 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (id);
#line 2261 "smtp-outbox-folder.c"
		}
#line 90 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_id_it);
#line 2265 "smtp-outbox-folder.c"
	}
#line 105 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 105 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 2271 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome ___lambda96__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error) {
	GearyDbTransactionOutcome result;
	result = __lambda96_ (self, cx, error);
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 2280 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_find_boundaries_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	GearySmtpOutboxFolderFindBoundariesAsyncData* _data_;
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_find_boundaries_async_co (_data_);
#line 2294 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_real_find_boundaries_async_co (GearySmtpOutboxFolderFindBoundariesAsyncData* _data_) {
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 2303 "smtp-outbox-folder.c"
		goto _state_0;
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 2307 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 2312 "smtp-outbox-folder.c"
	}
	_state_0:
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data72_ = g_slice_new0 (Block72Data);
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data72_->_ref_count_ = 1;
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data72_->self = g_object_ref (_data_->self);
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = NULL;
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->ids;
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data72_->ids);
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data72_->ids = _data_->_tmp0_;
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = NULL;
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->cancellable;
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data72_->cancellable);
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data72_->cancellable = _data_->_tmp1_;
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data72_->_async_data_ = _data_;
#line 87 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data72_->outbox_low = NULL;
#line 88 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data72_->outbox_high = NULL;
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = NULL;
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = _data_->self->priv->db;
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = NULL;
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = _data_->_data72_->cancellable;
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_RO, ___lambda96__geary_db_transaction_method, _data_->_data72_, _data_->_tmp3_, geary_smtp_outbox_folder_find_boundaries_async_ready, _data_);
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 2357 "smtp-outbox-folder.c"
	_state_1:
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block72_data_unref (_data_->_data72_);
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data72_ = NULL;
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 2375 "smtp-outbox-folder.c"
		} else {
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 2379 "smtp-outbox-folder.c"
		}
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 89 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 2385 "smtp-outbox-folder.c"
	}
#line 108 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = NULL;
#line 108 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_data72_->outbox_low, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier));
#line 108 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->low);
#line 108 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->low = _data_->_tmp4_;
#line 109 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp5_ = NULL;
#line 109 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_data72_->outbox_high, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier));
#line 109 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->high);
#line 109 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->high = _data_->_tmp5_;
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block72_data_unref (_data_->_data72_);
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data72_ = NULL;
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 2411 "smtp-outbox-folder.c"
	} else {
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 2415 "smtp-outbox-folder.c"
	}
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 84 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 2421 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_add_to_containing_folders_async_data_free (gpointer _data) {
	GearySmtpOutboxFolderAddToContainingFoldersAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderAddToContainingFoldersAsyncData, _data_);
#line 2434 "smtp-outbox-folder.c"
}


void geary_smtp_outbox_folder_add_to_containing_folders_async (GearySmtpOutboxFolder* self, GeeCollection* ids, GeeHashMultiMap* map, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GearySmtpOutboxFolderAddToContainingFoldersAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
	GeeCollection* _tmp2_ = NULL;
	GeeHashMultiMap* _tmp3_ = NULL;
	GeeHashMultiMap* _tmp4_ = NULL;
	GCancellable* _tmp5_ = NULL;
	GCancellable* _tmp6_ = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderAddToContainingFoldersAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, geary_smtp_outbox_folder_add_to_containing_folders_async);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, geary_smtp_outbox_folder_add_to_containing_folders_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = ids;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->ids);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->ids = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = map;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->map);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->map = _tmp4_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = cancellable;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp6_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_add_to_containing_folders_async_co (_data_);
#line 2483 "smtp-outbox-folder.c"
}


void geary_smtp_outbox_folder_add_to_containing_folders_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error) {
	GearySmtpOutboxFolderAddToContainingFoldersAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 2493 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 2497 "smtp-outbox-folder.c"
}


static Block73Data* block73_data_ref (Block73Data* _data73_) {
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data73_->_ref_count_);
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data73_;
#line 2506 "smtp-outbox-folder.c"
}


static void block73_data_unref (void * _userdata_) {
	Block73Data* _data73_;
	_data73_ = (Block73Data*) _userdata_;
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data73_->_ref_count_)) {
#line 2515 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data73_->self;
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data73_->ids);
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data73_->map);
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block73Data, _data73_);
#line 2527 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome __lambda97_ (Block73Data* _data73_, GearyDbConnection* cx, GCancellable* cancellable, GError** error) {
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	GError * _inner_error_ = NULL;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data73_->self;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), 0);
#line 2542 "smtp-outbox-folder.c"
	{
		GeeIterator* _id_it = NULL;
		GeeCollection* _tmp0_ = NULL;
		GeeIterator* _tmp1_ = NULL;
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = _data73_->ids;
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_id_it = _tmp1_;
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (TRUE) {
#line 2555 "smtp-outbox-folder.c"
			GeeIterator* _tmp2_ = NULL;
			gboolean _tmp3_ = FALSE;
			GearyEmailIdentifier* id = NULL;
			GeeIterator* _tmp4_ = NULL;
			gpointer _tmp5_ = NULL;
			GearySmtpOutboxEmailIdentifier* outbox_id = NULL;
			GearyEmailIdentifier* _tmp6_ = NULL;
			GearySmtpOutboxEmailIdentifier* _tmp7_ = NULL;
			GearySmtpOutboxEmailIdentifier* _tmp8_ = NULL;
			GearySmtpOutboxFolderOutboxRow* row = NULL;
			GearyDbConnection* _tmp9_ = NULL;
			GearySmtpOutboxEmailIdentifier* _tmp10_ = NULL;
			gint64 _tmp11_ = 0LL;
			gint64 _tmp12_ = 0LL;
			GCancellable* _tmp13_ = NULL;
			GearySmtpOutboxFolderOutboxRow* _tmp14_ = NULL;
			GearySmtpOutboxFolderOutboxRow* _tmp15_ = NULL;
			GeeHashMultiMap* _tmp16_ = NULL;
			GearyEmailIdentifier* _tmp17_ = NULL;
			GearyFolderPath* _tmp18_ = NULL;
			GearyFolderPath* _tmp19_ = NULL;
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp2_ = _id_it;
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!_tmp3_) {
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				break;
#line 2585 "smtp-outbox-folder.c"
			}
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp4_ = _id_it;
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			id = (GearyEmailIdentifier*) _tmp5_;
#line 116 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp6_ = id;
#line 116 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER) ? ((GearySmtpOutboxEmailIdentifier*) _tmp6_) : NULL);
#line 116 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			outbox_id = _tmp7_;
#line 117 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp8_ = outbox_id;
#line 117 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp8_ == NULL) {
#line 118 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 118 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 118 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				continue;
#line 2609 "smtp-outbox-folder.c"
			}
#line 120 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp9_ = cx;
#line 120 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp10_ = outbox_id;
#line 120 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp11_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp10_);
#line 120 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp12_ = _tmp11_;
#line 120 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp13_ = cancellable;
#line 120 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp14_ = geary_smtp_outbox_folder_do_fetch_row_by_ordering (self, _tmp9_, _tmp12_, _tmp13_, &_inner_error_);
#line 120 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			row = _tmp14_;
#line 120 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 120 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 120 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 120 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 120 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_it);
#line 120 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 2637 "smtp-outbox-folder.c"
			}
#line 121 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp15_ = row;
#line 121 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp15_ == NULL) {
#line 122 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (row);
#line 122 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 122 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 122 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				continue;
#line 2651 "smtp-outbox-folder.c"
			}
#line 124 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp16_ = _data73_->map;
#line 124 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp17_ = id;
#line 124 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp18_ = geary_folder_get_path (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_FOLDER, GearyFolder));
#line 124 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp19_ = _tmp18_;
#line 124 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp17_, _tmp19_);
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_geary_smtp_outbox_folder_outbox_row_unref0 (row);
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (outbox_id);
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (id);
#line 2669 "smtp-outbox-folder.c"
		}
#line 115 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_id_it);
#line 2673 "smtp-outbox-folder.c"
	}
#line 127 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 127 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 2679 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome ___lambda97__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error) {
	GearyDbTransactionOutcome result;
	result = __lambda97_ (self, cx, cancellable, error);
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 2688 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_add_to_containing_folders_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	GearySmtpOutboxFolderAddToContainingFoldersAsyncData* _data_;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_add_to_containing_folders_async_co (_data_);
#line 2702 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_add_to_containing_folders_async_co (GearySmtpOutboxFolderAddToContainingFoldersAsyncData* _data_) {
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 2711 "smtp-outbox-folder.c"
		goto _state_0;
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 2715 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 2720 "smtp-outbox-folder.c"
	}
	_state_0:
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data73_ = g_slice_new0 (Block73Data);
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data73_->_ref_count_ = 1;
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data73_->self = g_object_ref (_data_->self);
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = NULL;
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->ids;
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data73_->ids);
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data73_->ids = _data_->_tmp0_;
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = NULL;
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->map;
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data73_->map);
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data73_->map = _data_->_tmp1_;
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data73_->_async_data_ = _data_;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = NULL;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = _data_->self->priv->db;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = NULL;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = _data_->cancellable;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_RO, ___lambda97__geary_db_transaction_method, _data_->_data73_, _data_->_tmp3_, geary_smtp_outbox_folder_add_to_containing_folders_async_ready, _data_);
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 2761 "smtp-outbox-folder.c"
	_state_1:
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block73_data_unref (_data_->_data73_);
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data73_ = NULL;
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 2779 "smtp-outbox-folder.c"
		} else {
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 2783 "smtp-outbox-folder.c"
		}
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 114 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 2789 "smtp-outbox-folder.c"
	}
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block73_data_unref (_data_->_data73_);
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data73_ = NULL;
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 2799 "smtp-outbox-folder.c"
	} else {
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 2803 "smtp-outbox-folder.c"
	}
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 112 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 2809 "smtp-outbox-folder.c"
}


static gchar* geary_smtp_outbox_folder_message_subject (GearyRFC822Message* message) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GearyRFC822Message* _tmp2_ = NULL;
	GearyRFC822Subject* _tmp3_ = NULL;
	GearyRFC822Subject* _tmp4_ = NULL;
#line 132 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MESSAGE (message), NULL);
#line 133 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = message;
#line 133 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = geary_rf_c822_message_get_subject (_tmp2_);
#line 133 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _tmp3_;
#line 133 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp4_ != NULL) {
#line 2830 "smtp-outbox-folder.c"
		GearyRFC822Message* _tmp5_ = NULL;
		GearyRFC822Subject* _tmp6_ = NULL;
		GearyRFC822Subject* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
#line 133 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp5_ = message;
#line 133 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp6_ = geary_rf_c822_message_get_subject (_tmp5_);
#line 133 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp7_ = _tmp6_;
#line 133 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp8_ = geary_message_data_abstract_message_data_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData));
#line 133 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp9_ = _tmp8_;
#line 133 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp10_ = geary_string_is_empty (_tmp9_);
#line 133 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp1_ = !_tmp10_;
#line 133 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (_tmp9_);
#line 2853 "smtp-outbox-folder.c"
	} else {
#line 133 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp1_ = FALSE;
#line 2857 "smtp-outbox-folder.c"
	}
#line 133 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp1_) {
#line 2861 "smtp-outbox-folder.c"
		GearyRFC822Message* _tmp11_ = NULL;
		GearyRFC822Subject* _tmp12_ = NULL;
		GearyRFC822Subject* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
#line 134 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp11_ = message;
#line 134 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp12_ = geary_rf_c822_message_get_subject (_tmp11_);
#line 134 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp13_ = _tmp12_;
#line 134 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp14_ = geary_message_data_abstract_message_data_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEARY_MESSAGE_DATA_TYPE_ABSTRACT_MESSAGE_DATA, GearyMessageDataAbstractMessageData));
#line 134 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (_tmp0_);
#line 134 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = _tmp14_;
#line 2878 "smtp-outbox-folder.c"
	} else {
		gchar* _tmp15_ = NULL;
#line 134 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp15_ = g_strdup ("(no subject)");
#line 134 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (_tmp0_);
#line 134 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = _tmp15_;
#line 2887 "smtp-outbox-folder.c"
	}
#line 133 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _tmp0_;
#line 133 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 2893 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_do_postman_async_data_free (gpointer _data) {
	GearySmtpOutboxFolderDoPostmanAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderDoPostmanAsyncData, _data_);
#line 2904 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_do_postman_async (GearySmtpOutboxFolder* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GearySmtpOutboxFolderDoPostmanAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_ = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderDoPostmanAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, geary_smtp_outbox_folder_do_postman_async);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, geary_smtp_outbox_folder_do_postman_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_do_postman_async_co (_data_);
#line 2923 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_do_postman_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_) {
	GearySmtpOutboxFolderDoPostmanAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 2931 "smtp-outbox-folder.c"
}


static Block74Data* block74_data_ref (Block74Data* _data74_) {
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data74_->_ref_count_);
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data74_;
#line 2940 "smtp-outbox-folder.c"
}


static void block74_data_unref (void * _userdata_) {
	Block74Data* _data74_;
	_data74_ = (Block74Data*) _userdata_;
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data74_->_ref_count_)) {
#line 2949 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data74_->self;
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data74_->list);
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block74Data, _data74_);
#line 2959 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome ___lambda92_ (Block74Data* _data74_, GearyDbConnection* cx, GCancellable* cancellable, GError** error) {
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	GearyDbStatement* stmt = NULL;
	GearyDbConnection* _tmp0_ = NULL;
	GearyDbStatement* _tmp1_ = NULL;
	GearyDbResult* results = NULL;
	GearyDbStatement* _tmp2_ = NULL;
	GCancellable* _tmp3_ = NULL;
	GearyDbResult* _tmp4_ = NULL;
	gint position = 0;
	GError * _inner_error_ = NULL;
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data74_->self;
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), 0);
#line 146 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = cx;
#line 146 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = geary_db_connection_prepare (_tmp0_, "\n" \
"                    SELECT id, ordering, message\n" \
"                    FROM SmtpOutboxTable\n" \
"                    WHERE sent = 0\n" \
"                    ORDER BY ordering\n" \
"                ", &_inner_error_);
#line 146 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp1_;
#line 146 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 146 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 146 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 2994 "smtp-outbox-folder.c"
	}
#line 153 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = stmt;
#line 153 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = cancellable;
#line 153 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = geary_db_statement_exec (_tmp2_, _tmp3_, &_inner_error_);
#line 153 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	results = _tmp4_;
#line 153 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 153 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 153 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 153 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 3012 "smtp-outbox-folder.c"
	}
#line 154 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	position = 1;
#line 155 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	while (TRUE) {
#line 3018 "smtp-outbox-folder.c"
		GearyDbResult* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gint64 _tmp8_ = 0LL;
		GearyDbResult* _tmp9_ = NULL;
		gint64 _tmp10_ = 0LL;
		gint64 _tmp11_ = 0LL;
		GearyDbResult* _tmp12_ = NULL;
		gint64 _tmp13_ = 0LL;
		GearyMemoryBuffer* _tmp14_ = NULL;
		GearyDbResult* _tmp15_ = NULL;
		GearyMemoryBuffer* _tmp16_ = NULL;
		GeeArrayList* _tmp17_ = NULL;
		gint _tmp18_ = 0;
		GearySmtpOutboxFolderRoot* _tmp19_ = NULL;
		GearySmtpOutboxFolderOutboxRow* _tmp20_ = NULL;
		GearySmtpOutboxFolderOutboxRow* _tmp21_ = NULL;
		GearyDbResult* _tmp22_ = NULL;
		GCancellable* _tmp23_ = NULL;
#line 155 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp5_ = results;
#line 155 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp6_ = geary_db_result_get_finished (_tmp5_);
#line 155 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp7_ = _tmp6_;
#line 155 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (!(!_tmp7_)) {
#line 155 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			break;
#line 3048 "smtp-outbox-folder.c"
		}
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp9_ = results;
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp10_ = geary_db_result_rowid_at (_tmp9_, 0, &_inner_error_);
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp8_ = _tmp10_;
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (results);
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 3066 "smtp-outbox-folder.c"
		}
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp12_ = results;
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp13_ = geary_db_result_int64_at (_tmp12_, 1, &_inner_error_);
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp11_ = _tmp13_;
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (results);
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 3084 "smtp-outbox-folder.c"
		}
#line 157 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp15_ = results;
#line 157 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp16_ = geary_db_result_string_buffer_at (_tmp15_, 2, &_inner_error_);
#line 157 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp14_ = _tmp16_;
#line 157 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 157 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 157 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (results);
#line 157 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 157 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 3102 "smtp-outbox-folder.c"
		}
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp17_ = _data74_->list;
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp18_ = position;
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		position = _tmp18_ + 1;
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp19_ = self->priv->_path;
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp20_ = geary_smtp_outbox_folder_outbox_row_new (_tmp8_, _tmp18_, _tmp11_, FALSE, _tmp14_, _tmp19_);
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp21_ = _tmp20_;
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp21_);
#line 156 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_geary_smtp_outbox_folder_outbox_row_unref0 (_tmp21_);
#line 158 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp22_ = results;
#line 158 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp23_ = cancellable;
#line 158 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_db_result_next (_tmp22_, _tmp23_, &_inner_error_);
#line 158 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 158 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 158 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_tmp14_);
#line 158 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (results);
#line 158 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 158 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 3138 "smtp-outbox-folder.c"
		}
#line 155 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp14_);
#line 3142 "smtp-outbox-folder.c"
	}
#line 161 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 161 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (results);
#line 161 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 161 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 3152 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome ____lambda92__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error) {
	GearyDbTransactionOutcome result;
	result = ___lambda92_ (self, cx, cancellable, error);
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 3161 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_do_postman_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	GearySmtpOutboxFolderDoPostmanAsyncData* _data_;
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_do_postman_async_co (_data_);
#line 3175 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_do_postman_async_co (GearySmtpOutboxFolderDoPostmanAsyncData* _data_) {
#line 138 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 138 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 3184 "smtp-outbox-folder.c"
		goto _state_0;
#line 138 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 3188 "smtp-outbox-folder.c"
		goto _state_1;
#line 138 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 2:
#line 3192 "smtp-outbox-folder.c"
		goto _state_2;
#line 138 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 3:
#line 3196 "smtp-outbox-folder.c"
		goto _state_3;
#line 138 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 4:
#line 3200 "smtp-outbox-folder.c"
		goto _state_4;
#line 138 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 5:
#line 3204 "smtp-outbox-folder.c"
		goto _state_5;
#line 138 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 6:
#line 3208 "smtp-outbox-folder.c"
		goto _state_6;
#line 138 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 7:
#line 3212 "smtp-outbox-folder.c"
		goto _state_7;
#line 138 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 8:
#line 3216 "smtp-outbox-folder.c"
		goto _state_8;
#line 138 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 9:
#line 3220 "smtp-outbox-folder.c"
		goto _state_9;
#line 138 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 10:
#line 3224 "smtp-outbox-folder.c"
		goto _state_10;
		default:
#line 138 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 3229 "smtp-outbox-folder.c"
	}
	_state_0:
#line 139 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_debug ("smtp-outbox-folder.vala:139: Starting outbox postman");
#line 140 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->send_retry_seconds = GEARY_SMTP_OUTBOX_FOLDER_MIN_SEND_RETRY_INTERVAL_SEC;
#line 3236 "smtp-outbox-folder.c"
	{
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data74_ = g_slice_new0 (Block74Data);
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data74_->_ref_count_ = 1;
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data74_->self = g_object_ref (_data_->self);
#line 144 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp0_ = NULL;
#line 144 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp0_ = gee_array_list_new (GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW, (GBoxedCopyFunc) geary_smtp_outbox_folder_outbox_row_ref, geary_smtp_outbox_folder_outbox_row_unref, NULL, NULL, NULL);
#line 144 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data74_->list = _data_->_tmp0_;
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp1_ = NULL;
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp1_ = _data_->self->priv->db;
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_state_ = 1;
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_RO, ____lambda92__geary_db_transaction_method, _data_->_data74_, NULL, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 3260 "smtp-outbox-folder.c"
		_state_1:
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			block74_data_unref (_data_->_data74_);
#line 145 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_data74_ = NULL;
#line 3270 "smtp-outbox-folder.c"
			goto __catch189_g_error;
		}
#line 164 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp2_ = NULL;
#line 164 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp2_ = _data_->_data74_->list;
#line 164 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp3_ = 0;
#line 164 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp3_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 164 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp4_ = 0;
#line 164 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 164 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_tmp4_ > 0) {
#line 166 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp5_ = NULL;
#line 166 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp5_ = _data_->self->priv->_properties;
#line 166 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp6_ = NULL;
#line 166 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp6_ = _data_->_data74_->list;
#line 166 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp7_ = 0;
#line 166 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp7_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, GEE_TYPE_COLLECTION, GeeCollection));
#line 166 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp8_ = 0;
#line 166 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp8_ = _data_->_tmp7_;
#line 166 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			geary_smtp_outbox_folder_properties_set_total (_data_->_tmp5_, _data_->_tmp8_);
#line 168 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp9_ = NULL;
#line 168 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp9_ = _data_->_data74_->list;
#line 168 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp10_ = 0;
#line 168 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp10_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp9_, GEE_TYPE_COLLECTION, GeeCollection));
#line 168 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp11_ = 0;
#line 168 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp11_ = _data_->_tmp10_;
#line 168 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_debug ("smtp-outbox-folder.vala:168: Priming outbox postman with %d stored mes" \
"sages", _data_->_tmp11_);
#line 3319 "smtp-outbox-folder.c"
			{
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp12_ = NULL;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp12_ = _data_->_data74_->list;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp13_ = NULL;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp13_ = _g_object_ref0 (_data_->_tmp12_);
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_row_list = _data_->_tmp13_;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp14_ = NULL;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp14_ = _data_->_row_list;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp15_ = 0;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp15_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp14_, GEE_TYPE_COLLECTION, GeeCollection));
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp16_ = 0;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp16_ = _data_->_tmp15_;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_row_size = _data_->_tmp16_;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_row_index = -1;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				while (TRUE) {
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp17_ = 0;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp17_ = _data_->_row_index;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_row_index = _data_->_tmp17_ + 1;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp18_ = 0;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp18_ = _data_->_row_index;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp19_ = 0;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp19_ = _data_->_row_size;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					if (!(_data_->_tmp18_ < _data_->_tmp19_)) {
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						break;
#line 3367 "smtp-outbox-folder.c"
					}
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp20_ = NULL;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp20_ = _data_->_row_list;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp21_ = 0;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp21_ = _data_->_row_index;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp22_ = NULL;
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp22_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp20_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _data_->_tmp21_);
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->row = (GearySmtpOutboxFolderOutboxRow*) _data_->_tmp22_;
#line 170 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp23_ = NULL;
#line 170 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp23_ = _data_->self->priv->outbox_queue;
#line 170 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp24_ = NULL;
#line 170 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp24_ = _data_->row;
#line 170 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					geary_nonblocking_mailbox_send (_data_->_tmp23_, _data_->_tmp24_);
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->row);
#line 3395 "smtp-outbox-folder.c"
				}
#line 169 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->_row_list);
#line 3399 "smtp-outbox-folder.c"
			}
		}
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block74_data_unref (_data_->_data74_);
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data74_ = NULL;
#line 3406 "smtp-outbox-folder.c"
	}
	goto __finally189;
	__catch189_g_error:
	{
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->prime_err = _data_->_inner_error_;
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = NULL;
#line 173 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp25_ = NULL;
#line 173 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp25_ = _data_->prime_err;
#line 173 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp26_ = NULL;
#line 173 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp26_ = _data_->_tmp25_->message;
#line 173 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_warning ("smtp-outbox-folder.vala:173: Error priming outbox: %s", _data_->_tmp26_);
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_error_free0 (_data_->prime_err);
#line 3427 "smtp-outbox-folder.c"
	}
	__finally189:
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_clear_error (&_data_->_inner_error_);
#line 143 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 3438 "smtp-outbox-folder.c"
	}
	{
#line 177 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp27_ = TRUE;
#line 177 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (TRUE) {
#line 177 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!_data_->_tmp27_) {
#line 3447 "smtp-outbox-folder.c"
			}
#line 177 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp27_ = FALSE;
#line 3451 "smtp-outbox-folder.c"
			{
#line 181 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp29_ = NULL;
#line 181 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp29_ = _data_->self->priv->outbox_queue;
#line 181 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_state_ = 2;
#line 181 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				geary_nonblocking_mailbox_recv_async (_data_->_tmp29_, NULL, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 181 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return FALSE;
#line 3463 "smtp-outbox-folder.c"
				_state_2:
#line 181 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp30_ = NULL;
#line 181 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp30_ = geary_nonblocking_mailbox_recv_finish (_data_->_tmp29_, _data_->_res_, &_data_->_inner_error_);
#line 181 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp28_ = (GearySmtpOutboxFolderOutboxRow*) _data_->_tmp30_;
#line 181 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 3473 "smtp-outbox-folder.c"
					goto __catch190_g_error;
				}
#line 181 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp31_ = NULL;
#line 181 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp31_ = _data_->_tmp28_;
#line 181 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp28_ = NULL;
#line 181 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_vala1_row);
#line 181 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_vala1_row = _data_->_tmp31_;
#line 184 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp33_ = NULL;
#line 184 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp33_ = _data_->_vala1_row;
#line 184 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp34_ = 0LL;
#line 184 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp34_ = _data_->_tmp33_->ordering;
#line 184 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_state_ = 3;
#line 184 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				geary_smtp_outbox_folder_is_unsent_async (_data_->self, _data_->_tmp34_, NULL, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 184 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return FALSE;
#line 3500 "smtp-outbox-folder.c"
				_state_3:
#line 184 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp35_ = FALSE;
#line 184 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp35_ = geary_smtp_outbox_folder_is_unsent_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 184 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp32_ = _data_->_tmp35_;
#line 184 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 184 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_tmp28_);
#line 3512 "smtp-outbox-folder.c"
					goto __catch190_g_error;
				}
#line 184 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (!_data_->_tmp32_) {
#line 185 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp36_ = NULL;
#line 185 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp36_ = _data_->_vala1_row;
#line 185 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp37_ = NULL;
#line 185 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp37_ = _data_->_tmp36_->outbox_id;
#line 185 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp38_ = NULL;
#line 185 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp38_ = geary_email_identifier_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp37_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier));
#line 185 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp39_ = NULL;
#line 185 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp39_ = _data_->_tmp38_;
#line 185 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_debug ("smtp-outbox-folder.vala:185: Dropping sent outbox message %s", _data_->_tmp39_);
#line 185 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_free0 (_data_->_tmp39_);
#line 186 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_tmp28_);
#line 186 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_vala1_row);
#line 186 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					continue;
#line 3543 "smtp-outbox-folder.c"
				}
#line 180 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_tmp28_);
#line 3547 "smtp-outbox-folder.c"
			}
			goto __finally190;
			__catch190_g_error:
			{
#line 180 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->wait_err = _data_->_inner_error_;
#line 180 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_inner_error_ = NULL;
#line 189 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp40_ = NULL;
#line 189 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp40_ = _data_->wait_err->message;
#line 189 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_debug ("smtp-outbox-folder.vala:189: Outbox postman queue error: %s", _data_->_tmp40_);
#line 191 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_error_free0 (_data_->wait_err);
#line 191 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_vala1_row);
#line 191 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				break;
#line 3568 "smtp-outbox-folder.c"
			}
			__finally190:
#line 180 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 180 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_vala1_row);
#line 180 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 180 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_clear_error (&_data_->_inner_error_);
#line 180 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return FALSE;
#line 3581 "smtp-outbox-folder.c"
			}
#line 197 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp42_ = NULL;
#line 197 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp42_ = _data_->self->priv->_account;
#line 197 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp43_ = NULL;
#line 197 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp43_ = geary_account_get_information (_data_->_tmp42_);
#line 197 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp44_ = NULL;
#line 197 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp44_ = _data_->_tmp43_;
#line 197 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp45_ = NULL;
#line 197 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp45_ = geary_account_information_get_smtp_credentials (_data_->_tmp44_);
#line 197 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp46_ = NULL;
#line 197 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp46_ = _data_->_tmp45_;
#line 197 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_data_->_tmp46_ != NULL) {
#line 198 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp47_ = NULL;
#line 198 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp47_ = _data_->self->priv->_account;
#line 198 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp48_ = NULL;
#line 198 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp48_ = geary_account_get_information (_data_->_tmp47_);
#line 198 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp49_ = NULL;
#line 198 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp49_ = _data_->_tmp48_;
#line 198 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp50_ = NULL;
#line 198 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp50_ = geary_account_information_get_smtp_credentials (_data_->_tmp49_);
#line 198 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp51_ = NULL;
#line 198 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp51_ = _data_->_tmp50_;
#line 198 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp52_ = FALSE;
#line 198 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp52_ = geary_credentials_is_complete (_data_->_tmp51_);
#line 198 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp41_ = !_data_->_tmp52_;
#line 3631 "smtp-outbox-folder.c"
			} else {
#line 197 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp41_ = FALSE;
#line 3635 "smtp-outbox-folder.c"
			}
#line 197 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_data_->_tmp41_) {
#line 3639 "smtp-outbox-folder.c"
				{
#line 200 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp53_ = NULL;
#line 200 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp53_ = _data_->self->priv->_account;
#line 200 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp54_ = NULL;
#line 200 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp54_ = geary_account_get_information (_data_->_tmp53_);
#line 200 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp55_ = NULL;
#line 200 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp55_ = _data_->_tmp54_;
#line 200 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_state_ = 4;
#line 200 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					geary_account_information_get_passwords_async (_data_->_tmp55_, GEARY_SERVICE_FLAG_SMTP, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 200 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					return FALSE;
#line 3659 "smtp-outbox-folder.c"
					_state_4:
#line 200 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					geary_account_information_get_passwords_finish (_data_->_tmp55_, _data_->_res_, &_data_->_inner_error_);
#line 200 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 3665 "smtp-outbox-folder.c"
						goto __catch191_g_error;
					}
				}
				goto __finally191;
				__catch191_g_error:
				{
#line 199 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->e = _data_->_inner_error_;
#line 199 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_inner_error_ = NULL;
#line 202 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp56_ = NULL;
#line 202 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp56_ = _data_->e;
#line 202 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp57_ = NULL;
#line 202 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp57_ = _data_->_tmp56_->message;
#line 202 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_debug ("smtp-outbox-folder.vala:202: SMTP password fetch error: %s", _data_->_tmp57_);
#line 199 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_error_free0 (_data_->e);
#line 3688 "smtp-outbox-folder.c"
				}
				__finally191:
#line 199 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 199 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_vala1_row);
#line 199 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 199 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_clear_error (&_data_->_inner_error_);
#line 199 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					return FALSE;
#line 3701 "smtp-outbox-folder.c"
				}
			}
			{
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp59_ = NULL;
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp59_ = _data_->_vala1_row;
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp60_ = NULL;
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp60_ = _data_->_tmp59_->message;
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp61_ = NULL;
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp61_ = geary_rf_c822_message_new_from_buffer (_data_->_tmp60_, &_data_->_inner_error_);
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp58_ = _data_->_tmp61_;
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					if (_data_->_inner_error_->domain == GEARY_RF_C822_ERROR) {
#line 3723 "smtp-outbox-folder.c"
						goto __catch192_geary_rf_c822_error;
					}
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (_data_->message);
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_vala1_row);
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_clear_error (&_data_->_inner_error_);
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					return FALSE;
#line 3736 "smtp-outbox-folder.c"
				}
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp62_ = NULL;
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp62_ = _data_->_tmp58_;
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp58_ = NULL;
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->message);
#line 209 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->message = _data_->_tmp62_;
#line 208 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->_tmp58_);
#line 3750 "smtp-outbox-folder.c"
			}
			goto __finally192;
			__catch192_geary_rf_c822_error:
			{
#line 208 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->msg_err = _data_->_inner_error_;
#line 208 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_inner_error_ = NULL;
#line 212 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp63_ = NULL;
#line 212 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp63_ = _data_->msg_err;
#line 212 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp64_ = NULL;
#line 212 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp64_ = _data_->_tmp63_->message;
#line 212 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_debug ("smtp-outbox-folder.vala:212: Outbox postman message error: %s", _data_->_tmp64_);
#line 214 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_error_free0 (_data_->msg_err);
#line 214 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->message);
#line 214 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_vala1_row);
#line 214 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				continue;
#line 3777 "smtp-outbox-folder.c"
			}
			__finally192:
#line 208 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 208 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->message);
#line 208 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_vala1_row);
#line 208 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 208 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_clear_error (&_data_->_inner_error_);
#line 208 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return FALSE;
#line 3792 "smtp-outbox-folder.c"
			}
#line 218 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->should_nap = FALSE;
#line 219 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->mail_sent = FALSE;
#line 3798 "smtp-outbox-folder.c"
			{
#line 223 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp65_ = NULL;
#line 223 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp65_ = _data_->self->priv->_account;
#line 223 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp66_ = NULL;
#line 223 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp66_ = geary_account_get_information (_data_->_tmp65_);
#line 223 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp67_ = NULL;
#line 223 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp67_ = _data_->_tmp66_;
#line 223 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp68_ = NULL;
#line 223 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp68_ = geary_account_information_get_smtp_endpoint (_data_->_tmp67_);
#line 223 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp69_ = NULL;
#line 223 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp69_ = _data_->_tmp68_;
#line 223 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp70_ = FALSE;
#line 223 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp70_ = geary_endpoint_get_is_trusted_or_never_connected (_data_->_tmp69_);
#line 223 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp71_ = FALSE;
#line 223 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp71_ = _data_->_tmp70_;
#line 223 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp72_ = FALSE;
#line 223 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp72_ = _data_->_tmp71_;
#line 223 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->_tmp69_);
#line 223 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (_data_->_tmp72_) {
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp73_ = NULL;
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp73_ = _data_->message;
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp74_ = NULL;
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp74_ = geary_smtp_outbox_folder_message_subject (_data_->_tmp73_);
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp75_ = NULL;
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp75_ = _data_->_tmp74_;
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp76_ = NULL;
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp76_ = _data_->_vala1_row;
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp77_ = NULL;
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp77_ = _data_->_tmp76_->outbox_id;
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp78_ = NULL;
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp78_ = geary_email_identifier_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp77_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier));
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp79_ = NULL;
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp79_ = _data_->_tmp78_;
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_debug ("smtp-outbox-folder.vala:224: Outbox postman: Sending \"%s\" (ID:%s)...", _data_->_tmp75_, _data_->_tmp79_);
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_free0 (_data_->_tmp79_);
#line 224 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_free0 (_data_->_tmp75_);
#line 226 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp80_ = NULL;
#line 226 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp80_ = _data_->message;
#line 226 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_state_ = 5;
#line 226 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					geary_smtp_outbox_folder_send_email_async (_data_->self, _data_->_tmp80_, NULL, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 226 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					return FALSE;
#line 3880 "smtp-outbox-folder.c"
					_state_5:
#line 226 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					geary_smtp_outbox_folder_send_email_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 226 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 3886 "smtp-outbox-folder.c"
						goto __catch193_g_error;
					}
#line 227 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->mail_sent = TRUE;
#line 3891 "smtp-outbox-folder.c"
				} else {
#line 231 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp81_ = NULL;
#line 231 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp81_ = _data_->self->priv->outbox_queue;
#line 231 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp82_ = NULL;
#line 231 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp82_ = _data_->_vala1_row;
#line 231 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					geary_nonblocking_mailbox_send (_data_->_tmp81_, _data_->_tmp82_);
#line 232 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->should_nap = TRUE;
#line 3905 "smtp-outbox-folder.c"
				}
			}
			goto __finally193;
			__catch193_g_error:
			{
#line 220 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->send_err = _data_->_inner_error_;
#line 220 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_inner_error_ = NULL;
#line 235 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp83_ = NULL;
#line 235 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp83_ = _data_->send_err;
#line 235 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp84_ = NULL;
#line 235 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp84_ = _data_->_tmp83_->message;
#line 235 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_debug ("smtp-outbox-folder.vala:235: Outbox postman send error, retrying: %s", _data_->_tmp84_);
#line 237 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->should_nap = TRUE;
#line 239 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp85_ = NULL;
#line 239 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp85_ = _data_->send_err;
#line 239 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (g_error_matches (_data_->_tmp85_, GEARY_SMTP_ERROR, GEARY_SMTP_ERROR_AUTHENTICATION_FAILED)) {
#line 240 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->report = TRUE;
#line 243 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->should_nap = FALSE;
#line 3937 "smtp-outbox-folder.c"
					{
#line 248 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp87_ = NULL;
#line 248 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp87_ = _data_->self->priv->_account;
#line 248 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp88_ = NULL;
#line 248 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp88_ = geary_account_get_information (_data_->_tmp87_);
#line 248 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp89_ = NULL;
#line 248 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp89_ = _data_->_tmp88_;
#line 248 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_state_ = 6;
#line 248 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						geary_account_information_fetch_passwords_async (_data_->_tmp89_, GEARY_SERVICE_FLAG_SMTP, TRUE, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 248 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						return FALSE;
#line 3957 "smtp-outbox-folder.c"
						_state_6:
#line 248 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp90_ = FALSE;
#line 248 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp90_ = geary_account_information_fetch_passwords_finish (_data_->_tmp89_, _data_->_res_, &_data_->_inner_error_);
#line 248 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp86_ = _data_->_tmp90_;
#line 248 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 3967 "smtp-outbox-folder.c"
							goto __catch194_g_error;
						}
#line 248 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						if (_data_->_tmp86_) {
#line 249 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
							_data_->report = FALSE;
#line 3974 "smtp-outbox-folder.c"
						}
					}
					goto __finally194;
					__catch194_g_error:
					{
#line 247 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_vala1_e = _data_->_inner_error_;
#line 247 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_inner_error_ = NULL;
#line 251 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp91_ = NULL;
#line 251 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp91_ = _data_->_vala1_e;
#line 251 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp92_ = NULL;
#line 251 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp92_ = _data_->_tmp91_->message;
#line 251 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						g_debug ("smtp-outbox-folder.vala:251: Error prompting for SMTP password: %s", _data_->_tmp92_);
#line 247 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_g_error_free0 (_data_->_vala1_e);
#line 3996 "smtp-outbox-folder.c"
					}
					__finally194:
#line 247 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 247 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_g_error_free0 (_data_->send_err);
#line 247 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_g_error_free0 (_data_->send_err);
#line 247 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_g_object_unref0 (_data_->message);
#line 247 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_vala1_row);
#line 247 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 247 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						g_clear_error (&_data_->_inner_error_);
#line 247 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						return FALSE;
#line 4015 "smtp-outbox-folder.c"
					}
#line 254 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp93_ = FALSE;
#line 254 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp93_ = _data_->report;
#line 254 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					if (_data_->_tmp93_) {
#line 255 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp94_ = NULL;
#line 255 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp94_ = _data_->send_err;
#line 255 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						g_signal_emit_by_name (_data_->self, "report-problem", GEARY_ACCOUNT_PROBLEM_SEND_EMAIL_LOGIN_FAILED, _data_->_tmp94_);
#line 4029 "smtp-outbox-folder.c"
					}
				} else {
#line 256 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp95_ = NULL;
#line 256 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp95_ = _data_->send_err;
#line 256 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					if (_data_->_tmp95_->domain == G_TLS_ERROR) {
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp96_ = NULL;
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp96_ = _data_->self->priv->_account;
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp97_ = NULL;
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp97_ = geary_account_get_information (_data_->_tmp96_);
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp98_ = NULL;
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp98_ = _data_->_tmp97_;
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp99_ = NULL;
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp99_ = geary_account_information_get_smtp_endpoint (_data_->_tmp98_);
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp100_ = NULL;
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp100_ = _data_->_tmp99_;
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp101_ = NULL;
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp101_ = geary_endpoint_to_string (_data_->_tmp100_);
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp102_ = NULL;
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp102_ = _data_->_tmp101_;
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						g_debug ("smtp-outbox-folder.vala:259: TLS connection warnings connecting to %s," \
" user must confirm connection to continue", _data_->_tmp102_);
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_g_free0 (_data_->_tmp102_);
#line 259 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_g_object_unref0 (_data_->_tmp100_);
#line 4072 "smtp-outbox-folder.c"
					} else {
#line 262 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp103_ = NULL;
#line 262 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_data_->_tmp103_ = _data_->send_err;
#line 262 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						g_signal_emit_by_name (_data_->self, "report-problem", GEARY_ACCOUNT_PROBLEM_EMAIL_DELIVERY_FAILURE, _data_->_tmp103_);
#line 4080 "smtp-outbox-folder.c"
					}
				}
#line 220 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_error_free0 (_data_->send_err);
#line 4085 "smtp-outbox-folder.c"
			}
			__finally193:
#line 220 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 220 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->message);
#line 220 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_vala1_row);
#line 220 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 220 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_clear_error (&_data_->_inner_error_);
#line 220 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return FALSE;
#line 4100 "smtp-outbox-folder.c"
			}
#line 266 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp104_ = FALSE;
#line 266 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp104_ = _data_->should_nap;
#line 266 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_data_->_tmp104_) {
#line 267 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp105_ = 0U;
#line 267 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp105_ = _data_->send_retry_seconds;
#line 267 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_debug ("smtp-outbox-folder.vala:267: Outbox napping for %u seconds...", _data_->_tmp105_);
#line 270 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp106_ = 0U;
#line 270 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp106_ = _data_->send_retry_seconds;
#line 270 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_state_ = 7;
#line 270 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				geary_scheduler_sleep_async (_data_->_tmp106_, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 270 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return FALSE;
#line 4124 "smtp-outbox-folder.c"
				_state_7:
#line 270 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				geary_scheduler_sleep_finish (_data_->_res_);
#line 271 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp107_ = 0U;
#line 271 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp107_ = _data_->send_retry_seconds;
#line 271 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp108_ = 0U;
#line 271 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp108_ = geary_numeric_uint_ceiling (_data_->_tmp107_ * 2, GEARY_SMTP_OUTBOX_FOLDER_MAX_SEND_RETRY_INTERVAL_SEC);
#line 271 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->send_retry_seconds = _data_->_tmp108_;
#line 4138 "smtp-outbox-folder.c"
			}
#line 274 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp109_ = FALSE;
#line 274 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp109_ = _data_->mail_sent;
#line 274 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!_data_->_tmp109_) {
#line 276 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp110_ = NULL;
#line 276 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp110_ = _data_->self->priv->outbox_queue;
#line 276 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp111_ = NULL;
#line 276 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp111_ = _data_->_vala1_row;
#line 276 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				geary_nonblocking_mailbox_send (_data_->_tmp110_, _data_->_tmp111_);
#line 278 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->message);
#line 278 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_vala1_row);
#line 278 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				continue;
#line 4162 "smtp-outbox-folder.c"
			}
#line 282 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->send_retry_seconds = GEARY_SMTP_OUTBOX_FOLDER_MIN_SEND_RETRY_INTERVAL_SEC;
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp113_ = NULL;
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp113_ = _data_->self->priv->_account;
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp114_ = NULL;
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp114_ = geary_account_get_information (_data_->_tmp113_);
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp115_ = NULL;
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp115_ = _data_->_tmp114_;
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp116_ = FALSE;
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp116_ = geary_account_information_allow_save_sent_mail (_data_->_tmp115_);
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_data_->_tmp116_) {
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp117_ = NULL;
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp117_ = _data_->self->priv->_account;
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp118_ = NULL;
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp118_ = geary_account_get_information (_data_->_tmp117_);
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp119_ = NULL;
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp119_ = _data_->_tmp118_;
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp120_ = FALSE;
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp120_ = geary_account_information_get_save_sent_mail (_data_->_tmp119_);
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp121_ = FALSE;
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp121_ = _data_->_tmp120_;
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp112_ = _data_->_tmp121_;
#line 4206 "smtp-outbox-folder.c"
			} else {
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp112_ = FALSE;
#line 4210 "smtp-outbox-folder.c"
			}
#line 284 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_data_->_tmp112_) {
#line 4214 "smtp-outbox-folder.c"
				{
#line 288 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp122_ = NULL;
#line 288 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp122_ = _data_->_vala1_row;
#line 288 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp123_ = NULL;
#line 288 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp123_ = _data_->_tmp122_->outbox_id;
#line 288 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp124_ = NULL;
#line 288 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp124_ = geary_email_identifier_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp123_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier));
#line 288 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp125_ = NULL;
#line 288 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp125_ = _data_->_tmp124_;
#line 288 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_debug ("smtp-outbox-folder.vala:288: Outbox postman: Marking %s as sent", _data_->_tmp125_);
#line 288 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_free0 (_data_->_tmp125_);
#line 289 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp126_ = NULL;
#line 289 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp126_ = _data_->_vala1_row;
#line 289 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp127_ = NULL;
#line 289 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp127_ = _data_->_tmp126_->outbox_id;
#line 289 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_state_ = 8;
#line 289 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					geary_smtp_outbox_folder_mark_email_as_sent_async (_data_->self, _data_->_tmp127_, NULL, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 289 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					return FALSE;
#line 4250 "smtp-outbox-folder.c"
					_state_8:
#line 289 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					geary_smtp_outbox_folder_mark_email_as_sent_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 289 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 4256 "smtp-outbox-folder.c"
						goto __catch195_g_error;
					}
				}
				goto __finally195;
				__catch195_g_error:
				{
#line 287 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_vala2_e = _data_->_inner_error_;
#line 287 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_inner_error_ = NULL;
#line 291 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp128_ = NULL;
#line 291 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp128_ = _data_->_vala2_e;
#line 291 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp129_ = NULL;
#line 291 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp129_ = _data_->_tmp128_->message;
#line 291 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_debug ("smtp-outbox-folder.vala:291: Outbox postman: Unable to mark row as sen" \
"t: %s", _data_->_tmp129_);
#line 287 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_error_free0 (_data_->_vala2_e);
#line 4279 "smtp-outbox-folder.c"
				}
				__finally195:
#line 287 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 287 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (_data_->message);
#line 287 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_vala1_row);
#line 287 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 287 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_clear_error (&_data_->_inner_error_);
#line 287 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					return FALSE;
#line 4294 "smtp-outbox-folder.c"
				}
				{
#line 295 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp130_ = NULL;
#line 295 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp130_ = _data_->_vala1_row;
#line 295 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp131_ = NULL;
#line 295 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp131_ = _data_->_tmp130_->outbox_id;
#line 295 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp132_ = NULL;
#line 295 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp132_ = geary_email_identifier_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp131_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier));
#line 295 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp133_ = NULL;
#line 295 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp133_ = _data_->_tmp132_;
#line 295 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_debug ("smtp-outbox-folder.vala:295: Outbox postman: Saving %s to sent mail", _data_->_tmp133_);
#line 295 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_free0 (_data_->_tmp133_);
#line 296 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp134_ = NULL;
#line 296 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp134_ = _data_->message;
#line 296 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_state_ = 9;
#line 296 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					geary_smtp_outbox_folder_save_sent_mail_async (_data_->self, _data_->_tmp134_, NULL, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 296 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					return FALSE;
#line 4327 "smtp-outbox-folder.c"
					_state_9:
#line 296 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					geary_smtp_outbox_folder_save_sent_mail_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 296 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 4333 "smtp-outbox-folder.c"
						goto __catch196_g_error;
					}
				}
				goto __finally196;
				__catch196_g_error:
				{
#line 294 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_vala3_e = _data_->_inner_error_;
#line 294 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_inner_error_ = NULL;
#line 298 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp135_ = NULL;
#line 298 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp135_ = _data_->_vala3_e;
#line 298 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp136_ = NULL;
#line 298 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp136_ = _data_->_tmp135_->message;
#line 298 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_debug ("smtp-outbox-folder.vala:298: Outbox postman: Error saving sent mail: %" \
"s", _data_->_tmp136_);
#line 299 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp137_ = NULL;
#line 299 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_data_->_tmp137_ = _data_->_vala3_e;
#line 299 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_signal_emit_by_name (_data_->self, "report-problem", GEARY_ACCOUNT_PROBLEM_SAVE_SENT_MAIL_FAILED, _data_->_tmp137_);
#line 301 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_error_free0 (_data_->_vala3_e);
#line 301 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (_data_->message);
#line 301 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_vala1_row);
#line 301 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					continue;
#line 4368 "smtp-outbox-folder.c"
				}
				__finally196:
#line 294 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 294 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (_data_->message);
#line 294 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_vala1_row);
#line 294 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 294 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_clear_error (&_data_->_inner_error_);
#line 294 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					return FALSE;
#line 4383 "smtp-outbox-folder.c"
				}
			}
			{
#line 308 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp138_ = NULL;
#line 308 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp138_ = _data_->_vala1_row;
#line 308 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp139_ = NULL;
#line 308 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp139_ = _data_->_tmp138_->outbox_id;
#line 308 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp140_ = NULL;
#line 308 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp140_ = geary_email_identifier_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp139_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier));
#line 308 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp141_ = NULL;
#line 308 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp141_ = _data_->_tmp140_;
#line 308 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_debug ("smtp-outbox-folder.vala:308: Outbox postman: Deleting row %s", _data_->_tmp141_);
#line 308 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_free0 (_data_->_tmp141_);
#line 309 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp142_ = NULL;
#line 309 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp142_ = gee_array_list_new (GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 309 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->list = _data_->_tmp142_;
#line 310 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp143_ = NULL;
#line 310 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp143_ = _data_->list;
#line 310 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp144_ = NULL;
#line 310 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp144_ = _data_->_vala1_row;
#line 310 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp145_ = NULL;
#line 310 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp145_ = _data_->_tmp144_->outbox_id;
#line 310 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp143_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _data_->_tmp145_);
#line 311 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp146_ = NULL;
#line 311 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp146_ = _data_->list;
#line 311 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_state_ = 10;
#line 311 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				geary_smtp_outbox_folder_internal_remove_email_async (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp146_, GEE_TYPE_LIST, GeeList), NULL, geary_smtp_outbox_folder_do_postman_async_ready, _data_);
#line 311 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return FALSE;
#line 4437 "smtp-outbox-folder.c"
				_state_10:
#line 311 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				geary_smtp_outbox_folder_internal_remove_email_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 311 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 311 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (_data_->list);
#line 4445 "smtp-outbox-folder.c"
					goto __catch197_g_error;
				}
#line 307 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->list);
#line 4450 "smtp-outbox-folder.c"
			}
			goto __finally197;
			__catch197_g_error:
			{
#line 307 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_vala4_e = _data_->_inner_error_;
#line 307 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_inner_error_ = NULL;
#line 313 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp147_ = NULL;
#line 313 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp147_ = _data_->_vala4_e;
#line 313 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp148_ = NULL;
#line 313 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp148_ = _data_->_tmp147_->message;
#line 313 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_debug ("smtp-outbox-folder.vala:313: Outbox postman: Unable to delete row: %s", _data_->_tmp148_);
#line 307 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_error_free0 (_data_->_vala4_e);
#line 4471 "smtp-outbox-folder.c"
			}
			__finally197:
#line 307 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 307 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->message);
#line 307 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_vala1_row);
#line 307 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 307 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_clear_error (&_data_->_inner_error_);
#line 307 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return FALSE;
#line 4486 "smtp-outbox-folder.c"
			}
#line 177 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_data_->message);
#line 177 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_geary_smtp_outbox_folder_outbox_row_unref0 (_data_->_vala1_row);
#line 4492 "smtp-outbox-folder.c"
		}
	}
#line 317 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_debug ("smtp-outbox-folder.vala:317: Exiting outbox postman");
#line 138 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 138 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 4501 "smtp-outbox-folder.c"
	} else {
#line 138 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 4505 "smtp-outbox-folder.c"
	}
#line 138 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 138 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 4511 "smtp-outbox-folder.c"
}


static GearyFolderOpenState geary_smtp_outbox_folder_real_get_open_state (GearyFolder* base) {
	GearySmtpOutboxFolder * self;
	GearyFolderOpenState result = 0;
	GearyFolderOpenState _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
#line 320 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 321 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = geary_abstract_local_folder_is_open (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolder));
#line 321 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp1_) {
#line 321 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = GEARY_FOLDER_OPEN_STATE_LOCAL;
#line 4528 "smtp-outbox-folder.c"
	} else {
#line 321 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = GEARY_FOLDER_OPEN_STATE_CLOSED;
#line 4532 "smtp-outbox-folder.c"
	}
#line 321 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _tmp0_;
#line 321 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 4538 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_get_email_count_async_data_free (gpointer _data) {
	GearySmtpOutboxFolderGetEmailCountAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderGetEmailCountAsyncData, _data_);
#line 4549 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_get_email_count_async (GearySmtpOutboxFolder* self, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GearySmtpOutboxFolderGetEmailCountAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_ = NULL;
	GCancellable* _tmp1_ = NULL;
	GCancellable* _tmp2_ = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderGetEmailCountAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, geary_smtp_outbox_folder_get_email_count_async);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, geary_smtp_outbox_folder_get_email_count_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = cancellable;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_get_email_count_async_co (_data_);
#line 4578 "smtp-outbox-folder.c"
}


static gint geary_smtp_outbox_folder_get_email_count_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error) {
	gint result;
	GearySmtpOutboxFolderGetEmailCountAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 4589 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _data_->result;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 4597 "smtp-outbox-folder.c"
}


static Block75Data* block75_data_ref (Block75Data* _data75_) {
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data75_->_ref_count_);
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data75_;
#line 4606 "smtp-outbox-folder.c"
}


static void block75_data_unref (void * _userdata_) {
	Block75Data* _data75_;
	_data75_ = (Block75Data*) _userdata_;
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data75_->_ref_count_)) {
#line 4615 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data75_->self;
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data75_->cancellable);
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block75Data, _data75_);
#line 4625 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome __lambda98_ (Block75Data* _data75_, GearyDbConnection* cx, GError** error) {
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	gint _tmp0_ = 0;
	GearyDbConnection* _tmp1_ = NULL;
	GCancellable* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	GError * _inner_error_ = NULL;
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data75_->self;
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 327 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = cx;
#line 327 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _data75_->cancellable;
#line 327 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = geary_smtp_outbox_folder_do_get_email_count (self, _tmp1_, _tmp2_, &_inner_error_);
#line 327 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _tmp3_;
#line 327 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 327 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 327 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 4656 "smtp-outbox-folder.c"
	}
#line 327 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data75_->count = _tmp0_;
#line 329 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 329 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 4664 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome ___lambda98__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error) {
	GearyDbTransactionOutcome result;
	result = __lambda98_ (self, cx, error);
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 4673 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_get_email_count_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	GearySmtpOutboxFolderGetEmailCountAsyncData* _data_;
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_get_email_count_async_co (_data_);
#line 4687 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_get_email_count_async_co (GearySmtpOutboxFolderGetEmailCountAsyncData* _data_) {
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 4696 "smtp-outbox-folder.c"
		goto _state_0;
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 4700 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 4705 "smtp-outbox-folder.c"
	}
	_state_0:
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data75_ = g_slice_new0 (Block75Data);
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data75_->_ref_count_ = 1;
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data75_->self = g_object_ref (_data_->self);
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = NULL;
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->cancellable;
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data75_->cancellable);
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data75_->cancellable = _data_->_tmp0_;
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data75_->_async_data_ = _data_;
#line 325 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data75_->count = 0;
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = NULL;
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->self->priv->db;
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = NULL;
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = _data_->_data75_->cancellable;
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_RO, ___lambda98__geary_db_transaction_method, _data_->_data75_, _data_->_tmp2_, geary_smtp_outbox_folder_get_email_count_async_ready, _data_);
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 4740 "smtp-outbox-folder.c"
	_state_1:
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block75_data_unref (_data_->_data75_);
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data75_ = NULL;
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 4758 "smtp-outbox-folder.c"
		} else {
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 4762 "smtp-outbox-folder.c"
		}
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 326 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 4768 "smtp-outbox-folder.c"
	}
#line 332 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = _data_->_data75_->count;
#line 332 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block75_data_unref (_data_->_data75_);
#line 332 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data75_ = NULL;
#line 332 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 332 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 4780 "smtp-outbox-folder.c"
	} else {
#line 332 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 4784 "smtp-outbox-folder.c"
	}
#line 332 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 332 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block75_data_unref (_data_->_data75_);
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data75_ = NULL;
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 4798 "smtp-outbox-folder.c"
	} else {
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 4802 "smtp-outbox-folder.c"
	}
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 324 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 4808 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_enqueue_email_async_data_free (gpointer _data) {
	GearySmtpOutboxFolderEnqueueEmailAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->result);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderEnqueueEmailAsyncData, _data_);
#line 4821 "smtp-outbox-folder.c"
}


void geary_smtp_outbox_folder_enqueue_email_async (GearySmtpOutboxFolder* self, GearyRFC822Message* rfc822, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GearySmtpOutboxFolderEnqueueEmailAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_ = NULL;
	GearyRFC822Message* _tmp1_ = NULL;
	GearyRFC822Message* _tmp2_ = NULL;
	GCancellable* _tmp3_ = NULL;
	GCancellable* _tmp4_ = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderEnqueueEmailAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, geary_smtp_outbox_folder_enqueue_email_async);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, geary_smtp_outbox_folder_enqueue_email_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = rfc822;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->rfc822);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->rfc822 = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = cancellable;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp4_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_enqueue_email_async_co (_data_);
#line 4860 "smtp-outbox-folder.c"
}


GearySmtpOutboxEmailIdentifier* geary_smtp_outbox_folder_enqueue_email_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error) {
	GearySmtpOutboxEmailIdentifier* result;
	GearySmtpOutboxFolderEnqueueEmailAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 4871 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _data_->result;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 4881 "smtp-outbox-folder.c"
}


static Block76Data* block76_data_ref (Block76Data* _data76_) {
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data76_->_ref_count_);
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data76_;
#line 4890 "smtp-outbox-folder.c"
}


static void block76_data_unref (void * _userdata_) {
	Block76Data* _data76_;
	_data76_ = (Block76Data*) _userdata_;
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data76_->_ref_count_)) {
#line 4899 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data76_->self;
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_geary_smtp_outbox_folder_outbox_row_unref0 (_data76_->row);
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data76_->rfc822);
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data76_->cancellable);
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block76Data, _data76_);
#line 4913 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome __lambda99_ (Block76Data* _data76_, GearyDbConnection* cx, GError** error) {
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	gint64 ordering = 0LL;
	GearyDbConnection* _tmp0_ = NULL;
	GCancellable* _tmp1_ = NULL;
	gint64 _tmp2_ = 0LL;
	GearyDbStatement* stmt = NULL;
	GearyDbConnection* _tmp3_ = NULL;
	GearyDbStatement* _tmp4_ = NULL;
	GearyMemoryBuffer* _tmp5_ = NULL;
	GearyRFC822Message* _tmp6_ = NULL;
	GearyMemoryBuffer* _tmp7_ = NULL;
	GearyDbStatement* _tmp8_ = NULL;
	GearyDbStatement* _tmp9_ = NULL;
	GearyDbStatement* _tmp10_ = NULL;
	GearyDbStatement* _tmp11_ = NULL;
	gint64 _tmp12_ = 0LL;
	GearyDbStatement* _tmp13_ = NULL;
	GearyDbStatement* _tmp14_ = NULL;
	gint64 id = 0LL;
	GearyDbStatement* _tmp15_ = NULL;
	GCancellable* _tmp16_ = NULL;
	gint64 _tmp17_ = 0LL;
	GearyDbStatement* _tmp18_ = NULL;
	GearyDbConnection* _tmp19_ = NULL;
	GearyDbStatement* _tmp20_ = NULL;
	GearyDbStatement* _tmp21_ = NULL;
	GearyDbStatement* _tmp22_ = NULL;
	gint64 _tmp23_ = 0LL;
	GearyDbStatement* _tmp24_ = NULL;
	GearyDbStatement* _tmp25_ = NULL;
	GearyDbResult* results = NULL;
	GearyDbStatement* _tmp26_ = NULL;
	GCancellable* _tmp27_ = NULL;
	GearyDbResult* _tmp28_ = NULL;
	GearyDbResult* _tmp29_ = NULL;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	GearyMemoryBuffer* message = NULL;
	GearyDbResult* _tmp32_ = NULL;
	GearyMemoryBuffer* _tmp33_ = NULL;
	gint position = 0;
	GearyDbConnection* _tmp34_ = NULL;
	gint64 _tmp35_ = 0LL;
	GCancellable* _tmp36_ = NULL;
	gint _tmp37_ = 0;
	gint64 _tmp38_ = 0LL;
	gint _tmp39_ = 0;
	gint64 _tmp40_ = 0LL;
	GearyMemoryBuffer* _tmp41_ = NULL;
	GearySmtpOutboxFolderRoot* _tmp42_ = NULL;
	GearySmtpOutboxFolderOutboxRow* _tmp43_ = NULL;
	gint _tmp44_ = 0;
	GearyDbConnection* _tmp45_ = NULL;
	GCancellable* _tmp46_ = NULL;
	gint _tmp47_ = 0;
	GError * _inner_error_ = NULL;
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data76_->self;
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 343 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = cx;
#line 343 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _data76_->cancellable;
#line 343 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = geary_smtp_outbox_folder_do_get_next_ordering (self, _tmp0_, _tmp1_, &_inner_error_);
#line 343 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	ordering = _tmp2_;
#line 343 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 343 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 343 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 4994 "smtp-outbox-folder.c"
	}
#line 346 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = cx;
#line 346 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = geary_db_connection_prepare (_tmp3_, "INSERT INTO SmtpOutboxTable (message, ordering) VALUES (?, ?)", &_inner_error_);
#line 346 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp4_;
#line 346 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 346 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 346 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5008 "smtp-outbox-folder.c"
	}
#line 348 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = _data76_->rfc822;
#line 348 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = geary_rf_c822_message_get_network_buffer (_tmp6_, FALSE, &_inner_error_);
#line 348 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = _tmp7_;
#line 348 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 348 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 348 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 348 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5024 "smtp-outbox-folder.c"
	}
#line 348 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = stmt;
#line 348 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp9_ = geary_db_statement_bind_string_buffer (_tmp8_, 0, _tmp5_, &_inner_error_);
#line 348 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp10_ = _tmp9_;
#line 348 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp10_);
#line 348 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 348 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 348 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp5_);
#line 348 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 348 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5044 "smtp-outbox-folder.c"
	}
#line 349 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp11_ = stmt;
#line 349 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp12_ = ordering;
#line 349 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp13_ = geary_db_statement_bind_int64 (_tmp11_, 1, _tmp12_, &_inner_error_);
#line 349 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp14_ = _tmp13_;
#line 349 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp14_);
#line 349 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 349 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 349 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp5_);
#line 349 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 349 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5066 "smtp-outbox-folder.c"
	}
#line 351 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp15_ = stmt;
#line 351 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp16_ = _data76_->cancellable;
#line 351 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp17_ = geary_db_statement_exec_insert (_tmp15_, _tmp16_, &_inner_error_);
#line 351 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	id = _tmp17_;
#line 351 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 351 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 351 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp5_);
#line 351 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 351 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5086 "smtp-outbox-folder.c"
	}
#line 353 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp19_ = cx;
#line 353 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp20_ = geary_db_connection_prepare (_tmp19_, "SELECT message FROM SmtpOutboxTable WHERE id=?", &_inner_error_);
#line 353 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp18_ = _tmp20_;
#line 353 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 353 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 353 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp5_);
#line 353 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 353 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5104 "smtp-outbox-folder.c"
	}
#line 353 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp21_ = _tmp18_;
#line 353 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp18_ = NULL;
#line 353 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 353 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp21_;
#line 354 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp22_ = stmt;
#line 354 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp23_ = id;
#line 354 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp24_ = geary_db_statement_bind_rowid (_tmp22_, 0, _tmp23_, &_inner_error_);
#line 354 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp25_ = _tmp24_;
#line 354 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp25_);
#line 354 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 354 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 354 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp18_);
#line 354 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp5_);
#line 354 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 354 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5136 "smtp-outbox-folder.c"
	}
#line 357 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp26_ = stmt;
#line 357 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp27_ = _data76_->cancellable;
#line 357 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp28_ = geary_db_statement_exec (_tmp26_, _tmp27_, &_inner_error_);
#line 357 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	results = _tmp28_;
#line 357 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 357 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 357 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp18_);
#line 357 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp5_);
#line 357 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 357 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5158 "smtp-outbox-folder.c"
	}
#line 358 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp29_ = results;
#line 358 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp30_ = geary_db_result_get_finished (_tmp29_);
#line 358 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp31_ = _tmp30_;
#line 358 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_vala_assert (!_tmp31_, "!results.finished");
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp32_ = results;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp33_ = geary_db_result_string_buffer_at (_tmp32_, 0, &_inner_error_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	message = _tmp33_;
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp18_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp5_);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 360 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5188 "smtp-outbox-folder.c"
	}
#line 362 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp34_ = cx;
#line 362 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp35_ = ordering;
#line 362 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp36_ = _data76_->cancellable;
#line 362 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp37_ = geary_smtp_outbox_folder_do_get_position_by_ordering (self, _tmp34_, _tmp35_, _tmp36_, &_inner_error_);
#line 362 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	position = _tmp37_;
#line 362 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 362 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 362 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (message);
#line 362 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 362 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp18_);
#line 362 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp5_);
#line 362 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 362 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5216 "smtp-outbox-folder.c"
	}
#line 364 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp38_ = id;
#line 364 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp39_ = position;
#line 364 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp40_ = ordering;
#line 364 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp41_ = message;
#line 364 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp42_ = self->priv->_path;
#line 364 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp43_ = geary_smtp_outbox_folder_outbox_row_new (_tmp38_, _tmp39_, _tmp40_, FALSE, _tmp41_, _tmp42_);
#line 364 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_geary_smtp_outbox_folder_outbox_row_unref0 (_data76_->row);
#line 364 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data76_->row = _tmp43_;
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp45_ = cx;
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp46_ = _data76_->cancellable;
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp47_ = geary_smtp_outbox_folder_do_get_email_count (self, _tmp45_, _tmp46_, &_inner_error_);
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp44_ = _tmp47_;
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (message);
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp18_);
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp5_);
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 5258 "smtp-outbox-folder.c"
	}
#line 365 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data76_->email_count = _tmp44_;
#line 367 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_COMMIT;
#line 367 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (message);
#line 367 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (results);
#line 367 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp18_);
#line 367 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp5_);
#line 367 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 367 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 5276 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome ___lambda99__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error) {
	GearyDbTransactionOutcome result;
	result = __lambda99_ (self, cx, error);
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 5285 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_enqueue_email_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	GearySmtpOutboxFolderEnqueueEmailAsyncData* _data_;
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_enqueue_email_async_co (_data_);
#line 5299 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_enqueue_email_async_co (GearySmtpOutboxFolderEnqueueEmailAsyncData* _data_) {
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 5308 "smtp-outbox-folder.c"
		goto _state_0;
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 5312 "smtp-outbox-folder.c"
		goto _state_1;
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 2:
#line 5316 "smtp-outbox-folder.c"
		goto _state_2;
		default:
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 5321 "smtp-outbox-folder.c"
	}
	_state_0:
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data76_ = g_slice_new0 (Block76Data);
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data76_->_ref_count_ = 1;
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data76_->self = g_object_ref (_data_->self);
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = NULL;
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->rfc822;
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data76_->rfc822);
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data76_->rfc822 = _data_->_tmp0_;
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = NULL;
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->cancellable;
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data76_->cancellable);
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data76_->cancellable = _data_->_tmp1_;
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data76_->_async_data_ = _data_;
#line 340 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data76_->email_count = 0;
#line 341 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data76_->row = NULL;
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = NULL;
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = _data_->self->priv->db;
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = NULL;
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = _data_->_data76_->cancellable;
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_WR, ___lambda99__geary_db_transaction_method, _data_->_data76_, _data_->_tmp3_, geary_smtp_outbox_folder_enqueue_email_async_ready, _data_);
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 5366 "smtp-outbox-folder.c"
	_state_1:
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block76_data_unref (_data_->_data76_);
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data76_ = NULL;
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 5384 "smtp-outbox-folder.c"
		} else {
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 5388 "smtp-outbox-folder.c"
		}
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 342 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 5394 "smtp-outbox-folder.c"
	}
#line 371 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = NULL;
#line 371 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = _data_->_data76_->row;
#line 371 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_vala_assert (_data_->_tmp4_ != NULL, "row != null");
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp6_ = NULL;
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp6_ = _data_->_data76_->cancellable;
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 2;
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_get_email_count_async (_data_->self, _data_->_tmp6_, geary_smtp_outbox_folder_enqueue_email_async_ready, _data_);
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 5412 "smtp-outbox-folder.c"
	_state_2:
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp7_ = 0;
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp7_ = geary_smtp_outbox_folder_get_email_count_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp5_ = _data_->_tmp7_;
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block76_data_unref (_data_->_data76_);
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data76_ = NULL;
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 5434 "smtp-outbox-folder.c"
		} else {
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 5438 "smtp-outbox-folder.c"
		}
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 5444 "smtp-outbox-folder.c"
	}
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp8_ = NULL;
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp8_ = _data_->self->priv->_properties;
#line 374 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_properties_set_total (_data_->_tmp8_, _data_->_tmp5_);
#line 377 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp9_ = NULL;
#line 377 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp9_ = _data_->self->priv->outbox_queue;
#line 377 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp10_ = NULL;
#line 377 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp10_ = _data_->_data76_->row;
#line 377 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_nonblocking_mailbox_send (_data_->_tmp9_, _data_->_tmp10_);
#line 379 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp11_ = NULL;
#line 379 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp11_ = gee_array_list_new (GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 379 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->list = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp11_, GEE_TYPE_LIST, GeeList);
#line 380 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp12_ = NULL;
#line 380 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp12_ = _data_->list;
#line 380 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp13_ = NULL;
#line 380 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp13_ = _data_->_data76_->row;
#line 380 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp14_ = NULL;
#line 380 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp14_ = _data_->_tmp13_->outbox_id;
#line 380 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp12_, GEE_TYPE_COLLECTION, GeeCollection), _data_->_tmp14_);
#line 382 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp15_ = NULL;
#line 382 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp15_ = _data_->list;
#line 382 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_folder_notify_email_appended (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_FOLDER, GearyFolder), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp15_, GEE_TYPE_COLLECTION, GeeCollection));
#line 383 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp16_ = NULL;
#line 383 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp16_ = _data_->list;
#line 383 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_folder_notify_email_locally_appended (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_FOLDER, GearyFolder), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp16_, GEE_TYPE_COLLECTION, GeeCollection));
#line 384 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp17_ = 0;
#line 384 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp17_ = _data_->_data76_->email_count;
#line 384 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_folder_notify_email_count_changed (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_FOLDER, GearyFolder), _data_->_tmp17_, GEARY_FOLDER_COUNT_CHANGE_REASON_APPENDED);
#line 386 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp18_ = NULL;
#line 386 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp18_ = _data_->_data76_->row;
#line 386 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp19_ = NULL;
#line 386 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp19_ = _data_->_tmp18_->outbox_id;
#line 386 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp20_ = NULL;
#line 386 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp20_ = _g_object_ref0 (_data_->_tmp19_);
#line 386 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = _data_->_tmp20_;
#line 386 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->list);
#line 386 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block76_data_unref (_data_->_data76_);
#line 386 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data76_ = NULL;
#line 386 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 386 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 5524 "smtp-outbox-folder.c"
	} else {
#line 386 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 5528 "smtp-outbox-folder.c"
	}
#line 386 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 386 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->list);
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block76_data_unref (_data_->_data76_);
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data76_ = NULL;
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 5544 "smtp-outbox-folder.c"
	} else {
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 5548 "smtp-outbox-folder.c"
	}
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 338 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 5554 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_create_email_async_data_free (gpointer _data) {
	GearySmtpOutboxFolderCreateEmailAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->rfc822);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->flags);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_date_time_unref0 (_data_->date_received);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->id);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->result);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderCreateEmailAsyncData, _data_);
#line 5577 "smtp-outbox-folder.c"
}


static gpointer _g_date_time_ref0 (gpointer self) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 5584 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_create_email_async (GearySmtpOutboxFolder* self, GearyRFC822Message* rfc822, GearyEmailFlags* flags, GDateTime* date_received, GearyEmailIdentifier* id, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GearySmtpOutboxFolderCreateEmailAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_ = NULL;
	GearyRFC822Message* _tmp1_ = NULL;
	GearyRFC822Message* _tmp2_ = NULL;
	GearyEmailFlags* _tmp3_ = NULL;
	GearyEmailFlags* _tmp4_ = NULL;
	GDateTime* _tmp5_ = NULL;
	GDateTime* _tmp6_ = NULL;
	GearyEmailIdentifier* _tmp7_ = NULL;
	GearyEmailIdentifier* _tmp8_ = NULL;
	GCancellable* _tmp9_ = NULL;
	GCancellable* _tmp10_ = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderCreateEmailAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, geary_smtp_outbox_folder_real_create_email_async);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, geary_smtp_outbox_folder_real_create_email_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = rfc822;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->rfc822);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->rfc822 = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = flags;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->flags);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->flags = _tmp4_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = date_received;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = _g_date_time_ref0 (_tmp5_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_date_time_unref0 (_data_->date_received);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->date_received = _tmp6_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = id;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->id);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->id = _tmp8_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp9_ = cancellable;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp10_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_create_email_async_co (_data_);
#line 5653 "smtp-outbox-folder.c"
}


static GearyEmailIdentifier* geary_smtp_outbox_folder_real_create_email_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error) {
	GearyEmailIdentifier* result;
	GearySmtpOutboxFolderCreateEmailAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 5664 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _data_->result;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 5674 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_create_email_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	GearySmtpOutboxFolderCreateEmailAsyncData* _data_;
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_create_email_async_co (_data_);
#line 5688 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_real_create_email_async_co (GearySmtpOutboxFolderCreateEmailAsyncData* _data_) {
#line 389 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 389 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 5697 "smtp-outbox-folder.c"
		goto _state_0;
#line 389 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 5701 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 389 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 5706 "smtp-outbox-folder.c"
	}
	_state_0:
#line 391 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_abstract_local_folder_check_open (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolder), &_data_->_inner_error_);
#line 391 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 391 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 391 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 391 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 391 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 5721 "smtp-outbox-folder.c"
		} else {
#line 391 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 5725 "smtp-outbox-folder.c"
		}
#line 391 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 391 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 5731 "smtp-outbox-folder.c"
	}
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = NULL;
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->rfc822;
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = NULL;
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = _data_->cancellable;
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_enqueue_email_async (_data_->self, _data_->_tmp1_, _data_->_tmp2_, geary_smtp_outbox_folder_create_email_async_ready, _data_);
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 5747 "smtp-outbox-folder.c"
	_state_1:
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = NULL;
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = geary_smtp_outbox_folder_enqueue_email_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->_tmp3_;
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 5765 "smtp-outbox-folder.c"
		} else {
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 5769 "smtp-outbox-folder.c"
		}
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 5775 "smtp-outbox-folder.c"
	}
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = NULL;
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = _data_->_tmp0_;
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = NULL;
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier);
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_tmp0_);
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 5791 "smtp-outbox-folder.c"
	} else {
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 5795 "smtp-outbox-folder.c"
	}
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 393 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 389 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_tmp0_);
#line 389 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 389 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 5807 "smtp-outbox-folder.c"
	} else {
#line 389 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 5811 "smtp-outbox-folder.c"
	}
#line 389 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 389 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 5817 "smtp-outbox-folder.c"
}


void geary_smtp_outbox_folder_create_email_async (GearySmtpOutboxFolder* self, GearyRFC822Message* rfc822, GearyEmailFlags* flags, GDateTime* date_received, GearyEmailIdentifier* id, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	GEARY_SMTP_OUTBOX_FOLDER_GET_CLASS (self)->create_email_async (self, rfc822, flags, date_received, id, cancellable, _callback_, _user_data_);
#line 5824 "smtp-outbox-folder.c"
}


GearyEmailIdentifier* geary_smtp_outbox_folder_create_email_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return GEARY_SMTP_OUTBOX_FOLDER_GET_CLASS (self)->create_email_finish (self, _res_, error);
#line 5831 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_list_email_by_id_async_data_free (gpointer _data) {
	GearySmtpOutboxFolderListEmailByIdAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_initial_id);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->result);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderListEmailByIdAsyncData, _data_);
#line 5846 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_list_email_by_id_async (GearyFolder* base, GearyEmailIdentifier* _initial_id, gint count, GearyEmailField required_fields, GearyFolderListFlags flags, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GearySmtpOutboxFolder * self;
	GearySmtpOutboxFolderListEmailByIdAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_ = NULL;
	GearyEmailIdentifier* _tmp1_ = NULL;
	GearyEmailIdentifier* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	GearyEmailField _tmp4_ = 0;
	GearyFolderListFlags _tmp5_ = 0;
	GCancellable* _tmp6_ = NULL;
	GCancellable* _tmp7_ = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderListEmailByIdAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, geary_smtp_outbox_folder_real_list_email_by_id_async);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, geary_smtp_outbox_folder_real_list_email_by_id_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _initial_id;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_initial_id);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_initial_id = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = count;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->count = _tmp3_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = required_fields;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->required_fields = _tmp4_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = flags;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->flags = _tmp5_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = cancellable;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp7_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_list_email_by_id_async_co (_data_);
#line 5903 "smtp-outbox-folder.c"
}


static GeeList* geary_smtp_outbox_folder_real_list_email_by_id_finish (GearyFolder* base, GAsyncResult* _res_, GError** error) {
	GeeList* result;
	GearySmtpOutboxFolderListEmailByIdAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 5914 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _data_->result;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 5924 "smtp-outbox-folder.c"
}


static Block77Data* block77_data_ref (Block77Data* _data77_) {
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data77_->_ref_count_);
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data77_;
#line 5933 "smtp-outbox-folder.c"
}


static void block77_data_unref (void * _userdata_) {
	Block77Data* _data77_;
	_data77_ = (Block77Data*) _userdata_;
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data77_->_ref_count_)) {
#line 5942 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data77_->self;
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data77_->list);
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data77_->initial_id);
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data77_->cancellable);
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block77Data, _data77_);
#line 5956 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome __lambda100_ (Block77Data* _data77_, GearyDbConnection* cx, GError** error) {
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	const gchar* _tmp0_ = NULL;
	GearyFolderListFlags _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
	gchar* dir = NULL;
	gchar* _tmp3_ = NULL;
	GearyDbStatement* stmt = NULL;
	GearySmtpOutboxEmailIdentifier* _tmp4_ = NULL;
	GearyDbResult* results = NULL;
	GearyDbStatement* _tmp41_ = NULL;
	GCancellable* _tmp42_ = NULL;
	GearyDbResult* _tmp43_ = NULL;
	GearyDbResult* _tmp44_ = NULL;
	gboolean _tmp45_ = FALSE;
	gboolean _tmp46_ = FALSE;
	GeeArrayList* _tmp47_ = NULL;
	gint position = 0;
	GError * _inner_error_ = NULL;
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data77_->self;
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 412 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _data77_->flags;
#line 412 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = geary_folder_list_flags_is_newest_to_oldest (_tmp1_);
#line 412 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp2_) {
#line 412 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = "DESC";
#line 5993 "smtp-outbox-folder.c"
	} else {
#line 412 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = "ASC";
#line 5997 "smtp-outbox-folder.c"
	}
#line 412 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = g_strdup (_tmp0_);
#line 412 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	dir = _tmp3_;
#line 415 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _data77_->initial_id;
#line 415 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp4_ != NULL) {
#line 6007 "smtp-outbox-folder.c"
		GearyDbStatement* _tmp5_ = NULL;
		GearyDbConnection* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		GearyDbStatement* _tmp10_ = NULL;
		GearyDbStatement* _tmp11_ = NULL;
		GearyDbStatement* _tmp12_ = NULL;
		gint64 _tmp13_ = 0LL;
		GearyFolderListFlags _tmp14_ = 0;
		gboolean _tmp15_ = FALSE;
		GearyDbStatement* _tmp22_ = NULL;
		GearyDbStatement* _tmp23_ = NULL;
		GearyDbStatement* _tmp24_ = NULL;
		GearyDbStatement* _tmp25_ = NULL;
		gint _tmp26_ = 0;
		GearyDbStatement* _tmp27_ = NULL;
		GearyDbStatement* _tmp28_ = NULL;
#line 416 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp6_ = cx;
#line 416 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp7_ = dir;
#line 416 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp8_ = g_strdup_printf ("\n" \
"                    SELECT id, ordering, message, sent\n" \
"                    FROM SmtpOutboxTable\n" \
"                    WHERE ordering >= ?\n" \
"                    ORDER BY ordering %s\n" \
"                    LIMIT ?\n" \
"                ", _tmp7_);
#line 416 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp9_ = _tmp8_;
#line 416 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp10_ = geary_db_connection_prepare (_tmp6_, _tmp9_, &_inner_error_);
#line 416 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp11_ = _tmp10_;
#line 416 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (_tmp9_);
#line 416 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp5_ = _tmp11_;
#line 416 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 416 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 416 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 416 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_free0 (dir);
#line 416 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 6052 "smtp-outbox-folder.c"
		}
#line 416 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp12_ = _tmp5_;
#line 416 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp5_ = NULL;
#line 416 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 416 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		stmt = _tmp12_;
#line 424 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp14_ = _data77_->flags;
#line 424 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp15_ = geary_folder_list_flags_is_including_id (_tmp14_);
#line 424 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_tmp15_) {
#line 6068 "smtp-outbox-folder.c"
			GearySmtpOutboxEmailIdentifier* _tmp16_ = NULL;
			gint64 _tmp17_ = 0LL;
			gint64 _tmp18_ = 0LL;
#line 424 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp16_ = _data77_->initial_id;
#line 424 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp17_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp16_);
#line 424 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp18_ = _tmp17_;
#line 424 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp13_ = _tmp18_;
#line 6080 "smtp-outbox-folder.c"
		} else {
			GearySmtpOutboxEmailIdentifier* _tmp19_ = NULL;
			gint64 _tmp20_ = 0LL;
			gint64 _tmp21_ = 0LL;
#line 424 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp19_ = _data77_->initial_id;
#line 424 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp20_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp19_);
#line 424 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp21_ = _tmp20_;
#line 424 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp13_ = _tmp21_ + 1;
#line 6093 "smtp-outbox-folder.c"
		}
#line 423 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp22_ = stmt;
#line 423 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp23_ = geary_db_statement_bind_int64 (_tmp22_, 0, _tmp13_, &_inner_error_);
#line 423 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp24_ = _tmp23_;
#line 423 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp24_);
#line 423 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 423 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 423 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_tmp5_);
#line 423 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 423 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_free0 (dir);
#line 423 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 6115 "smtp-outbox-folder.c"
		}
#line 425 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp25_ = stmt;
#line 425 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp26_ = _data77_->count;
#line 425 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp27_ = geary_db_statement_bind_int (_tmp25_, 1, _tmp26_, &_inner_error_);
#line 425 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp28_ = _tmp27_;
#line 425 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp28_);
#line 425 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 425 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 425 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_tmp5_);
#line 425 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 425 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_free0 (dir);
#line 425 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 6139 "smtp-outbox-folder.c"
		}
#line 415 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp5_);
#line 6143 "smtp-outbox-folder.c"
	} else {
		GearyDbStatement* _tmp29_ = NULL;
		GearyDbConnection* _tmp30_ = NULL;
		const gchar* _tmp31_ = NULL;
		gchar* _tmp32_ = NULL;
		gchar* _tmp33_ = NULL;
		GearyDbStatement* _tmp34_ = NULL;
		GearyDbStatement* _tmp35_ = NULL;
		GearyDbStatement* _tmp36_ = NULL;
		GearyDbStatement* _tmp37_ = NULL;
		gint _tmp38_ = 0;
		GearyDbStatement* _tmp39_ = NULL;
		GearyDbStatement* _tmp40_ = NULL;
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp30_ = cx;
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp31_ = dir;
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp32_ = g_strdup_printf ("\n" \
"                    SELECT id, ordering, message, sent\n" \
"                    FROM SmtpOutboxTable\n" \
"                    ORDER BY ordering %s\n" \
"                    LIMIT ?\n" \
"                ", _tmp31_);
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp33_ = _tmp32_;
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp34_ = geary_db_connection_prepare (_tmp30_, _tmp33_, &_inner_error_);
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp35_ = _tmp34_;
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (_tmp33_);
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp29_ = _tmp35_;
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_free0 (dir);
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 6183 "smtp-outbox-folder.c"
		}
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp36_ = _tmp29_;
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp29_ = NULL;
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 427 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		stmt = _tmp36_;
#line 433 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp37_ = stmt;
#line 433 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp38_ = _data77_->count;
#line 433 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp39_ = geary_db_statement_bind_int (_tmp37_, 0, _tmp38_, &_inner_error_);
#line 433 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp40_ = _tmp39_;
#line 433 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp40_);
#line 433 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 433 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 433 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_tmp29_);
#line 433 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 433 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_free0 (dir);
#line 433 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 6215 "smtp-outbox-folder.c"
		}
#line 415 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp29_);
#line 6219 "smtp-outbox-folder.c"
	}
#line 436 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp41_ = stmt;
#line 436 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp42_ = _data77_->cancellable;
#line 436 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp43_ = geary_db_statement_exec (_tmp41_, _tmp42_, &_inner_error_);
#line 436 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	results = _tmp43_;
#line 436 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 436 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 436 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 436 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (dir);
#line 436 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 6239 "smtp-outbox-folder.c"
	}
#line 437 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp44_ = results;
#line 437 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp45_ = geary_db_result_get_finished (_tmp44_);
#line 437 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp46_ = _tmp45_;
#line 437 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp46_) {
#line 438 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 438 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 438 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 438 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (dir);
#line 438 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return result;
#line 6259 "smtp-outbox-folder.c"
	}
#line 440 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp47_ = gee_array_list_new (GEARY_TYPE_EMAIL, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 440 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data77_->list);
#line 440 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data77_->list = G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, GEE_TYPE_LIST, GeeList);
#line 441 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	position = -1;
#line 6269 "smtp-outbox-folder.c"
	{
		gboolean _tmp48_ = FALSE;
#line 442 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp48_ = TRUE;
#line 442 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (TRUE) {
#line 6276 "smtp-outbox-folder.c"
			gint64 ordering = 0LL;
			GearyDbResult* _tmp52_ = NULL;
			gint64 _tmp53_ = 0LL;
			gint _tmp54_ = 0;
			gint64 _tmp61_ = 0LL;
			GearyDbResult* _tmp62_ = NULL;
			gint64 _tmp63_ = 0LL;
			gboolean _tmp64_ = FALSE;
			GearyDbResult* _tmp65_ = NULL;
			gboolean _tmp66_ = FALSE;
			GearyMemoryBuffer* _tmp67_ = NULL;
			GearyDbResult* _tmp68_ = NULL;
			GearyMemoryBuffer* _tmp69_ = NULL;
			GearyEmail* _tmp70_ = NULL;
			gint _tmp71_ = 0;
			gint64 _tmp72_ = 0LL;
			GearySmtpOutboxFolderRoot* _tmp73_ = NULL;
			GearySmtpOutboxFolderOutboxRow* _tmp74_ = NULL;
			GearySmtpOutboxFolderOutboxRow* _tmp75_ = NULL;
			GearyEmail* _tmp76_ = NULL;
			GearyEmail* _tmp77_ = NULL;
			GeeList* _tmp78_ = NULL;
			gint _tmp79_ = 0;
			GearyFolderListFlags _tmp80_ = 0;
			gboolean _tmp81_ = FALSE;
			gint _tmp82_ = 0;
			gint _tmp83_ = 0;
#line 442 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!_tmp48_) {
#line 6306 "smtp-outbox-folder.c"
				gboolean _tmp49_ = FALSE;
				GearyDbResult* _tmp50_ = NULL;
				gboolean _tmp51_ = FALSE;
#line 453 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp50_ = results;
#line 453 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp51_ = geary_db_result_next (_tmp50_, NULL, &_inner_error_);
#line 453 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp49_ = _tmp51_;
#line 453 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 453 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_propagate_error (error, _inner_error_);
#line 453 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (results);
#line 453 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (stmt);
#line 453 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_free0 (dir);
#line 453 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					return 0;
#line 6328 "smtp-outbox-folder.c"
				}
#line 453 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (!_tmp49_) {
#line 453 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					break;
#line 6334 "smtp-outbox-folder.c"
				}
			}
#line 442 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp48_ = FALSE;
#line 443 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp52_ = results;
#line 443 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp53_ = geary_db_result_int64_at (_tmp52_, 1, &_inner_error_);
#line 443 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			ordering = _tmp53_;
#line 443 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 443 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 443 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (results);
#line 443 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 443 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_free0 (dir);
#line 443 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 6357 "smtp-outbox-folder.c"
			}
#line 444 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp54_ = position;
#line 444 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp54_ == -1) {
#line 6363 "smtp-outbox-folder.c"
				gint _tmp55_ = 0;
				GearyDbConnection* _tmp56_ = NULL;
				gint64 _tmp57_ = 0LL;
				GCancellable* _tmp58_ = NULL;
				gint _tmp59_ = 0;
				gint _tmp60_ = 0;
#line 445 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp56_ = cx;
#line 445 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp57_ = ordering;
#line 445 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp58_ = _data77_->cancellable;
#line 445 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp59_ = geary_smtp_outbox_folder_do_get_position_by_ordering (self, _tmp56_, _tmp57_, _tmp58_, &_inner_error_);
#line 445 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp55_ = _tmp59_;
#line 445 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 445 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					g_propagate_error (error, _inner_error_);
#line 445 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (results);
#line 445 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (stmt);
#line 445 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_free0 (dir);
#line 445 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					return 0;
#line 6392 "smtp-outbox-folder.c"
				}
#line 445 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				position = _tmp55_;
#line 446 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp60_ = position;
#line 446 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_vala_assert (_tmp60_ >= 1, "position >= 1");
#line 6400 "smtp-outbox-folder.c"
			}
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp62_ = results;
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp63_ = geary_db_result_rowid_at (_tmp62_, 0, &_inner_error_);
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp61_ = _tmp63_;
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (results);
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_free0 (dir);
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 6420 "smtp-outbox-folder.c"
			}
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp65_ = results;
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp66_ = geary_db_result_bool_at (_tmp65_, 3, &_inner_error_);
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp64_ = _tmp66_;
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (results);
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_free0 (dir);
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 6440 "smtp-outbox-folder.c"
			}
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp68_ = results;
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp69_ = geary_db_result_string_buffer_at (_tmp68_, 2, &_inner_error_);
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp67_ = _tmp69_;
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (results);
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_free0 (dir);
#line 450 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 6460 "smtp-outbox-folder.c"
			}
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp71_ = position;
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp72_ = ordering;
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp73_ = self->priv->_path;
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp74_ = geary_smtp_outbox_folder_outbox_row_new (_tmp61_, _tmp71_, _tmp72_, _tmp64_, _tmp67_, _tmp73_);
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp75_ = _tmp74_;
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp76_ = geary_smtp_outbox_folder_row_to_email (self, _tmp75_, &_inner_error_);
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp77_ = _tmp76_;
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_geary_smtp_outbox_folder_outbox_row_unref0 (_tmp75_);
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp70_ = _tmp77_;
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_tmp67_);
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (results);
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_free0 (dir);
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 6494 "smtp-outbox-folder.c"
			}
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp78_ = _data77_->list;
#line 449 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp78_, GEE_TYPE_COLLECTION, GeeCollection), _tmp70_);
#line 451 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp80_ = _data77_->flags;
#line 451 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp81_ = geary_folder_list_flags_is_newest_to_oldest (_tmp80_);
#line 451 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp81_) {
#line 451 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp79_ = -1;
#line 6508 "smtp-outbox-folder.c"
			} else {
#line 451 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp79_ = 1;
#line 6512 "smtp-outbox-folder.c"
			}
#line 451 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp82_ = position;
#line 451 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			position = _tmp82_ + _tmp79_;
#line 452 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp83_ = position;
#line 452 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_vala_assert (_tmp83_ >= 1, "position >= 1");
#line 442 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_tmp70_);
#line 442 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_tmp67_);
#line 6526 "smtp-outbox-folder.c"
		}
	}
#line 455 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 455 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (results);
#line 455 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 455 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_free0 (dir);
#line 455 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 6539 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome ___lambda100__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error) {
	GearyDbTransactionOutcome result;
	result = __lambda100_ (self, cx, error);
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 6548 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_list_email_by_id_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	GearySmtpOutboxFolderListEmailByIdAsyncData* _data_;
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_list_email_by_id_async_co (_data_);
#line 6562 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_real_list_email_by_id_async_co (GearySmtpOutboxFolderListEmailByIdAsyncData* _data_) {
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 6571 "smtp-outbox-folder.c"
		goto _state_0;
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 6575 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 6580 "smtp-outbox-folder.c"
	}
	_state_0:
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_ = g_slice_new0 (Block77Data);
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_->_ref_count_ = 1;
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_->self = g_object_ref (_data_->self);
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = 0;
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->count;
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_->count = _data_->_tmp0_;
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = 0;
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->flags;
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_->flags = _data_->_tmp1_;
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = NULL;
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = _data_->cancellable;
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data77_->cancellable);
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_->cancellable = _data_->_tmp2_;
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_->_async_data_ = _data_;
#line 399 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_abstract_local_folder_check_open (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolder), &_data_->_inner_error_);
#line 399 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 399 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 399 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 399 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block77_data_unref (_data_->_data77_);
#line 399 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data77_ = NULL;
#line 399 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 399 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 6627 "smtp-outbox-folder.c"
		} else {
#line 399 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 6631 "smtp-outbox-folder.c"
		}
#line 399 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 399 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 6637 "smtp-outbox-folder.c"
	}
#line 401 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = NULL;
#line 401 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = _data_->_initial_id;
#line 401 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = NULL;
#line 401 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp3_, GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER) ? ((GearySmtpOutboxEmailIdentifier*) _data_->_tmp3_) : NULL);
#line 401 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_->initial_id = _data_->_tmp4_;
#line 402 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp6_ = NULL;
#line 402 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp6_ = _data_->_initial_id;
#line 402 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp6_ != NULL) {
#line 402 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp7_ = NULL;
#line 402 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp7_ = _data_->_data77_->initial_id;
#line 402 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp5_ = _data_->_tmp7_ == NULL;
#line 6661 "smtp-outbox-folder.c"
	} else {
#line 402 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp5_ = FALSE;
#line 6665 "smtp-outbox-folder.c"
	}
#line 402 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp5_) {
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp8_ = NULL;
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp8_ = _data_->_data77_->initial_id;
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp9_ = NULL;
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp9_ = geary_email_identifier_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier));
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp10_ = NULL;
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp11_ = NULL;
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp11_ = g_error_new (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_BAD_PARAMETERS, "EmailIdentifier %s not for Outbox", _data_->_tmp10_);
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp12_ = NULL;
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (_data_->_tmp10_);
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = _data_->_tmp12_;
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block77_data_unref (_data_->_data77_);
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data77_ = NULL;
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 6705 "smtp-outbox-folder.c"
		} else {
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 6709 "smtp-outbox-folder.c"
		}
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 403 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 6715 "smtp-outbox-folder.c"
	}
#line 407 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp13_ = 0;
#line 407 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp13_ = _data_->_data77_->count;
#line 407 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp13_ <= 0) {
#line 408 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->result = NULL;
#line 408 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block77_data_unref (_data_->_data77_);
#line 408 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data77_ = NULL;
#line 408 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 408 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 6733 "smtp-outbox-folder.c"
		} else {
#line 408 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 6737 "smtp-outbox-folder.c"
		}
#line 408 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 408 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 6743 "smtp-outbox-folder.c"
	}
#line 410 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_->list = NULL;
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp14_ = NULL;
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp14_ = _data_->self->priv->db;
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp15_ = NULL;
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp15_ = _data_->_data77_->cancellable;
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp14_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_RO, ___lambda100__geary_db_transaction_method, _data_->_data77_, _data_->_tmp15_, geary_smtp_outbox_folder_list_email_by_id_async_ready, _data_);
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 6761 "smtp-outbox-folder.c"
	_state_1:
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp14_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block77_data_unref (_data_->_data77_);
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data77_ = NULL;
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 6779 "smtp-outbox-folder.c"
		} else {
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 6783 "smtp-outbox-folder.c"
		}
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 411 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 6789 "smtp-outbox-folder.c"
	}
#line 458 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp16_ = NULL;
#line 458 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp16_ = _data_->_data77_->list;
#line 458 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp17_ = NULL;
#line 458 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp17_ = _g_object_ref0 (_data_->_tmp16_);
#line 458 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = _data_->_tmp17_;
#line 458 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block77_data_unref (_data_->_data77_);
#line 458 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_ = NULL;
#line 458 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 458 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 6809 "smtp-outbox-folder.c"
	} else {
#line 458 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 6813 "smtp-outbox-folder.c"
	}
#line 458 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 458 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block77_data_unref (_data_->_data77_);
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data77_ = NULL;
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 6827 "smtp-outbox-folder.c"
	} else {
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 6831 "smtp-outbox-folder.c"
	}
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 396 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 6837 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_list_email_by_sparse_id_async_data_free (gpointer _data) {
	GearySmtpOutboxFolderListEmailBySparseIdAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->result);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderListEmailBySparseIdAsyncData, _data_);
#line 6850 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_list_email_by_sparse_id_async (GearyFolder* base, GeeCollection* ids, GearyEmailField required_fields, GearyFolderListFlags flags, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GearySmtpOutboxFolder * self;
	GearySmtpOutboxFolderListEmailBySparseIdAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
	GeeCollection* _tmp2_ = NULL;
	GearyEmailField _tmp3_ = 0;
	GearyFolderListFlags _tmp4_ = 0;
	GCancellable* _tmp5_ = NULL;
	GCancellable* _tmp6_ = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderListEmailBySparseIdAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, geary_smtp_outbox_folder_real_list_email_by_sparse_id_async);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, geary_smtp_outbox_folder_real_list_email_by_sparse_id_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = ids;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->ids);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->ids = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = required_fields;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->required_fields = _tmp3_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = flags;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->flags = _tmp4_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = cancellable;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp6_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_list_email_by_sparse_id_async_co (_data_);
#line 6902 "smtp-outbox-folder.c"
}


static GeeList* geary_smtp_outbox_folder_real_list_email_by_sparse_id_finish (GearyFolder* base, GAsyncResult* _res_, GError** error) {
	GeeList* result;
	GearySmtpOutboxFolderListEmailBySparseIdAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 6913 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _data_->result;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 6923 "smtp-outbox-folder.c"
}


static Block78Data* block78_data_ref (Block78Data* _data78_) {
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data78_->_ref_count_);
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data78_;
#line 6932 "smtp-outbox-folder.c"
}


static void block78_data_unref (void * _userdata_) {
	Block78Data* _data78_;
	_data78_ = (Block78Data*) _userdata_;
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data78_->_ref_count_)) {
#line 6941 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data78_->self;
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data78_->list);
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data78_->ids);
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data78_->cancellable);
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block78Data, _data78_);
#line 6955 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome __lambda101_ (Block78Data* _data78_, GearyDbConnection* cx, GError** error) {
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	GError * _inner_error_ = NULL;
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data78_->self;
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 6968 "smtp-outbox-folder.c"
	{
		GeeIterator* _id_it = NULL;
		GeeCollection* _tmp0_ = NULL;
		GeeIterator* _tmp1_ = NULL;
#line 468 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = _data78_->ids;
#line 468 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 468 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_id_it = _tmp1_;
#line 468 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (TRUE) {
#line 6981 "smtp-outbox-folder.c"
			GeeIterator* _tmp2_ = NULL;
			gboolean _tmp3_ = FALSE;
			GearyEmailIdentifier* id = NULL;
			GeeIterator* _tmp4_ = NULL;
			gpointer _tmp5_ = NULL;
			GearySmtpOutboxEmailIdentifier* outbox_id = NULL;
			GearyEmailIdentifier* _tmp6_ = NULL;
			GearySmtpOutboxEmailIdentifier* _tmp7_ = NULL;
			GearySmtpOutboxEmailIdentifier* _tmp8_ = NULL;
			GearySmtpOutboxFolderOutboxRow* row = NULL;
			GearyDbConnection* _tmp14_ = NULL;
			GearySmtpOutboxEmailIdentifier* _tmp15_ = NULL;
			gint64 _tmp16_ = 0LL;
			gint64 _tmp17_ = 0LL;
			GCancellable* _tmp18_ = NULL;
			GearySmtpOutboxFolderOutboxRow* _tmp19_ = NULL;
			GearySmtpOutboxFolderOutboxRow* _tmp20_ = NULL;
			GearyEmail* _tmp21_ = NULL;
			GearySmtpOutboxFolderOutboxRow* _tmp22_ = NULL;
			GearyEmail* _tmp23_ = NULL;
			GeeList* _tmp24_ = NULL;
#line 468 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp2_ = _id_it;
#line 468 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 468 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!_tmp3_) {
#line 468 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				break;
#line 7011 "smtp-outbox-folder.c"
			}
#line 468 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp4_ = _id_it;
#line 468 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 468 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			id = (GearyEmailIdentifier*) _tmp5_;
#line 469 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp6_ = id;
#line 469 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER) ? ((GearySmtpOutboxEmailIdentifier*) _tmp6_) : NULL);
#line 469 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			outbox_id = _tmp7_;
#line 470 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp8_ = outbox_id;
#line 470 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp8_ == NULL) {
#line 7029 "smtp-outbox-folder.c"
				GearyEmailIdentifier* _tmp9_ = NULL;
				gchar* _tmp10_ = NULL;
				gchar* _tmp11_ = NULL;
				GError* _tmp12_ = NULL;
				GError* _tmp13_ = NULL;
#line 471 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp9_ = id;
#line 471 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp10_ = geary_email_identifier_to_string (_tmp9_);
#line 471 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp11_ = _tmp10_;
#line 471 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp12_ = g_error_new (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_BAD_PARAMETERS, "%s is not outbox EmailIdentifier", _tmp11_);
#line 471 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp13_ = _tmp12_;
#line 471 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_free0 (_tmp11_);
#line 471 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_inner_error_ = _tmp13_;
#line 471 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 471 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 471 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 471 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_it);
#line 471 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 7059 "smtp-outbox-folder.c"
			}
#line 473 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp14_ = cx;
#line 473 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp15_ = outbox_id;
#line 473 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp16_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp15_);
#line 473 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp17_ = _tmp16_;
#line 473 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp18_ = _data78_->cancellable;
#line 473 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp19_ = geary_smtp_outbox_folder_do_fetch_row_by_ordering (self, _tmp14_, _tmp17_, _tmp18_, &_inner_error_);
#line 473 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			row = _tmp19_;
#line 473 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 473 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 473 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 473 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 473 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_it);
#line 473 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 7087 "smtp-outbox-folder.c"
			}
#line 474 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp20_ = row;
#line 474 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp20_ == NULL) {
#line 475 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (row);
#line 475 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 475 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 475 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				continue;
#line 7101 "smtp-outbox-folder.c"
			}
#line 477 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp22_ = row;
#line 477 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp23_ = geary_smtp_outbox_folder_row_to_email (self, _tmp22_, &_inner_error_);
#line 477 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp21_ = _tmp23_;
#line 477 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 477 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 477 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_geary_smtp_outbox_folder_outbox_row_unref0 (row);
#line 477 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 477 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 477 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_it);
#line 477 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 7123 "smtp-outbox-folder.c"
			}
#line 477 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp24_ = _data78_->list;
#line 477 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_COLLECTION, GeeCollection), _tmp21_);
#line 468 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_tmp21_);
#line 468 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_geary_smtp_outbox_folder_outbox_row_unref0 (row);
#line 468 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (outbox_id);
#line 468 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (id);
#line 7137 "smtp-outbox-folder.c"
		}
#line 468 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_id_it);
#line 7141 "smtp-outbox-folder.c"
	}
#line 480 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 480 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 7147 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome ___lambda101__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error) {
	GearyDbTransactionOutcome result;
	result = __lambda101_ (self, cx, error);
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 7156 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_list_email_by_sparse_id_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	GearySmtpOutboxFolderListEmailBySparseIdAsyncData* _data_;
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_list_email_by_sparse_id_async_co (_data_);
#line 7170 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_real_list_email_by_sparse_id_async_co (GearySmtpOutboxFolderListEmailBySparseIdAsyncData* _data_) {
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 7179 "smtp-outbox-folder.c"
		goto _state_0;
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 7183 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 7188 "smtp-outbox-folder.c"
	}
	_state_0:
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_ = g_slice_new0 (Block78Data);
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_->_ref_count_ = 1;
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_->self = g_object_ref (_data_->self);
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = NULL;
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->ids;
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data78_->ids);
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_->ids = _data_->_tmp0_;
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = NULL;
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->cancellable;
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data78_->cancellable);
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_->cancellable = _data_->_tmp1_;
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_->_async_data_ = _data_;
#line 464 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_abstract_local_folder_check_open (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolder), &_data_->_inner_error_);
#line 464 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 464 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 464 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 464 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block78_data_unref (_data_->_data78_);
#line 464 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data78_ = NULL;
#line 464 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 464 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 7231 "smtp-outbox-folder.c"
		} else {
#line 464 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 7235 "smtp-outbox-folder.c"
		}
#line 464 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 464 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 7241 "smtp-outbox-folder.c"
	}
#line 466 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = NULL;
#line 466 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = gee_array_list_new (GEARY_TYPE_EMAIL, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 466 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_->list = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEE_TYPE_LIST, GeeList);
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = NULL;
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = _data_->self->priv->db;
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = NULL;
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = _data_->_data78_->cancellable;
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_RO, ___lambda101__geary_db_transaction_method, _data_->_data78_, _data_->_tmp4_, geary_smtp_outbox_folder_list_email_by_sparse_id_async_ready, _data_);
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 7263 "smtp-outbox-folder.c"
	_state_1:
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block78_data_unref (_data_->_data78_);
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data78_ = NULL;
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 7281 "smtp-outbox-folder.c"
		} else {
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 7285 "smtp-outbox-folder.c"
		}
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 467 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 7291 "smtp-outbox-folder.c"
	}
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp6_ = NULL;
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp6_ = _data_->_data78_->list;
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp7_ = 0;
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp7_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, GEE_TYPE_COLLECTION, GeeCollection));
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp8_ = 0;
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp8_ > 0) {
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp9_ = NULL;
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp9_ = _data_->_data78_->list;
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp5_ = _data_->_tmp9_;
#line 7313 "smtp-outbox-folder.c"
	} else {
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp5_ = NULL;
#line 7317 "smtp-outbox-folder.c"
	}
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp10_ = NULL;
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp10_ = _g_object_ref0 (_data_->_tmp5_);
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = _data_->_tmp10_;
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block78_data_unref (_data_->_data78_);
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_ = NULL;
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 7333 "smtp-outbox-folder.c"
	} else {
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 7337 "smtp-outbox-folder.c"
	}
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 483 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block78_data_unref (_data_->_data78_);
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data78_ = NULL;
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 7351 "smtp-outbox-folder.c"
	} else {
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 7355 "smtp-outbox-folder.c"
	}
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 461 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 7361 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_list_local_email_fields_async_data_free (gpointer _data) {
	GearySmtpOutboxFolderListLocalEmailFieldsAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->result);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderListLocalEmailFieldsAsyncData, _data_);
#line 7374 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_list_local_email_fields_async (GearyFolder* base, GeeCollection* ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GearySmtpOutboxFolder * self;
	GearySmtpOutboxFolderListLocalEmailFieldsAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
	GeeCollection* _tmp2_ = NULL;
	GCancellable* _tmp3_ = NULL;
	GCancellable* _tmp4_ = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderListLocalEmailFieldsAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, geary_smtp_outbox_folder_real_list_local_email_fields_async);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, geary_smtp_outbox_folder_real_list_local_email_fields_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = ids;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->ids);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->ids = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = cancellable;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp4_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_list_local_email_fields_async_co (_data_);
#line 7416 "smtp-outbox-folder.c"
}


static GeeMap* geary_smtp_outbox_folder_real_list_local_email_fields_finish (GearyFolder* base, GAsyncResult* _res_, GError** error) {
	GeeMap* result;
	GearySmtpOutboxFolderListLocalEmailFieldsAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 7427 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _data_->result;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 7437 "smtp-outbox-folder.c"
}


static Block79Data* block79_data_ref (Block79Data* _data79_) {
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data79_->_ref_count_);
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data79_;
#line 7446 "smtp-outbox-folder.c"
}


static void block79_data_unref (void * _userdata_) {
	Block79Data* _data79_;
	_data79_ = (Block79Data*) _userdata_;
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data79_->_ref_count_)) {
#line 7455 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data79_->self;
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data79_->map);
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data79_->ids);
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data79_->cancellable);
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block79Data, _data79_);
#line 7469 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome __lambda102_ (Block79Data* _data79_, GearyDbConnection* cx, GError** error) {
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	GearyDbStatement* stmt = NULL;
	GearyDbConnection* _tmp0_ = NULL;
	GearyDbStatement* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data79_->self;
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 494 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = cx;
#line 494 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = geary_db_connection_prepare (_tmp0_, "SELECT id FROM SmtpOutboxTable WHERE ordering=?", &_inner_error_);
#line 494 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp1_;
#line 494 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 494 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 494 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 7497 "smtp-outbox-folder.c"
	}
	{
		GeeIterator* _id_it = NULL;
		GeeCollection* _tmp2_ = NULL;
		GeeIterator* _tmp3_ = NULL;
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp2_ = _data79_->ids;
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_id_it = _tmp3_;
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (TRUE) {
#line 7511 "smtp-outbox-folder.c"
			GeeIterator* _tmp4_ = NULL;
			gboolean _tmp5_ = FALSE;
			GearyEmailIdentifier* id = NULL;
			GeeIterator* _tmp6_ = NULL;
			gpointer _tmp7_ = NULL;
			GearySmtpOutboxEmailIdentifier* outbox_id = NULL;
			GearyEmailIdentifier* _tmp8_ = NULL;
			GearySmtpOutboxEmailIdentifier* _tmp9_ = NULL;
			GearySmtpOutboxEmailIdentifier* _tmp10_ = NULL;
			GearyDbStatement* _tmp16_ = NULL;
			GearyDbStatement* _tmp17_ = NULL;
			GearyDbStatement* _tmp18_ = NULL;
			GearyDbStatement* _tmp19_ = NULL;
			GearySmtpOutboxEmailIdentifier* _tmp20_ = NULL;
			gint64 _tmp21_ = 0LL;
			gint64 _tmp22_ = 0LL;
			GearyDbStatement* _tmp23_ = NULL;
			GearyDbStatement* _tmp24_ = NULL;
			GearyDbResult* results = NULL;
			GearyDbStatement* _tmp25_ = NULL;
			GCancellable* _tmp26_ = NULL;
			GearyDbResult* _tmp27_ = NULL;
			GearyDbResult* _tmp28_ = NULL;
			gboolean _tmp29_ = FALSE;
			gboolean _tmp30_ = FALSE;
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp4_ = _id_it;
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp5_ = gee_iterator_next (_tmp4_);
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!_tmp5_) {
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				break;
#line 7545 "smtp-outbox-folder.c"
			}
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp6_ = _id_it;
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			id = (GearyEmailIdentifier*) _tmp7_;
#line 497 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp8_ = id;
#line 497 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER) ? ((GearySmtpOutboxEmailIdentifier*) _tmp8_) : NULL);
#line 497 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			outbox_id = _tmp9_;
#line 498 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp10_ = outbox_id;
#line 498 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp10_ == NULL) {
#line 7563 "smtp-outbox-folder.c"
				GearyEmailIdentifier* _tmp11_ = NULL;
				gchar* _tmp12_ = NULL;
				gchar* _tmp13_ = NULL;
				GError* _tmp14_ = NULL;
				GError* _tmp15_ = NULL;
#line 499 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp11_ = id;
#line 499 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp12_ = geary_email_identifier_to_string (_tmp11_);
#line 499 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp13_ = _tmp12_;
#line 499 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp14_ = g_error_new (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_BAD_PARAMETERS, "%s is not outbox EmailIdentifier", _tmp13_);
#line 499 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp15_ = _tmp14_;
#line 499 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_free0 (_tmp13_);
#line 499 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_inner_error_ = _tmp15_;
#line 499 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 499 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 499 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 499 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_it);
#line 499 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 499 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 7595 "smtp-outbox-folder.c"
			}
#line 501 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp16_ = stmt;
#line 501 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp17_ = geary_db_statement_reset (_tmp16_, GEARY_DB_RESET_SCOPE_CLEAR_BINDINGS, &_inner_error_);
#line 501 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp18_ = _tmp17_;
#line 501 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_tmp18_);
#line 501 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 501 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 501 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 501 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 501 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_it);
#line 501 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 501 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 7619 "smtp-outbox-folder.c"
			}
#line 502 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp19_ = stmt;
#line 502 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp20_ = outbox_id;
#line 502 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp21_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp20_);
#line 502 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp22_ = _tmp21_;
#line 502 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp23_ = geary_db_statement_bind_int64 (_tmp19_, 0, _tmp22_, &_inner_error_);
#line 502 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp24_ = _tmp23_;
#line 502 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_tmp24_);
#line 502 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 502 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 502 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 502 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 502 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_it);
#line 502 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 502 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 7649 "smtp-outbox-folder.c"
			}
#line 505 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp25_ = stmt;
#line 505 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp26_ = _data79_->cancellable;
#line 505 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp27_ = geary_db_statement_exec (_tmp25_, _tmp26_, &_inner_error_);
#line 505 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			results = _tmp27_;
#line 505 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 505 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 505 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 505 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 505 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_it);
#line 505 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 505 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 7673 "smtp-outbox-folder.c"
			}
#line 506 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp28_ = results;
#line 506 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp29_ = geary_db_result_get_finished (_tmp28_);
#line 506 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp30_ = _tmp29_;
#line 506 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!_tmp30_) {
#line 7683 "smtp-outbox-folder.c"
				GeeMap* _tmp31_ = NULL;
				GearySmtpOutboxEmailIdentifier* _tmp32_ = NULL;
#line 507 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp31_ = _data79_->map;
#line 507 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp32_ = outbox_id;
#line 507 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				gee_map_set (_tmp31_, G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier), (gpointer) ((gintptr) GEARY_EMAIL_FIELD_ALL));
#line 7692 "smtp-outbox-folder.c"
			}
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (results);
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (outbox_id);
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (id);
#line 7700 "smtp-outbox-folder.c"
		}
#line 496 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_id_it);
#line 7704 "smtp-outbox-folder.c"
	}
#line 510 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 510 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 510 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 7712 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome ___lambda102__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error) {
	GearyDbTransactionOutcome result;
	result = __lambda102_ (self, cx, error);
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 7721 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_list_local_email_fields_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	GearySmtpOutboxFolderListLocalEmailFieldsAsyncData* _data_;
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_list_local_email_fields_async_co (_data_);
#line 7735 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_real_list_local_email_fields_async_co (GearySmtpOutboxFolderListLocalEmailFieldsAsyncData* _data_) {
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 7744 "smtp-outbox-folder.c"
		goto _state_0;
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 7748 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 7753 "smtp-outbox-folder.c"
	}
	_state_0:
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data79_ = g_slice_new0 (Block79Data);
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data79_->_ref_count_ = 1;
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data79_->self = g_object_ref (_data_->self);
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = NULL;
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->ids;
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data79_->ids);
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data79_->ids = _data_->_tmp0_;
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = NULL;
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->cancellable;
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data79_->cancellable);
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data79_->cancellable = _data_->_tmp1_;
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data79_->_async_data_ = _data_;
#line 489 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_abstract_local_folder_check_open (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolder), &_data_->_inner_error_);
#line 489 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 489 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 489 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 489 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block79_data_unref (_data_->_data79_);
#line 489 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data79_ = NULL;
#line 489 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 489 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 7796 "smtp-outbox-folder.c"
		} else {
#line 489 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 7800 "smtp-outbox-folder.c"
		}
#line 489 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 489 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 7806 "smtp-outbox-folder.c"
	}
#line 491 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = NULL;
#line 491 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = gee_hash_map_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, g_object_unref, GEARY_EMAIL_TYPE_FIELD, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 491 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data79_->map = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEE_TYPE_MAP, GeeMap);
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = NULL;
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = _data_->self->priv->db;
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = NULL;
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = _data_->_data79_->cancellable;
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_RO, ___lambda102__geary_db_transaction_method, _data_->_data79_, _data_->_tmp4_, geary_smtp_outbox_folder_list_local_email_fields_async_ready, _data_);
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 7828 "smtp-outbox-folder.c"
	_state_1:
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block79_data_unref (_data_->_data79_);
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data79_ = NULL;
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 7846 "smtp-outbox-folder.c"
		} else {
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 7850 "smtp-outbox-folder.c"
		}
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 493 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 7856 "smtp-outbox-folder.c"
	}
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp6_ = NULL;
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp6_ = _data_->_data79_->map;
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp7_ = 0;
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp7_ = gee_map_get_size (_data_->_tmp6_);
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp8_ = 0;
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp8_ > 0) {
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp9_ = NULL;
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp9_ = _data_->_data79_->map;
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp5_ = _data_->_tmp9_;
#line 7878 "smtp-outbox-folder.c"
	} else {
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp5_ = NULL;
#line 7882 "smtp-outbox-folder.c"
	}
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp10_ = NULL;
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp10_ = _g_object_ref0 (_data_->_tmp5_);
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = _data_->_tmp10_;
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block79_data_unref (_data_->_data79_);
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data79_ = NULL;
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 7898 "smtp-outbox-folder.c"
	} else {
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 7902 "smtp-outbox-folder.c"
	}
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 513 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block79_data_unref (_data_->_data79_);
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data79_ = NULL;
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 7916 "smtp-outbox-folder.c"
	} else {
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 7920 "smtp-outbox-folder.c"
	}
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 486 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 7926 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_fetch_email_async_data_free (gpointer _data) {
	GearySmtpOutboxFolderFetchEmailAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->id);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->result);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderFetchEmailAsyncData, _data_);
#line 7941 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_fetch_email_async (GearyFolder* base, GearyEmailIdentifier* id, GearyEmailField required_fields, GearyFolderListFlags flags, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GearySmtpOutboxFolder * self;
	GearySmtpOutboxFolderFetchEmailAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_ = NULL;
	GearyEmailIdentifier* _tmp1_ = NULL;
	GearyEmailIdentifier* _tmp2_ = NULL;
	GearyEmailField _tmp3_ = 0;
	GearyFolderListFlags _tmp4_ = 0;
	GCancellable* _tmp5_ = NULL;
	GCancellable* _tmp6_ = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderFetchEmailAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, geary_smtp_outbox_folder_real_fetch_email_async);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, geary_smtp_outbox_folder_real_fetch_email_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = id;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->id);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->id = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = required_fields;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->required_fields = _tmp3_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = flags;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->flags = _tmp4_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = cancellable;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp6_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_fetch_email_async_co (_data_);
#line 7993 "smtp-outbox-folder.c"
}


static GearyEmail* geary_smtp_outbox_folder_real_fetch_email_finish (GearyFolder* base, GAsyncResult* _res_, GError** error) {
	GearyEmail* result;
	GearySmtpOutboxFolderFetchEmailAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 8004 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _data_->result;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 8014 "smtp-outbox-folder.c"
}


static Block80Data* block80_data_ref (Block80Data* _data80_) {
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data80_->_ref_count_);
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data80_;
#line 8023 "smtp-outbox-folder.c"
}


static void block80_data_unref (void * _userdata_) {
	Block80Data* _data80_;
	_data80_ = (Block80Data*) _userdata_;
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data80_->_ref_count_)) {
#line 8032 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data80_->self;
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_geary_smtp_outbox_folder_outbox_row_unref0 (_data80_->row);
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data80_->outbox_id);
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data80_->cancellable);
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block80Data, _data80_);
#line 8046 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome __lambda103_ (Block80Data* _data80_, GearyDbConnection* cx, GError** error) {
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	GearySmtpOutboxFolderOutboxRow* _tmp0_ = NULL;
	GearyDbConnection* _tmp1_ = NULL;
	GearySmtpOutboxEmailIdentifier* _tmp2_ = NULL;
	gint64 _tmp3_ = 0LL;
	gint64 _tmp4_ = 0LL;
	GCancellable* _tmp5_ = NULL;
	GearySmtpOutboxFolderOutboxRow* _tmp6_ = NULL;
	GearySmtpOutboxFolderOutboxRow* _tmp7_ = NULL;
	GError * _inner_error_ = NULL;
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data80_->self;
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 527 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = cx;
#line 527 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _data80_->outbox_id;
#line 527 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp2_);
#line 527 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _tmp3_;
#line 527 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = _data80_->cancellable;
#line 527 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = geary_smtp_outbox_folder_do_fetch_row_by_ordering (self, _tmp1_, _tmp4_, _tmp5_, &_inner_error_);
#line 527 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _tmp6_;
#line 527 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 527 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 527 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 8087 "smtp-outbox-folder.c"
	}
#line 527 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = _tmp0_;
#line 527 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = NULL;
#line 527 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_geary_smtp_outbox_folder_outbox_row_unref0 (_data80_->row);
#line 527 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data80_->row = _tmp7_;
#line 529 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 529 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_geary_smtp_outbox_folder_outbox_row_unref0 (_tmp0_);
#line 529 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 8103 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome ___lambda103__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error) {
	GearyDbTransactionOutcome result;
	result = __lambda103_ (self, cx, error);
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 8112 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_fetch_email_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	GearySmtpOutboxFolderFetchEmailAsyncData* _data_;
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_fetch_email_async_co (_data_);
#line 8126 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_real_fetch_email_async_co (GearySmtpOutboxFolderFetchEmailAsyncData* _data_) {
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 8135 "smtp-outbox-folder.c"
		goto _state_0;
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 8139 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 8144 "smtp-outbox-folder.c"
	}
	_state_0:
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data80_ = g_slice_new0 (Block80Data);
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data80_->_ref_count_ = 1;
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data80_->self = g_object_ref (_data_->self);
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = NULL;
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->cancellable;
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data80_->cancellable);
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data80_->cancellable = _data_->_tmp0_;
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data80_->_async_data_ = _data_;
#line 519 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_abstract_local_folder_check_open (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolder), &_data_->_inner_error_);
#line 519 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 519 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 519 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 519 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block80_data_unref (_data_->_data80_);
#line 519 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data80_ = NULL;
#line 519 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 519 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 8179 "smtp-outbox-folder.c"
		} else {
#line 519 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 8183 "smtp-outbox-folder.c"
		}
#line 519 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 519 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 8189 "smtp-outbox-folder.c"
	}
#line 521 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = NULL;
#line 521 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->id;
#line 521 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = NULL;
#line 521 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp1_, GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER) ? ((GearySmtpOutboxEmailIdentifier*) _data_->_tmp1_) : NULL);
#line 521 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data80_->outbox_id = _data_->_tmp2_;
#line 522 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = NULL;
#line 522 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = _data_->_data80_->outbox_id;
#line 522 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp3_ == NULL) {
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp4_ = NULL;
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp4_ = _data_->id;
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp5_ = NULL;
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp5_ = geary_email_identifier_to_string (_data_->_tmp4_);
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp6_ = NULL;
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp7_ = NULL;
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp7_ = g_error_new (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_BAD_PARAMETERS, "%s is not outbox EmailIdentifier", _data_->_tmp6_);
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp8_ = NULL;
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (_data_->_tmp6_);
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = _data_->_tmp8_;
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block80_data_unref (_data_->_data80_);
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data80_ = NULL;
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 8243 "smtp-outbox-folder.c"
		} else {
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 8247 "smtp-outbox-folder.c"
		}
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 523 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 8253 "smtp-outbox-folder.c"
	}
#line 525 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data80_->row = NULL;
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp9_ = NULL;
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp9_ = _data_->self->priv->db;
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp10_ = NULL;
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp10_ = _data_->_data80_->cancellable;
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp9_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_RO, ___lambda103__geary_db_transaction_method, _data_->_data80_, _data_->_tmp10_, geary_smtp_outbox_folder_fetch_email_async_ready, _data_);
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 8271 "smtp-outbox-folder.c"
	_state_1:
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp9_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block80_data_unref (_data_->_data80_);
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data80_ = NULL;
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 8289 "smtp-outbox-folder.c"
		} else {
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 8293 "smtp-outbox-folder.c"
		}
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 526 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 8299 "smtp-outbox-folder.c"
	}
#line 532 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp11_ = NULL;
#line 532 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp11_ = _data_->_data80_->row;
#line 532 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp11_ == NULL) {
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp12_ = NULL;
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp12_ = _data_->id;
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp13_ = NULL;
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp13_ = geary_email_identifier_to_string (_data_->_tmp12_);
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp14_ = NULL;
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp14_ = _data_->_tmp13_;
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp15_ = NULL;
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp15_ = g_error_new (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_NOT_FOUND, "No message with ID %s in outbox", _data_->_tmp14_);
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp16_ = NULL;
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp16_ = _data_->_tmp15_;
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (_data_->_tmp14_);
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = _data_->_tmp16_;
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block80_data_unref (_data_->_data80_);
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data80_ = NULL;
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 8343 "smtp-outbox-folder.c"
		} else {
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 8347 "smtp-outbox-folder.c"
		}
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 533 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 8353 "smtp-outbox-folder.c"
	}
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp18_ = NULL;
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp18_ = _data_->_data80_->row;
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp19_ = NULL;
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp19_ = geary_smtp_outbox_folder_row_to_email (_data_->self, _data_->_tmp18_, &_data_->_inner_error_);
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp17_ = _data_->_tmp19_;
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block80_data_unref (_data_->_data80_);
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data80_ = NULL;
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 8379 "smtp-outbox-folder.c"
		} else {
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 8383 "smtp-outbox-folder.c"
		}
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 8389 "smtp-outbox-folder.c"
	}
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp20_ = NULL;
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp20_ = _data_->_tmp17_;
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp17_ = NULL;
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = _data_->_tmp20_;
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_tmp17_);
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block80_data_unref (_data_->_data80_);
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data80_ = NULL;
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 8409 "smtp-outbox-folder.c"
	} else {
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 8413 "smtp-outbox-folder.c"
	}
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 535 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_tmp17_);
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block80_data_unref (_data_->_data80_);
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data80_ = NULL;
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 8429 "smtp-outbox-folder.c"
	} else {
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 8433 "smtp-outbox-folder.c"
	}
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 516 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 8439 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_mark_email_as_sent_async_data_free (gpointer _data) {
	GearySmtpOutboxFolderMarkEmailAsSentAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderMarkEmailAsSentAsyncData, _data_);
#line 8450 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_mark_email_as_sent_async (GearySmtpOutboxFolder* self, GearySmtpOutboxEmailIdentifier* outbox_id, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GearySmtpOutboxFolderMarkEmailAsSentAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_ = NULL;
	GearySmtpOutboxEmailIdentifier* _tmp1_ = NULL;
	GearySmtpOutboxEmailIdentifier* _tmp2_ = NULL;
	GCancellable* _tmp3_ = NULL;
	GCancellable* _tmp4_ = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderMarkEmailAsSentAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, geary_smtp_outbox_folder_mark_email_as_sent_async);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, geary_smtp_outbox_folder_mark_email_as_sent_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = outbox_id;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->outbox_id);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->outbox_id = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = cancellable;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp4_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_mark_email_as_sent_async_co (_data_);
#line 8489 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_mark_email_as_sent_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error) {
	GearySmtpOutboxFolderMarkEmailAsSentAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 8499 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 8503 "smtp-outbox-folder.c"
}


static Block81Data* block81_data_ref (Block81Data* _data81_) {
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data81_->_ref_count_);
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data81_;
#line 8512 "smtp-outbox-folder.c"
}


static void block81_data_unref (void * _userdata_) {
	Block81Data* _data81_;
	_data81_ = (Block81Data*) _userdata_;
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data81_->_ref_count_)) {
#line 8521 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data81_->self;
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data81_->outbox_id);
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data81_->cancellable);
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block81Data, _data81_);
#line 8533 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome __lambda94_ (Block81Data* _data81_, GearyDbConnection* cx, GError** error) {
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	GearyDbConnection* _tmp0_ = NULL;
	GearySmtpOutboxEmailIdentifier* _tmp1_ = NULL;
	GCancellable* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data81_->self;
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 541 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = cx;
#line 541 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _data81_->outbox_id;
#line 541 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _data81_->cancellable;
#line 541 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_do_mark_email_as_sent (self, _tmp0_, _tmp1_, _tmp2_, &_inner_error_);
#line 541 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 541 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 541 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 8563 "smtp-outbox-folder.c"
	}
#line 543 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_COMMIT;
#line 543 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 8569 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome ___lambda94__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error) {
	GearyDbTransactionOutcome result;
	result = __lambda94_ (self, cx, error);
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 8578 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_mark_email_as_sent_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	GearySmtpOutboxFolderMarkEmailAsSentAsyncData* _data_;
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_mark_email_as_sent_async_co (_data_);
#line 8592 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_mark_email_as_sent_async_co (GearySmtpOutboxFolderMarkEmailAsSentAsyncData* _data_) {
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 8601 "smtp-outbox-folder.c"
		goto _state_0;
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 8605 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 8610 "smtp-outbox-folder.c"
	}
	_state_0:
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data81_ = g_slice_new0 (Block81Data);
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data81_->_ref_count_ = 1;
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data81_->self = g_object_ref (_data_->self);
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = NULL;
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->outbox_id;
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data81_->outbox_id);
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data81_->outbox_id = _data_->_tmp0_;
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = NULL;
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->cancellable;
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data81_->cancellable);
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data81_->cancellable = _data_->_tmp1_;
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data81_->_async_data_ = _data_;
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = NULL;
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = _data_->self->priv->db;
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = NULL;
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = _data_->_data81_->cancellable;
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_WR, ___lambda94__geary_db_transaction_method, _data_->_data81_, _data_->_tmp3_, geary_smtp_outbox_folder_mark_email_as_sent_async_ready, _data_);
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 8651 "smtp-outbox-folder.c"
	_state_1:
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block81_data_unref (_data_->_data81_);
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data81_ = NULL;
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 8669 "smtp-outbox-folder.c"
		} else {
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 8673 "smtp-outbox-folder.c"
		}
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 540 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 8679 "smtp-outbox-folder.c"
	}
#line 546 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = NULL;
#line 546 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = geary_email_flags_new ();
#line 546 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->flags = _data_->_tmp4_;
#line 547 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp5_ = NULL;
#line 547 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp5_ = _data_->flags;
#line 547 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp6_ = NULL;
#line 547 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp6_ = geary_email_flags_get_OUTBOX_SENT ();
#line 547 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp7_ = NULL;
#line 547 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 547 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp8_ = NULL;
#line 547 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 547 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_named_flags_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp5_, GEARY_TYPE_NAMED_FLAGS, GearyNamedFlags), _data_->_tmp8_);
#line 547 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_tmp8_);
#line 549 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp9_ = NULL;
#line 549 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp9_ = gee_hash_map_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, g_object_unref, GEARY_TYPE_EMAIL_FLAGS, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 549 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->changed_map = _data_->_tmp9_;
#line 551 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp10_ = NULL;
#line 551 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp10_ = _data_->changed_map;
#line 551 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp11_ = NULL;
#line 551 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp11_ = _data_->_data81_->outbox_id;
#line 551 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp12_ = NULL;
#line 551 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp12_ = _data_->flags;
#line 551 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp10_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp11_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier), _data_->_tmp12_);
#line 552 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp13_ = NULL;
#line 552 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp13_ = _data_->changed_map;
#line 552 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_folder_notify_email_flags_changed (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_FOLDER, GearyFolder), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp13_, GEE_TYPE_MAP, GeeMap));
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->changed_map);
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->flags);
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block81_data_unref (_data_->_data81_);
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data81_ = NULL;
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 8745 "smtp-outbox-folder.c"
	} else {
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 8749 "smtp-outbox-folder.c"
	}
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 538 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 8755 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_remove_email_async_data_free (gpointer _data) {
	GearySmtpOutboxFolderRemoveEmailAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->email_ids);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderRemoveEmailAsyncData, _data_);
#line 8770 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_remove_email_async (GearySmtpOutboxFolder* self, GeeList* email_ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GearySmtpOutboxFolderRemoveEmailAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_ = NULL;
	GeeList* _tmp1_ = NULL;
	GeeList* _tmp2_ = NULL;
	GCancellable* _tmp3_ = NULL;
	GCancellable* _tmp4_ = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderRemoveEmailAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, geary_smtp_outbox_folder_real_remove_email_async);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, geary_smtp_outbox_folder_real_remove_email_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = email_ids;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->email_ids);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->email_ids = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = cancellable;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp4_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_remove_email_async_co (_data_);
#line 8809 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_remove_email_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error) {
	GearySmtpOutboxFolderRemoveEmailAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 8819 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 8823 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_remove_email_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	GearySmtpOutboxFolderRemoveEmailAsyncData* _data_;
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_remove_email_async_co (_data_);
#line 8837 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_real_remove_email_async_co (GearySmtpOutboxFolderRemoveEmailAsyncData* _data_) {
#line 555 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 555 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 8846 "smtp-outbox-folder.c"
		goto _state_0;
#line 555 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 8850 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 555 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 8855 "smtp-outbox-folder.c"
	}
	_state_0:
#line 557 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_abstract_local_folder_check_open (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, GearyAbstractLocalFolder), &_data_->_inner_error_);
#line 557 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 557 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 557 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 557 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 557 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 8870 "smtp-outbox-folder.c"
		} else {
#line 557 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 8874 "smtp-outbox-folder.c"
		}
#line 557 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 557 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 8880 "smtp-outbox-folder.c"
	}
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = NULL;
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->email_ids;
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = NULL;
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->cancellable;
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_internal_remove_email_async (_data_->self, _data_->_tmp0_, _data_->_tmp1_, geary_smtp_outbox_folder_remove_email_async_ready, _data_);
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 8896 "smtp-outbox-folder.c"
	_state_1:
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_internal_remove_email_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 8910 "smtp-outbox-folder.c"
		} else {
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 8914 "smtp-outbox-folder.c"
		}
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 559 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 8920 "smtp-outbox-folder.c"
	}
#line 555 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 555 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 8926 "smtp-outbox-folder.c"
	} else {
#line 555 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 8930 "smtp-outbox-folder.c"
	}
#line 555 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 555 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 8936 "smtp-outbox-folder.c"
}


void geary_smtp_outbox_folder_remove_email_async (GearySmtpOutboxFolder* self, GeeList* email_ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	GEARY_SMTP_OUTBOX_FOLDER_GET_CLASS (self)->remove_email_async (self, email_ids, cancellable, _callback_, _user_data_);
#line 8943 "smtp-outbox-folder.c"
}


void geary_smtp_outbox_folder_remove_email_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	GEARY_SMTP_OUTBOX_FOLDER_GET_CLASS (self)->remove_email_finish (self, _res_, error);
#line 8950 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_internal_remove_email_async_data_free (gpointer _data) {
	GearySmtpOutboxFolderInternalRemoveEmailAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderInternalRemoveEmailAsyncData, _data_);
#line 8961 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_internal_remove_email_async (GearySmtpOutboxFolder* self, GeeList* email_ids, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GearySmtpOutboxFolderInternalRemoveEmailAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_ = NULL;
	GeeList* _tmp1_ = NULL;
	GeeList* _tmp2_ = NULL;
	GCancellable* _tmp3_ = NULL;
	GCancellable* _tmp4_ = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderInternalRemoveEmailAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, geary_smtp_outbox_folder_internal_remove_email_async);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, geary_smtp_outbox_folder_internal_remove_email_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = email_ids;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->email_ids);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->email_ids = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = cancellable;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp4_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_internal_remove_email_async_co (_data_);
#line 9000 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_internal_remove_email_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error) {
	gboolean result;
	GearySmtpOutboxFolderInternalRemoveEmailAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 9011 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _data_->result;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 9019 "smtp-outbox-folder.c"
}


static Block82Data* block82_data_ref (Block82Data* _data82_) {
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data82_->_ref_count_);
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data82_;
#line 9028 "smtp-outbox-folder.c"
}


static void block82_data_unref (void * _userdata_) {
	Block82Data* _data82_;
	_data82_ = (Block82Data*) _userdata_;
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data82_->_ref_count_)) {
#line 9037 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data82_->self;
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data82_->removed);
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data82_->email_ids);
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data82_->cancellable);
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block82Data, _data82_);
#line 9051 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome __lambda95_ (Block82Data* _data82_, GearyDbConnection* cx, GError** error) {
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	gint _tmp22_ = 0;
	GearyDbConnection* _tmp23_ = NULL;
	GCancellable* _tmp24_ = NULL;
	gint _tmp25_ = 0;
	GError * _inner_error_ = NULL;
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data82_->self;
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 9068 "smtp-outbox-folder.c"
	{
		GeeList* _id_list = NULL;
		GeeList* _tmp0_ = NULL;
		GeeList* _tmp1_ = NULL;
		gint _id_size = 0;
		GeeList* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gint _id_index = 0;
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = _data82_->email_ids;
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_id_list = _tmp1_;
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp2_ = _id_list;
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp3_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp4_ = _tmp3_;
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_id_size = _tmp4_;
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_id_index = -1;
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		while (TRUE) {
#line 9096 "smtp-outbox-folder.c"
			gint _tmp5_ = 0;
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			GearyEmailIdentifier* id = NULL;
			GeeList* _tmp8_ = NULL;
			gint _tmp9_ = 0;
			gpointer _tmp10_ = NULL;
			GearySmtpOutboxEmailIdentifier* outbox_id = NULL;
			GearyEmailIdentifier* _tmp11_ = NULL;
			GearySmtpOutboxEmailIdentifier* _tmp12_ = NULL;
			GearySmtpOutboxEmailIdentifier* _tmp13_ = NULL;
			GearyDbConnection* _tmp14_ = NULL;
			GCancellable* _tmp15_ = NULL;
			gboolean _tmp16_ = FALSE;
			GearyDbConnection* _tmp17_ = NULL;
			GearySmtpOutboxEmailIdentifier* _tmp18_ = NULL;
			GCancellable* _tmp19_ = NULL;
			gboolean _tmp20_ = FALSE;
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp5_ = _id_index;
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_id_index = _tmp5_ + 1;
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp6_ = _id_index;
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp7_ = _id_size;
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				break;
#line 9127 "smtp-outbox-folder.c"
			}
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp8_ = _id_list;
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp9_ = _id_index;
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp10_ = gee_list_get (_tmp8_, _tmp9_);
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			id = (GearyEmailIdentifier*) _tmp10_;
#line 571 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp11_ = id;
#line 571 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, GEARY_TYPE_SMTP_OUTBOX_EMAIL_IDENTIFIER) ? ((GearySmtpOutboxEmailIdentifier*) _tmp11_) : NULL);
#line 571 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			outbox_id = _tmp12_;
#line 572 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp13_ = outbox_id;
#line 572 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp13_ == NULL) {
#line 573 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 573 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 573 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				continue;
#line 9153 "smtp-outbox-folder.c"
			}
#line 578 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp14_ = cx;
#line 578 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp15_ = _data82_->cancellable;
#line 578 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			geary_smtp_outbox_folder_do_get_next_ordering (self, _tmp14_, _tmp15_, &_inner_error_);
#line 578 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 578 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 578 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 578 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 578 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_list);
#line 578 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 9173 "smtp-outbox-folder.c"
			}
#line 580 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp17_ = cx;
#line 580 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp18_ = outbox_id;
#line 580 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp19_ = _data82_->cancellable;
#line 580 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp20_ = geary_smtp_outbox_folder_do_remove_email (self, _tmp17_, _tmp18_, _tmp19_, &_inner_error_);
#line 580 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp16_ = _tmp20_;
#line 580 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 580 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_propagate_error (error, _inner_error_);
#line 580 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (outbox_id);
#line 580 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (id);
#line 580 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_id_list);
#line 580 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return 0;
#line 9197 "smtp-outbox-folder.c"
			}
#line 580 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp16_) {
#line 9201 "smtp-outbox-folder.c"
				GearySmtpOutboxEmailIdentifier* _tmp21_ = NULL;
#line 581 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp21_ = outbox_id;
#line 581 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data82_->removed, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier));
#line 9207 "smtp-outbox-folder.c"
			}
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (outbox_id);
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (id);
#line 9213 "smtp-outbox-folder.c"
		}
#line 568 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_id_list);
#line 9217 "smtp-outbox-folder.c"
	}
#line 584 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp23_ = cx;
#line 584 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp24_ = _data82_->cancellable;
#line 584 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp25_ = geary_smtp_outbox_folder_do_get_email_count (self, _tmp23_, _tmp24_, &_inner_error_);
#line 584 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp22_ = _tmp25_;
#line 584 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 584 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 584 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 9233 "smtp-outbox-folder.c"
	}
#line 584 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data82_->final_count = _tmp22_;
#line 586 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_COMMIT;
#line 586 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 9241 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome ___lambda95__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error) {
	GearyDbTransactionOutcome result;
	result = __lambda95_ (self, cx, error);
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 9250 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_internal_remove_email_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	GearySmtpOutboxFolderInternalRemoveEmailAsyncData* _data_;
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_internal_remove_email_async_co (_data_);
#line 9264 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_internal_remove_email_async_co (GearySmtpOutboxFolderInternalRemoveEmailAsyncData* _data_) {
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 9273 "smtp-outbox-folder.c"
		goto _state_0;
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 9277 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 9282 "smtp-outbox-folder.c"
	}
	_state_0:
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data82_ = g_slice_new0 (Block82Data);
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data82_->_ref_count_ = 1;
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data82_->self = g_object_ref (_data_->self);
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = NULL;
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->email_ids;
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data82_->email_ids);
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data82_->email_ids = _data_->_tmp0_;
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = NULL;
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->cancellable;
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data82_->cancellable);
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data82_->cancellable = _data_->_tmp1_;
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data82_->_async_data_ = _data_;
#line 565 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = NULL;
#line 565 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = gee_array_list_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 565 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data82_->removed = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEE_TYPE_LIST, GeeList);
#line 566 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data82_->final_count = 0;
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = NULL;
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = _data_->self->priv->db;
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = NULL;
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = _data_->_data82_->cancellable;
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_WR, ___lambda95__geary_db_transaction_method, _data_->_data82_, _data_->_tmp4_, geary_smtp_outbox_folder_internal_remove_email_async_ready, _data_);
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 9331 "smtp-outbox-folder.c"
	_state_1:
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block82_data_unref (_data_->_data82_);
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data82_ = NULL;
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 9349 "smtp-outbox-folder.c"
		} else {
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 9353 "smtp-outbox-folder.c"
		}
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 567 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 9359 "smtp-outbox-folder.c"
	}
#line 589 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp5_ = 0;
#line 589 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp5_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_data82_->removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 589 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp6_ = 0;
#line 589 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 589 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp6_ == 0) {
#line 590 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->result = FALSE;
#line 590 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block82_data_unref (_data_->_data82_);
#line 590 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data82_ = NULL;
#line 590 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 590 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 9381 "smtp-outbox-folder.c"
		} else {
#line 590 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 9385 "smtp-outbox-folder.c"
		}
#line 590 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 590 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 9391 "smtp-outbox-folder.c"
	}
#line 592 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp7_ = NULL;
#line 592 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp7_ = _data_->self->priv->_properties;
#line 592 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_properties_set_total (_data_->_tmp7_, _data_->_data82_->final_count);
#line 594 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_folder_notify_email_removed (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_FOLDER, GearyFolder), G_TYPE_CHECK_INSTANCE_CAST (_data_->_data82_->removed, GEE_TYPE_COLLECTION, GeeCollection));
#line 595 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_folder_notify_email_count_changed (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, GEARY_TYPE_FOLDER, GearyFolder), _data_->_data82_->final_count, GEARY_FOLDER_COUNT_CHANGE_REASON_REMOVED);
#line 597 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = TRUE;
#line 597 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block82_data_unref (_data_->_data82_);
#line 597 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data82_ = NULL;
#line 597 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 597 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 9413 "smtp-outbox-folder.c"
	} else {
#line 597 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 9417 "smtp-outbox-folder.c"
	}
#line 597 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 597 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block82_data_unref (_data_->_data82_);
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data82_ = NULL;
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 9431 "smtp-outbox-folder.c"
	} else {
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 9435 "smtp-outbox-folder.c"
	}
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 563 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 9441 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_remove_single_email_async_data_free (gpointer _data) {
	GearySmtpOutboxFolderRemoveSingleEmailAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->id);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderRemoveSingleEmailAsyncData, _data_);
#line 9456 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_remove_single_email_async (GearySmtpOutboxFolder* self, GearyEmailIdentifier* id, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GearySmtpOutboxFolderRemoveSingleEmailAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_ = NULL;
	GearyEmailIdentifier* _tmp1_ = NULL;
	GearyEmailIdentifier* _tmp2_ = NULL;
	GCancellable* _tmp3_ = NULL;
	GCancellable* _tmp4_ = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderRemoveSingleEmailAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, geary_smtp_outbox_folder_real_remove_single_email_async);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, geary_smtp_outbox_folder_real_remove_single_email_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = id;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->id);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->id = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = cancellable;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp4_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_remove_single_email_async_co (_data_);
#line 9495 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_real_remove_single_email_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error) {
	GearySmtpOutboxFolderRemoveSingleEmailAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 9505 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 9509 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_remove_single_email_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	GearySmtpOutboxFolderRemoveSingleEmailAsyncData* _data_;
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_real_remove_single_email_async_co (_data_);
#line 9523 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_real_remove_single_email_async_co (GearySmtpOutboxFolderRemoveSingleEmailAsyncData* _data_) {
#line 600 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 600 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 9532 "smtp-outbox-folder.c"
		goto _state_0;
#line 600 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 9536 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 600 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 9541 "smtp-outbox-folder.c"
	}
	_state_0:
#line 602 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = NULL;
#line 602 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = gee_array_list_new (GEARY_TYPE_EMAIL_IDENTIFIER, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 602 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->list = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEE_TYPE_LIST, GeeList);
#line 603 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = NULL;
#line 603 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->id;
#line 603 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->list, GEE_TYPE_COLLECTION, GeeCollection), _data_->_tmp1_);
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = NULL;
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = _data_->cancellable;
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_remove_email_async (_data_->self, _data_->list, _data_->_tmp2_, geary_smtp_outbox_folder_remove_single_email_async_ready, _data_);
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 9566 "smtp-outbox-folder.c"
	_state_1:
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_remove_email_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data_->list);
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 9582 "smtp-outbox-folder.c"
		} else {
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 9586 "smtp-outbox-folder.c"
		}
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 605 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 9592 "smtp-outbox-folder.c"
	}
#line 600 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->list);
#line 600 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 600 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 9600 "smtp-outbox-folder.c"
	} else {
#line 600 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 9604 "smtp-outbox-folder.c"
	}
#line 600 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 600 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 9610 "smtp-outbox-folder.c"
}


void geary_smtp_outbox_folder_remove_single_email_async (GearySmtpOutboxFolder* self, GearyEmailIdentifier* id, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	GEARY_SMTP_OUTBOX_FOLDER_GET_CLASS (self)->remove_single_email_async (self, id, cancellable, _callback_, _user_data_);
#line 9617 "smtp-outbox-folder.c"
}


void geary_smtp_outbox_folder_remove_single_email_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	GEARY_SMTP_OUTBOX_FOLDER_GET_CLASS (self)->remove_single_email_finish (self, _res_, error);
#line 9624 "smtp-outbox-folder.c"
}


static GearyEmail* geary_smtp_outbox_folder_row_to_email (GearySmtpOutboxFolder* self, GearySmtpOutboxFolderOutboxRow* row, GError** error) {
	GearyEmail* result = NULL;
	GearyRFC822Message* message = NULL;
	GearySmtpOutboxFolderOutboxRow* _tmp0_ = NULL;
	GearyMemoryBuffer* _tmp1_ = NULL;
	GearyRFC822Message* _tmp2_ = NULL;
	GearyEmail* email = NULL;
	GearyRFC822Message* _tmp3_ = NULL;
	GearySmtpOutboxFolderOutboxRow* _tmp4_ = NULL;
	GearySmtpOutboxEmailIdentifier* _tmp5_ = NULL;
	GearyEmail* _tmp6_ = NULL;
	GearyEmail* _tmp7_ = NULL;
	GDateTime* _tmp8_ = NULL;
	GDateTime* _tmp9_ = NULL;
	GearySmtpOutboxEmailProperties* _tmp10_ = NULL;
	GearySmtpOutboxEmailProperties* _tmp11_ = NULL;
	GearyEmailFlags* flags = NULL;
	GearyEmailFlags* _tmp12_ = NULL;
	GearySmtpOutboxFolderOutboxRow* _tmp13_ = NULL;
	gboolean _tmp14_ = FALSE;
	GearyEmail* _tmp19_ = NULL;
	GearyEmailFlags* _tmp20_ = NULL;
	GError * _inner_error_ = NULL;
#line 609 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_SMTP_OUTBOX_FOLDER (self), NULL);
#line 609 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_SMTP_OUTBOX_FOLDER_IS_OUTBOX_ROW (row), NULL);
#line 610 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = row;
#line 610 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = _tmp0_->message;
#line 610 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = geary_rf_c822_message_new_from_buffer (_tmp1_, &_inner_error_);
#line 610 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	message = _tmp2_;
#line 610 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 610 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 610 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 9669 "smtp-outbox-folder.c"
	}
#line 612 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = message;
#line 612 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = row;
#line 612 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = _tmp4_->outbox_id;
#line 612 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = geary_rf_c822_message_get_email (_tmp3_, G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEARY_TYPE_EMAIL_IDENTIFIER, GearyEmailIdentifier), &_inner_error_);
#line 612 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	email = _tmp6_;
#line 612 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 612 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 612 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (message);
#line 612 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 9689 "smtp-outbox-folder.c"
	}
#line 614 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = email;
#line 614 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = g_date_time_new_now_local ();
#line 614 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp9_ = _tmp8_;
#line 614 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp10_ = geary_smtp_outbox_email_properties_new (_tmp9_, (glong) -1);
#line 614 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp11_ = _tmp10_;
#line 614 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_email_set_email_properties (_tmp7_, G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEARY_TYPE_EMAIL_PROPERTIES, GearyEmailProperties));
#line 614 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp11_);
#line 614 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_date_time_unref0 (_tmp9_);
#line 615 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp12_ = geary_email_flags_new ();
#line 615 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	flags = _tmp12_;
#line 616 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp13_ = row;
#line 616 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp14_ = _tmp13_->sent;
#line 616 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp14_) {
#line 9717 "smtp-outbox-folder.c"
		GearyEmailFlags* _tmp15_ = NULL;
		GearyNamedFlag* _tmp16_ = NULL;
		GearyNamedFlag* _tmp17_ = NULL;
		GearyNamedFlag* _tmp18_ = NULL;
#line 617 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp15_ = flags;
#line 617 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp16_ = geary_email_flags_get_OUTBOX_SENT ();
#line 617 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp17_ = _tmp16_;
#line 617 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp18_ = _tmp17_;
#line 617 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_named_flags_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEARY_TYPE_NAMED_FLAGS, GearyNamedFlags), _tmp18_);
#line 617 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_tmp18_);
#line 9734 "smtp-outbox-folder.c"
	}
#line 618 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp19_ = email;
#line 618 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp20_ = flags;
#line 618 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_email_set_flags (_tmp19_, _tmp20_);
#line 620 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = email;
#line 620 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (flags);
#line 620 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (message);
#line 620 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 9750 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_send_email_async_data_free (gpointer _data) {
	GearySmtpOutboxFolderSendEmailAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->rfc822);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderSendEmailAsyncData, _data_);
#line 9765 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_send_email_async (GearySmtpOutboxFolder* self, GearyRFC822Message* rfc822, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GearySmtpOutboxFolderSendEmailAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_ = NULL;
	GearyRFC822Message* _tmp1_ = NULL;
	GearyRFC822Message* _tmp2_ = NULL;
	GCancellable* _tmp3_ = NULL;
	GCancellable* _tmp4_ = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderSendEmailAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, geary_smtp_outbox_folder_send_email_async);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, geary_smtp_outbox_folder_send_email_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = rfc822;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->rfc822);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->rfc822 = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = cancellable;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp4_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_send_email_async_co (_data_);
#line 9804 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_send_email_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error) {
	GearySmtpOutboxFolderSendEmailAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 9814 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 9818 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_send_email_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	GearySmtpOutboxFolderSendEmailAsyncData* _data_;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_send_email_async_co (_data_);
#line 9832 "smtp-outbox-folder.c"
}


static gpointer _g_error_copy0 (gpointer self) {
#line 632 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return self ? g_error_copy (self) : NULL;
#line 9839 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_send_email_async_co (GearySmtpOutboxFolderSendEmailAsyncData* _data_) {
#line 623 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 623 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 9848 "smtp-outbox-folder.c"
		goto _state_0;
#line 623 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 9852 "smtp-outbox-folder.c"
		goto _state_1;
#line 623 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 2:
#line 9856 "smtp-outbox-folder.c"
		goto _state_2;
#line 623 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 3:
#line 9860 "smtp-outbox-folder.c"
		goto _state_3;
		default:
#line 623 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 9865 "smtp-outbox-folder.c"
	}
	_state_0:
#line 625 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = NULL;
#line 625 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->self->priv->sending_monitor;
#line 625 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_progress_monitor_notify_start (_data_->_tmp0_);
#line 627 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->smtp_err = NULL;
#line 9876 "smtp-outbox-folder.c"
	{
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp1_ = NULL;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp1_ = _data_->self->priv->smtp;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp2_ = NULL;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp2_ = _data_->self->priv->_account;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp3_ = NULL;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp3_ = geary_account_get_information (_data_->_tmp2_);
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp4_ = NULL;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp5_ = NULL;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp5_ = geary_account_information_get_smtp_credentials (_data_->_tmp4_);
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp6_ = NULL;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp7_ = NULL;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp7_ = _data_->cancellable;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_state_ = 1;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_smtp_client_session_login_async (_data_->_tmp1_, _data_->_tmp6_, _data_->_tmp7_, geary_smtp_outbox_folder_send_email_async_ready, _data_);
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 9912 "smtp-outbox-folder.c"
		_state_1:
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp8_ = NULL;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp8_ = geary_smtp_client_session_login_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error_);
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp9_ = NULL;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_geary_smtp_response_unref0 (_data_->_tmp9_);
#line 629 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 9926 "smtp-outbox-folder.c"
			goto __catch198_g_error;
		}
	}
	goto __finally198;
	__catch198_g_error:
	{
#line 628 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->login_err = _data_->_inner_error_;
#line 628 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = NULL;
#line 631 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp10_ = NULL;
#line 631 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp10_ = _data_->login_err;
#line 631 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp11_ = NULL;
#line 631 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp11_ = _data_->_tmp10_->message;
#line 631 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_debug ("smtp-outbox-folder.vala:631: SMTP login error: %s", _data_->_tmp11_);
#line 632 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp12_ = NULL;
#line 632 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp12_ = _data_->login_err;
#line 632 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp13_ = NULL;
#line 632 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp13_ = _g_error_copy0 (_data_->_tmp12_);
#line 632 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_error_free0 (_data_->smtp_err);
#line 632 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->smtp_err = _data_->_tmp13_;
#line 628 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_error_free0 (_data_->login_err);
#line 9961 "smtp-outbox-folder.c"
	}
	__finally198:
#line 628 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 628 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 628 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 628 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_error_free0 (_data_->smtp_err);
#line 628 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 628 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 9976 "smtp-outbox-folder.c"
		} else {
#line 628 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 9980 "smtp-outbox-folder.c"
		}
#line 628 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 628 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 9986 "smtp-outbox-folder.c"
	}
#line 635 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp14_ = NULL;
#line 635 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp14_ = _data_->smtp_err;
#line 635 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp14_ == NULL) {
#line 9994 "smtp-outbox-folder.c"
		{
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp15_ = NULL;
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp15_ = _data_->self->priv->smtp;
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp16_ = NULL;
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp16_ = _data_->self->priv->_account;
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp17_ = NULL;
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp17_ = geary_account_get_information (_data_->_tmp16_);
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp18_ = NULL;
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp18_ = _data_->_tmp17_;
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp19_ = NULL;
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp19_ = geary_account_information_get_primary_mailbox_address (_data_->_tmp18_);
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp20_ = NULL;
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp20_ = _data_->_tmp19_;
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp21_ = NULL;
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp21_ = _data_->rfc822;
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp22_ = NULL;
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp22_ = _data_->cancellable;
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_state_ = 2;
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			geary_smtp_client_session_send_email_async (_data_->_tmp15_, _data_->_tmp20_, _data_->_tmp21_, _data_->_tmp22_, geary_smtp_outbox_folder_send_email_async_ready, _data_);
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return FALSE;
#line 10034 "smtp-outbox-folder.c"
			_state_2:
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			geary_smtp_client_session_send_email_finish (_data_->_tmp15_, _data_->_res_, &_data_->_inner_error_);
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (_data_->_tmp20_);
#line 637 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 10042 "smtp-outbox-folder.c"
				goto __catch199_g_error;
			}
		}
		goto __finally199;
		__catch199_g_error:
		{
#line 636 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->send_err = _data_->_inner_error_;
#line 636 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_inner_error_ = NULL;
#line 640 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp23_ = NULL;
#line 640 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp23_ = _data_->send_err;
#line 640 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp24_ = NULL;
#line 640 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp24_ = _data_->_tmp23_->message;
#line 640 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_debug ("smtp-outbox-folder.vala:640: SMTP send mail error: %s", _data_->_tmp24_);
#line 641 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp25_ = NULL;
#line 641 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp25_ = _data_->send_err;
#line 641 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp26_ = NULL;
#line 641 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->_tmp26_ = _g_error_copy0 (_data_->_tmp25_);
#line 641 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_error_free0 (_data_->smtp_err);
#line 641 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_data_->smtp_err = _data_->_tmp26_;
#line 636 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_error_free0 (_data_->send_err);
#line 10077 "smtp-outbox-folder.c"
		}
		__finally199:
#line 636 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 636 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 636 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_error_free (_data_->_inner_error_);
#line 636 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_error_free0 (_data_->smtp_err);
#line 636 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_data_->_state_ == 0) {
#line 636 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 10092 "smtp-outbox-folder.c"
			} else {
#line 636 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_simple_async_result_complete (_data_->_async_result);
#line 10096 "smtp-outbox-folder.c"
			}
#line 636 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_object_unref (_data_->_async_result);
#line 636 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return FALSE;
#line 10102 "smtp-outbox-folder.c"
		}
	}
	{
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp27_ = NULL;
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp27_ = _data_->self->priv->smtp;
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp28_ = NULL;
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp28_ = _data_->cancellable;
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_state_ = 3;
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_smtp_client_session_logout_async (_data_->_tmp27_, FALSE, _data_->_tmp28_, geary_smtp_outbox_folder_send_email_async_ready, _data_);
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10120 "smtp-outbox-folder.c"
		_state_3:
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp29_ = NULL;
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp29_ = geary_smtp_client_session_logout_finish (_data_->_tmp27_, _data_->_res_, &_data_->_inner_error_);
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp30_ = NULL;
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp30_ = _data_->_tmp29_;
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_geary_smtp_response_unref0 (_data_->_tmp30_);
#line 647 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 10134 "smtp-outbox-folder.c"
			goto __catch200_g_error;
		}
	}
	goto __finally200;
	__catch200_g_error:
	{
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->err = _data_->_inner_error_;
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = NULL;
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp31_ = NULL;
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp31_ = _data_->self->priv->smtp;
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp32_ = NULL;
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp32_ = geary_smtp_client_session_to_string (_data_->_tmp31_);
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp33_ = NULL;
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp33_ = _data_->_tmp32_;
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp34_ = NULL;
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp34_ = _data_->err;
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp35_ = NULL;
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp35_ = _data_->_tmp34_->message;
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_debug ("smtp-outbox-folder.vala:649: Unable to disconnect from SMTP server %s:" \
" %s", _data_->_tmp33_, _data_->_tmp35_);
#line 649 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_free0 (_data_->_tmp33_);
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_error_free0 (_data_->err);
#line 10171 "smtp-outbox-folder.c"
	}
	__finally200:
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_error_free0 (_data_->smtp_err);
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 10186 "smtp-outbox-folder.c"
		} else {
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 10190 "smtp-outbox-folder.c"
		}
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 646 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10196 "smtp-outbox-folder.c"
	}
#line 652 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp36_ = NULL;
#line 652 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp36_ = _data_->self->priv->sending_monitor;
#line 652 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_progress_monitor_notify_finish (_data_->_tmp36_);
#line 654 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp37_ = NULL;
#line 654 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp37_ = _data_->smtp_err;
#line 654 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp37_ != NULL) {
#line 655 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp38_ = NULL;
#line 655 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp38_ = _data_->smtp_err;
#line 655 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp39_ = NULL;
#line 655 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp39_ = _g_error_copy0 (_data_->_tmp38_);
#line 655 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = _data_->_tmp39_;
#line 655 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 655 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 655 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_error_free0 (_data_->smtp_err);
#line 655 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 655 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 10230 "smtp-outbox-folder.c"
		} else {
#line 655 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 10234 "smtp-outbox-folder.c"
		}
#line 655 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 655 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10240 "smtp-outbox-folder.c"
	}
#line 657 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp40_ = NULL;
#line 657 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp40_ = _data_->rfc822;
#line 657 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_signal_emit_by_name (_data_->self, "email-sent", _data_->_tmp40_);
#line 623 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_error_free0 (_data_->smtp_err);
#line 623 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 623 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 10254 "smtp-outbox-folder.c"
	} else {
#line 623 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 10258 "smtp-outbox-folder.c"
	}
#line 623 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 623 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 10264 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_save_sent_mail_async_data_free (gpointer _data) {
	GearySmtpOutboxFolderSaveSentMailAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->rfc822);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderSaveSentMailAsyncData, _data_);
#line 10279 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_save_sent_mail_async (GearySmtpOutboxFolder* self, GearyRFC822Message* rfc822, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GearySmtpOutboxFolderSaveSentMailAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_ = NULL;
	GearyRFC822Message* _tmp1_ = NULL;
	GearyRFC822Message* _tmp2_ = NULL;
	GCancellable* _tmp3_ = NULL;
	GCancellable* _tmp4_ = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderSaveSentMailAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, geary_smtp_outbox_folder_save_sent_mail_async);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, geary_smtp_outbox_folder_save_sent_mail_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = rfc822;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->rfc822);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->rfc822 = _tmp2_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = cancellable;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp4_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_save_sent_mail_async_co (_data_);
#line 10318 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_save_sent_mail_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error) {
	GearySmtpOutboxFolderSaveSentMailAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 10328 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 10332 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_save_sent_mail_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	GearySmtpOutboxFolderSaveSentMailAsyncData* _data_;
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_save_sent_mail_async_co (_data_);
#line 10346 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_save_sent_mail_async_co (GearySmtpOutboxFolderSaveSentMailAsyncData* _data_) {
#line 660 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 660 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 10355 "smtp-outbox-folder.c"
		goto _state_0;
#line 660 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 10359 "smtp-outbox-folder.c"
		goto _state_1;
#line 660 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 2:
#line 10363 "smtp-outbox-folder.c"
		goto _state_2;
#line 660 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 3:
#line 10367 "smtp-outbox-folder.c"
		goto _state_3;
#line 660 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 4:
#line 10371 "smtp-outbox-folder.c"
		goto _state_4;
#line 660 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 5:
#line 10375 "smtp-outbox-folder.c"
		goto _state_5;
		default:
#line 660 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 10380 "smtp-outbox-folder.c"
	}
	_state_0:
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = NULL;
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->self->priv->_account;
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = NULL;
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = _data_->cancellable;
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_account_get_required_special_folder_async (_data_->_tmp1_, GEARY_SPECIAL_FOLDER_TYPE_SENT, _data_->_tmp2_, geary_smtp_outbox_folder_save_sent_mail_async_ready, _data_);
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 10397 "smtp-outbox-folder.c"
	_state_1:
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = NULL;
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = geary_account_get_required_special_folder_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error_);
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->_tmp3_;
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 10415 "smtp-outbox-folder.c"
		} else {
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 10419 "smtp-outbox-folder.c"
		}
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10425 "smtp-outbox-folder.c"
	}
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = NULL;
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp4_ = _data_->_tmp0_;
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = NULL;
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp5_ = NULL;
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp5_ = G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp4_, GEARY_FOLDER_SUPPORT_TYPE_CREATE) ? ((GearyFolderSupportCreate*) _data_->_tmp4_) : NULL;
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp5_ == NULL) {
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data_->_tmp4_);
#line 10441 "smtp-outbox-folder.c"
	}
#line 662 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->create = _data_->_tmp5_;
#line 664 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp6_ = NULL;
#line 664 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp6_ = _data_->create;
#line 664 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_tmp6_ == NULL) {
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp7_ = NULL;
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp7_ = g_error_new_literal (GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_NOT_FOUND, "Save sent mail enabled, but no writable sent mail folder");
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = _data_->_tmp7_;
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data_->create);
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 10469 "smtp-outbox-folder.c"
		} else {
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 10473 "smtp-outbox-folder.c"
		}
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 665 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10479 "smtp-outbox-folder.c"
	}
#line 667 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->open = FALSE;
#line 10483 "smtp-outbox-folder.c"
	{
#line 669 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp8_ = NULL;
#line 669 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp8_ = _data_->create;
#line 669 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp9_ = NULL;
#line 669 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp9_ = _data_->cancellable;
#line 669 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_state_ = 2;
#line 669 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_folder_open_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, GEARY_TYPE_FOLDER, GearyFolder), GEARY_FOLDER_OPEN_FLAGS_FAST_OPEN, _data_->_tmp9_, geary_smtp_outbox_folder_save_sent_mail_async_ready, _data_);
#line 669 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10499 "smtp-outbox-folder.c"
		_state_2:
#line 669 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_folder_open_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp8_, GEARY_TYPE_FOLDER, GearyFolder), _data_->_res_, &_data_->_inner_error_);
#line 669 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 10505 "smtp-outbox-folder.c"
			goto __catch201_g_error;
		}
#line 670 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->open = TRUE;
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp10_ = NULL;
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp10_ = _data_->create;
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp11_ = NULL;
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp11_ = _data_->rfc822;
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp12_ = NULL;
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp12_ = _data_->cancellable;
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_state_ = 3;
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_folder_support_create_create_email_async (_data_->_tmp10_, _data_->_tmp11_, NULL, NULL, NULL, _data_->_tmp12_, geary_smtp_outbox_folder_save_sent_mail_async_ready, _data_);
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10528 "smtp-outbox-folder.c"
		_state_3:
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp13_ = NULL;
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp13_ = geary_folder_support_create_create_email_finish (_data_->_tmp10_, _data_->_res_, &_data_->_inner_error_);
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp14_ = NULL;
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp14_ = _data_->_tmp13_;
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data_->_tmp14_);
#line 672 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 10542 "smtp-outbox-folder.c"
			goto __catch201_g_error;
		}
#line 674 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp15_ = NULL;
#line 674 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp15_ = _data_->create;
#line 674 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp16_ = NULL;
#line 674 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp16_ = _data_->cancellable;
#line 674 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_state_ = 4;
#line 674 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_folder_close_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp15_, GEARY_TYPE_FOLDER, GearyFolder), _data_->_tmp16_, geary_smtp_outbox_folder_save_sent_mail_async_ready, _data_);
#line 674 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10559 "smtp-outbox-folder.c"
		_state_4:
#line 674 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_folder_close_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp15_, GEARY_TYPE_FOLDER, GearyFolder), _data_->_res_, &_data_->_inner_error_);
#line 674 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 10565 "smtp-outbox-folder.c"
			goto __catch201_g_error;
		}
#line 675 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->open = FALSE;
#line 10570 "smtp-outbox-folder.c"
	}
	goto __finally201;
	__catch201_g_error:
	{
#line 668 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->e = _data_->_inner_error_;
#line 668 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = NULL;
#line 677 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp17_ = FALSE;
#line 677 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp17_ = _data_->open;
#line 677 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_tmp17_) {
#line 10585 "smtp-outbox-folder.c"
			{
#line 679 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp18_ = NULL;
#line 679 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp18_ = _data_->create;
#line 679 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp19_ = NULL;
#line 679 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp19_ = _data_->cancellable;
#line 679 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_state_ = 5;
#line 679 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				geary_folder_close_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp18_, GEARY_TYPE_FOLDER, GearyFolder), _data_->_tmp19_, geary_smtp_outbox_folder_save_sent_mail_async_ready, _data_);
#line 679 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return FALSE;
#line 10601 "smtp-outbox-folder.c"
				_state_5:
#line 679 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				geary_folder_close_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp18_, GEARY_TYPE_FOLDER, GearyFolder), _data_->_res_, &_data_->_inner_error_);
#line 679 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 10607 "smtp-outbox-folder.c"
					goto __catch202_g_error;
				}
#line 680 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->open = FALSE;
#line 10612 "smtp-outbox-folder.c"
			}
			goto __finally202;
			__catch202_g_error:
			{
#line 678 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_vala1_e = _data_->_inner_error_;
#line 678 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_inner_error_ = NULL;
#line 682 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp20_ = NULL;
#line 682 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp20_ = _data_->create;
#line 682 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp21_ = NULL;
#line 682 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp21_ = geary_folder_to_string (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp20_, GEARY_TYPE_FOLDER, GearyFolder));
#line 682 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp22_ = NULL;
#line 682 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp22_ = _data_->_tmp21_;
#line 682 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp23_ = NULL;
#line 682 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp23_ = _data_->_vala1_e;
#line 682 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp24_ = NULL;
#line 682 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_data_->_tmp24_ = _data_->_tmp23_->message;
#line 682 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_debug ("smtp-outbox-folder.vala:682: Error closing folder %s: %s", _data_->_tmp22_, _data_->_tmp24_);
#line 682 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_free0 (_data_->_tmp22_);
#line 678 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_error_free0 (_data_->_vala1_e);
#line 10647 "smtp-outbox-folder.c"
			}
			__finally202:
#line 678 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 678 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_error_free0 (_data_->e);
#line 678 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_error_free0 (_data_->e);
#line 678 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->create);
#line 678 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_data_->_tmp0_);
#line 678 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 678 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_clear_error (&_data_->_inner_error_);
#line 678 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				return FALSE;
#line 10666 "smtp-outbox-folder.c"
			}
		}
#line 685 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp25_ = NULL;
#line 685 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp25_ = _data_->e;
#line 685 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp26_ = NULL;
#line 685 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_tmp26_ = _g_error_copy0 (_data_->_tmp25_);
#line 685 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_inner_error_ = _data_->_tmp26_;
#line 685 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_error_free0 (_data_->e);
#line 10681 "smtp-outbox-folder.c"
		goto __finally201;
	}
	__finally201:
#line 668 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 668 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 668 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 668 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data_->create);
#line 668 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 668 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 668 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 10699 "smtp-outbox-folder.c"
		} else {
#line 668 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 10703 "smtp-outbox-folder.c"
		}
#line 668 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 668 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10709 "smtp-outbox-folder.c"
	}
#line 660 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->create);
#line 660 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_tmp0_);
#line 660 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 660 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 10719 "smtp-outbox-folder.c"
	} else {
#line 660 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 10723 "smtp-outbox-folder.c"
	}
#line 660 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 660 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 10729 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_is_unsent_async_data_free (gpointer _data) {
	GearySmtpOutboxFolderIsUnsentAsyncData* _data_;
	_data_ = _data;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_slice_free (GearySmtpOutboxFolderIsUnsentAsyncData, _data_);
#line 10740 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_is_unsent_async (GearySmtpOutboxFolder* self, gint64 ordering, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GearySmtpOutboxFolderIsUnsentAsyncData* _data_;
	GearySmtpOutboxFolder* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
	GCancellable* _tmp2_ = NULL;
	GCancellable* _tmp3_ = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_slice_new0 (GearySmtpOutboxFolderIsUnsentAsyncData);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, geary_smtp_outbox_folder_is_unsent_async);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, geary_smtp_outbox_folder_is_unsent_async_data_free);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->self = _tmp0_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = ordering;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->ordering = _tmp1_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = cancellable;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->cancellable);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->cancellable = _tmp3_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_is_unsent_async_co (_data_);
#line 10774 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_is_unsent_finish (GearySmtpOutboxFolder* self, GAsyncResult* _res_, GError** error) {
	gboolean result;
	GearySmtpOutboxFolderIsUnsentAsyncData* _data_;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 10785 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _data_->result;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 10793 "smtp-outbox-folder.c"
}


static Block83Data* block83_data_ref (Block83Data* _data83_) {
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&_data83_->_ref_count_);
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return _data83_;
#line 10802 "smtp-outbox-folder.c"
}


static void block83_data_unref (void * _userdata_) {
	Block83Data* _data83_;
	_data83_ = (Block83Data*) _userdata_;
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&_data83_->_ref_count_)) {
#line 10811 "smtp-outbox-folder.c"
		GearySmtpOutboxFolder* self;
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		self = _data83_->self;
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (_data83_->cancellable);
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (self);
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_slice_free (Block83Data, _data83_);
#line 10821 "smtp-outbox-folder.c"
	}
}


static GearyDbTransactionOutcome __lambda93_ (Block83Data* _data83_, GearyDbConnection* cx, GError** error) {
	GearySmtpOutboxFolder* self;
	GearyDbTransactionOutcome result = 0;
	GearyDbStatement* stmt = NULL;
	GearyDbConnection* _tmp0_ = NULL;
	GearyDbStatement* _tmp1_ = NULL;
	GearyDbStatement* _tmp2_ = NULL;
	gint64 _tmp3_ = 0LL;
	GearyDbStatement* _tmp4_ = NULL;
	GearyDbStatement* _tmp5_ = NULL;
	GearyDbResult* _tmp6_ = NULL;
	GearyDbStatement* _tmp7_ = NULL;
	GCancellable* _tmp8_ = NULL;
	GearyDbResult* _tmp9_ = NULL;
	GearyDbResult* _tmp10_ = NULL;
	GearyDbResult* _tmp11_ = NULL;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	GError * _inner_error_ = NULL;
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = _data83_->self;
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 692 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = cx;
#line 692 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = geary_db_connection_prepare (_tmp0_, "SELECT 1 FROM SmtpOutboxTable WHERE ordering=? AND sent = 0", &_inner_error_);
#line 692 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp1_;
#line 692 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 692 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 692 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 10861 "smtp-outbox-folder.c"
	}
#line 694 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = stmt;
#line 694 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = _data83_->ordering;
#line 694 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = geary_db_statement_bind_int64 (_tmp2_, 0, _tmp3_, &_inner_error_);
#line 694 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = _tmp4_;
#line 694 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp5_);
#line 694 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 694 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 694 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 694 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 10881 "smtp-outbox-folder.c"
	}
#line 696 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = stmt;
#line 696 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = _data83_->cancellable;
#line 696 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp9_ = geary_db_statement_exec (_tmp7_, _tmp8_, &_inner_error_);
#line 696 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = _tmp9_;
#line 696 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 696 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 696 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 696 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 10899 "smtp-outbox-folder.c"
	}
#line 696 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp10_ = _tmp6_;
#line 696 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = NULL;
#line 696 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp11_ = _tmp10_;
#line 696 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp12_ = geary_db_result_get_finished (_tmp11_);
#line 696 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp13_ = _tmp12_;
#line 696 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data83_->exists = !_tmp13_;
#line 696 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp11_);
#line 698 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_DB_TRANSACTION_OUTCOME_DONE;
#line 698 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp6_);
#line 698 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 698 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 10923 "smtp-outbox-folder.c"
}


static GearyDbTransactionOutcome ___lambda93__geary_db_transaction_method (GearyDbConnection* cx, GCancellable* cancellable, gpointer self, GError** error) {
	GearyDbTransactionOutcome result;
	result = __lambda93_ (self, cx, error);
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 10932 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_is_unsent_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	GearySmtpOutboxFolderIsUnsentAsyncData* _data_;
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_ = _user_data_;
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_source_object_ = source_object;
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_res_ = _res_;
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_is_unsent_async_co (_data_);
#line 10946 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_is_unsent_async_co (GearySmtpOutboxFolderIsUnsentAsyncData* _data_) {
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (_data_->_state_) {
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 0:
#line 10955 "smtp-outbox-folder.c"
		goto _state_0;
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case 1:
#line 10959 "smtp-outbox-folder.c"
		goto _state_1;
		default:
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_assert_not_reached ();
#line 10964 "smtp-outbox-folder.c"
	}
	_state_0:
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data83_ = g_slice_new0 (Block83Data);
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data83_->_ref_count_ = 1;
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data83_->self = g_object_ref (_data_->self);
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = 0LL;
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp0_ = _data_->ordering;
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data83_->ordering = _data_->_tmp0_;
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = NULL;
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp1_ = _data_->cancellable;
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_data_->_data83_->cancellable);
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data83_->cancellable = _data_->_tmp1_;
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data83_->_async_data_ = _data_;
#line 690 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data83_->exists = FALSE;
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = NULL;
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp2_ = _data_->self->priv->db;
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = NULL;
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_tmp3_ = _data_->_data83_->cancellable;
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_state_ = 1;
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), GEARY_DB_TRANSACTION_TYPE_RO, ___lambda93__geary_db_transaction_method, _data_->_data83_, _data_->_tmp3_, geary_smtp_outbox_folder_is_unsent_async_ready, _data_);
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 11005 "smtp-outbox-folder.c"
	_state_1:
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_db_database_exec_transaction_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, GEARY_DB_TYPE_DATABASE, GearyDbDatabase), _data_->_res_, &_data_->_inner_error_);
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_error_free (_data_->_inner_error_);
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		block83_data_unref (_data_->_data83_);
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_data_->_data83_ = NULL;
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (_data_->_state_ == 0) {
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 11023 "smtp-outbox-folder.c"
		} else {
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 11027 "smtp-outbox-folder.c"
		}
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_object_unref (_data_->_async_result);
#line 691 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 11033 "smtp-outbox-folder.c"
	}
#line 701 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->result = _data_->_data83_->exists;
#line 701 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block83_data_unref (_data_->_data83_);
#line 701 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data83_ = NULL;
#line 701 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 701 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 11045 "smtp-outbox-folder.c"
	} else {
#line 701 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 11049 "smtp-outbox-folder.c"
	}
#line 701 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 701 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	block83_data_unref (_data_->_data83_);
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_data_->_data83_ = NULL;
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_data_->_state_ == 0) {
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 11063 "smtp-outbox-folder.c"
	} else {
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 11067 "smtp-outbox-folder.c"
	}
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_unref (_data_->_async_result);
#line 689 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return FALSE;
#line 11073 "smtp-outbox-folder.c"
}


static gint64 geary_smtp_outbox_folder_do_get_next_ordering (GearySmtpOutboxFolder* self, GearyDbConnection* cx, GCancellable* cancellable, GError** error) {
	gint64 result = 0LL;
	GError * _inner_error_ = NULL;
#line 708 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_SMTP_OUTBOX_FOLDER (self), 0LL);
#line 708 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0LL);
#line 708 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), 0LL);
#line 11086 "smtp-outbox-folder.c"
	{
		gint64 _tmp0_ = 0LL;
#line 709 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp0_ = self->priv->next_ordering;
#line 709 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_rec_mutex_lock (&self->priv->__lock_next_ordering);
#line 11093 "smtp-outbox-folder.c"
		{
			gint64 _tmp1_ = 0LL;
			gint64 _tmp14_ = 0LL;
#line 710 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp1_ = self->priv->next_ordering;
#line 710 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			if (_tmp1_ == ((gint64) 0)) {
#line 11101 "smtp-outbox-folder.c"
				GearyDbStatement* stmt = NULL;
				GearyDbConnection* _tmp2_ = NULL;
				GearyDbStatement* _tmp3_ = NULL;
				GearyDbResult* _result_ = NULL;
				GearyDbStatement* _tmp4_ = NULL;
				GCancellable* _tmp5_ = NULL;
				GearyDbResult* _tmp6_ = NULL;
				GearyDbResult* _tmp7_ = NULL;
				gboolean _tmp8_ = FALSE;
				gboolean _tmp9_ = FALSE;
				gint64 _tmp13_ = 0LL;
#line 711 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp2_ = cx;
#line 711 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp3_ = geary_db_connection_prepare (_tmp2_, "SELECT COALESCE(MAX(ordering), 0) + 1 FROM SmtpOutboxTable", &_inner_error_);
#line 711 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				stmt = _tmp3_;
#line 711 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 11121 "smtp-outbox-folder.c"
					goto __finally203;
				}
#line 713 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp4_ = stmt;
#line 713 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp5_ = cancellable;
#line 713 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp6_ = geary_db_statement_exec (_tmp4_, _tmp5_, &_inner_error_);
#line 713 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_result_ = _tmp6_;
#line 713 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 713 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_g_object_unref0 (stmt);
#line 11136 "smtp-outbox-folder.c"
					goto __finally203;
				}
#line 714 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp7_ = _result_;
#line 714 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp8_ = geary_db_result_get_finished (_tmp7_);
#line 714 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp9_ = _tmp8_;
#line 714 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				if (!_tmp9_) {
#line 11147 "smtp-outbox-folder.c"
					gint64 _tmp10_ = 0LL;
					GearyDbResult* _tmp11_ = NULL;
					gint64 _tmp12_ = 0LL;
#line 715 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_tmp11_ = _result_;
#line 715 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_tmp12_ = geary_db_result_int64_at (_tmp11_, 0, &_inner_error_);
#line 715 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					_tmp10_ = _tmp12_;
#line 715 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 715 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_g_object_unref0 (_result_);
#line 715 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
						_g_object_unref0 (stmt);
#line 11163 "smtp-outbox-folder.c"
						goto __finally203;
					}
#line 715 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
					self->priv->next_ordering = _tmp10_;
#line 11168 "smtp-outbox-folder.c"
				}
#line 717 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp13_ = self->priv->next_ordering;
#line 717 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_vala_assert (_tmp13_ > ((gint64) 0), "next_ordering > 0");
#line 710 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (_result_);
#line 710 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_g_object_unref0 (stmt);
#line 11178 "smtp-outbox-folder.c"
			}
#line 720 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp14_ = self->priv->next_ordering;
#line 720 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			self->priv->next_ordering = _tmp14_ + 1;
#line 720 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			result = _tmp14_;
#line 11186 "smtp-outbox-folder.c"
			{
				gint64 _tmp15_ = 0LL;
#line 709 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				_tmp15_ = self->priv->next_ordering;
#line 709 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
				g_rec_mutex_unlock (&self->priv->__lock_next_ordering);
#line 11193 "smtp-outbox-folder.c"
			}
#line 720 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return result;
#line 11197 "smtp-outbox-folder.c"
		}
		__finally203:
		{
			gint64 _tmp16_ = 0LL;
#line 709 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_tmp16_ = self->priv->next_ordering;
#line 709 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_rec_mutex_unlock (&self->priv->__lock_next_ordering);
#line 11206 "smtp-outbox-folder.c"
		}
#line 709 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 709 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0LL;
#line 11212 "smtp-outbox-folder.c"
	}
}


static gint geary_smtp_outbox_folder_do_get_email_count (GearySmtpOutboxFolder* self, GearyDbConnection* cx, GCancellable* cancellable, GError** error) {
	gint result = 0;
	GearyDbStatement* stmt = NULL;
	GearyDbConnection* _tmp0_ = NULL;
	GearyDbStatement* _tmp1_ = NULL;
	GearyDbResult* results = NULL;
	GearyDbStatement* _tmp2_ = NULL;
	GCancellable* _tmp3_ = NULL;
	GearyDbResult* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	GearyDbResult* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	GError * _inner_error_ = NULL;
#line 724 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_SMTP_OUTBOX_FOLDER (self), 0);
#line 724 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 724 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), 0);
#line 725 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = cx;
#line 725 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = geary_db_connection_prepare (_tmp0_, "SELECT COUNT(*) FROM SmtpOutboxTable", &_inner_error_);
#line 725 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp1_;
#line 725 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 725 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 725 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 11249 "smtp-outbox-folder.c"
	}
#line 727 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = stmt;
#line 727 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = cancellable;
#line 727 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = geary_db_statement_exec (_tmp2_, _tmp3_, &_inner_error_);
#line 727 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	results = _tmp4_;
#line 727 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 727 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 727 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 727 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 11267 "smtp-outbox-folder.c"
	}
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = results;
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = geary_db_result_get_finished (_tmp6_);
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = _tmp7_;
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (!_tmp8_) {
#line 11277 "smtp-outbox-folder.c"
		GearyDbResult* _tmp9_ = NULL;
		gint _tmp10_ = 0;
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp9_ = results;
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp10_ = geary_db_result_int_at (_tmp9_, 0, &_inner_error_);
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp5_ = _tmp10_;
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			g_propagate_error (error, _inner_error_);
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (results);
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			_g_object_unref0 (stmt);
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return 0;
#line 11296 "smtp-outbox-folder.c"
		}
	} else {
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_tmp5_ = 0;
#line 11301 "smtp-outbox-folder.c"
	}
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _tmp5_;
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (results);
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 729 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 11311 "smtp-outbox-folder.c"
}


static gint geary_smtp_outbox_folder_do_get_position_by_ordering (GearySmtpOutboxFolder* self, GearyDbConnection* cx, gint64 ordering, GCancellable* cancellable, GError** error) {
	gint result = 0;
	GearyDbStatement* stmt = NULL;
	GearyDbConnection* _tmp0_ = NULL;
	GearyDbStatement* _tmp1_ = NULL;
	GearyDbStatement* _tmp2_ = NULL;
	gint64 _tmp3_ = 0LL;
	GearyDbStatement* _tmp4_ = NULL;
	GearyDbStatement* _tmp5_ = NULL;
	GearyDbResult* results = NULL;
	GearyDbStatement* _tmp6_ = NULL;
	GCancellable* _tmp7_ = NULL;
	GearyDbResult* _tmp8_ = NULL;
	GearyDbResult* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gint64 _tmp12_ = 0LL;
	GearyDbResult* _tmp13_ = NULL;
	gint64 _tmp14_ = 0LL;
	gint64 _tmp15_ = 0LL;
	gint _tmp16_ = 0;
	GearyDbResult* _tmp17_ = NULL;
	gint _tmp18_ = 0;
	GError * _inner_error_ = NULL;
#line 732 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_SMTP_OUTBOX_FOLDER (self), 0);
#line 732 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), 0);
#line 732 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), 0);
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = cx;
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = geary_db_connection_prepare (_tmp0_, "SELECT COUNT(*), MAX(ordering) FROM SmtpOutboxTable WHERE ordering <= " \
"? ORDER BY ordering ASC", &_inner_error_);
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp1_;
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 734 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 11357 "smtp-outbox-folder.c"
	}
#line 736 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = stmt;
#line 736 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = ordering;
#line 736 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = geary_db_statement_bind_int64 (_tmp2_, 0, _tmp3_, &_inner_error_);
#line 736 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = _tmp4_;
#line 736 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp5_);
#line 736 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 736 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 736 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 736 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 11377 "smtp-outbox-folder.c"
	}
#line 738 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = stmt;
#line 738 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = cancellable;
#line 738 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = geary_db_statement_exec (_tmp6_, _tmp7_, &_inner_error_);
#line 738 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	results = _tmp8_;
#line 738 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 738 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 738 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 738 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 11395 "smtp-outbox-folder.c"
	}
#line 739 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp9_ = results;
#line 739 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp10_ = geary_db_result_get_finished (_tmp9_);
#line 739 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp11_ = _tmp10_;
#line 739 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp11_) {
#line 740 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		result = -1;
#line 740 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 740 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 740 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return result;
#line 11413 "smtp-outbox-folder.c"
	}
#line 743 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp13_ = results;
#line 743 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp14_ = geary_db_result_int64_at (_tmp13_, 1, &_inner_error_);
#line 743 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp12_ = _tmp14_;
#line 743 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 743 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 743 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 743 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 743 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 11431 "smtp-outbox-folder.c"
	}
#line 743 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp15_ = ordering;
#line 743 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp12_ != _tmp15_) {
#line 744 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		result = -1;
#line 744 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 744 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 744 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return result;
#line 11445 "smtp-outbox-folder.c"
	}
#line 746 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp17_ = results;
#line 746 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp18_ = geary_db_result_int_at (_tmp17_, 0, &_inner_error_);
#line 746 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp16_ = _tmp18_;
#line 746 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 746 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 746 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 746 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 746 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return 0;
#line 11463 "smtp-outbox-folder.c"
	}
#line 746 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _tmp16_ + 1;
#line 746 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (results);
#line 746 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 746 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 11473 "smtp-outbox-folder.c"
}


static GearySmtpOutboxFolderOutboxRow* geary_smtp_outbox_folder_do_fetch_row_by_ordering (GearySmtpOutboxFolder* self, GearyDbConnection* cx, gint64 ordering, GCancellable* cancellable, GError** error) {
	GearySmtpOutboxFolderOutboxRow* result = NULL;
	GearyDbStatement* stmt = NULL;
	GearyDbConnection* _tmp0_ = NULL;
	GearyDbStatement* _tmp1_ = NULL;
	GearyDbStatement* _tmp2_ = NULL;
	gint64 _tmp3_ = 0LL;
	GearyDbStatement* _tmp4_ = NULL;
	GearyDbStatement* _tmp5_ = NULL;
	GearyDbResult* results = NULL;
	GearyDbStatement* _tmp6_ = NULL;
	GCancellable* _tmp7_ = NULL;
	GearyDbResult* _tmp8_ = NULL;
	GearyDbResult* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gint position = 0;
	GearyDbConnection* _tmp12_ = NULL;
	gint64 _tmp13_ = 0LL;
	GCancellable* _tmp14_ = NULL;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	gint64 _tmp17_ = 0LL;
	GearyDbResult* _tmp18_ = NULL;
	gint64 _tmp19_ = 0LL;
	gboolean _tmp20_ = FALSE;
	GearyDbResult* _tmp21_ = NULL;
	gboolean _tmp22_ = FALSE;
	GearyMemoryBuffer* _tmp23_ = NULL;
	GearyDbResult* _tmp24_ = NULL;
	GearyMemoryBuffer* _tmp25_ = NULL;
	gint _tmp26_ = 0;
	gint64 _tmp27_ = 0LL;
	GearySmtpOutboxFolderRoot* _tmp28_ = NULL;
	GearySmtpOutboxFolderOutboxRow* _tmp29_ = NULL;
	GError * _inner_error_ = NULL;
#line 749 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_SMTP_OUTBOX_FOLDER (self), NULL);
#line 749 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), NULL);
#line 749 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), NULL);
#line 751 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = cx;
#line 751 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = geary_db_connection_prepare (_tmp0_, "\n" \
"            SELECT id, message, sent\n" \
"            FROM SmtpOutboxTable\n" \
"            WHERE ordering=?\n" \
"        ", &_inner_error_);
#line 751 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp1_;
#line 751 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 751 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 751 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 11531 "smtp-outbox-folder.c"
	}
#line 756 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = stmt;
#line 756 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = ordering;
#line 756 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = geary_db_statement_bind_int64 (_tmp2_, 0, _tmp3_, &_inner_error_);
#line 756 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = _tmp4_;
#line 756 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp5_);
#line 756 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 756 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 756 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 756 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 11551 "smtp-outbox-folder.c"
	}
#line 758 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = stmt;
#line 758 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = cancellable;
#line 758 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = geary_db_statement_exec (_tmp6_, _tmp7_, &_inner_error_);
#line 758 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	results = _tmp8_;
#line 758 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 758 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 758 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 758 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 11569 "smtp-outbox-folder.c"
	}
#line 759 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp9_ = results;
#line 759 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp10_ = geary_db_result_get_finished (_tmp9_);
#line 759 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp11_ = _tmp10_;
#line 759 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp11_) {
#line 760 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		result = NULL;
#line 760 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 760 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 760 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return result;
#line 11587 "smtp-outbox-folder.c"
	}
#line 762 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp12_ = cx;
#line 762 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp13_ = ordering;
#line 762 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp14_ = cancellable;
#line 762 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp15_ = geary_smtp_outbox_folder_do_get_position_by_ordering (self, _tmp12_, _tmp13_, _tmp14_, &_inner_error_);
#line 762 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	position = _tmp15_;
#line 762 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 762 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 762 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 762 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 762 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 11609 "smtp-outbox-folder.c"
	}
#line 763 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp16_ = position;
#line 763 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (_tmp16_ < 1) {
#line 764 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		result = NULL;
#line 764 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 764 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 764 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return result;
#line 11623 "smtp-outbox-folder.c"
	}
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp18_ = results;
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp19_ = geary_db_result_rowid_at (_tmp18_, 0, &_inner_error_);
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp17_ = _tmp19_;
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 11641 "smtp-outbox-folder.c"
	}
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp21_ = results;
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp22_ = geary_db_result_bool_at (_tmp21_, 2, &_inner_error_);
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp20_ = _tmp22_;
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 11659 "smtp-outbox-folder.c"
	}
#line 767 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp24_ = results;
#line 767 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp25_ = geary_db_result_string_buffer_at (_tmp24_, 1, &_inner_error_);
#line 767 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp23_ = _tmp25_;
#line 767 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 767 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 767 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (results);
#line 767 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 767 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return NULL;
#line 11677 "smtp-outbox-folder.c"
	}
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp26_ = position;
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp27_ = ordering;
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp28_ = self->priv->_path;
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp29_ = geary_smtp_outbox_folder_outbox_row_new (_tmp17_, _tmp26_, _tmp27_, _tmp20_, _tmp23_, _tmp28_);
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _tmp29_;
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp23_);
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (results);
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 766 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 11697 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_do_mark_email_as_sent (GearySmtpOutboxFolder* self, GearyDbConnection* cx, GearySmtpOutboxEmailIdentifier* id, GCancellable* cancellable, GError** error) {
	GearyDbStatement* stmt = NULL;
	GearyDbConnection* _tmp0_ = NULL;
	GearyDbStatement* _tmp1_ = NULL;
	GearyDbStatement* _tmp2_ = NULL;
	GearySmtpOutboxEmailIdentifier* _tmp3_ = NULL;
	gint64 _tmp4_ = 0LL;
	gint64 _tmp5_ = 0LL;
	GearyDbStatement* _tmp6_ = NULL;
	GearyDbStatement* _tmp7_ = NULL;
	GearyDbStatement* _tmp8_ = NULL;
	GCancellable* _tmp9_ = NULL;
	GearyDbResult* _tmp10_ = NULL;
	GearyDbResult* _tmp11_ = NULL;
	GError * _inner_error_ = NULL;
#line 770 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_if_fail (GEARY_IS_SMTP_OUTBOX_FOLDER (self));
#line 770 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_if_fail (GEARY_DB_IS_CONNECTION (cx));
#line 770 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_if_fail (GEARY_IS_SMTP_OUTBOX_EMAIL_IDENTIFIER (id));
#line 770 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable));
#line 772 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = cx;
#line 772 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = geary_db_connection_prepare (_tmp0_, "UPDATE SmtpOutboxTable SET sent = 1 WHERE ordering = ?", &_inner_error_);
#line 772 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp1_;
#line 772 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 772 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 772 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 11736 "smtp-outbox-folder.c"
	}
#line 773 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = stmt;
#line 773 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = id;
#line 773 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp3_);
#line 773 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = _tmp4_;
#line 773 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = geary_db_statement_bind_int64 (_tmp2_, 0, _tmp5_, &_inner_error_);
#line 773 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = _tmp6_;
#line 773 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp7_);
#line 773 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 773 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 773 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 773 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 11760 "smtp-outbox-folder.c"
	}
#line 775 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = stmt;
#line 775 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp9_ = cancellable;
#line 775 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp10_ = geary_db_statement_exec (_tmp8_, _tmp9_, &_inner_error_);
#line 775 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp11_ = _tmp10_;
#line 775 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp11_);
#line 775 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 775 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 775 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 775 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return;
#line 11780 "smtp-outbox-folder.c"
	}
#line 770 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 11784 "smtp-outbox-folder.c"
}


static gboolean geary_smtp_outbox_folder_do_remove_email (GearySmtpOutboxFolder* self, GearyDbConnection* cx, GearySmtpOutboxEmailIdentifier* id, GCancellable* cancellable, GError** error) {
	gboolean result = FALSE;
	GearyDbStatement* stmt = NULL;
	GearyDbConnection* _tmp0_ = NULL;
	GearyDbStatement* _tmp1_ = NULL;
	GearyDbStatement* _tmp2_ = NULL;
	GearySmtpOutboxEmailIdentifier* _tmp3_ = NULL;
	gint64 _tmp4_ = 0LL;
	gint64 _tmp5_ = 0LL;
	GearyDbStatement* _tmp6_ = NULL;
	GearyDbStatement* _tmp7_ = NULL;
	gint _tmp8_ = 0;
	GearyDbStatement* _tmp9_ = NULL;
	GCancellable* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	GError * _inner_error_ = NULL;
#line 778 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_SMTP_OUTBOX_FOLDER (self), FALSE);
#line 778 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_DB_IS_CONNECTION (cx), FALSE);
#line 778 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_SMTP_OUTBOX_EMAIL_IDENTIFIER (id), FALSE);
#line 778 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), FALSE);
#line 780 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = cx;
#line 780 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = geary_db_connection_prepare (_tmp0_, "DELETE FROM SmtpOutboxTable WHERE ordering=?", &_inner_error_);
#line 780 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	stmt = _tmp1_;
#line 780 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 780 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 780 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 11824 "smtp-outbox-folder.c"
	}
#line 781 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = stmt;
#line 781 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = id;
#line 781 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = geary_smtp_outbox_email_identifier_get_ordering (_tmp3_);
#line 781 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = _tmp4_;
#line 781 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = geary_db_statement_bind_int64 (_tmp2_, 0, _tmp5_, &_inner_error_);
#line 781 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = _tmp6_;
#line 781 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (_tmp7_);
#line 781 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 781 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 781 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 781 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 11848 "smtp-outbox-folder.c"
	}
#line 783 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp9_ = stmt;
#line 783 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp10_ = cancellable;
#line 783 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp11_ = geary_db_statement_exec_get_modified (_tmp9_, _tmp10_, &_inner_error_);
#line 783 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = _tmp11_;
#line 783 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 783 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_propagate_error (error, _inner_error_);
#line 783 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		_g_object_unref0 (stmt);
#line 783 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return FALSE;
#line 11866 "smtp-outbox-folder.c"
	}
#line 783 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _tmp8_ > 0;
#line 783 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (stmt);
#line 783 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 11874 "smtp-outbox-folder.c"
}


static GearyAccount* geary_smtp_outbox_folder_real_get_account (GearyFolder* base) {
	GearyAccount* result;
	GearySmtpOutboxFolder* self;
	GearyAccount* _tmp0_ = NULL;
#line 38 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 38 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = self->priv->_account;
#line 38 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = _tmp0_;
#line 38 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 11890 "smtp-outbox-folder.c"
}


static GearyFolderProperties* geary_smtp_outbox_folder_real_get_properties (GearyFolder* base) {
	GearyFolderProperties* result;
	GearySmtpOutboxFolder* self;
	GearySmtpOutboxFolderProperties* _tmp0_ = NULL;
#line 40 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 40 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = self->priv->_properties;
#line 40 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_TYPE_FOLDER_PROPERTIES, GearyFolderProperties);
#line 40 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 11906 "smtp-outbox-folder.c"
}


static GearyFolderPath* geary_smtp_outbox_folder_real_get_path (GearyFolder* base) {
	GearyFolderPath* result;
	GearySmtpOutboxFolder* self;
	GearySmtpOutboxFolderRoot* _tmp0_ = NULL;
#line 44 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 45 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = self->priv->_path;
#line 45 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEARY_TYPE_FOLDER_PATH, GearyFolderPath);
#line 45 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 11922 "smtp-outbox-folder.c"
}


static GearySpecialFolderType geary_smtp_outbox_folder_real_get_special_folder_type (GearyFolder* base) {
	GearySpecialFolderType result;
	GearySmtpOutboxFolder* self;
#line 50 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 51 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	result = GEARY_SPECIAL_FOLDER_TYPE_OUTBOX;
#line 51 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return result;
#line 11935 "smtp-outbox-folder.c"
}


static void g_cclosure_user_marshal_VOID__ENUM_POINTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__ENUM_POINTER) (gpointer data1, gint arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__ENUM_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_if_fail (n_param_values == 3);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		data1 = closure->data;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		data2 = param_values->data[0].v_pointer;
#line 11954 "smtp-outbox-folder.c"
	} else {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		data2 = closure->data;
#line 11960 "smtp-outbox-folder.c"
	}
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	callback = (GMarshalFunc_VOID__ENUM_POINTER) (marshal_data ? marshal_data : cc->callback);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	callback (data1, g_value_get_enum (param_values + 1), g_value_get_pointer (param_values + 2), data2);
#line 11966 "smtp-outbox-folder.c"
}


static GearySmtpOutboxFolderOutboxRow* geary_smtp_outbox_folder_outbox_row_construct (GType object_type, gint64 id, gint position, gint64 ordering, gboolean sent, GearyMemoryBuffer* message, GearySmtpOutboxFolderRoot* root) {
	GearySmtpOutboxFolderOutboxRow* self = NULL;
	gint _tmp0_ = 0;
	gint64 _tmp1_ = 0LL;
	gint _tmp2_ = 0;
	gint64 _tmp3_ = 0LL;
	GearyMemoryBuffer* _tmp4_ = NULL;
	GearyMemoryBuffer* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	gint64 _tmp7_ = 0LL;
	gint64 _tmp8_ = 0LL;
	GearySmtpOutboxEmailIdentifier* _tmp9_ = NULL;
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail ((message == NULL) || GEARY_MEMORY_IS_BUFFER (message), NULL);
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (GEARY_IS_SMTP_OUTBOX_FOLDER_ROOT (root), NULL);
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = (GearySmtpOutboxFolderOutboxRow*) g_type_create_instance (object_type);
#line 26 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = position;
#line 26 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_vala_assert (_tmp0_ >= 1, "position >= 1");
#line 28 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = id;
#line 28 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->id = _tmp1_;
#line 29 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = position;
#line 29 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->position = _tmp2_;
#line 30 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp3_ = ordering;
#line 30 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->ordering = _tmp3_;
#line 31 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp4_ = message;
#line 31 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 31 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->message);
#line 31 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->message = _tmp5_;
#line 32 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp6_ = sent;
#line 32 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->sent = _tmp6_;
#line 34 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp7_ = id;
#line 34 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp8_ = ordering;
#line 34 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp9_ = geary_smtp_outbox_email_identifier_new (_tmp7_, _tmp8_);
#line 34 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->outbox_id);
#line 34 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->outbox_id = _tmp9_;
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return self;
#line 12028 "smtp-outbox-folder.c"
}


static GearySmtpOutboxFolderOutboxRow* geary_smtp_outbox_folder_outbox_row_new (gint64 id, gint position, gint64 ordering, gboolean sent, GearyMemoryBuffer* message, GearySmtpOutboxFolderRoot* root) {
#line 24 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return geary_smtp_outbox_folder_outbox_row_construct (GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW, id, position, ordering, sent, message, root);
#line 12035 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_value_outbox_row_init (GValue* value) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	value->data[0].v_pointer = NULL;
#line 12042 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_value_outbox_row_free_value (GValue* value) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (value->data[0].v_pointer) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_smtp_outbox_folder_outbox_row_unref (value->data[0].v_pointer);
#line 12051 "smtp-outbox-folder.c"
	}
}


static void geary_smtp_outbox_folder_value_outbox_row_copy_value (const GValue* src_value, GValue* dest_value) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (src_value->data[0].v_pointer) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		dest_value->data[0].v_pointer = geary_smtp_outbox_folder_outbox_row_ref (src_value->data[0].v_pointer);
#line 12061 "smtp-outbox-folder.c"
	} else {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		dest_value->data[0].v_pointer = NULL;
#line 12065 "smtp-outbox-folder.c"
	}
}


static gpointer geary_smtp_outbox_folder_value_outbox_row_peek_pointer (const GValue* value) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return value->data[0].v_pointer;
#line 12073 "smtp-outbox-folder.c"
}


static gchar* geary_smtp_outbox_folder_value_outbox_row_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (collect_values[0].v_pointer) {
#line 12080 "smtp-outbox-folder.c"
		GearySmtpOutboxFolderOutboxRow* object;
		object = collect_values[0].v_pointer;
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		if (object->parent_instance.g_class == NULL) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 12087 "smtp-outbox-folder.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 12091 "smtp-outbox-folder.c"
		}
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		value->data[0].v_pointer = geary_smtp_outbox_folder_outbox_row_ref (object);
#line 12095 "smtp-outbox-folder.c"
	} else {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		value->data[0].v_pointer = NULL;
#line 12099 "smtp-outbox-folder.c"
	}
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return NULL;
#line 12103 "smtp-outbox-folder.c"
}


static gchar* geary_smtp_outbox_folder_value_outbox_row_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	GearySmtpOutboxFolderOutboxRow** object_p;
	object_p = collect_values[0].v_pointer;
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (!object_p) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 12114 "smtp-outbox-folder.c"
	}
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (!value->data[0].v_pointer) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		*object_p = NULL;
#line 12120 "smtp-outbox-folder.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		*object_p = value->data[0].v_pointer;
#line 12124 "smtp-outbox-folder.c"
	} else {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		*object_p = geary_smtp_outbox_folder_outbox_row_ref (value->data[0].v_pointer);
#line 12128 "smtp-outbox-folder.c"
	}
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return NULL;
#line 12132 "smtp-outbox-folder.c"
}


static GParamSpec* geary_smtp_outbox_folder_param_spec_outbox_row (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	GearySmtpOutboxFolderParamSpecOutboxRow* spec;
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW), NULL);
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return G_PARAM_SPEC (spec);
#line 12146 "smtp-outbox-folder.c"
}


static gpointer geary_smtp_outbox_folder_value_get_outbox_row (const GValue* value) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW), NULL);
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return value->data[0].v_pointer;
#line 12155 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_value_set_outbox_row (GValue* value, gpointer v_object) {
	GearySmtpOutboxFolderOutboxRow* old;
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW));
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	old = value->data[0].v_pointer;
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (v_object) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW));
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		value->data[0].v_pointer = v_object;
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_smtp_outbox_folder_outbox_row_ref (value->data[0].v_pointer);
#line 12175 "smtp-outbox-folder.c"
	} else {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		value->data[0].v_pointer = NULL;
#line 12179 "smtp-outbox-folder.c"
	}
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (old) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_smtp_outbox_folder_outbox_row_unref (old);
#line 12185 "smtp-outbox-folder.c"
	}
}


static void geary_smtp_outbox_folder_value_take_outbox_row (GValue* value, gpointer v_object) {
	GearySmtpOutboxFolderOutboxRow* old;
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW));
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	old = value->data[0].v_pointer;
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (v_object) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW));
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		value->data[0].v_pointer = v_object;
#line 12204 "smtp-outbox-folder.c"
	} else {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		value->data[0].v_pointer = NULL;
#line 12208 "smtp-outbox-folder.c"
	}
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (old) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		geary_smtp_outbox_folder_outbox_row_unref (old);
#line 12214 "smtp-outbox-folder.c"
	}
}


static void geary_smtp_outbox_folder_outbox_row_class_init (GearySmtpOutboxFolderOutboxRowClass * klass) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_outbox_row_parent_class = g_type_class_peek_parent (klass);
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearySmtpOutboxFolderOutboxRowClass *) klass)->finalize = geary_smtp_outbox_folder_outbox_row_finalize;
#line 12224 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_outbox_row_instance_init (GearySmtpOutboxFolderOutboxRow * self) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->ref_count = 1;
#line 12231 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_outbox_row_finalize (GearySmtpOutboxFolderOutboxRow* obj) {
	GearySmtpOutboxFolderOutboxRow * self;
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW, GearySmtpOutboxFolderOutboxRow);
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_signal_handlers_destroy (self);
#line 21 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->message);
#line 22 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->outbox_id);
#line 12245 "smtp-outbox-folder.c"
}


static GType geary_smtp_outbox_folder_outbox_row_get_type (void) {
	static volatile gsize geary_smtp_outbox_folder_outbox_row_type_id__volatile = 0;
	if (g_once_init_enter (&geary_smtp_outbox_folder_outbox_row_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { geary_smtp_outbox_folder_value_outbox_row_init, geary_smtp_outbox_folder_value_outbox_row_free_value, geary_smtp_outbox_folder_value_outbox_row_copy_value, geary_smtp_outbox_folder_value_outbox_row_peek_pointer, "p", geary_smtp_outbox_folder_value_outbox_row_collect_value, "p", geary_smtp_outbox_folder_value_outbox_row_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GearySmtpOutboxFolderOutboxRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_smtp_outbox_folder_outbox_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearySmtpOutboxFolderOutboxRow), 0, (GInstanceInitFunc) geary_smtp_outbox_folder_outbox_row_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType geary_smtp_outbox_folder_outbox_row_type_id;
		geary_smtp_outbox_folder_outbox_row_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GearySmtpOutboxFolderOutboxRow", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&geary_smtp_outbox_folder_outbox_row_type_id__volatile, geary_smtp_outbox_folder_outbox_row_type_id);
	}
	return geary_smtp_outbox_folder_outbox_row_type_id__volatile;
}


static gpointer geary_smtp_outbox_folder_outbox_row_ref (gpointer instance) {
	GearySmtpOutboxFolderOutboxRow* self;
	self = instance;
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_atomic_int_inc (&self->ref_count);
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	return instance;
#line 12270 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_outbox_row_unref (gpointer instance) {
	GearySmtpOutboxFolderOutboxRow* self;
	self = instance;
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		GEARY_SMTP_OUTBOX_FOLDER_OUTBOX_ROW_GET_CLASS (self)->finalize (self);
#line 16 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 12283 "smtp-outbox-folder.c"
	}
}


static void geary_smtp_outbox_folder_class_init (GearySmtpOutboxFolderClass * klass) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_parent_class = g_type_class_peek_parent (klass);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_type_class_add_private (klass, sizeof (GearySmtpOutboxFolderPrivate));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->find_boundaries_async = geary_smtp_outbox_folder_real_find_boundaries_async;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->find_boundaries_finish = geary_smtp_outbox_folder_real_find_boundaries_finish;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->get_open_state = geary_smtp_outbox_folder_real_get_open_state;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearySmtpOutboxFolderClass *) klass)->create_email_async = geary_smtp_outbox_folder_real_create_email_async;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearySmtpOutboxFolderClass *) klass)->create_email_finish = geary_smtp_outbox_folder_real_create_email_finish;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->list_email_by_id_async = geary_smtp_outbox_folder_real_list_email_by_id_async;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->list_email_by_id_finish = geary_smtp_outbox_folder_real_list_email_by_id_finish;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->list_email_by_sparse_id_async = geary_smtp_outbox_folder_real_list_email_by_sparse_id_async;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->list_email_by_sparse_id_finish = geary_smtp_outbox_folder_real_list_email_by_sparse_id_finish;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->list_local_email_fields_async = geary_smtp_outbox_folder_real_list_local_email_fields_async;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->list_local_email_fields_finish = geary_smtp_outbox_folder_real_list_local_email_fields_finish;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->fetch_email_async = geary_smtp_outbox_folder_real_fetch_email_async;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearyFolderClass *) klass)->fetch_email_finish = geary_smtp_outbox_folder_real_fetch_email_finish;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearySmtpOutboxFolderClass *) klass)->remove_email_async = geary_smtp_outbox_folder_real_remove_email_async;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearySmtpOutboxFolderClass *) klass)->remove_email_finish = geary_smtp_outbox_folder_real_remove_email_finish;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearySmtpOutboxFolderClass *) klass)->remove_single_email_async = geary_smtp_outbox_folder_real_remove_single_email_async;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	((GearySmtpOutboxFolderClass *) klass)->remove_single_email_finish = geary_smtp_outbox_folder_real_remove_single_email_finish;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	GEARY_FOLDER_CLASS (klass)->get_account = geary_smtp_outbox_folder_real_get_account;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	GEARY_FOLDER_CLASS (klass)->get_properties = geary_smtp_outbox_folder_real_get_properties;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	GEARY_FOLDER_CLASS (klass)->get_path = geary_smtp_outbox_folder_real_get_path;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	GEARY_FOLDER_CLASS (klass)->get_special_folder_type = geary_smtp_outbox_folder_real_get_special_folder_type;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_smtp_outbox_folder_get_property;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_smtp_outbox_folder_finalize;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SMTP_OUTBOX_FOLDER_ACCOUNT, g_param_spec_object ("account", "account", "account", GEARY_TYPE_ACCOUNT, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SMTP_OUTBOX_FOLDER_PROPERTIES, g_param_spec_object ("properties", "properties", "properties", GEARY_TYPE_FOLDER_PROPERTIES, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SMTP_OUTBOX_FOLDER_PATH, g_param_spec_object ("path", "path", "path", GEARY_TYPE_FOLDER_PATH, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_SMTP_OUTBOX_FOLDER_SPECIAL_FOLDER_TYPE, g_param_spec_enum ("special-folder-type", "special-folder-type", "special-folder-type", GEARY_TYPE_SPECIAL_FOLDER_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_signal_new ("report_problem", GEARY_TYPE_SMTP_OUTBOX_FOLDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_POINTER, G_TYPE_NONE, 2, GEARY_ACCOUNT_TYPE_PROBLEM, G_TYPE_POINTER);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_signal_new ("email_sent", GEARY_TYPE_SMTP_OUTBOX_FOLDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_RF_C822_TYPE_MESSAGE);
#line 12351 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_geary_folder_support_remove_interface_init (GearyFolderSupportRemoveIface * iface) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_geary_folder_support_remove_parent_iface = g_type_interface_peek_parent (iface);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	iface->remove_email_async = (void (*)(GearyFolderSupportRemove*, GeeList*, GCancellable*, GError**)) geary_smtp_outbox_folder_remove_email_async;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	iface->remove_email_finish = geary_smtp_outbox_folder_remove_email_finish;
#line 12362 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_geary_folder_support_create_interface_init (GearyFolderSupportCreateIface * iface) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	geary_smtp_outbox_folder_geary_folder_support_create_parent_iface = g_type_interface_peek_parent (iface);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	iface->create_email_async = (GearyEmailIdentifier* (*)(GearyFolderSupportCreate*, GearyRFC822Message*, GearyEmailFlags*, GDateTime*, GearyEmailIdentifier*, GCancellable*, GError**)) geary_smtp_outbox_folder_create_email_async;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	iface->create_email_finish = geary_smtp_outbox_folder_create_email_finish;
#line 12373 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_instance_init (GearySmtpOutboxFolder * self) {
	GearySmtpOutboxFolderRoot* _tmp0_ = NULL;
	GearyNonblockingMailbox* _tmp1_ = NULL;
	GearySmtpOutboxFolderProperties* _tmp2_ = NULL;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->priv = GEARY_SMTP_OUTBOX_FOLDER_GET_PRIVATE (self);
#line 42 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp0_ = geary_smtp_outbox_folder_root_new ();
#line 42 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->priv->_path = _tmp0_;
#line 63 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp1_ = geary_nonblocking_mailbox_new (GEARY_SMTP_OUTBOX_FOLDER_TYPE_OUTBOX_ROW, (GBoxedCopyFunc) geary_smtp_outbox_folder_outbox_row_ref, geary_smtp_outbox_folder_outbox_row_unref, NULL, NULL, NULL);
#line 63 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->priv->outbox_queue = _tmp1_;
#line 64 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_tmp2_ = geary_smtp_outbox_folder_properties_new (0, 0);
#line 64 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->priv->_properties = _tmp2_;
#line 65 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_rec_mutex_init (&self->priv->__lock_next_ordering);
#line 65 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self->priv->next_ordering = (gint64) 0;
#line 12399 "smtp-outbox-folder.c"
}


static void geary_smtp_outbox_folder_finalize (GObject* obj) {
	GearySmtpOutboxFolder * self;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 42 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->priv->_path);
#line 59 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->priv->db);
#line 61 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->priv->sending_monitor);
#line 62 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_geary_smtp_client_session_unref0 (self->priv->smtp);
#line 63 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->priv->outbox_queue);
#line 64 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	_g_object_unref0 (self->priv->_properties);
#line 65 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	g_rec_mutex_clear (&self->priv->__lock_next_ordering);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	G_OBJECT_CLASS (geary_smtp_outbox_folder_parent_class)->finalize (obj);
#line 12423 "smtp-outbox-folder.c"
}


GType geary_smtp_outbox_folder_get_type (void) {
	static volatile gsize geary_smtp_outbox_folder_type_id__volatile = 0;
	if (g_once_init_enter (&geary_smtp_outbox_folder_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GearySmtpOutboxFolderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_smtp_outbox_folder_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearySmtpOutboxFolder), 0, (GInstanceInitFunc) geary_smtp_outbox_folder_instance_init, NULL };
		static const GInterfaceInfo geary_folder_support_remove_info = { (GInterfaceInitFunc) geary_smtp_outbox_folder_geary_folder_support_remove_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo geary_folder_support_create_info = { (GInterfaceInitFunc) geary_smtp_outbox_folder_geary_folder_support_create_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType geary_smtp_outbox_folder_type_id;
		geary_smtp_outbox_folder_type_id = g_type_register_static (GEARY_TYPE_ABSTRACT_LOCAL_FOLDER, "GearySmtpOutboxFolder", &g_define_type_info, 0);
		g_type_add_interface_static (geary_smtp_outbox_folder_type_id, GEARY_FOLDER_SUPPORT_TYPE_REMOVE, &geary_folder_support_remove_info);
		g_type_add_interface_static (geary_smtp_outbox_folder_type_id, GEARY_FOLDER_SUPPORT_TYPE_CREATE, &geary_folder_support_create_info);
		g_once_init_leave (&geary_smtp_outbox_folder_type_id__volatile, geary_smtp_outbox_folder_type_id);
	}
	return geary_smtp_outbox_folder_type_id__volatile;
}


static void _vala_geary_smtp_outbox_folder_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GearySmtpOutboxFolder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_TYPE_SMTP_OUTBOX_FOLDER, GearySmtpOutboxFolder);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
	switch (property_id) {
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case GEARY_SMTP_OUTBOX_FOLDER_ACCOUNT:
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_value_set_object (value, geary_folder_get_account (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_FOLDER, GearyFolder)));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case GEARY_SMTP_OUTBOX_FOLDER_PROPERTIES:
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_value_set_object (value, geary_folder_get_properties (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_FOLDER, GearyFolder)));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case GEARY_SMTP_OUTBOX_FOLDER_PATH:
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_value_set_object (value, geary_folder_get_path (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_FOLDER, GearyFolder)));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		break;
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		case GEARY_SMTP_OUTBOX_FOLDER_SPECIAL_FOLDER_TYPE:
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		g_value_set_enum (value, geary_folder_get_special_folder_type (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_FOLDER, GearyFolder)));
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		break;
#line 12472 "smtp-outbox-folder.c"
		default:
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "/builddir/build/BUILD/geary-0.11.2/src/engine/imap-db/outbox/smtp-outbox-folder.vala"
		break;
#line 12478 "smtp-outbox-folder.c"
	}
}



